// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/bigquery/biglake/v1/metastore.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fbigquery_2fbiglake_2fv1_2fmetastore_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fbigquery_2fbiglake_2fv1_2fmetastore_2eproto__INCLUDED

#include "google/cloud/bigquery/biglake/v1/metastore.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace bigquery {
namespace biglake {
namespace v1 {

// BigLake Metastore is a serverless, highly available, multi-tenant runtime
// metastore for Google Cloud Data Analytics products.
//
// The BigLake Metastore API defines the following resource model:
//
// * A collection of Google Cloud projects: `/projects/*`
// * Each project has a collection of available locations: `/locations/*`
// * Each location has a collection of catalogs: `/catalogs/*`
// * Each catalog has a collection of databases: `/databases/*`
// * Each database has a collection of tables: `/tables/*`
class MetastoreService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.bigquery.biglake.v1.MetastoreService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a new catalog.
    virtual ::grpc::Status CreateCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest& request, ::google::cloud::bigquery::biglake::v1::Catalog* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>> AsyncCreateCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>>(AsyncCreateCatalogRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>> PrepareAsyncCreateCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>>(PrepareAsyncCreateCatalogRaw(context, request, cq));
    }
    // Deletes an existing catalog specified by the catalog ID.
    virtual ::grpc::Status DeleteCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest& request, ::google::cloud::bigquery::biglake::v1::Catalog* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>> AsyncDeleteCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>>(AsyncDeleteCatalogRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>> PrepareAsyncDeleteCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>>(PrepareAsyncDeleteCatalogRaw(context, request, cq));
    }
    // Gets the catalog specified by the resource name.
    virtual ::grpc::Status GetCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest& request, ::google::cloud::bigquery::biglake::v1::Catalog* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>> AsyncGetCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>>(AsyncGetCatalogRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>> PrepareAsyncGetCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>>(PrepareAsyncGetCatalogRaw(context, request, cq));
    }
    // List all catalogs in a specified project.
    virtual ::grpc::Status ListCatalogs(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest& request, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>> AsyncListCatalogs(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>>(AsyncListCatalogsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>> PrepareAsyncListCatalogs(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>>(PrepareAsyncListCatalogsRaw(context, request, cq));
    }
    // Creates a new database.
    virtual ::grpc::Status CreateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest& request, ::google::cloud::bigquery::biglake::v1::Database* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>> AsyncCreateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>>(AsyncCreateDatabaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>> PrepareAsyncCreateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>>(PrepareAsyncCreateDatabaseRaw(context, request, cq));
    }
    // Deletes an existing database specified by the database ID.
    virtual ::grpc::Status DeleteDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest& request, ::google::cloud::bigquery::biglake::v1::Database* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>> AsyncDeleteDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>>(AsyncDeleteDatabaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>> PrepareAsyncDeleteDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>>(PrepareAsyncDeleteDatabaseRaw(context, request, cq));
    }
    // Updates an existing database specified by the database ID.
    virtual ::grpc::Status UpdateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest& request, ::google::cloud::bigquery::biglake::v1::Database* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>> AsyncUpdateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>>(AsyncUpdateDatabaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>> PrepareAsyncUpdateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>>(PrepareAsyncUpdateDatabaseRaw(context, request, cq));
    }
    // Gets the database specified by the resource name.
    virtual ::grpc::Status GetDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest& request, ::google::cloud::bigquery::biglake::v1::Database* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>> AsyncGetDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>>(AsyncGetDatabaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>> PrepareAsyncGetDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>>(PrepareAsyncGetDatabaseRaw(context, request, cq));
    }
    // List all databases in a specified catalog.
    virtual ::grpc::Status ListDatabases(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest& request, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>> AsyncListDatabases(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>>(AsyncListDatabasesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>> PrepareAsyncListDatabases(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>>(PrepareAsyncListDatabasesRaw(context, request, cq));
    }
    // Creates a new table.
    virtual ::grpc::Status CreateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest& request, ::google::cloud::bigquery::biglake::v1::Table* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>> AsyncCreateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>>(AsyncCreateTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>> PrepareAsyncCreateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>>(PrepareAsyncCreateTableRaw(context, request, cq));
    }
    // Deletes an existing table specified by the table ID.
    virtual ::grpc::Status DeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest& request, ::google::cloud::bigquery::biglake::v1::Table* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>> AsyncDeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>>(AsyncDeleteTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>> PrepareAsyncDeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>>(PrepareAsyncDeleteTableRaw(context, request, cq));
    }
    // Updates an existing table specified by the table ID.
    virtual ::grpc::Status UpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest& request, ::google::cloud::bigquery::biglake::v1::Table* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>> AsyncUpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>>(AsyncUpdateTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>> PrepareAsyncUpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>>(PrepareAsyncUpdateTableRaw(context, request, cq));
    }
    // Renames an existing table specified by the table ID.
    virtual ::grpc::Status RenameTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest& request, ::google::cloud::bigquery::biglake::v1::Table* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>> AsyncRenameTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>>(AsyncRenameTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>> PrepareAsyncRenameTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>>(PrepareAsyncRenameTableRaw(context, request, cq));
    }
    // Gets the table specified by the resource name.
    virtual ::grpc::Status GetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetTableRequest& request, ::google::cloud::bigquery::biglake::v1::Table* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>> AsyncGetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>>(AsyncGetTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>> PrepareAsyncGetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>>(PrepareAsyncGetTableRaw(context, request, cq));
    }
    // List all tables in a specified database.
    virtual ::grpc::Status ListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest& request, ::google::cloud::bigquery::biglake::v1::ListTablesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListTablesResponse>> AsyncListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListTablesResponse>>(AsyncListTablesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListTablesResponse>> PrepareAsyncListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListTablesResponse>>(PrepareAsyncListTablesRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a new catalog.
      virtual void CreateCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an existing catalog specified by the catalog ID.
      virtual void DeleteCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the catalog specified by the resource name.
      virtual void GetCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List all catalogs in a specified project.
      virtual void ListCatalogs(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest* request, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListCatalogs(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest* request, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new database.
      virtual void CreateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an existing database specified by the database ID.
      virtual void DeleteDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an existing database specified by the database ID.
      virtual void UpdateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the database specified by the resource name.
      virtual void GetDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List all databases in a specified catalog.
      virtual void ListDatabases(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest* request, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListDatabases(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest* request, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new table.
      virtual void CreateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an existing table specified by the table ID.
      virtual void DeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an existing table specified by the table ID.
      virtual void UpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Renames an existing table specified by the table ID.
      virtual void RenameTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RenameTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the table specified by the resource name.
      virtual void GetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List all tables in a specified database.
      virtual void ListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest* request, ::google::cloud::bigquery::biglake::v1::ListTablesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest* request, ::google::cloud::bigquery::biglake::v1::ListTablesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>* AsyncCreateCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>* PrepareAsyncCreateCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>* AsyncDeleteCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>* PrepareAsyncDeleteCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>* AsyncGetCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Catalog>* PrepareAsyncGetCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>* AsyncListCatalogsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>* PrepareAsyncListCatalogsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>* AsyncCreateDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>* PrepareAsyncCreateDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>* AsyncDeleteDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>* PrepareAsyncDeleteDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>* AsyncUpdateDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>* PrepareAsyncUpdateDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>* AsyncGetDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Database>* PrepareAsyncGetDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>* AsyncListDatabasesRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>* PrepareAsyncListDatabasesRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>* AsyncCreateTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>* PrepareAsyncCreateTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>* AsyncDeleteTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>* PrepareAsyncDeleteTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>* AsyncUpdateTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>* PrepareAsyncUpdateTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>* AsyncRenameTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>* PrepareAsyncRenameTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>* AsyncGetTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::Table>* PrepareAsyncGetTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListTablesResponse>* AsyncListTablesRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::biglake::v1::ListTablesResponse>* PrepareAsyncListTablesRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest& request, ::google::cloud::bigquery::biglake::v1::Catalog* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>> AsyncCreateCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>>(AsyncCreateCatalogRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>> PrepareAsyncCreateCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>>(PrepareAsyncCreateCatalogRaw(context, request, cq));
    }
    ::grpc::Status DeleteCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest& request, ::google::cloud::bigquery::biglake::v1::Catalog* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>> AsyncDeleteCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>>(AsyncDeleteCatalogRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>> PrepareAsyncDeleteCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>>(PrepareAsyncDeleteCatalogRaw(context, request, cq));
    }
    ::grpc::Status GetCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest& request, ::google::cloud::bigquery::biglake::v1::Catalog* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>> AsyncGetCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>>(AsyncGetCatalogRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>> PrepareAsyncGetCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>>(PrepareAsyncGetCatalogRaw(context, request, cq));
    }
    ::grpc::Status ListCatalogs(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest& request, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>> AsyncListCatalogs(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>>(AsyncListCatalogsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>> PrepareAsyncListCatalogs(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>>(PrepareAsyncListCatalogsRaw(context, request, cq));
    }
    ::grpc::Status CreateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest& request, ::google::cloud::bigquery::biglake::v1::Database* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>> AsyncCreateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>>(AsyncCreateDatabaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>> PrepareAsyncCreateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>>(PrepareAsyncCreateDatabaseRaw(context, request, cq));
    }
    ::grpc::Status DeleteDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest& request, ::google::cloud::bigquery::biglake::v1::Database* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>> AsyncDeleteDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>>(AsyncDeleteDatabaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>> PrepareAsyncDeleteDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>>(PrepareAsyncDeleteDatabaseRaw(context, request, cq));
    }
    ::grpc::Status UpdateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest& request, ::google::cloud::bigquery::biglake::v1::Database* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>> AsyncUpdateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>>(AsyncUpdateDatabaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>> PrepareAsyncUpdateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>>(PrepareAsyncUpdateDatabaseRaw(context, request, cq));
    }
    ::grpc::Status GetDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest& request, ::google::cloud::bigquery::biglake::v1::Database* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>> AsyncGetDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>>(AsyncGetDatabaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>> PrepareAsyncGetDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>>(PrepareAsyncGetDatabaseRaw(context, request, cq));
    }
    ::grpc::Status ListDatabases(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest& request, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>> AsyncListDatabases(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>>(AsyncListDatabasesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>> PrepareAsyncListDatabases(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>>(PrepareAsyncListDatabasesRaw(context, request, cq));
    }
    ::grpc::Status CreateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest& request, ::google::cloud::bigquery::biglake::v1::Table* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>> AsyncCreateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>>(AsyncCreateTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>> PrepareAsyncCreateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>>(PrepareAsyncCreateTableRaw(context, request, cq));
    }
    ::grpc::Status DeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest& request, ::google::cloud::bigquery::biglake::v1::Table* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>> AsyncDeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>>(AsyncDeleteTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>> PrepareAsyncDeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>>(PrepareAsyncDeleteTableRaw(context, request, cq));
    }
    ::grpc::Status UpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest& request, ::google::cloud::bigquery::biglake::v1::Table* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>> AsyncUpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>>(AsyncUpdateTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>> PrepareAsyncUpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>>(PrepareAsyncUpdateTableRaw(context, request, cq));
    }
    ::grpc::Status RenameTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest& request, ::google::cloud::bigquery::biglake::v1::Table* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>> AsyncRenameTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>>(AsyncRenameTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>> PrepareAsyncRenameTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>>(PrepareAsyncRenameTableRaw(context, request, cq));
    }
    ::grpc::Status GetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetTableRequest& request, ::google::cloud::bigquery::biglake::v1::Table* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>> AsyncGetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>>(AsyncGetTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>> PrepareAsyncGetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>>(PrepareAsyncGetTableRaw(context, request, cq));
    }
    ::grpc::Status ListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest& request, ::google::cloud::bigquery::biglake::v1::ListTablesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListTablesResponse>> AsyncListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListTablesResponse>>(AsyncListTablesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListTablesResponse>> PrepareAsyncListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListTablesResponse>>(PrepareAsyncListTablesRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response, std::function<void(::grpc::Status)>) override;
      void CreateCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response, std::function<void(::grpc::Status)>) override;
      void DeleteCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response, std::function<void(::grpc::Status)>) override;
      void GetCatalog(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListCatalogs(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest* request, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListCatalogs(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest* request, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response, std::function<void(::grpc::Status)>) override;
      void CreateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response, std::function<void(::grpc::Status)>) override;
      void DeleteDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response, std::function<void(::grpc::Status)>) override;
      void UpdateDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response, std::function<void(::grpc::Status)>) override;
      void GetDatabase(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListDatabases(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest* request, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListDatabases(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest* request, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, std::function<void(::grpc::Status)>) override;
      void CreateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, std::function<void(::grpc::Status)>) override;
      void DeleteTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, std::function<void(::grpc::Status)>) override;
      void UpdateTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RenameTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, std::function<void(::grpc::Status)>) override;
      void RenameTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, std::function<void(::grpc::Status)>) override;
      void GetTable(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest* request, ::google::cloud::bigquery::biglake::v1::ListTablesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTables(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest* request, ::google::cloud::bigquery::biglake::v1::ListTablesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>* AsyncCreateCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>* PrepareAsyncCreateCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>* AsyncDeleteCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>* PrepareAsyncDeleteCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>* AsyncGetCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Catalog>* PrepareAsyncGetCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>* AsyncListCatalogsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>* PrepareAsyncListCatalogsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>* AsyncCreateDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>* PrepareAsyncCreateDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>* AsyncDeleteDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>* PrepareAsyncDeleteDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>* AsyncUpdateDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>* PrepareAsyncUpdateDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>* AsyncGetDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Database>* PrepareAsyncGetDatabaseRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>* AsyncListDatabasesRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>* PrepareAsyncListDatabasesRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>* AsyncCreateTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>* PrepareAsyncCreateTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>* AsyncDeleteTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>* PrepareAsyncDeleteTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>* AsyncUpdateTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>* PrepareAsyncUpdateTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>* AsyncRenameTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>* PrepareAsyncRenameTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>* AsyncGetTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::Table>* PrepareAsyncGetTableRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::GetTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListTablesResponse>* AsyncListTablesRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::biglake::v1::ListTablesResponse>* PrepareAsyncListTablesRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCatalog_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteCatalog_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCatalog_;
    const ::grpc::internal::RpcMethod rpcmethod_ListCatalogs_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateDatabase_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteDatabase_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateDatabase_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDatabase_;
    const ::grpc::internal::RpcMethod rpcmethod_ListDatabases_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateTable_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTable_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateTable_;
    const ::grpc::internal::RpcMethod rpcmethod_RenameTable_;
    const ::grpc::internal::RpcMethod rpcmethod_GetTable_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTables_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a new catalog.
    virtual ::grpc::Status CreateCatalog(::grpc::ServerContext* context, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response);
    // Deletes an existing catalog specified by the catalog ID.
    virtual ::grpc::Status DeleteCatalog(::grpc::ServerContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response);
    // Gets the catalog specified by the resource name.
    virtual ::grpc::Status GetCatalog(::grpc::ServerContext* context, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response);
    // List all catalogs in a specified project.
    virtual ::grpc::Status ListCatalogs(::grpc::ServerContext* context, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest* request, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse* response);
    // Creates a new database.
    virtual ::grpc::Status CreateDatabase(::grpc::ServerContext* context, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response);
    // Deletes an existing database specified by the database ID.
    virtual ::grpc::Status DeleteDatabase(::grpc::ServerContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response);
    // Updates an existing database specified by the database ID.
    virtual ::grpc::Status UpdateDatabase(::grpc::ServerContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response);
    // Gets the database specified by the resource name.
    virtual ::grpc::Status GetDatabase(::grpc::ServerContext* context, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response);
    // List all databases in a specified catalog.
    virtual ::grpc::Status ListDatabases(::grpc::ServerContext* context, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest* request, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse* response);
    // Creates a new table.
    virtual ::grpc::Status CreateTable(::grpc::ServerContext* context, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response);
    // Deletes an existing table specified by the table ID.
    virtual ::grpc::Status DeleteTable(::grpc::ServerContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response);
    // Updates an existing table specified by the table ID.
    virtual ::grpc::Status UpdateTable(::grpc::ServerContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response);
    // Renames an existing table specified by the table ID.
    virtual ::grpc::Status RenameTable(::grpc::ServerContext* context, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response);
    // Gets the table specified by the resource name.
    virtual ::grpc::Status GetTable(::grpc::ServerContext* context, const ::google::cloud::bigquery::biglake::v1::GetTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response);
    // List all tables in a specified database.
    virtual ::grpc::Status ListTables(::grpc::ServerContext* context, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest* request, ::google::cloud::bigquery::biglake::v1::ListTablesResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCatalog() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCatalog(::grpc::ServerContext* context, ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::biglake::v1::Catalog>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteCatalog() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_DeleteCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCatalog(::grpc::ServerContext* context, ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::biglake::v1::Catalog>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCatalog() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCatalog(::grpc::ServerContext* context, ::google::cloud::bigquery::biglake::v1::GetCatalogRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::biglake::v1::Catalog>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListCatalogs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListCatalogs() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ListCatalogs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCatalogs(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCatalogs(::grpc::ServerContext* context, ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateDatabase() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_CreateDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDatabase(::grpc::ServerContext* context, ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::biglake::v1::Database>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteDatabase() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_DeleteDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDatabase(::grpc::ServerContext* context, ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::biglake::v1::Database>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateDatabase() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_UpdateDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDatabase(::grpc::ServerContext* context, ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::biglake::v1::Database>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDatabase() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDatabase(::grpc::ServerContext* context, ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::biglake::v1::Database>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListDatabases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListDatabases() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_ListDatabases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDatabases(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDatabases(::grpc::ServerContext* context, ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateTable() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_CreateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTable(::grpc::ServerContext* context, ::google::cloud::bigquery::biglake::v1::CreateTableRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::biglake::v1::Table>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTable() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_DeleteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTable(::grpc::ServerContext* context, ::google::cloud::bigquery::biglake::v1::DeleteTableRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::biglake::v1::Table>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateTable() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_UpdateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTable(::grpc::ServerContext* context, ::google::cloud::bigquery::biglake::v1::UpdateTableRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::biglake::v1::Table>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RenameTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RenameTable() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_RenameTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RenameTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRenameTable(::grpc::ServerContext* context, ::google::cloud::bigquery::biglake::v1::RenameTableRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::biglake::v1::Table>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetTable() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_GetTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTable(::grpc::ServerContext* context, ::google::cloud::bigquery::biglake::v1::GetTableRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::biglake::v1::Table>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTables() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_ListTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTables(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListTablesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTables(::grpc::ServerContext* context, ::google::cloud::bigquery::biglake::v1::ListTablesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::biglake::v1::ListTablesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateCatalog<WithAsyncMethod_DeleteCatalog<WithAsyncMethod_GetCatalog<WithAsyncMethod_ListCatalogs<WithAsyncMethod_CreateDatabase<WithAsyncMethod_DeleteDatabase<WithAsyncMethod_UpdateDatabase<WithAsyncMethod_GetDatabase<WithAsyncMethod_ListDatabases<WithAsyncMethod_CreateTable<WithAsyncMethod_DeleteTable<WithAsyncMethod_UpdateTable<WithAsyncMethod_RenameTable<WithAsyncMethod_GetTable<WithAsyncMethod_ListTables<Service > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCatalog() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest, ::google::cloud::bigquery::biglake::v1::Catalog>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response) { return this->CreateCatalog(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCatalog(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest, ::google::cloud::bigquery::biglake::v1::Catalog>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest, ::google::cloud::bigquery::biglake::v1::Catalog>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCatalog(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteCatalog() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest, ::google::cloud::bigquery::biglake::v1::Catalog>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response) { return this->DeleteCatalog(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteCatalog(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest, ::google::cloud::bigquery::biglake::v1::Catalog>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest, ::google::cloud::bigquery::biglake::v1::Catalog>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCatalog(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCatalog() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::GetCatalogRequest, ::google::cloud::bigquery::biglake::v1::Catalog>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest* request, ::google::cloud::bigquery::biglake::v1::Catalog* response) { return this->GetCatalog(context, request, response); }));}
    void SetMessageAllocatorFor_GetCatalog(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::biglake::v1::GetCatalogRequest, ::google::cloud::bigquery::biglake::v1::Catalog>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::GetCatalogRequest, ::google::cloud::bigquery::biglake::v1::Catalog>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCatalog(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListCatalogs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListCatalogs() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest* request, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse* response) { return this->ListCatalogs(context, request, response); }));}
    void SetMessageAllocatorFor_ListCatalogs(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListCatalogs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCatalogs(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCatalogs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateDatabase() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response) { return this->CreateDatabase(context, request, response); }));}
    void SetMessageAllocatorFor_CreateDatabase(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDatabase(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteDatabase() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response) { return this->DeleteDatabase(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteDatabase(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDatabase(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateDatabase() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response) { return this->UpdateDatabase(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateDatabase(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDatabase(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDatabase() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest* request, ::google::cloud::bigquery::biglake::v1::Database* response) { return this->GetDatabase(context, request, response); }));}
    void SetMessageAllocatorFor_GetDatabase(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDatabase(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListDatabases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListDatabases() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest* request, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse* response) { return this->ListDatabases(context, request, response); }));}
    void SetMessageAllocatorFor_ListDatabases(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListDatabases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDatabases(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDatabases(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateTable() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::CreateTableRequest, ::google::cloud::bigquery::biglake::v1::Table>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response) { return this->CreateTable(context, request, response); }));}
    void SetMessageAllocatorFor_CreateTable(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::biglake::v1::CreateTableRequest, ::google::cloud::bigquery::biglake::v1::Table>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::CreateTableRequest, ::google::cloud::bigquery::biglake::v1::Table>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTable(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTable() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::DeleteTableRequest, ::google::cloud::bigquery::biglake::v1::Table>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response) { return this->DeleteTable(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTable(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::biglake::v1::DeleteTableRequest, ::google::cloud::bigquery::biglake::v1::Table>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::DeleteTableRequest, ::google::cloud::bigquery::biglake::v1::Table>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTable(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateTable() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::UpdateTableRequest, ::google::cloud::bigquery::biglake::v1::Table>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response) { return this->UpdateTable(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateTable(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::biglake::v1::UpdateTableRequest, ::google::cloud::bigquery::biglake::v1::Table>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::UpdateTableRequest, ::google::cloud::bigquery::biglake::v1::Table>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTable(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RenameTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RenameTable() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::RenameTableRequest, ::google::cloud::bigquery::biglake::v1::Table>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response) { return this->RenameTable(context, request, response); }));}
    void SetMessageAllocatorFor_RenameTable(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::biglake::v1::RenameTableRequest, ::google::cloud::bigquery::biglake::v1::Table>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::RenameTableRequest, ::google::cloud::bigquery::biglake::v1::Table>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RenameTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RenameTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RenameTable(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetTable() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::GetTableRequest, ::google::cloud::bigquery::biglake::v1::Table>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::biglake::v1::GetTableRequest* request, ::google::cloud::bigquery::biglake::v1::Table* response) { return this->GetTable(context, request, response); }));}
    void SetMessageAllocatorFor_GetTable(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::biglake::v1::GetTableRequest, ::google::cloud::bigquery::biglake::v1::Table>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::GetTableRequest, ::google::cloud::bigquery::biglake::v1::Table>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTable(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTables() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::ListTablesRequest, ::google::cloud::bigquery::biglake::v1::ListTablesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest* request, ::google::cloud::bigquery::biglake::v1::ListTablesResponse* response) { return this->ListTables(context, request, response); }));}
    void SetMessageAllocatorFor_ListTables(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::biglake::v1::ListTablesRequest, ::google::cloud::bigquery::biglake::v1::ListTablesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::biglake::v1::ListTablesRequest, ::google::cloud::bigquery::biglake::v1::ListTablesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTables(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListTablesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTables(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListTablesResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateCatalog<WithCallbackMethod_DeleteCatalog<WithCallbackMethod_GetCatalog<WithCallbackMethod_ListCatalogs<WithCallbackMethod_CreateDatabase<WithCallbackMethod_DeleteDatabase<WithCallbackMethod_UpdateDatabase<WithCallbackMethod_GetDatabase<WithCallbackMethod_ListDatabases<WithCallbackMethod_CreateTable<WithCallbackMethod_DeleteTable<WithCallbackMethod_UpdateTable<WithCallbackMethod_RenameTable<WithCallbackMethod_GetTable<WithCallbackMethod_ListTables<Service > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCatalog() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteCatalog() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_DeleteCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCatalog() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListCatalogs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListCatalogs() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ListCatalogs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCatalogs(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateDatabase() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_CreateDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteDatabase() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_DeleteDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateDatabase() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_UpdateDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDatabase() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListDatabases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListDatabases() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_ListDatabases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDatabases(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateTable() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_CreateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTable() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_DeleteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateTable() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_UpdateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RenameTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RenameTable() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_RenameTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RenameTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetTable() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_GetTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTables() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_ListTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTables(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListTablesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCatalog() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCatalog(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteCatalog() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_DeleteCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCatalog(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCatalog() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCatalog(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListCatalogs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListCatalogs() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ListCatalogs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCatalogs(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCatalogs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateDatabase() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_CreateDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDatabase(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteDatabase() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_DeleteDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDatabase(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateDatabase() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_UpdateDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDatabase(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDatabase() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDatabase(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListDatabases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListDatabases() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_ListDatabases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDatabases(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDatabases(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateTable() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_CreateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTable(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTable() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_DeleteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTable(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateTable() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_UpdateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTable(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RenameTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RenameTable() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_RenameTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RenameTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRenameTable(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetTable() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_GetTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTable(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTables() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_ListTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTables(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListTablesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTables(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCatalog() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCatalog(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCatalog(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteCatalog() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteCatalog(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCatalog(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCatalog() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCatalog(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCatalog(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListCatalogs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListCatalogs() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListCatalogs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListCatalogs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCatalogs(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCatalogs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateDatabase() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateDatabase(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDatabase(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteDatabase() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteDatabase(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDatabase(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateDatabase() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateDatabase(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDatabase(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDatabase() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDatabase(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDatabase(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListDatabases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListDatabases() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListDatabases(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListDatabases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDatabases(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDatabases(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateTable() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateTable(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTable(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTable() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTable(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTable(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateTable() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateTable(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTable(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RenameTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RenameTable() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RenameTable(context, request, response); }));
    }
    ~WithRawCallbackMethod_RenameTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RenameTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RenameTable(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetTable() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetTable(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTable(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTables() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTables(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTables(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListTablesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTables(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCatalog() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest, ::google::cloud::bigquery::biglake::v1::Catalog>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest, ::google::cloud::bigquery::biglake::v1::Catalog>* streamer) {
                       return this->StreamedCreateCatalog(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCatalog(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::biglake::v1::CreateCatalogRequest,::google::cloud::bigquery::biglake::v1::Catalog>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteCatalog() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest, ::google::cloud::bigquery::biglake::v1::Catalog>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest, ::google::cloud::bigquery::biglake::v1::Catalog>* streamer) {
                       return this->StreamedDeleteCatalog(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteCatalog(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::biglake::v1::DeleteCatalogRequest,::google::cloud::bigquery::biglake::v1::Catalog>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCatalog() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::biglake::v1::GetCatalogRequest, ::google::cloud::bigquery::biglake::v1::Catalog>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::biglake::v1::GetCatalogRequest, ::google::cloud::bigquery::biglake::v1::Catalog>* streamer) {
                       return this->StreamedGetCatalog(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetCatalogRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Catalog* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCatalog(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::biglake::v1::GetCatalogRequest,::google::cloud::bigquery::biglake::v1::Catalog>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListCatalogs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListCatalogs() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>* streamer) {
                       return this->StreamedListCatalogs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListCatalogs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListCatalogs(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListCatalogsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListCatalogs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::biglake::v1::ListCatalogsRequest,::google::cloud::bigquery::biglake::v1::ListCatalogsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateDatabase() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>* streamer) {
                       return this->StreamedCreateDatabase(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateDatabase(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::biglake::v1::CreateDatabaseRequest,::google::cloud::bigquery::biglake::v1::Database>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteDatabase() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>* streamer) {
                       return this->StreamedDeleteDatabase(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteDatabase(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::biglake::v1::DeleteDatabaseRequest,::google::cloud::bigquery::biglake::v1::Database>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateDatabase() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>* streamer) {
                       return this->StreamedUpdateDatabase(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateDatabase(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::biglake::v1::UpdateDatabaseRequest,::google::cloud::bigquery::biglake::v1::Database>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDatabase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDatabase() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest, ::google::cloud::bigquery::biglake::v1::Database>* streamer) {
                       return this->StreamedGetDatabase(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDatabase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDatabase(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Database* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDatabase(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::biglake::v1::GetDatabaseRequest,::google::cloud::bigquery::biglake::v1::Database>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListDatabases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListDatabases() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>* streamer) {
                       return this->StreamedListDatabases(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListDatabases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListDatabases(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListDatabasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListDatabases(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::biglake::v1::ListDatabasesRequest,::google::cloud::bigquery::biglake::v1::ListDatabasesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateTable() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::biglake::v1::CreateTableRequest, ::google::cloud::bigquery::biglake::v1::Table>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::biglake::v1::CreateTableRequest, ::google::cloud::bigquery::biglake::v1::Table>* streamer) {
                       return this->StreamedCreateTable(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::CreateTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateTable(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::biglake::v1::CreateTableRequest,::google::cloud::bigquery::biglake::v1::Table>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTable() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::biglake::v1::DeleteTableRequest, ::google::cloud::bigquery::biglake::v1::Table>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::biglake::v1::DeleteTableRequest, ::google::cloud::bigquery::biglake::v1::Table>* streamer) {
                       return this->StreamedDeleteTable(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::DeleteTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTable(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::biglake::v1::DeleteTableRequest,::google::cloud::bigquery::biglake::v1::Table>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateTable() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::biglake::v1::UpdateTableRequest, ::google::cloud::bigquery::biglake::v1::Table>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::biglake::v1::UpdateTableRequest, ::google::cloud::bigquery::biglake::v1::Table>* streamer) {
                       return this->StreamedUpdateTable(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::UpdateTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateTable(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::biglake::v1::UpdateTableRequest,::google::cloud::bigquery::biglake::v1::Table>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RenameTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RenameTable() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::biglake::v1::RenameTableRequest, ::google::cloud::bigquery::biglake::v1::Table>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::biglake::v1::RenameTableRequest, ::google::cloud::bigquery::biglake::v1::Table>* streamer) {
                       return this->StreamedRenameTable(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RenameTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RenameTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::RenameTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRenameTable(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::biglake::v1::RenameTableRequest,::google::cloud::bigquery::biglake::v1::Table>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetTable() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::biglake::v1::GetTableRequest, ::google::cloud::bigquery::biglake::v1::Table>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::biglake::v1::GetTableRequest, ::google::cloud::bigquery::biglake::v1::Table>* streamer) {
                       return this->StreamedGetTable(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetTable(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::GetTableRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::Table* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetTable(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::biglake::v1::GetTableRequest,::google::cloud::bigquery::biglake::v1::Table>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTables() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::biglake::v1::ListTablesRequest, ::google::cloud::bigquery::biglake::v1::ListTablesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::biglake::v1::ListTablesRequest, ::google::cloud::bigquery::biglake::v1::ListTablesResponse>* streamer) {
                       return this->StreamedListTables(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTables(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::biglake::v1::ListTablesRequest* /*request*/, ::google::cloud::bigquery::biglake::v1::ListTablesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTables(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::biglake::v1::ListTablesRequest,::google::cloud::bigquery::biglake::v1::ListTablesResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateCatalog<WithStreamedUnaryMethod_DeleteCatalog<WithStreamedUnaryMethod_GetCatalog<WithStreamedUnaryMethod_ListCatalogs<WithStreamedUnaryMethod_CreateDatabase<WithStreamedUnaryMethod_DeleteDatabase<WithStreamedUnaryMethod_UpdateDatabase<WithStreamedUnaryMethod_GetDatabase<WithStreamedUnaryMethod_ListDatabases<WithStreamedUnaryMethod_CreateTable<WithStreamedUnaryMethod_DeleteTable<WithStreamedUnaryMethod_UpdateTable<WithStreamedUnaryMethod_RenameTable<WithStreamedUnaryMethod_GetTable<WithStreamedUnaryMethod_ListTables<Service > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateCatalog<WithStreamedUnaryMethod_DeleteCatalog<WithStreamedUnaryMethod_GetCatalog<WithStreamedUnaryMethod_ListCatalogs<WithStreamedUnaryMethod_CreateDatabase<WithStreamedUnaryMethod_DeleteDatabase<WithStreamedUnaryMethod_UpdateDatabase<WithStreamedUnaryMethod_GetDatabase<WithStreamedUnaryMethod_ListDatabases<WithStreamedUnaryMethod_CreateTable<WithStreamedUnaryMethod_DeleteTable<WithStreamedUnaryMethod_UpdateTable<WithStreamedUnaryMethod_RenameTable<WithStreamedUnaryMethod_GetTable<WithStreamedUnaryMethod_ListTables<Service > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace biglake
}  // namespace bigquery
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fbigquery_2fbiglake_2fv1_2fmetastore_2eproto__INCLUDED
