// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/bigquery/v2/job.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fbigquery_2fv2_2fjob_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fbigquery_2fv2_2fjob_2eproto__INCLUDED

#include "google/cloud/bigquery/v2/job.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace bigquery {
namespace v2 {

class JobService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.bigquery.v2.JobService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Requests that a job be cancelled. This call will return immediately, and
    // the client will need to poll for the job status to see if the cancel
    // completed successfully. Cancelled jobs may still incur costs.
    virtual ::grpc::Status CancelJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::CancelJobRequest& request, ::google::cloud::bigquery::v2::JobCancelResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::JobCancelResponse>> AsyncCancelJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::CancelJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::JobCancelResponse>>(AsyncCancelJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::JobCancelResponse>> PrepareAsyncCancelJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::CancelJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::JobCancelResponse>>(PrepareAsyncCancelJobRaw(context, request, cq));
    }
    // Returns information about a specific job. Job information is available for
    // a six month period after creation. Requires that you're the person who ran
    // the job, or have the Is Owner project role.
    virtual ::grpc::Status GetJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetJobRequest& request, ::google::cloud::bigquery::v2::Job* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Job>> AsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Job>>(AsyncGetJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Job>> PrepareAsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Job>>(PrepareAsyncGetJobRaw(context, request, cq));
    }
    // Starts a new asynchronous job.
    //
    // This API has two different kinds of endpoint URIs, as this method supports
    // a variety of use cases.
    //
    // * The *Metadata* URI is used for most interactions, as it accepts the job
    //   configuration directly.
    // * The *Upload* URI is ONLY for the case when you're sending both a load job
    //   configuration and a data stream together.  In this case, the Upload URI
    //   accepts the job configuration and the data as two distinct multipart MIME
    //   parts.
    virtual ::grpc::Status InsertJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertJobRequest& request, ::google::cloud::bigquery::v2::Job* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Job>> AsyncInsertJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Job>>(AsyncInsertJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Job>> PrepareAsyncInsertJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Job>>(PrepareAsyncInsertJobRaw(context, request, cq));
    }
    // Requests the deletion of the metadata of a job. This call returns when the
    // job's metadata is deleted.
    virtual ::grpc::Status DeleteJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteJobRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteJobRaw(context, request, cq));
    }
    // Lists all jobs that you started in the specified project. Job information
    // is available for a six month period after creation. The job list is sorted
    // in reverse chronological order, by job creation time. Requires the Can View
    // project role, or the Is Owner project role if you set the allUsers
    // property.
    virtual ::grpc::Status ListJobs(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListJobsRequest& request, ::google::cloud::bigquery::v2::JobList* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::JobList>> AsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::JobList>>(AsyncListJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::JobList>> PrepareAsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::JobList>>(PrepareAsyncListJobsRaw(context, request, cq));
    }
    // RPC to get the results of a query job.
    virtual ::grpc::Status GetQueryResults(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetQueryResultsRequest& request, ::google::cloud::bigquery::v2::GetQueryResultsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::GetQueryResultsResponse>> AsyncGetQueryResults(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetQueryResultsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::GetQueryResultsResponse>>(AsyncGetQueryResultsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::GetQueryResultsResponse>> PrepareAsyncGetQueryResults(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetQueryResultsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::GetQueryResultsResponse>>(PrepareAsyncGetQueryResultsRaw(context, request, cq));
    }
    // Runs a BigQuery SQL query synchronously and returns query results if the
    // query completes within a specified timeout.
    virtual ::grpc::Status Query(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::PostQueryRequest& request, ::google::cloud::bigquery::v2::QueryResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::QueryResponse>> AsyncQuery(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::PostQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::QueryResponse>>(AsyncQueryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::QueryResponse>> PrepareAsyncQuery(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::PostQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::QueryResponse>>(PrepareAsyncQueryRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Requests that a job be cancelled. This call will return immediately, and
      // the client will need to poll for the job status to see if the cancel
      // completed successfully. Cancelled jobs may still incur costs.
      virtual void CancelJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::CancelJobRequest* request, ::google::cloud::bigquery::v2::JobCancelResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CancelJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::CancelJobRequest* request, ::google::cloud::bigquery::v2::JobCancelResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns information about a specific job. Job information is available for
      // a six month period after creation. Requires that you're the person who ran
      // the job, or have the Is Owner project role.
      virtual void GetJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetJobRequest* request, ::google::cloud::bigquery::v2::Job* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetJobRequest* request, ::google::cloud::bigquery::v2::Job* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Starts a new asynchronous job.
      //
      // This API has two different kinds of endpoint URIs, as this method supports
      // a variety of use cases.
      //
      // * The *Metadata* URI is used for most interactions, as it accepts the job
      //   configuration directly.
      // * The *Upload* URI is ONLY for the case when you're sending both a load job
      //   configuration and a data stream together.  In this case, the Upload URI
      //   accepts the job configuration and the data as two distinct multipart MIME
      //   parts.
      virtual void InsertJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertJobRequest* request, ::google::cloud::bigquery::v2::Job* response, std::function<void(::grpc::Status)>) = 0;
      virtual void InsertJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertJobRequest* request, ::google::cloud::bigquery::v2::Job* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Requests the deletion of the metadata of a job. This call returns when the
      // job's metadata is deleted.
      virtual void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all jobs that you started in the specified project. Job information
      // is available for a six month period after creation. The job list is sorted
      // in reverse chronological order, by job creation time. Requires the Can View
      // project role, or the Is Owner project role if you set the allUsers
      // property.
      virtual void ListJobs(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListJobsRequest* request, ::google::cloud::bigquery::v2::JobList* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListJobs(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListJobsRequest* request, ::google::cloud::bigquery::v2::JobList* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // RPC to get the results of a query job.
      virtual void GetQueryResults(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetQueryResultsRequest* request, ::google::cloud::bigquery::v2::GetQueryResultsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetQueryResults(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetQueryResultsRequest* request, ::google::cloud::bigquery::v2::GetQueryResultsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Runs a BigQuery SQL query synchronously and returns query results if the
      // query completes within a specified timeout.
      virtual void Query(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::PostQueryRequest* request, ::google::cloud::bigquery::v2::QueryResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Query(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::PostQueryRequest* request, ::google::cloud::bigquery::v2::QueryResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::JobCancelResponse>* AsyncCancelJobRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::CancelJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::JobCancelResponse>* PrepareAsyncCancelJobRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::CancelJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Job>* AsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Job>* PrepareAsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Job>* AsyncInsertJobRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::Job>* PrepareAsyncInsertJobRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::JobList>* AsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::JobList>* PrepareAsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::GetQueryResultsResponse>* AsyncGetQueryResultsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetQueryResultsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::GetQueryResultsResponse>* PrepareAsyncGetQueryResultsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetQueryResultsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::QueryResponse>* AsyncQueryRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::PostQueryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::bigquery::v2::QueryResponse>* PrepareAsyncQueryRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::PostQueryRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CancelJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::CancelJobRequest& request, ::google::cloud::bigquery::v2::JobCancelResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::JobCancelResponse>> AsyncCancelJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::CancelJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::JobCancelResponse>>(AsyncCancelJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::JobCancelResponse>> PrepareAsyncCancelJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::CancelJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::JobCancelResponse>>(PrepareAsyncCancelJobRaw(context, request, cq));
    }
    ::grpc::Status GetJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetJobRequest& request, ::google::cloud::bigquery::v2::Job* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Job>> AsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Job>>(AsyncGetJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Job>> PrepareAsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Job>>(PrepareAsyncGetJobRaw(context, request, cq));
    }
    ::grpc::Status InsertJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertJobRequest& request, ::google::cloud::bigquery::v2::Job* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Job>> AsyncInsertJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Job>>(AsyncInsertJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Job>> PrepareAsyncInsertJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Job>>(PrepareAsyncInsertJobRaw(context, request, cq));
    }
    ::grpc::Status DeleteJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteJobRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteJobRaw(context, request, cq));
    }
    ::grpc::Status ListJobs(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListJobsRequest& request, ::google::cloud::bigquery::v2::JobList* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::JobList>> AsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::JobList>>(AsyncListJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::JobList>> PrepareAsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::JobList>>(PrepareAsyncListJobsRaw(context, request, cq));
    }
    ::grpc::Status GetQueryResults(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetQueryResultsRequest& request, ::google::cloud::bigquery::v2::GetQueryResultsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::GetQueryResultsResponse>> AsyncGetQueryResults(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetQueryResultsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::GetQueryResultsResponse>>(AsyncGetQueryResultsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::GetQueryResultsResponse>> PrepareAsyncGetQueryResults(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetQueryResultsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::GetQueryResultsResponse>>(PrepareAsyncGetQueryResultsRaw(context, request, cq));
    }
    ::grpc::Status Query(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::PostQueryRequest& request, ::google::cloud::bigquery::v2::QueryResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::QueryResponse>> AsyncQuery(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::PostQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::QueryResponse>>(AsyncQueryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::QueryResponse>> PrepareAsyncQuery(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::PostQueryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::QueryResponse>>(PrepareAsyncQueryRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CancelJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::CancelJobRequest* request, ::google::cloud::bigquery::v2::JobCancelResponse* response, std::function<void(::grpc::Status)>) override;
      void CancelJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::CancelJobRequest* request, ::google::cloud::bigquery::v2::JobCancelResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetJobRequest* request, ::google::cloud::bigquery::v2::Job* response, std::function<void(::grpc::Status)>) override;
      void GetJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetJobRequest* request, ::google::cloud::bigquery::v2::Job* response, ::grpc::ClientUnaryReactor* reactor) override;
      void InsertJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertJobRequest* request, ::google::cloud::bigquery::v2::Job* response, std::function<void(::grpc::Status)>) override;
      void InsertJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertJobRequest* request, ::google::cloud::bigquery::v2::Job* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListJobs(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListJobsRequest* request, ::google::cloud::bigquery::v2::JobList* response, std::function<void(::grpc::Status)>) override;
      void ListJobs(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListJobsRequest* request, ::google::cloud::bigquery::v2::JobList* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetQueryResults(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetQueryResultsRequest* request, ::google::cloud::bigquery::v2::GetQueryResultsResponse* response, std::function<void(::grpc::Status)>) override;
      void GetQueryResults(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetQueryResultsRequest* request, ::google::cloud::bigquery::v2::GetQueryResultsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void Query(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::PostQueryRequest* request, ::google::cloud::bigquery::v2::QueryResponse* response, std::function<void(::grpc::Status)>) override;
      void Query(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::PostQueryRequest* request, ::google::cloud::bigquery::v2::QueryResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::JobCancelResponse>* AsyncCancelJobRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::CancelJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::JobCancelResponse>* PrepareAsyncCancelJobRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::CancelJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Job>* AsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Job>* PrepareAsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Job>* AsyncInsertJobRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::Job>* PrepareAsyncInsertJobRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::InsertJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::JobList>* AsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::JobList>* PrepareAsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::ListJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::GetQueryResultsResponse>* AsyncGetQueryResultsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetQueryResultsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::GetQueryResultsResponse>* PrepareAsyncGetQueryResultsRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::GetQueryResultsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::QueryResponse>* AsyncQueryRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::PostQueryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::bigquery::v2::QueryResponse>* PrepareAsyncQueryRaw(::grpc::ClientContext* context, const ::google::cloud::bigquery::v2::PostQueryRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CancelJob_;
    const ::grpc::internal::RpcMethod rpcmethod_GetJob_;
    const ::grpc::internal::RpcMethod rpcmethod_InsertJob_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteJob_;
    const ::grpc::internal::RpcMethod rpcmethod_ListJobs_;
    const ::grpc::internal::RpcMethod rpcmethod_GetQueryResults_;
    const ::grpc::internal::RpcMethod rpcmethod_Query_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Requests that a job be cancelled. This call will return immediately, and
    // the client will need to poll for the job status to see if the cancel
    // completed successfully. Cancelled jobs may still incur costs.
    virtual ::grpc::Status CancelJob(::grpc::ServerContext* context, const ::google::cloud::bigquery::v2::CancelJobRequest* request, ::google::cloud::bigquery::v2::JobCancelResponse* response);
    // Returns information about a specific job. Job information is available for
    // a six month period after creation. Requires that you're the person who ran
    // the job, or have the Is Owner project role.
    virtual ::grpc::Status GetJob(::grpc::ServerContext* context, const ::google::cloud::bigquery::v2::GetJobRequest* request, ::google::cloud::bigquery::v2::Job* response);
    // Starts a new asynchronous job.
    //
    // This API has two different kinds of endpoint URIs, as this method supports
    // a variety of use cases.
    //
    // * The *Metadata* URI is used for most interactions, as it accepts the job
    //   configuration directly.
    // * The *Upload* URI is ONLY for the case when you're sending both a load job
    //   configuration and a data stream together.  In this case, the Upload URI
    //   accepts the job configuration and the data as two distinct multipart MIME
    //   parts.
    virtual ::grpc::Status InsertJob(::grpc::ServerContext* context, const ::google::cloud::bigquery::v2::InsertJobRequest* request, ::google::cloud::bigquery::v2::Job* response);
    // Requests the deletion of the metadata of a job. This call returns when the
    // job's metadata is deleted.
    virtual ::grpc::Status DeleteJob(::grpc::ServerContext* context, const ::google::cloud::bigquery::v2::DeleteJobRequest* request, ::google::protobuf::Empty* response);
    // Lists all jobs that you started in the specified project. Job information
    // is available for a six month period after creation. The job list is sorted
    // in reverse chronological order, by job creation time. Requires the Can View
    // project role, or the Is Owner project role if you set the allUsers
    // property.
    virtual ::grpc::Status ListJobs(::grpc::ServerContext* context, const ::google::cloud::bigquery::v2::ListJobsRequest* request, ::google::cloud::bigquery::v2::JobList* response);
    // RPC to get the results of a query job.
    virtual ::grpc::Status GetQueryResults(::grpc::ServerContext* context, const ::google::cloud::bigquery::v2::GetQueryResultsRequest* request, ::google::cloud::bigquery::v2::GetQueryResultsResponse* response);
    // Runs a BigQuery SQL query synchronously and returns query results if the
    // query completes within a specified timeout.
    virtual ::grpc::Status Query(::grpc::ServerContext* context, const ::google::cloud::bigquery::v2::PostQueryRequest* request, ::google::cloud::bigquery::v2::QueryResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CancelJob() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::CancelJobRequest* /*request*/, ::google::cloud::bigquery::v2::JobCancelResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelJob(::grpc::ServerContext* context, ::google::cloud::bigquery::v2::CancelJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::v2::JobCancelResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetJob() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetJobRequest* /*request*/, ::google::cloud::bigquery::v2::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJob(::grpc::ServerContext* context, ::google::cloud::bigquery::v2::GetJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::v2::Job>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_InsertJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_InsertJob() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_InsertJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InsertJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::InsertJobRequest* /*request*/, ::google::cloud::bigquery::v2::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInsertJob(::grpc::ServerContext* context, ::google::cloud::bigquery::v2::InsertJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::v2::Job>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteJob() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteJob(::grpc::ServerContext* context, ::google::cloud::bigquery::v2::DeleteJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListJobs() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::ListJobsRequest* /*request*/, ::google::cloud::bigquery::v2::JobList* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobs(::grpc::ServerContext* context, ::google::cloud::bigquery::v2::ListJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::v2::JobList>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetQueryResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetQueryResults() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_GetQueryResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetQueryResults(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetQueryResultsRequest* /*request*/, ::google::cloud::bigquery::v2::GetQueryResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetQueryResults(::grpc::ServerContext* context, ::google::cloud::bigquery::v2::GetQueryResultsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::v2::GetQueryResultsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Query : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Query() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_Query() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Query(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::PostQueryRequest* /*request*/, ::google::cloud::bigquery::v2::QueryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestQuery(::grpc::ServerContext* context, ::google::cloud::bigquery::v2::PostQueryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::bigquery::v2::QueryResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CancelJob<WithAsyncMethod_GetJob<WithAsyncMethod_InsertJob<WithAsyncMethod_DeleteJob<WithAsyncMethod_ListJobs<WithAsyncMethod_GetQueryResults<WithAsyncMethod_Query<Service > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CancelJob() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::CancelJobRequest, ::google::cloud::bigquery::v2::JobCancelResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::v2::CancelJobRequest* request, ::google::cloud::bigquery::v2::JobCancelResponse* response) { return this->CancelJob(context, request, response); }));}
    void SetMessageAllocatorFor_CancelJob(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::v2::CancelJobRequest, ::google::cloud::bigquery::v2::JobCancelResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::CancelJobRequest, ::google::cloud::bigquery::v2::JobCancelResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::CancelJobRequest* /*request*/, ::google::cloud::bigquery::v2::JobCancelResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::v2::CancelJobRequest* /*request*/, ::google::cloud::bigquery::v2::JobCancelResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetJob() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::GetJobRequest, ::google::cloud::bigquery::v2::Job>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::v2::GetJobRequest* request, ::google::cloud::bigquery::v2::Job* response) { return this->GetJob(context, request, response); }));}
    void SetMessageAllocatorFor_GetJob(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::v2::GetJobRequest, ::google::cloud::bigquery::v2::Job>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::GetJobRequest, ::google::cloud::bigquery::v2::Job>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetJobRequest* /*request*/, ::google::cloud::bigquery::v2::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetJobRequest* /*request*/, ::google::cloud::bigquery::v2::Job* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_InsertJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_InsertJob() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::InsertJobRequest, ::google::cloud::bigquery::v2::Job>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::v2::InsertJobRequest* request, ::google::cloud::bigquery::v2::Job* response) { return this->InsertJob(context, request, response); }));}
    void SetMessageAllocatorFor_InsertJob(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::v2::InsertJobRequest, ::google::cloud::bigquery::v2::Job>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::InsertJobRequest, ::google::cloud::bigquery::v2::Job>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_InsertJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InsertJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::InsertJobRequest* /*request*/, ::google::cloud::bigquery::v2::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* InsertJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::v2::InsertJobRequest* /*request*/, ::google::cloud::bigquery::v2::Job* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteJob() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::DeleteJobRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::v2::DeleteJobRequest* request, ::google::protobuf::Empty* response) { return this->DeleteJob(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteJob(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::v2::DeleteJobRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::DeleteJobRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::v2::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListJobs() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::ListJobsRequest, ::google::cloud::bigquery::v2::JobList>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::v2::ListJobsRequest* request, ::google::cloud::bigquery::v2::JobList* response) { return this->ListJobs(context, request, response); }));}
    void SetMessageAllocatorFor_ListJobs(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::v2::ListJobsRequest, ::google::cloud::bigquery::v2::JobList>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::ListJobsRequest, ::google::cloud::bigquery::v2::JobList>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::ListJobsRequest* /*request*/, ::google::cloud::bigquery::v2::JobList* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::v2::ListJobsRequest* /*request*/, ::google::cloud::bigquery::v2::JobList* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetQueryResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetQueryResults() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::GetQueryResultsRequest, ::google::cloud::bigquery::v2::GetQueryResultsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::v2::GetQueryResultsRequest* request, ::google::cloud::bigquery::v2::GetQueryResultsResponse* response) { return this->GetQueryResults(context, request, response); }));}
    void SetMessageAllocatorFor_GetQueryResults(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::v2::GetQueryResultsRequest, ::google::cloud::bigquery::v2::GetQueryResultsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::GetQueryResultsRequest, ::google::cloud::bigquery::v2::GetQueryResultsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetQueryResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetQueryResults(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetQueryResultsRequest* /*request*/, ::google::cloud::bigquery::v2::GetQueryResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetQueryResults(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetQueryResultsRequest* /*request*/, ::google::cloud::bigquery::v2::GetQueryResultsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Query : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Query() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::PostQueryRequest, ::google::cloud::bigquery::v2::QueryResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::bigquery::v2::PostQueryRequest* request, ::google::cloud::bigquery::v2::QueryResponse* response) { return this->Query(context, request, response); }));}
    void SetMessageAllocatorFor_Query(
        ::grpc::MessageAllocator< ::google::cloud::bigquery::v2::PostQueryRequest, ::google::cloud::bigquery::v2::QueryResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::bigquery::v2::PostQueryRequest, ::google::cloud::bigquery::v2::QueryResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Query() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Query(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::PostQueryRequest* /*request*/, ::google::cloud::bigquery::v2::QueryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Query(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::bigquery::v2::PostQueryRequest* /*request*/, ::google::cloud::bigquery::v2::QueryResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CancelJob<WithCallbackMethod_GetJob<WithCallbackMethod_InsertJob<WithCallbackMethod_DeleteJob<WithCallbackMethod_ListJobs<WithCallbackMethod_GetQueryResults<WithCallbackMethod_Query<Service > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CancelJob() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::CancelJobRequest* /*request*/, ::google::cloud::bigquery::v2::JobCancelResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetJob() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetJobRequest* /*request*/, ::google::cloud::bigquery::v2::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_InsertJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_InsertJob() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_InsertJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InsertJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::InsertJobRequest* /*request*/, ::google::cloud::bigquery::v2::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteJob() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListJobs() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::ListJobsRequest* /*request*/, ::google::cloud::bigquery::v2::JobList* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetQueryResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetQueryResults() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_GetQueryResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetQueryResults(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetQueryResultsRequest* /*request*/, ::google::cloud::bigquery::v2::GetQueryResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Query : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Query() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_Query() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Query(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::PostQueryRequest* /*request*/, ::google::cloud::bigquery::v2::QueryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CancelJob() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::CancelJobRequest* /*request*/, ::google::cloud::bigquery::v2::JobCancelResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetJob() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetJobRequest* /*request*/, ::google::cloud::bigquery::v2::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_InsertJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_InsertJob() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_InsertJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InsertJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::InsertJobRequest* /*request*/, ::google::cloud::bigquery::v2::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInsertJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteJob() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListJobs() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::ListJobsRequest* /*request*/, ::google::cloud::bigquery::v2::JobList* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetQueryResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetQueryResults() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_GetQueryResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetQueryResults(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetQueryResultsRequest* /*request*/, ::google::cloud::bigquery::v2::GetQueryResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetQueryResults(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Query : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Query() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_Query() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Query(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::PostQueryRequest* /*request*/, ::google::cloud::bigquery::v2::QueryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestQuery(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CancelJob() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CancelJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::CancelJobRequest* /*request*/, ::google::cloud::bigquery::v2::JobCancelResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetJob() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetJobRequest* /*request*/, ::google::cloud::bigquery::v2::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_InsertJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_InsertJob() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->InsertJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_InsertJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InsertJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::InsertJobRequest* /*request*/, ::google::cloud::bigquery::v2::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* InsertJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteJob() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListJobs() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::ListJobsRequest* /*request*/, ::google::cloud::bigquery::v2::JobList* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetQueryResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetQueryResults() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetQueryResults(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetQueryResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetQueryResults(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetQueryResultsRequest* /*request*/, ::google::cloud::bigquery::v2::GetQueryResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetQueryResults(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Query : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Query() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Query(context, request, response); }));
    }
    ~WithRawCallbackMethod_Query() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Query(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::PostQueryRequest* /*request*/, ::google::cloud::bigquery::v2::QueryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Query(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CancelJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CancelJob() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::v2::CancelJobRequest, ::google::cloud::bigquery::v2::JobCancelResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::v2::CancelJobRequest, ::google::cloud::bigquery::v2::JobCancelResponse>* streamer) {
                       return this->StreamedCancelJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CancelJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CancelJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::CancelJobRequest* /*request*/, ::google::cloud::bigquery::v2::JobCancelResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCancelJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::v2::CancelJobRequest,::google::cloud::bigquery::v2::JobCancelResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetJob() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::v2::GetJobRequest, ::google::cloud::bigquery::v2::Job>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::v2::GetJobRequest, ::google::cloud::bigquery::v2::Job>* streamer) {
                       return this->StreamedGetJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetJobRequest* /*request*/, ::google::cloud::bigquery::v2::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::v2::GetJobRequest,::google::cloud::bigquery::v2::Job>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_InsertJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_InsertJob() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::v2::InsertJobRequest, ::google::cloud::bigquery::v2::Job>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::v2::InsertJobRequest, ::google::cloud::bigquery::v2::Job>* streamer) {
                       return this->StreamedInsertJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_InsertJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status InsertJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::InsertJobRequest* /*request*/, ::google::cloud::bigquery::v2::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedInsertJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::v2::InsertJobRequest,::google::cloud::bigquery::v2::Job>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteJob() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::v2::DeleteJobRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::v2::DeleteJobRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::v2::DeleteJobRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListJobs() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::v2::ListJobsRequest, ::google::cloud::bigquery::v2::JobList>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::v2::ListJobsRequest, ::google::cloud::bigquery::v2::JobList>* streamer) {
                       return this->StreamedListJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::ListJobsRequest* /*request*/, ::google::cloud::bigquery::v2::JobList* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::v2::ListJobsRequest,::google::cloud::bigquery::v2::JobList>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetQueryResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetQueryResults() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::v2::GetQueryResultsRequest, ::google::cloud::bigquery::v2::GetQueryResultsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::v2::GetQueryResultsRequest, ::google::cloud::bigquery::v2::GetQueryResultsResponse>* streamer) {
                       return this->StreamedGetQueryResults(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetQueryResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetQueryResults(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::GetQueryResultsRequest* /*request*/, ::google::cloud::bigquery::v2::GetQueryResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetQueryResults(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::v2::GetQueryResultsRequest,::google::cloud::bigquery::v2::GetQueryResultsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Query : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Query() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::bigquery::v2::PostQueryRequest, ::google::cloud::bigquery::v2::QueryResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::bigquery::v2::PostQueryRequest, ::google::cloud::bigquery::v2::QueryResponse>* streamer) {
                       return this->StreamedQuery(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Query() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Query(::grpc::ServerContext* /*context*/, const ::google::cloud::bigquery::v2::PostQueryRequest* /*request*/, ::google::cloud::bigquery::v2::QueryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedQuery(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::bigquery::v2::PostQueryRequest,::google::cloud::bigquery::v2::QueryResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CancelJob<WithStreamedUnaryMethod_GetJob<WithStreamedUnaryMethod_InsertJob<WithStreamedUnaryMethod_DeleteJob<WithStreamedUnaryMethod_ListJobs<WithStreamedUnaryMethod_GetQueryResults<WithStreamedUnaryMethod_Query<Service > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CancelJob<WithStreamedUnaryMethod_GetJob<WithStreamedUnaryMethod_InsertJob<WithStreamedUnaryMethod_DeleteJob<WithStreamedUnaryMethod_ListJobs<WithStreamedUnaryMethod_GetQueryResults<WithStreamedUnaryMethod_Query<Service > > > > > > > StreamedService;
};

}  // namespace v2
}  // namespace bigquery
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fbigquery_2fv2_2fjob_2eproto__INCLUDED
