// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/binaryauthorization/v1/service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fbinaryauthorization_2fv1_2fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fbinaryauthorization_2fv1_2fservice_2eproto__INCLUDED

#include "google/cloud/binaryauthorization/v1/service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace binaryauthorization {
namespace v1 {

// Customer-facing API for Cloud Binary Authorization.
//
// Google Cloud Management Service for Binary Authorization admission policies
// and attestation authorities.
//
// This API implements a REST model with the following objects:
//
// * [Policy][google.cloud.binaryauthorization.v1.Policy]
// * [Attestor][google.cloud.binaryauthorization.v1.Attestor]
class BinauthzManagementServiceV1 final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.binaryauthorization.v1.BinauthzManagementServiceV1";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // A [policy][google.cloud.binaryauthorization.v1.Policy] specifies the [attestors][google.cloud.binaryauthorization.v1.Attestor] that must attest to
    // a container image, before the project is allowed to deploy that
    // image. There is at most one policy per project. All image admission
    // requests are permitted if a project has no policy.
    //
    // Gets the [policy][google.cloud.binaryauthorization.v1.Policy] for this project. Returns a default
    // [policy][google.cloud.binaryauthorization.v1.Policy] if the project does not have one.
    virtual ::grpc::Status GetPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest& request, ::google::cloud::binaryauthorization::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>> AsyncGetPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>>(AsyncGetPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>> PrepareAsyncGetPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>>(PrepareAsyncGetPolicyRaw(context, request, cq));
    }
    // Creates or updates a project's [policy][google.cloud.binaryauthorization.v1.Policy], and returns a copy of the
    // new [policy][google.cloud.binaryauthorization.v1.Policy]. A policy is always updated as a whole, to avoid race
    // conditions with concurrent policy enforcement (or management!)
    // requests. Returns NOT_FOUND if the project does not exist, INVALID_ARGUMENT
    // if the request is malformed.
    virtual ::grpc::Status UpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest& request, ::google::cloud::binaryauthorization::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>> AsyncUpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>>(AsyncUpdatePolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>> PrepareAsyncUpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>>(PrepareAsyncUpdatePolicyRaw(context, request, cq));
    }
    // Creates an [attestor][google.cloud.binaryauthorization.v1.Attestor], and returns a copy of the new
    // [attestor][google.cloud.binaryauthorization.v1.Attestor]. Returns NOT_FOUND if the project does not exist,
    // INVALID_ARGUMENT if the request is malformed, ALREADY_EXISTS if the
    // [attestor][google.cloud.binaryauthorization.v1.Attestor] already exists.
    virtual ::grpc::Status CreateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest& request, ::google::cloud::binaryauthorization::v1::Attestor* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>> AsyncCreateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>>(AsyncCreateAttestorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>> PrepareAsyncCreateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>>(PrepareAsyncCreateAttestorRaw(context, request, cq));
    }
    // Gets an [attestor][google.cloud.binaryauthorization.v1.Attestor].
    // Returns NOT_FOUND if the [attestor][google.cloud.binaryauthorization.v1.Attestor] does not exist.
    virtual ::grpc::Status GetAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest& request, ::google::cloud::binaryauthorization::v1::Attestor* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>> AsyncGetAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>>(AsyncGetAttestorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>> PrepareAsyncGetAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>>(PrepareAsyncGetAttestorRaw(context, request, cq));
    }
    // Updates an [attestor][google.cloud.binaryauthorization.v1.Attestor].
    // Returns NOT_FOUND if the [attestor][google.cloud.binaryauthorization.v1.Attestor] does not exist.
    virtual ::grpc::Status UpdateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest& request, ::google::cloud::binaryauthorization::v1::Attestor* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>> AsyncUpdateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>>(AsyncUpdateAttestorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>> PrepareAsyncUpdateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>>(PrepareAsyncUpdateAttestorRaw(context, request, cq));
    }
    // Lists [attestors][google.cloud.binaryauthorization.v1.Attestor].
    // Returns INVALID_ARGUMENT if the project does not exist.
    virtual ::grpc::Status ListAttestors(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest& request, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>> AsyncListAttestors(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>>(AsyncListAttestorsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>> PrepareAsyncListAttestors(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>>(PrepareAsyncListAttestorsRaw(context, request, cq));
    }
    // Deletes an [attestor][google.cloud.binaryauthorization.v1.Attestor]. Returns NOT_FOUND if the
    // [attestor][google.cloud.binaryauthorization.v1.Attestor] does not exist.
    virtual ::grpc::Status DeleteAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteAttestorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteAttestorRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // A [policy][google.cloud.binaryauthorization.v1.Policy] specifies the [attestors][google.cloud.binaryauthorization.v1.Attestor] that must attest to
      // a container image, before the project is allowed to deploy that
      // image. There is at most one policy per project. All image admission
      // requests are permitted if a project has no policy.
      //
      // Gets the [policy][google.cloud.binaryauthorization.v1.Policy] for this project. Returns a default
      // [policy][google.cloud.binaryauthorization.v1.Policy] if the project does not have one.
      virtual void GetPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates or updates a project's [policy][google.cloud.binaryauthorization.v1.Policy], and returns a copy of the
      // new [policy][google.cloud.binaryauthorization.v1.Policy]. A policy is always updated as a whole, to avoid race
      // conditions with concurrent policy enforcement (or management!)
      // requests. Returns NOT_FOUND if the project does not exist, INVALID_ARGUMENT
      // if the request is malformed.
      virtual void UpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an [attestor][google.cloud.binaryauthorization.v1.Attestor], and returns a copy of the new
      // [attestor][google.cloud.binaryauthorization.v1.Attestor]. Returns NOT_FOUND if the project does not exist,
      // INVALID_ARGUMENT if the request is malformed, ALREADY_EXISTS if the
      // [attestor][google.cloud.binaryauthorization.v1.Attestor] already exists.
      virtual void CreateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets an [attestor][google.cloud.binaryauthorization.v1.Attestor].
      // Returns NOT_FOUND if the [attestor][google.cloud.binaryauthorization.v1.Attestor] does not exist.
      virtual void GetAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an [attestor][google.cloud.binaryauthorization.v1.Attestor].
      // Returns NOT_FOUND if the [attestor][google.cloud.binaryauthorization.v1.Attestor] does not exist.
      virtual void UpdateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists [attestors][google.cloud.binaryauthorization.v1.Attestor].
      // Returns INVALID_ARGUMENT if the project does not exist.
      virtual void ListAttestors(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest* request, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAttestors(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest* request, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an [attestor][google.cloud.binaryauthorization.v1.Attestor]. Returns NOT_FOUND if the
      // [attestor][google.cloud.binaryauthorization.v1.Attestor] does not exist.
      virtual void DeleteAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>* AsyncGetPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>* PrepareAsyncGetPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>* AsyncUpdatePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>* PrepareAsyncUpdatePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>* AsyncCreateAttestorRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>* PrepareAsyncCreateAttestorRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>* AsyncGetAttestorRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>* PrepareAsyncGetAttestorRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>* AsyncUpdateAttestorRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Attestor>* PrepareAsyncUpdateAttestorRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>* AsyncListAttestorsRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>* PrepareAsyncListAttestorsRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteAttestorRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteAttestorRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status GetPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest& request, ::google::cloud::binaryauthorization::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>> AsyncGetPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>>(AsyncGetPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>> PrepareAsyncGetPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>>(PrepareAsyncGetPolicyRaw(context, request, cq));
    }
    ::grpc::Status UpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest& request, ::google::cloud::binaryauthorization::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>> AsyncUpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>>(AsyncUpdatePolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>> PrepareAsyncUpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>>(PrepareAsyncUpdatePolicyRaw(context, request, cq));
    }
    ::grpc::Status CreateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest& request, ::google::cloud::binaryauthorization::v1::Attestor* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>> AsyncCreateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>>(AsyncCreateAttestorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>> PrepareAsyncCreateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>>(PrepareAsyncCreateAttestorRaw(context, request, cq));
    }
    ::grpc::Status GetAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest& request, ::google::cloud::binaryauthorization::v1::Attestor* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>> AsyncGetAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>>(AsyncGetAttestorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>> PrepareAsyncGetAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>>(PrepareAsyncGetAttestorRaw(context, request, cq));
    }
    ::grpc::Status UpdateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest& request, ::google::cloud::binaryauthorization::v1::Attestor* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>> AsyncUpdateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>>(AsyncUpdateAttestorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>> PrepareAsyncUpdateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>>(PrepareAsyncUpdateAttestorRaw(context, request, cq));
    }
    ::grpc::Status ListAttestors(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest& request, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>> AsyncListAttestors(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>>(AsyncListAttestorsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>> PrepareAsyncListAttestors(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>>(PrepareAsyncListAttestorsRaw(context, request, cq));
    }
    ::grpc::Status DeleteAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteAttestorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteAttestorRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void GetPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void GetPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void UpdatePolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response, std::function<void(::grpc::Status)>) override;
      void CreateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response, std::function<void(::grpc::Status)>) override;
      void GetAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response, std::function<void(::grpc::Status)>) override;
      void UpdateAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListAttestors(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest* request, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAttestors(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest* request, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteAttestor(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>* AsyncGetPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>* PrepareAsyncGetPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>* AsyncUpdatePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>* PrepareAsyncUpdatePolicyRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>* AsyncCreateAttestorRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>* PrepareAsyncCreateAttestorRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>* AsyncGetAttestorRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>* PrepareAsyncGetAttestorRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>* AsyncUpdateAttestorRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Attestor>* PrepareAsyncUpdateAttestorRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>* AsyncListAttestorsRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>* PrepareAsyncListAttestorsRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteAttestorRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteAttestorRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_GetPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdatePolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateAttestor_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAttestor_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateAttestor_;
    const ::grpc::internal::RpcMethod rpcmethod_ListAttestors_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAttestor_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // A [policy][google.cloud.binaryauthorization.v1.Policy] specifies the [attestors][google.cloud.binaryauthorization.v1.Attestor] that must attest to
    // a container image, before the project is allowed to deploy that
    // image. There is at most one policy per project. All image admission
    // requests are permitted if a project has no policy.
    //
    // Gets the [policy][google.cloud.binaryauthorization.v1.Policy] for this project. Returns a default
    // [policy][google.cloud.binaryauthorization.v1.Policy] if the project does not have one.
    virtual ::grpc::Status GetPolicy(::grpc::ServerContext* context, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response);
    // Creates or updates a project's [policy][google.cloud.binaryauthorization.v1.Policy], and returns a copy of the
    // new [policy][google.cloud.binaryauthorization.v1.Policy]. A policy is always updated as a whole, to avoid race
    // conditions with concurrent policy enforcement (or management!)
    // requests. Returns NOT_FOUND if the project does not exist, INVALID_ARGUMENT
    // if the request is malformed.
    virtual ::grpc::Status UpdatePolicy(::grpc::ServerContext* context, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response);
    // Creates an [attestor][google.cloud.binaryauthorization.v1.Attestor], and returns a copy of the new
    // [attestor][google.cloud.binaryauthorization.v1.Attestor]. Returns NOT_FOUND if the project does not exist,
    // INVALID_ARGUMENT if the request is malformed, ALREADY_EXISTS if the
    // [attestor][google.cloud.binaryauthorization.v1.Attestor] already exists.
    virtual ::grpc::Status CreateAttestor(::grpc::ServerContext* context, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response);
    // Gets an [attestor][google.cloud.binaryauthorization.v1.Attestor].
    // Returns NOT_FOUND if the [attestor][google.cloud.binaryauthorization.v1.Attestor] does not exist.
    virtual ::grpc::Status GetAttestor(::grpc::ServerContext* context, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response);
    // Updates an [attestor][google.cloud.binaryauthorization.v1.Attestor].
    // Returns NOT_FOUND if the [attestor][google.cloud.binaryauthorization.v1.Attestor] does not exist.
    virtual ::grpc::Status UpdateAttestor(::grpc::ServerContext* context, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response);
    // Lists [attestors][google.cloud.binaryauthorization.v1.Attestor].
    // Returns INVALID_ARGUMENT if the project does not exist.
    virtual ::grpc::Status ListAttestors(::grpc::ServerContext* context, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest* request, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse* response);
    // Deletes an [attestor][google.cloud.binaryauthorization.v1.Attestor]. Returns NOT_FOUND if the
    // [attestor][google.cloud.binaryauthorization.v1.Attestor] does not exist.
    virtual ::grpc::Status DeleteAttestor(::grpc::ServerContext* context, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest* request, ::google::protobuf::Empty* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPolicy() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_GetPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPolicy(::grpc::ServerContext* context, ::google::cloud::binaryauthorization::v1::GetPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::binaryauthorization::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdatePolicy() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_UpdatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePolicy(::grpc::ServerContext* context, ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::binaryauthorization::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateAttestor() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAttestor(::grpc::ServerContext* context, ::google::cloud::binaryauthorization::v1::CreateAttestorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::binaryauthorization::v1::Attestor>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAttestor() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_GetAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAttestor(::grpc::ServerContext* context, ::google::cloud::binaryauthorization::v1::GetAttestorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::binaryauthorization::v1::Attestor>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateAttestor() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAttestor(::grpc::ServerContext* context, ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::binaryauthorization::v1::Attestor>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAttestors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAttestors() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListAttestors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAttestors(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest* /*request*/, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAttestors(::grpc::ServerContext* context, ::google::cloud::binaryauthorization::v1::ListAttestorsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAttestor() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_DeleteAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAttestor(::grpc::ServerContext* context, ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_GetPolicy<WithAsyncMethod_UpdatePolicy<WithAsyncMethod_CreateAttestor<WithAsyncMethod_GetAttestor<WithAsyncMethod_UpdateAttestor<WithAsyncMethod_ListAttestors<WithAsyncMethod_DeleteAttestor<Service > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_GetPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPolicy() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::GetPolicyRequest, ::google::cloud::binaryauthorization::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response) { return this->GetPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetPolicy(
        ::grpc::MessageAllocator< ::google::cloud::binaryauthorization::v1::GetPolicyRequest, ::google::cloud::binaryauthorization::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::GetPolicyRequest, ::google::cloud::binaryauthorization::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdatePolicy() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest, ::google::cloud::binaryauthorization::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response) { return this->UpdatePolicy(context, request, response); }));}
    void SetMessageAllocatorFor_UpdatePolicy(
        ::grpc::MessageAllocator< ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest, ::google::cloud::binaryauthorization::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest, ::google::cloud::binaryauthorization::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateAttestor() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::CreateAttestorRequest, ::google::cloud::binaryauthorization::v1::Attestor>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response) { return this->CreateAttestor(context, request, response); }));}
    void SetMessageAllocatorFor_CreateAttestor(
        ::grpc::MessageAllocator< ::google::cloud::binaryauthorization::v1::CreateAttestorRequest, ::google::cloud::binaryauthorization::v1::Attestor>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::CreateAttestorRequest, ::google::cloud::binaryauthorization::v1::Attestor>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAttestor(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAttestor() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::GetAttestorRequest, ::google::cloud::binaryauthorization::v1::Attestor>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response) { return this->GetAttestor(context, request, response); }));}
    void SetMessageAllocatorFor_GetAttestor(
        ::grpc::MessageAllocator< ::google::cloud::binaryauthorization::v1::GetAttestorRequest, ::google::cloud::binaryauthorization::v1::Attestor>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::GetAttestorRequest, ::google::cloud::binaryauthorization::v1::Attestor>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAttestor(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateAttestor() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest, ::google::cloud::binaryauthorization::v1::Attestor>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest* request, ::google::cloud::binaryauthorization::v1::Attestor* response) { return this->UpdateAttestor(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateAttestor(
        ::grpc::MessageAllocator< ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest, ::google::cloud::binaryauthorization::v1::Attestor>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest, ::google::cloud::binaryauthorization::v1::Attestor>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAttestor(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListAttestors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAttestors() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::ListAttestorsRequest, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest* request, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse* response) { return this->ListAttestors(context, request, response); }));}
    void SetMessageAllocatorFor_ListAttestors(
        ::grpc::MessageAllocator< ::google::cloud::binaryauthorization::v1::ListAttestorsRequest, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::ListAttestorsRequest, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAttestors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAttestors(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest* /*request*/, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAttestors(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest* /*request*/, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteAttestor() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest* request, ::google::protobuf::Empty* response) { return this->DeleteAttestor(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAttestor(
        ::grpc::MessageAllocator< ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAttestor(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_GetPolicy<WithCallbackMethod_UpdatePolicy<WithCallbackMethod_CreateAttestor<WithCallbackMethod_GetAttestor<WithCallbackMethod_UpdateAttestor<WithCallbackMethod_ListAttestors<WithCallbackMethod_DeleteAttestor<Service > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_GetPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPolicy() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_GetPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdatePolicy() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_UpdatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateAttestor() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAttestor() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_GetAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateAttestor() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListAttestors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAttestors() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListAttestors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAttestors(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest* /*request*/, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAttestor() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_DeleteAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPolicy() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_GetPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdatePolicy() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_UpdatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateAttestor() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAttestor(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAttestor() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_GetAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAttestor(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateAttestor() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAttestor(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAttestors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAttestors() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListAttestors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAttestors(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest* /*request*/, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAttestors(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAttestor() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_DeleteAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAttestor(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPolicy() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdatePolicy() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdatePolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateAttestor() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateAttestor(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAttestor(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAttestor() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAttestor(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAttestor(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateAttestor() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateAttestor(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAttestor(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAttestors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAttestors() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAttestors(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAttestors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAttestors(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest* /*request*/, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAttestors(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteAttestor() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAttestor(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAttestor(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPolicy() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::binaryauthorization::v1::GetPolicyRequest, ::google::cloud::binaryauthorization::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::binaryauthorization::v1::GetPolicyRequest, ::google::cloud::binaryauthorization::v1::Policy>* streamer) {
                       return this->StreamedGetPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetPolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::binaryauthorization::v1::GetPolicyRequest,::google::cloud::binaryauthorization::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdatePolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdatePolicy() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest, ::google::cloud::binaryauthorization::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest, ::google::cloud::binaryauthorization::v1::Policy>* streamer) {
                       return this->StreamedUpdatePolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdatePolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdatePolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdatePolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::binaryauthorization::v1::UpdatePolicyRequest,::google::cloud::binaryauthorization::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateAttestor() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::binaryauthorization::v1::CreateAttestorRequest, ::google::cloud::binaryauthorization::v1::Attestor>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::binaryauthorization::v1::CreateAttestorRequest, ::google::cloud::binaryauthorization::v1::Attestor>* streamer) {
                       return this->StreamedCreateAttestor(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::CreateAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateAttestor(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::binaryauthorization::v1::CreateAttestorRequest,::google::cloud::binaryauthorization::v1::Attestor>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAttestor() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::binaryauthorization::v1::GetAttestorRequest, ::google::cloud::binaryauthorization::v1::Attestor>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::binaryauthorization::v1::GetAttestorRequest, ::google::cloud::binaryauthorization::v1::Attestor>* streamer) {
                       return this->StreamedGetAttestor(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAttestor(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::binaryauthorization::v1::GetAttestorRequest,::google::cloud::binaryauthorization::v1::Attestor>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateAttestor() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest, ::google::cloud::binaryauthorization::v1::Attestor>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest, ::google::cloud::binaryauthorization::v1::Attestor>* streamer) {
                       return this->StreamedUpdateAttestor(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Attestor* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateAttestor(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::binaryauthorization::v1::UpdateAttestorRequest,::google::cloud::binaryauthorization::v1::Attestor>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAttestors : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAttestors() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::binaryauthorization::v1::ListAttestorsRequest, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::binaryauthorization::v1::ListAttestorsRequest, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse>* streamer) {
                       return this->StreamedListAttestors(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAttestors() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAttestors(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::ListAttestorsRequest* /*request*/, ::google::cloud::binaryauthorization::v1::ListAttestorsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAttestors(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::binaryauthorization::v1::ListAttestorsRequest,::google::cloud::binaryauthorization::v1::ListAttestorsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAttestor : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAttestor() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteAttestor(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAttestor() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAttestor(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAttestor(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::binaryauthorization::v1::DeleteAttestorRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_GetPolicy<WithStreamedUnaryMethod_UpdatePolicy<WithStreamedUnaryMethod_CreateAttestor<WithStreamedUnaryMethod_GetAttestor<WithStreamedUnaryMethod_UpdateAttestor<WithStreamedUnaryMethod_ListAttestors<WithStreamedUnaryMethod_DeleteAttestor<Service > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_GetPolicy<WithStreamedUnaryMethod_UpdatePolicy<WithStreamedUnaryMethod_CreateAttestor<WithStreamedUnaryMethod_GetAttestor<WithStreamedUnaryMethod_UpdateAttestor<WithStreamedUnaryMethod_ListAttestors<WithStreamedUnaryMethod_DeleteAttestor<Service > > > > > > > StreamedService;
};

// API for working with the system policy.
class SystemPolicyV1 final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.binaryauthorization.v1.SystemPolicyV1";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Gets the current system policy in the specified location.
    virtual ::grpc::Status GetSystemPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest& request, ::google::cloud::binaryauthorization::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>> AsyncGetSystemPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>>(AsyncGetSystemPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>> PrepareAsyncGetSystemPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>>(PrepareAsyncGetSystemPolicyRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Gets the current system policy in the specified location.
      virtual void GetSystemPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetSystemPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>* AsyncGetSystemPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::Policy>* PrepareAsyncGetSystemPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status GetSystemPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest& request, ::google::cloud::binaryauthorization::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>> AsyncGetSystemPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>>(AsyncGetSystemPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>> PrepareAsyncGetSystemPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>>(PrepareAsyncGetSystemPolicyRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void GetSystemPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void GetSystemPolicy(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>* AsyncGetSystemPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::Policy>* PrepareAsyncGetSystemPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_GetSystemPolicy_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Gets the current system policy in the specified location.
    virtual ::grpc::Status GetSystemPolicy(::grpc::ServerContext* context, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_GetSystemPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetSystemPolicy() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_GetSystemPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSystemPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSystemPolicy(::grpc::ServerContext* context, ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::binaryauthorization::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_GetSystemPolicy<Service > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_GetSystemPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetSystemPolicy() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest, ::google::cloud::binaryauthorization::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest* request, ::google::cloud::binaryauthorization::v1::Policy* response) { return this->GetSystemPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetSystemPolicy(
        ::grpc::MessageAllocator< ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest, ::google::cloud::binaryauthorization::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest, ::google::cloud::binaryauthorization::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetSystemPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSystemPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSystemPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_GetSystemPolicy<Service > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_GetSystemPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetSystemPolicy() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_GetSystemPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSystemPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetSystemPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetSystemPolicy() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_GetSystemPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSystemPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSystemPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetSystemPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetSystemPolicy() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetSystemPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetSystemPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSystemPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSystemPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetSystemPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetSystemPolicy() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest, ::google::cloud::binaryauthorization::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest, ::google::cloud::binaryauthorization::v1::Policy>* streamer) {
                       return this->StreamedGetSystemPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetSystemPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetSystemPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest* /*request*/, ::google::cloud::binaryauthorization::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetSystemPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::binaryauthorization::v1::GetSystemPolicyRequest,::google::cloud::binaryauthorization::v1::Policy>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_GetSystemPolicy<Service > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_GetSystemPolicy<Service > StreamedService;
};

// BinAuthz Attestor verification
class ValidationHelperV1 final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.binaryauthorization.v1.ValidationHelperV1";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Returns whether the given Attestation for the given image URI
    // was signed by the given Attestor
    virtual ::grpc::Status ValidateAttestationOccurrence(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest& request, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>> AsyncValidateAttestationOccurrence(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>>(AsyncValidateAttestationOccurrenceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>> PrepareAsyncValidateAttestationOccurrence(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>>(PrepareAsyncValidateAttestationOccurrenceRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Returns whether the given Attestation for the given image URI
      // was signed by the given Attestor
      virtual void ValidateAttestationOccurrence(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest* request, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ValidateAttestationOccurrence(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest* request, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>* AsyncValidateAttestationOccurrenceRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>* PrepareAsyncValidateAttestationOccurrenceRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ValidateAttestationOccurrence(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest& request, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>> AsyncValidateAttestationOccurrence(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>>(AsyncValidateAttestationOccurrenceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>> PrepareAsyncValidateAttestationOccurrence(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>>(PrepareAsyncValidateAttestationOccurrenceRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ValidateAttestationOccurrence(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest* request, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse* response, std::function<void(::grpc::Status)>) override;
      void ValidateAttestationOccurrence(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest* request, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>* AsyncValidateAttestationOccurrenceRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>* PrepareAsyncValidateAttestationOccurrenceRaw(::grpc::ClientContext* context, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ValidateAttestationOccurrence_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Returns whether the given Attestation for the given image URI
    // was signed by the given Attestor
    virtual ::grpc::Status ValidateAttestationOccurrence(::grpc::ServerContext* context, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest* request, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ValidateAttestationOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ValidateAttestationOccurrence() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ValidateAttestationOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ValidateAttestationOccurrence(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest* /*request*/, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestValidateAttestationOccurrence(::grpc::ServerContext* context, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ValidateAttestationOccurrence<Service > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ValidateAttestationOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ValidateAttestationOccurrence() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest* request, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse* response) { return this->ValidateAttestationOccurrence(context, request, response); }));}
    void SetMessageAllocatorFor_ValidateAttestationOccurrence(
        ::grpc::MessageAllocator< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ValidateAttestationOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ValidateAttestationOccurrence(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest* /*request*/, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ValidateAttestationOccurrence(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest* /*request*/, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ValidateAttestationOccurrence<Service > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ValidateAttestationOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ValidateAttestationOccurrence() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ValidateAttestationOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ValidateAttestationOccurrence(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest* /*request*/, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ValidateAttestationOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ValidateAttestationOccurrence() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ValidateAttestationOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ValidateAttestationOccurrence(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest* /*request*/, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestValidateAttestationOccurrence(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ValidateAttestationOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ValidateAttestationOccurrence() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ValidateAttestationOccurrence(context, request, response); }));
    }
    ~WithRawCallbackMethod_ValidateAttestationOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ValidateAttestationOccurrence(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest* /*request*/, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ValidateAttestationOccurrence(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ValidateAttestationOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ValidateAttestationOccurrence() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>* streamer) {
                       return this->StreamedValidateAttestationOccurrence(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ValidateAttestationOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ValidateAttestationOccurrence(::grpc::ServerContext* /*context*/, const ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest* /*request*/, ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedValidateAttestationOccurrence(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceRequest,::google::cloud::binaryauthorization::v1::ValidateAttestationOccurrenceResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ValidateAttestationOccurrence<Service > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ValidateAttestationOccurrence<Service > StreamedService;
};

}  // namespace v1
}  // namespace binaryauthorization
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fbinaryauthorization_2fv1_2fservice_2eproto__INCLUDED
