// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/health_checks/v1/health_checks.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_HEALTH_CHECKS_V1_HEALTH_CHECKS_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_HEALTH_CHECKS_V1_HEALTH_CHECKS_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/health_checks/v1/health_checks.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_health_checks_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class HealthChecksConnectionIdempotencyPolicy {
 public:
  virtual ~HealthChecksConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<HealthChecksConnectionIdempotencyPolicy> clone()
      const;

  virtual google::cloud::Idempotency AggregatedListHealthChecks(
      google::cloud::cpp::compute::health_checks::v1::
          AggregatedListHealthChecksRequest request);

  virtual google::cloud::Idempotency DeleteHealthCheck(
      google::cloud::cpp::compute::health_checks::v1::
          DeleteHealthCheckRequest const& request);

  virtual google::cloud::Idempotency GetHealthCheck(
      google::cloud::cpp::compute::health_checks::v1::
          GetHealthCheckRequest const& request);

  virtual google::cloud::Idempotency InsertHealthCheck(
      google::cloud::cpp::compute::health_checks::v1::
          InsertHealthCheckRequest const& request);

  virtual google::cloud::Idempotency ListHealthChecks(
      google::cloud::cpp::compute::health_checks::v1::ListHealthChecksRequest
          request);

  virtual google::cloud::Idempotency PatchHealthCheck(
      google::cloud::cpp::compute::health_checks::v1::
          PatchHealthCheckRequest const& request);

  virtual google::cloud::Idempotency UpdateHealthCheck(
      google::cloud::cpp::compute::health_checks::v1::
          UpdateHealthCheckRequest const& request);
};

std::unique_ptr<HealthChecksConnectionIdempotencyPolicy>
MakeDefaultHealthChecksConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_health_checks_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_HEALTH_CHECKS_V1_HEALTH_CHECKS_CONNECTION_IDEMPOTENCY_POLICY_H
