// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/region_url_maps/v1/region_url_maps.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_URL_MAPS_V1_REGION_URL_MAPS_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_URL_MAPS_V1_REGION_URL_MAPS_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/region_url_maps/v1/region_url_maps.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_region_url_maps_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class RegionUrlMapsConnectionIdempotencyPolicy {
 public:
  virtual ~RegionUrlMapsConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<RegionUrlMapsConnectionIdempotencyPolicy> clone()
      const;

  virtual google::cloud::Idempotency DeleteUrlMap(
      google::cloud::cpp::compute::region_url_maps::v1::
          DeleteUrlMapRequest const& request);

  virtual google::cloud::Idempotency GetUrlMap(
      google::cloud::cpp::compute::region_url_maps::v1::GetUrlMapRequest const&
          request);

  virtual google::cloud::Idempotency InsertUrlMap(
      google::cloud::cpp::compute::region_url_maps::v1::
          InsertUrlMapRequest const& request);

  virtual google::cloud::Idempotency ListRegionUrlMaps(
      google::cloud::cpp::compute::region_url_maps::v1::ListRegionUrlMapsRequest
          request);

  virtual google::cloud::Idempotency PatchUrlMap(
      google::cloud::cpp::compute::region_url_maps::v1::
          PatchUrlMapRequest const& request);

  virtual google::cloud::Idempotency UpdateUrlMap(
      google::cloud::cpp::compute::region_url_maps::v1::
          UpdateUrlMapRequest const& request);

  virtual google::cloud::Idempotency Validate(
      google::cloud::cpp::compute::region_url_maps::v1::ValidateRequest const&
          request);
};

std::unique_ptr<RegionUrlMapsConnectionIdempotencyPolicy>
MakeDefaultRegionUrlMapsConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_region_url_maps_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_URL_MAPS_V1_REGION_URL_MAPS_CONNECTION_IDEMPOTENCY_POLICY_H
