// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/functions/v2/functions.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2ffunctions_2fv2_2ffunctions_2eproto__INCLUDED
#define GRPC_google_2fcloud_2ffunctions_2fv2_2ffunctions_2eproto__INCLUDED

#include "google/cloud/functions/v2/functions.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace functions {
namespace v2 {

// Google Cloud Functions is used to deploy functions that are executed by
// Google in response to various events. Data connected with that event is
// passed to a function as the input data.
//
// A **function** is a resource which describes a function that should be
// executed and how it is triggered.
class FunctionService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.functions.v2.FunctionService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Returns a function with the given name from the requested project.
    virtual ::grpc::Status GetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GetFunctionRequest& request, ::google::cloud::functions::v2::Function* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::Function>> AsyncGetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GetFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::Function>>(AsyncGetFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::Function>> PrepareAsyncGetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GetFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::Function>>(PrepareAsyncGetFunctionRaw(context, request, cq));
    }
    // Returns a list of functions that belong to the requested project.
    virtual ::grpc::Status ListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListFunctionsRequest& request, ::google::cloud::functions::v2::ListFunctionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::ListFunctionsResponse>> AsyncListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListFunctionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::ListFunctionsResponse>>(AsyncListFunctionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::ListFunctionsResponse>> PrepareAsyncListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListFunctionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::ListFunctionsResponse>>(PrepareAsyncListFunctionsRaw(context, request, cq));
    }
    // Creates a new function. If a function with the given name already exists in
    // the specified project, the long running operation will return
    // `ALREADY_EXISTS` error.
    virtual ::grpc::Status CreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::CreateFunctionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::CreateFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::CreateFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateFunctionRaw(context, request, cq));
    }
    // Updates existing function.
    virtual ::grpc::Status UpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::UpdateFunctionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::UpdateFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::UpdateFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateFunctionRaw(context, request, cq));
    }
    // Deletes a function with the given name from the specified project. If the
    // given function is used by some trigger, the trigger will be updated to
    // remove this function.
    virtual ::grpc::Status DeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::DeleteFunctionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::DeleteFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::DeleteFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteFunctionRaw(context, request, cq));
    }
    // Returns a signed URL for uploading a function source code.
    // For more information about the signed URL usage see:
    // https://cloud.google.com/storage/docs/access-control/signed-urls.
    // Once the function source code upload is complete, the used signed
    // URL should be provided in CreateFunction or UpdateFunction request
    // as a reference to the function source code.
    //
    // When uploading source code to the generated signed URL, please follow
    // these restrictions:
    //
    // * Source file type should be a zip file.
    // * No credentials should be attached - the signed URLs provide access to the
    //   target bucket using internal service identity; if credentials were
    //   attached, the identity from the credentials would be used, but that
    //   identity does not have permissions to upload files to the URL.
    //
    // When making a HTTP PUT request, specify this header:
    //
    // * `content-type: application/zip`
    //
    // Do not specify this header:
    //
    // * `Authorization: Bearer YOUR_TOKEN`
    virtual ::grpc::Status GenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateUploadUrlRequest& request, ::google::cloud::functions::v2::GenerateUploadUrlResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::GenerateUploadUrlResponse>> AsyncGenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateUploadUrlRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::GenerateUploadUrlResponse>>(AsyncGenerateUploadUrlRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::GenerateUploadUrlResponse>> PrepareAsyncGenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateUploadUrlRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::GenerateUploadUrlResponse>>(PrepareAsyncGenerateUploadUrlRaw(context, request, cq));
    }
    // Returns a signed URL for downloading deployed function source code.
    // The URL is only valid for a limited period and should be used within
    // 30 minutes of generation.
    // For more information about the signed URL usage see:
    // https://cloud.google.com/storage/docs/access-control/signed-urls
    virtual ::grpc::Status GenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest& request, ::google::cloud::functions::v2::GenerateDownloadUrlResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::GenerateDownloadUrlResponse>> AsyncGenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::GenerateDownloadUrlResponse>>(AsyncGenerateDownloadUrlRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::GenerateDownloadUrlResponse>> PrepareAsyncGenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::GenerateDownloadUrlResponse>>(PrepareAsyncGenerateDownloadUrlRaw(context, request, cq));
    }
    // Returns a list of runtimes that are supported for the requested project.
    virtual ::grpc::Status ListRuntimes(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListRuntimesRequest& request, ::google::cloud::functions::v2::ListRuntimesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::ListRuntimesResponse>> AsyncListRuntimes(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListRuntimesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::ListRuntimesResponse>>(AsyncListRuntimesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::ListRuntimesResponse>> PrepareAsyncListRuntimes(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListRuntimesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::ListRuntimesResponse>>(PrepareAsyncListRuntimesRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Returns a function with the given name from the requested project.
      virtual void GetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GetFunctionRequest* request, ::google::cloud::functions::v2::Function* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GetFunctionRequest* request, ::google::cloud::functions::v2::Function* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns a list of functions that belong to the requested project.
      virtual void ListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListFunctionsRequest* request, ::google::cloud::functions::v2::ListFunctionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListFunctionsRequest* request, ::google::cloud::functions::v2::ListFunctionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new function. If a function with the given name already exists in
      // the specified project, the long running operation will return
      // `ALREADY_EXISTS` error.
      virtual void CreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::CreateFunctionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::CreateFunctionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates existing function.
      virtual void UpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::UpdateFunctionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::UpdateFunctionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a function with the given name from the specified project. If the
      // given function is used by some trigger, the trigger will be updated to
      // remove this function.
      virtual void DeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::DeleteFunctionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::DeleteFunctionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns a signed URL for uploading a function source code.
      // For more information about the signed URL usage see:
      // https://cloud.google.com/storage/docs/access-control/signed-urls.
      // Once the function source code upload is complete, the used signed
      // URL should be provided in CreateFunction or UpdateFunction request
      // as a reference to the function source code.
      //
      // When uploading source code to the generated signed URL, please follow
      // these restrictions:
      //
      // * Source file type should be a zip file.
      // * No credentials should be attached - the signed URLs provide access to the
      //   target bucket using internal service identity; if credentials were
      //   attached, the identity from the credentials would be used, but that
      //   identity does not have permissions to upload files to the URL.
      //
      // When making a HTTP PUT request, specify this header:
      //
      // * `content-type: application/zip`
      //
      // Do not specify this header:
      //
      // * `Authorization: Bearer YOUR_TOKEN`
      virtual void GenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateUploadUrlRequest* request, ::google::cloud::functions::v2::GenerateUploadUrlResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateUploadUrlRequest* request, ::google::cloud::functions::v2::GenerateUploadUrlResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns a signed URL for downloading deployed function source code.
      // The URL is only valid for a limited period and should be used within
      // 30 minutes of generation.
      // For more information about the signed URL usage see:
      // https://cloud.google.com/storage/docs/access-control/signed-urls
      virtual void GenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest* request, ::google::cloud::functions::v2::GenerateDownloadUrlResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest* request, ::google::cloud::functions::v2::GenerateDownloadUrlResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns a list of runtimes that are supported for the requested project.
      virtual void ListRuntimes(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListRuntimesRequest* request, ::google::cloud::functions::v2::ListRuntimesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListRuntimes(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListRuntimesRequest* request, ::google::cloud::functions::v2::ListRuntimesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::Function>* AsyncGetFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GetFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::Function>* PrepareAsyncGetFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GetFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::ListFunctionsResponse>* AsyncListFunctionsRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListFunctionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::ListFunctionsResponse>* PrepareAsyncListFunctionsRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListFunctionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::CreateFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::CreateFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::UpdateFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::UpdateFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::DeleteFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::DeleteFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::GenerateUploadUrlResponse>* AsyncGenerateUploadUrlRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateUploadUrlRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::GenerateUploadUrlResponse>* PrepareAsyncGenerateUploadUrlRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateUploadUrlRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::GenerateDownloadUrlResponse>* AsyncGenerateDownloadUrlRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::GenerateDownloadUrlResponse>* PrepareAsyncGenerateDownloadUrlRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::ListRuntimesResponse>* AsyncListRuntimesRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListRuntimesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v2::ListRuntimesResponse>* PrepareAsyncListRuntimesRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListRuntimesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status GetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GetFunctionRequest& request, ::google::cloud::functions::v2::Function* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::Function>> AsyncGetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GetFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::Function>>(AsyncGetFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::Function>> PrepareAsyncGetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GetFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::Function>>(PrepareAsyncGetFunctionRaw(context, request, cq));
    }
    ::grpc::Status ListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListFunctionsRequest& request, ::google::cloud::functions::v2::ListFunctionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::ListFunctionsResponse>> AsyncListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListFunctionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::ListFunctionsResponse>>(AsyncListFunctionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::ListFunctionsResponse>> PrepareAsyncListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListFunctionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::ListFunctionsResponse>>(PrepareAsyncListFunctionsRaw(context, request, cq));
    }
    ::grpc::Status CreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::CreateFunctionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::CreateFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::CreateFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateFunctionRaw(context, request, cq));
    }
    ::grpc::Status UpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::UpdateFunctionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::UpdateFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::UpdateFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateFunctionRaw(context, request, cq));
    }
    ::grpc::Status DeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::DeleteFunctionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::DeleteFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::DeleteFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteFunctionRaw(context, request, cq));
    }
    ::grpc::Status GenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateUploadUrlRequest& request, ::google::cloud::functions::v2::GenerateUploadUrlResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::GenerateUploadUrlResponse>> AsyncGenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateUploadUrlRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::GenerateUploadUrlResponse>>(AsyncGenerateUploadUrlRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::GenerateUploadUrlResponse>> PrepareAsyncGenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateUploadUrlRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::GenerateUploadUrlResponse>>(PrepareAsyncGenerateUploadUrlRaw(context, request, cq));
    }
    ::grpc::Status GenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest& request, ::google::cloud::functions::v2::GenerateDownloadUrlResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::GenerateDownloadUrlResponse>> AsyncGenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::GenerateDownloadUrlResponse>>(AsyncGenerateDownloadUrlRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::GenerateDownloadUrlResponse>> PrepareAsyncGenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::GenerateDownloadUrlResponse>>(PrepareAsyncGenerateDownloadUrlRaw(context, request, cq));
    }
    ::grpc::Status ListRuntimes(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListRuntimesRequest& request, ::google::cloud::functions::v2::ListRuntimesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::ListRuntimesResponse>> AsyncListRuntimes(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListRuntimesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::ListRuntimesResponse>>(AsyncListRuntimesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::ListRuntimesResponse>> PrepareAsyncListRuntimes(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListRuntimesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::ListRuntimesResponse>>(PrepareAsyncListRuntimesRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void GetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GetFunctionRequest* request, ::google::cloud::functions::v2::Function* response, std::function<void(::grpc::Status)>) override;
      void GetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GetFunctionRequest* request, ::google::cloud::functions::v2::Function* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListFunctionsRequest* request, ::google::cloud::functions::v2::ListFunctionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListFunctionsRequest* request, ::google::cloud::functions::v2::ListFunctionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::CreateFunctionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::CreateFunctionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::UpdateFunctionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::UpdateFunctionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::DeleteFunctionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v2::DeleteFunctionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateUploadUrlRequest* request, ::google::cloud::functions::v2::GenerateUploadUrlResponse* response, std::function<void(::grpc::Status)>) override;
      void GenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateUploadUrlRequest* request, ::google::cloud::functions::v2::GenerateUploadUrlResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest* request, ::google::cloud::functions::v2::GenerateDownloadUrlResponse* response, std::function<void(::grpc::Status)>) override;
      void GenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest* request, ::google::cloud::functions::v2::GenerateDownloadUrlResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListRuntimes(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListRuntimesRequest* request, ::google::cloud::functions::v2::ListRuntimesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListRuntimes(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListRuntimesRequest* request, ::google::cloud::functions::v2::ListRuntimesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::Function>* AsyncGetFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GetFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::Function>* PrepareAsyncGetFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GetFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::ListFunctionsResponse>* AsyncListFunctionsRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListFunctionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::ListFunctionsResponse>* PrepareAsyncListFunctionsRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListFunctionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::CreateFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::CreateFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::UpdateFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::UpdateFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::DeleteFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::DeleteFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::GenerateUploadUrlResponse>* AsyncGenerateUploadUrlRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateUploadUrlRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::GenerateUploadUrlResponse>* PrepareAsyncGenerateUploadUrlRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateUploadUrlRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::GenerateDownloadUrlResponse>* AsyncGenerateDownloadUrlRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::GenerateDownloadUrlResponse>* PrepareAsyncGenerateDownloadUrlRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::ListRuntimesResponse>* AsyncListRuntimesRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListRuntimesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v2::ListRuntimesResponse>* PrepareAsyncListRuntimesRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v2::ListRuntimesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_GetFunction_;
    const ::grpc::internal::RpcMethod rpcmethod_ListFunctions_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateFunction_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateFunction_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteFunction_;
    const ::grpc::internal::RpcMethod rpcmethod_GenerateUploadUrl_;
    const ::grpc::internal::RpcMethod rpcmethod_GenerateDownloadUrl_;
    const ::grpc::internal::RpcMethod rpcmethod_ListRuntimes_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Returns a function with the given name from the requested project.
    virtual ::grpc::Status GetFunction(::grpc::ServerContext* context, const ::google::cloud::functions::v2::GetFunctionRequest* request, ::google::cloud::functions::v2::Function* response);
    // Returns a list of functions that belong to the requested project.
    virtual ::grpc::Status ListFunctions(::grpc::ServerContext* context, const ::google::cloud::functions::v2::ListFunctionsRequest* request, ::google::cloud::functions::v2::ListFunctionsResponse* response);
    // Creates a new function. If a function with the given name already exists in
    // the specified project, the long running operation will return
    // `ALREADY_EXISTS` error.
    virtual ::grpc::Status CreateFunction(::grpc::ServerContext* context, const ::google::cloud::functions::v2::CreateFunctionRequest* request, ::google::longrunning::Operation* response);
    // Updates existing function.
    virtual ::grpc::Status UpdateFunction(::grpc::ServerContext* context, const ::google::cloud::functions::v2::UpdateFunctionRequest* request, ::google::longrunning::Operation* response);
    // Deletes a function with the given name from the specified project. If the
    // given function is used by some trigger, the trigger will be updated to
    // remove this function.
    virtual ::grpc::Status DeleteFunction(::grpc::ServerContext* context, const ::google::cloud::functions::v2::DeleteFunctionRequest* request, ::google::longrunning::Operation* response);
    // Returns a signed URL for uploading a function source code.
    // For more information about the signed URL usage see:
    // https://cloud.google.com/storage/docs/access-control/signed-urls.
    // Once the function source code upload is complete, the used signed
    // URL should be provided in CreateFunction or UpdateFunction request
    // as a reference to the function source code.
    //
    // When uploading source code to the generated signed URL, please follow
    // these restrictions:
    //
    // * Source file type should be a zip file.
    // * No credentials should be attached - the signed URLs provide access to the
    //   target bucket using internal service identity; if credentials were
    //   attached, the identity from the credentials would be used, but that
    //   identity does not have permissions to upload files to the URL.
    //
    // When making a HTTP PUT request, specify this header:
    //
    // * `content-type: application/zip`
    //
    // Do not specify this header:
    //
    // * `Authorization: Bearer YOUR_TOKEN`
    virtual ::grpc::Status GenerateUploadUrl(::grpc::ServerContext* context, const ::google::cloud::functions::v2::GenerateUploadUrlRequest* request, ::google::cloud::functions::v2::GenerateUploadUrlResponse* response);
    // Returns a signed URL for downloading deployed function source code.
    // The URL is only valid for a limited period and should be used within
    // 30 minutes of generation.
    // For more information about the signed URL usage see:
    // https://cloud.google.com/storage/docs/access-control/signed-urls
    virtual ::grpc::Status GenerateDownloadUrl(::grpc::ServerContext* context, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest* request, ::google::cloud::functions::v2::GenerateDownloadUrlResponse* response);
    // Returns a list of runtimes that are supported for the requested project.
    virtual ::grpc::Status ListRuntimes(::grpc::ServerContext* context, const ::google::cloud::functions::v2::ListRuntimesRequest* request, ::google::cloud::functions::v2::ListRuntimesResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_GetFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetFunction() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_GetFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GetFunctionRequest* /*request*/, ::google::cloud::functions::v2::Function* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetFunction(::grpc::ServerContext* context, ::google::cloud::functions::v2::GetFunctionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::functions::v2::Function>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListFunctions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListFunctions() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListFunctions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFunctions(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::ListFunctionsRequest* /*request*/, ::google::cloud::functions::v2::ListFunctionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListFunctions(::grpc::ServerContext* context, ::google::cloud::functions::v2::ListFunctionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::functions::v2::ListFunctionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateFunction() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::CreateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateFunction(::grpc::ServerContext* context, ::google::cloud::functions::v2::CreateFunctionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateFunction() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::UpdateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateFunction(::grpc::ServerContext* context, ::google::cloud::functions::v2::UpdateFunctionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteFunction() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::DeleteFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteFunction(::grpc::ServerContext* context, ::google::cloud::functions::v2::DeleteFunctionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GenerateUploadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GenerateUploadUrl() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_GenerateUploadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateUploadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GenerateUploadUrlRequest* /*request*/, ::google::cloud::functions::v2::GenerateUploadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateUploadUrl(::grpc::ServerContext* context, ::google::cloud::functions::v2::GenerateUploadUrlRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::functions::v2::GenerateUploadUrlResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GenerateDownloadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GenerateDownloadUrl() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GenerateDownloadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateDownloadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest* /*request*/, ::google::cloud::functions::v2::GenerateDownloadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateDownloadUrl(::grpc::ServerContext* context, ::google::cloud::functions::v2::GenerateDownloadUrlRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::functions::v2::GenerateDownloadUrlResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListRuntimes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListRuntimes() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_ListRuntimes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRuntimes(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::ListRuntimesRequest* /*request*/, ::google::cloud::functions::v2::ListRuntimesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRuntimes(::grpc::ServerContext* context, ::google::cloud::functions::v2::ListRuntimesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::functions::v2::ListRuntimesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_GetFunction<WithAsyncMethod_ListFunctions<WithAsyncMethod_CreateFunction<WithAsyncMethod_UpdateFunction<WithAsyncMethod_DeleteFunction<WithAsyncMethod_GenerateUploadUrl<WithAsyncMethod_GenerateDownloadUrl<WithAsyncMethod_ListRuntimes<Service > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_GetFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetFunction() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v2::GetFunctionRequest, ::google::cloud::functions::v2::Function>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::functions::v2::GetFunctionRequest* request, ::google::cloud::functions::v2::Function* response) { return this->GetFunction(context, request, response); }));}
    void SetMessageAllocatorFor_GetFunction(
        ::grpc::MessageAllocator< ::google::cloud::functions::v2::GetFunctionRequest, ::google::cloud::functions::v2::Function>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v2::GetFunctionRequest, ::google::cloud::functions::v2::Function>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GetFunctionRequest* /*request*/, ::google::cloud::functions::v2::Function* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::functions::v2::GetFunctionRequest* /*request*/, ::google::cloud::functions::v2::Function* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListFunctions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListFunctions() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v2::ListFunctionsRequest, ::google::cloud::functions::v2::ListFunctionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::functions::v2::ListFunctionsRequest* request, ::google::cloud::functions::v2::ListFunctionsResponse* response) { return this->ListFunctions(context, request, response); }));}
    void SetMessageAllocatorFor_ListFunctions(
        ::grpc::MessageAllocator< ::google::cloud::functions::v2::ListFunctionsRequest, ::google::cloud::functions::v2::ListFunctionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v2::ListFunctionsRequest, ::google::cloud::functions::v2::ListFunctionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListFunctions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFunctions(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::ListFunctionsRequest* /*request*/, ::google::cloud::functions::v2::ListFunctionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListFunctions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::functions::v2::ListFunctionsRequest* /*request*/, ::google::cloud::functions::v2::ListFunctionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateFunction() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v2::CreateFunctionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::functions::v2::CreateFunctionRequest* request, ::google::longrunning::Operation* response) { return this->CreateFunction(context, request, response); }));}
    void SetMessageAllocatorFor_CreateFunction(
        ::grpc::MessageAllocator< ::google::cloud::functions::v2::CreateFunctionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v2::CreateFunctionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::CreateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::functions::v2::CreateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateFunction() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v2::UpdateFunctionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::functions::v2::UpdateFunctionRequest* request, ::google::longrunning::Operation* response) { return this->UpdateFunction(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateFunction(
        ::grpc::MessageAllocator< ::google::cloud::functions::v2::UpdateFunctionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v2::UpdateFunctionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::UpdateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::functions::v2::UpdateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteFunction() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v2::DeleteFunctionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::functions::v2::DeleteFunctionRequest* request, ::google::longrunning::Operation* response) { return this->DeleteFunction(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteFunction(
        ::grpc::MessageAllocator< ::google::cloud::functions::v2::DeleteFunctionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v2::DeleteFunctionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::DeleteFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::functions::v2::DeleteFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GenerateUploadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GenerateUploadUrl() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v2::GenerateUploadUrlRequest, ::google::cloud::functions::v2::GenerateUploadUrlResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::functions::v2::GenerateUploadUrlRequest* request, ::google::cloud::functions::v2::GenerateUploadUrlResponse* response) { return this->GenerateUploadUrl(context, request, response); }));}
    void SetMessageAllocatorFor_GenerateUploadUrl(
        ::grpc::MessageAllocator< ::google::cloud::functions::v2::GenerateUploadUrlRequest, ::google::cloud::functions::v2::GenerateUploadUrlResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v2::GenerateUploadUrlRequest, ::google::cloud::functions::v2::GenerateUploadUrlResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GenerateUploadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateUploadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GenerateUploadUrlRequest* /*request*/, ::google::cloud::functions::v2::GenerateUploadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateUploadUrl(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::functions::v2::GenerateUploadUrlRequest* /*request*/, ::google::cloud::functions::v2::GenerateUploadUrlResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GenerateDownloadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GenerateDownloadUrl() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v2::GenerateDownloadUrlRequest, ::google::cloud::functions::v2::GenerateDownloadUrlResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest* request, ::google::cloud::functions::v2::GenerateDownloadUrlResponse* response) { return this->GenerateDownloadUrl(context, request, response); }));}
    void SetMessageAllocatorFor_GenerateDownloadUrl(
        ::grpc::MessageAllocator< ::google::cloud::functions::v2::GenerateDownloadUrlRequest, ::google::cloud::functions::v2::GenerateDownloadUrlResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v2::GenerateDownloadUrlRequest, ::google::cloud::functions::v2::GenerateDownloadUrlResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GenerateDownloadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateDownloadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest* /*request*/, ::google::cloud::functions::v2::GenerateDownloadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateDownloadUrl(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest* /*request*/, ::google::cloud::functions::v2::GenerateDownloadUrlResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListRuntimes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListRuntimes() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v2::ListRuntimesRequest, ::google::cloud::functions::v2::ListRuntimesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::functions::v2::ListRuntimesRequest* request, ::google::cloud::functions::v2::ListRuntimesResponse* response) { return this->ListRuntimes(context, request, response); }));}
    void SetMessageAllocatorFor_ListRuntimes(
        ::grpc::MessageAllocator< ::google::cloud::functions::v2::ListRuntimesRequest, ::google::cloud::functions::v2::ListRuntimesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v2::ListRuntimesRequest, ::google::cloud::functions::v2::ListRuntimesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListRuntimes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRuntimes(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::ListRuntimesRequest* /*request*/, ::google::cloud::functions::v2::ListRuntimesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRuntimes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::functions::v2::ListRuntimesRequest* /*request*/, ::google::cloud::functions::v2::ListRuntimesResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_GetFunction<WithCallbackMethod_ListFunctions<WithCallbackMethod_CreateFunction<WithCallbackMethod_UpdateFunction<WithCallbackMethod_DeleteFunction<WithCallbackMethod_GenerateUploadUrl<WithCallbackMethod_GenerateDownloadUrl<WithCallbackMethod_ListRuntimes<Service > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_GetFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetFunction() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_GetFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GetFunctionRequest* /*request*/, ::google::cloud::functions::v2::Function* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListFunctions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListFunctions() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListFunctions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFunctions(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::ListFunctionsRequest* /*request*/, ::google::cloud::functions::v2::ListFunctionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateFunction() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::CreateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateFunction() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::UpdateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteFunction() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::DeleteFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GenerateUploadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GenerateUploadUrl() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_GenerateUploadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateUploadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GenerateUploadUrlRequest* /*request*/, ::google::cloud::functions::v2::GenerateUploadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GenerateDownloadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GenerateDownloadUrl() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GenerateDownloadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateDownloadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest* /*request*/, ::google::cloud::functions::v2::GenerateDownloadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListRuntimes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListRuntimes() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_ListRuntimes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRuntimes(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::ListRuntimesRequest* /*request*/, ::google::cloud::functions::v2::ListRuntimesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetFunction() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_GetFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GetFunctionRequest* /*request*/, ::google::cloud::functions::v2::Function* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetFunction(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListFunctions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListFunctions() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListFunctions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFunctions(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::ListFunctionsRequest* /*request*/, ::google::cloud::functions::v2::ListFunctionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListFunctions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateFunction() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::CreateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateFunction(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateFunction() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::UpdateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateFunction(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteFunction() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::DeleteFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteFunction(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GenerateUploadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GenerateUploadUrl() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_GenerateUploadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateUploadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GenerateUploadUrlRequest* /*request*/, ::google::cloud::functions::v2::GenerateUploadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateUploadUrl(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GenerateDownloadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GenerateDownloadUrl() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GenerateDownloadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateDownloadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest* /*request*/, ::google::cloud::functions::v2::GenerateDownloadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateDownloadUrl(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListRuntimes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListRuntimes() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_ListRuntimes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRuntimes(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::ListRuntimesRequest* /*request*/, ::google::cloud::functions::v2::ListRuntimesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRuntimes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetFunction() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetFunction(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GetFunctionRequest* /*request*/, ::google::cloud::functions::v2::Function* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListFunctions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListFunctions() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListFunctions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListFunctions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFunctions(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::ListFunctionsRequest* /*request*/, ::google::cloud::functions::v2::ListFunctionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListFunctions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateFunction() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateFunction(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::CreateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateFunction() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateFunction(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::UpdateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteFunction() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteFunction(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::DeleteFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GenerateUploadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GenerateUploadUrl() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GenerateUploadUrl(context, request, response); }));
    }
    ~WithRawCallbackMethod_GenerateUploadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateUploadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GenerateUploadUrlRequest* /*request*/, ::google::cloud::functions::v2::GenerateUploadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateUploadUrl(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GenerateDownloadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GenerateDownloadUrl() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GenerateDownloadUrl(context, request, response); }));
    }
    ~WithRawCallbackMethod_GenerateDownloadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateDownloadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest* /*request*/, ::google::cloud::functions::v2::GenerateDownloadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateDownloadUrl(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListRuntimes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListRuntimes() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListRuntimes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListRuntimes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRuntimes(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::ListRuntimesRequest* /*request*/, ::google::cloud::functions::v2::ListRuntimesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRuntimes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetFunction() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::functions::v2::GetFunctionRequest, ::google::cloud::functions::v2::Function>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::functions::v2::GetFunctionRequest, ::google::cloud::functions::v2::Function>* streamer) {
                       return this->StreamedGetFunction(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GetFunctionRequest* /*request*/, ::google::cloud::functions::v2::Function* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetFunction(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::functions::v2::GetFunctionRequest,::google::cloud::functions::v2::Function>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListFunctions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListFunctions() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::functions::v2::ListFunctionsRequest, ::google::cloud::functions::v2::ListFunctionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::functions::v2::ListFunctionsRequest, ::google::cloud::functions::v2::ListFunctionsResponse>* streamer) {
                       return this->StreamedListFunctions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListFunctions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListFunctions(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::ListFunctionsRequest* /*request*/, ::google::cloud::functions::v2::ListFunctionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListFunctions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::functions::v2::ListFunctionsRequest,::google::cloud::functions::v2::ListFunctionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateFunction() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::functions::v2::CreateFunctionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::functions::v2::CreateFunctionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateFunction(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::CreateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateFunction(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::functions::v2::CreateFunctionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateFunction() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::functions::v2::UpdateFunctionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::functions::v2::UpdateFunctionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateFunction(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::UpdateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateFunction(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::functions::v2::UpdateFunctionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteFunction() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::functions::v2::DeleteFunctionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::functions::v2::DeleteFunctionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteFunction(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::DeleteFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteFunction(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::functions::v2::DeleteFunctionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GenerateUploadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GenerateUploadUrl() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::functions::v2::GenerateUploadUrlRequest, ::google::cloud::functions::v2::GenerateUploadUrlResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::functions::v2::GenerateUploadUrlRequest, ::google::cloud::functions::v2::GenerateUploadUrlResponse>* streamer) {
                       return this->StreamedGenerateUploadUrl(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GenerateUploadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GenerateUploadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GenerateUploadUrlRequest* /*request*/, ::google::cloud::functions::v2::GenerateUploadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGenerateUploadUrl(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::functions::v2::GenerateUploadUrlRequest,::google::cloud::functions::v2::GenerateUploadUrlResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GenerateDownloadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GenerateDownloadUrl() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::functions::v2::GenerateDownloadUrlRequest, ::google::cloud::functions::v2::GenerateDownloadUrlResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::functions::v2::GenerateDownloadUrlRequest, ::google::cloud::functions::v2::GenerateDownloadUrlResponse>* streamer) {
                       return this->StreamedGenerateDownloadUrl(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GenerateDownloadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GenerateDownloadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::GenerateDownloadUrlRequest* /*request*/, ::google::cloud::functions::v2::GenerateDownloadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGenerateDownloadUrl(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::functions::v2::GenerateDownloadUrlRequest,::google::cloud::functions::v2::GenerateDownloadUrlResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListRuntimes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListRuntimes() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::functions::v2::ListRuntimesRequest, ::google::cloud::functions::v2::ListRuntimesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::functions::v2::ListRuntimesRequest, ::google::cloud::functions::v2::ListRuntimesResponse>* streamer) {
                       return this->StreamedListRuntimes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListRuntimes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListRuntimes(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v2::ListRuntimesRequest* /*request*/, ::google::cloud::functions::v2::ListRuntimesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListRuntimes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::functions::v2::ListRuntimesRequest,::google::cloud::functions::v2::ListRuntimesResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_GetFunction<WithStreamedUnaryMethod_ListFunctions<WithStreamedUnaryMethod_CreateFunction<WithStreamedUnaryMethod_UpdateFunction<WithStreamedUnaryMethod_DeleteFunction<WithStreamedUnaryMethod_GenerateUploadUrl<WithStreamedUnaryMethod_GenerateDownloadUrl<WithStreamedUnaryMethod_ListRuntimes<Service > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_GetFunction<WithStreamedUnaryMethod_ListFunctions<WithStreamedUnaryMethod_CreateFunction<WithStreamedUnaryMethod_UpdateFunction<WithStreamedUnaryMethod_DeleteFunction<WithStreamedUnaryMethod_GenerateUploadUrl<WithStreamedUnaryMethod_GenerateDownloadUrl<WithStreamedUnaryMethod_ListRuntimes<Service > > > > > > > > StreamedService;
};

}  // namespace v2
}  // namespace functions
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2ffunctions_2fv2_2ffunctions_2eproto__INCLUDED
