// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/osconfig/v1/osconfig_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fosconfig_2fv1_2fosconfig_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fosconfig_2fv1_2fosconfig_5fservice_2eproto__INCLUDED

#include "google/cloud/osconfig/v1/osconfig_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace osconfig {
namespace v1 {

// OS Config API
//
// The OS Config service is a server-side component that you can use to
// manage package installations and patch jobs for virtual machine instances.
class OsConfigService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.osconfig.v1.OsConfigService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Patch VM instances by creating and running a patch job.
    virtual ::grpc::Status ExecutePatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest& request, ::google::cloud::osconfig::v1::PatchJob* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>> AsyncExecutePatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>>(AsyncExecutePatchJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>> PrepareAsyncExecutePatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>>(PrepareAsyncExecutePatchJobRaw(context, request, cq));
    }
    // Get the patch job. This can be used to track the progress of an
    // ongoing patch job or review the details of completed jobs.
    virtual ::grpc::Status GetPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchJobRequest& request, ::google::cloud::osconfig::v1::PatchJob* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>> AsyncGetPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>>(AsyncGetPatchJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>> PrepareAsyncGetPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>>(PrepareAsyncGetPatchJobRaw(context, request, cq));
    }
    // Cancel a patch job. The patch job must be active. Canceled patch jobs
    // cannot be restarted.
    virtual ::grpc::Status CancelPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CancelPatchJobRequest& request, ::google::cloud::osconfig::v1::PatchJob* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>> AsyncCancelPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CancelPatchJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>>(AsyncCancelPatchJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>> PrepareAsyncCancelPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CancelPatchJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>>(PrepareAsyncCancelPatchJobRaw(context, request, cq));
    }
    // Get a list of patch jobs.
    virtual ::grpc::Status ListPatchJobs(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobsRequest& request, ::google::cloud::osconfig::v1::ListPatchJobsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchJobsResponse>> AsyncListPatchJobs(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchJobsResponse>>(AsyncListPatchJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchJobsResponse>> PrepareAsyncListPatchJobs(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchJobsResponse>>(PrepareAsyncListPatchJobsRaw(context, request, cq));
    }
    // Get a list of instance details for a given patch job.
    virtual ::grpc::Status ListPatchJobInstanceDetails(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest& request, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>> AsyncListPatchJobInstanceDetails(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>>(AsyncListPatchJobInstanceDetailsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>> PrepareAsyncListPatchJobInstanceDetails(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>>(PrepareAsyncListPatchJobInstanceDetailsRaw(context, request, cq));
    }
    // Create an OS Config patch deployment.
    virtual ::grpc::Status CreatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest& request, ::google::cloud::osconfig::v1::PatchDeployment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>> AsyncCreatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>>(AsyncCreatePatchDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>> PrepareAsyncCreatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>>(PrepareAsyncCreatePatchDeploymentRaw(context, request, cq));
    }
    // Get an OS Config patch deployment.
    virtual ::grpc::Status GetPatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest& request, ::google::cloud::osconfig::v1::PatchDeployment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>> AsyncGetPatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>>(AsyncGetPatchDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>> PrepareAsyncGetPatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>>(PrepareAsyncGetPatchDeploymentRaw(context, request, cq));
    }
    // Get a page of OS Config patch deployments.
    virtual ::grpc::Status ListPatchDeployments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest& request, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>> AsyncListPatchDeployments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>>(AsyncListPatchDeploymentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>> PrepareAsyncListPatchDeployments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>>(PrepareAsyncListPatchDeploymentsRaw(context, request, cq));
    }
    // Delete an OS Config patch deployment.
    virtual ::grpc::Status DeletePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeletePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeletePatchDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeletePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeletePatchDeploymentRaw(context, request, cq));
    }
    // Update an OS Config patch deployment.
    virtual ::grpc::Status UpdatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest& request, ::google::cloud::osconfig::v1::PatchDeployment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>> AsyncUpdatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>>(AsyncUpdatePatchDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>> PrepareAsyncUpdatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>>(PrepareAsyncUpdatePatchDeploymentRaw(context, request, cq));
    }
    // Change state of patch deployment to "PAUSED".
    // Patch deployment in paused state doesn't generate patch jobs.
    virtual ::grpc::Status PausePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest& request, ::google::cloud::osconfig::v1::PatchDeployment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>> AsyncPausePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>>(AsyncPausePatchDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>> PrepareAsyncPausePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>>(PrepareAsyncPausePatchDeploymentRaw(context, request, cq));
    }
    // Change state of patch deployment back to "ACTIVE".
    // Patch deployment in active state continues to generate patch jobs.
    virtual ::grpc::Status ResumePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest& request, ::google::cloud::osconfig::v1::PatchDeployment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>> AsyncResumePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>>(AsyncResumePatchDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>> PrepareAsyncResumePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>>(PrepareAsyncResumePatchDeploymentRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Patch VM instances by creating and running a patch job.
      virtual void ExecutePatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ExecutePatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get the patch job. This can be used to track the progress of an
      // ongoing patch job or review the details of completed jobs.
      virtual void GetPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Cancel a patch job. The patch job must be active. Canceled patch jobs
      // cannot be restarted.
      virtual void CancelPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CancelPatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CancelPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CancelPatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get a list of patch jobs.
      virtual void ListPatchJobs(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobsRequest* request, ::google::cloud::osconfig::v1::ListPatchJobsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPatchJobs(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobsRequest* request, ::google::cloud::osconfig::v1::ListPatchJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get a list of instance details for a given patch job.
      virtual void ListPatchJobInstanceDetails(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest* request, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPatchJobInstanceDetails(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest* request, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Create an OS Config patch deployment.
      virtual void CreatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get an OS Config patch deployment.
      virtual void GetPatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get a page of OS Config patch deployments.
      virtual void ListPatchDeployments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest* request, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPatchDeployments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest* request, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Delete an OS Config patch deployment.
      virtual void DeletePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeletePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Update an OS Config patch deployment.
      virtual void UpdatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Change state of patch deployment to "PAUSED".
      // Patch deployment in paused state doesn't generate patch jobs.
      virtual void PausePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void PausePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Change state of patch deployment back to "ACTIVE".
      // Patch deployment in active state continues to generate patch jobs.
      virtual void ResumePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResumePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>* AsyncExecutePatchJobRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>* PrepareAsyncExecutePatchJobRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>* AsyncGetPatchJobRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>* PrepareAsyncGetPatchJobRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>* AsyncCancelPatchJobRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CancelPatchJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchJob>* PrepareAsyncCancelPatchJobRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CancelPatchJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchJobsResponse>* AsyncListPatchJobsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchJobsResponse>* PrepareAsyncListPatchJobsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>* AsyncListPatchJobInstanceDetailsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>* PrepareAsyncListPatchJobInstanceDetailsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>* AsyncCreatePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>* PrepareAsyncCreatePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>* AsyncGetPatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>* PrepareAsyncGetPatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>* AsyncListPatchDeploymentsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>* PrepareAsyncListPatchDeploymentsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeletePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeletePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>* AsyncUpdatePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>* PrepareAsyncUpdatePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>* AsyncPausePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>* PrepareAsyncPausePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>* AsyncResumePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::osconfig::v1::PatchDeployment>* PrepareAsyncResumePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ExecutePatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest& request, ::google::cloud::osconfig::v1::PatchJob* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>> AsyncExecutePatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>>(AsyncExecutePatchJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>> PrepareAsyncExecutePatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>>(PrepareAsyncExecutePatchJobRaw(context, request, cq));
    }
    ::grpc::Status GetPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchJobRequest& request, ::google::cloud::osconfig::v1::PatchJob* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>> AsyncGetPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>>(AsyncGetPatchJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>> PrepareAsyncGetPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>>(PrepareAsyncGetPatchJobRaw(context, request, cq));
    }
    ::grpc::Status CancelPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CancelPatchJobRequest& request, ::google::cloud::osconfig::v1::PatchJob* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>> AsyncCancelPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CancelPatchJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>>(AsyncCancelPatchJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>> PrepareAsyncCancelPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CancelPatchJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>>(PrepareAsyncCancelPatchJobRaw(context, request, cq));
    }
    ::grpc::Status ListPatchJobs(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobsRequest& request, ::google::cloud::osconfig::v1::ListPatchJobsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchJobsResponse>> AsyncListPatchJobs(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchJobsResponse>>(AsyncListPatchJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchJobsResponse>> PrepareAsyncListPatchJobs(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchJobsResponse>>(PrepareAsyncListPatchJobsRaw(context, request, cq));
    }
    ::grpc::Status ListPatchJobInstanceDetails(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest& request, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>> AsyncListPatchJobInstanceDetails(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>>(AsyncListPatchJobInstanceDetailsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>> PrepareAsyncListPatchJobInstanceDetails(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>>(PrepareAsyncListPatchJobInstanceDetailsRaw(context, request, cq));
    }
    ::grpc::Status CreatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest& request, ::google::cloud::osconfig::v1::PatchDeployment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>> AsyncCreatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>>(AsyncCreatePatchDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>> PrepareAsyncCreatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>>(PrepareAsyncCreatePatchDeploymentRaw(context, request, cq));
    }
    ::grpc::Status GetPatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest& request, ::google::cloud::osconfig::v1::PatchDeployment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>> AsyncGetPatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>>(AsyncGetPatchDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>> PrepareAsyncGetPatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>>(PrepareAsyncGetPatchDeploymentRaw(context, request, cq));
    }
    ::grpc::Status ListPatchDeployments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest& request, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>> AsyncListPatchDeployments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>>(AsyncListPatchDeploymentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>> PrepareAsyncListPatchDeployments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>>(PrepareAsyncListPatchDeploymentsRaw(context, request, cq));
    }
    ::grpc::Status DeletePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeletePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeletePatchDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeletePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeletePatchDeploymentRaw(context, request, cq));
    }
    ::grpc::Status UpdatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest& request, ::google::cloud::osconfig::v1::PatchDeployment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>> AsyncUpdatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>>(AsyncUpdatePatchDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>> PrepareAsyncUpdatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>>(PrepareAsyncUpdatePatchDeploymentRaw(context, request, cq));
    }
    ::grpc::Status PausePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest& request, ::google::cloud::osconfig::v1::PatchDeployment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>> AsyncPausePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>>(AsyncPausePatchDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>> PrepareAsyncPausePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>>(PrepareAsyncPausePatchDeploymentRaw(context, request, cq));
    }
    ::grpc::Status ResumePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest& request, ::google::cloud::osconfig::v1::PatchDeployment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>> AsyncResumePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>>(AsyncResumePatchDeploymentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>> PrepareAsyncResumePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>>(PrepareAsyncResumePatchDeploymentRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ExecutePatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response, std::function<void(::grpc::Status)>) override;
      void ExecutePatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response, std::function<void(::grpc::Status)>) override;
      void GetPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CancelPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CancelPatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response, std::function<void(::grpc::Status)>) override;
      void CancelPatchJob(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CancelPatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPatchJobs(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobsRequest* request, ::google::cloud::osconfig::v1::ListPatchJobsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPatchJobs(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobsRequest* request, ::google::cloud::osconfig::v1::ListPatchJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPatchJobInstanceDetails(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest* request, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPatchJobInstanceDetails(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest* request, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, std::function<void(::grpc::Status)>) override;
      void CreatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetPatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, std::function<void(::grpc::Status)>) override;
      void GetPatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPatchDeployments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest* request, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPatchDeployments(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest* request, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeletePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeletePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, std::function<void(::grpc::Status)>) override;
      void UpdatePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void PausePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, std::function<void(::grpc::Status)>) override;
      void PausePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ResumePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, std::function<void(::grpc::Status)>) override;
      void ResumePatchDeployment(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>* AsyncExecutePatchJobRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>* PrepareAsyncExecutePatchJobRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>* AsyncGetPatchJobRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>* PrepareAsyncGetPatchJobRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>* AsyncCancelPatchJobRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CancelPatchJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchJob>* PrepareAsyncCancelPatchJobRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CancelPatchJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchJobsResponse>* AsyncListPatchJobsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchJobsResponse>* PrepareAsyncListPatchJobsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>* AsyncListPatchJobInstanceDetailsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>* PrepareAsyncListPatchJobInstanceDetailsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>* AsyncCreatePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>* PrepareAsyncCreatePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>* AsyncGetPatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>* PrepareAsyncGetPatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>* AsyncListPatchDeploymentsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>* PrepareAsyncListPatchDeploymentsRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeletePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeletePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>* AsyncUpdatePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>* PrepareAsyncUpdatePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>* AsyncPausePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>* PrepareAsyncPausePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>* AsyncResumePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::osconfig::v1::PatchDeployment>* PrepareAsyncResumePatchDeploymentRaw(::grpc::ClientContext* context, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ExecutePatchJob_;
    const ::grpc::internal::RpcMethod rpcmethod_GetPatchJob_;
    const ::grpc::internal::RpcMethod rpcmethod_CancelPatchJob_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPatchJobs_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPatchJobInstanceDetails_;
    const ::grpc::internal::RpcMethod rpcmethod_CreatePatchDeployment_;
    const ::grpc::internal::RpcMethod rpcmethod_GetPatchDeployment_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPatchDeployments_;
    const ::grpc::internal::RpcMethod rpcmethod_DeletePatchDeployment_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdatePatchDeployment_;
    const ::grpc::internal::RpcMethod rpcmethod_PausePatchDeployment_;
    const ::grpc::internal::RpcMethod rpcmethod_ResumePatchDeployment_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Patch VM instances by creating and running a patch job.
    virtual ::grpc::Status ExecutePatchJob(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response);
    // Get the patch job. This can be used to track the progress of an
    // ongoing patch job or review the details of completed jobs.
    virtual ::grpc::Status GetPatchJob(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::GetPatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response);
    // Cancel a patch job. The patch job must be active. Canceled patch jobs
    // cannot be restarted.
    virtual ::grpc::Status CancelPatchJob(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::CancelPatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response);
    // Get a list of patch jobs.
    virtual ::grpc::Status ListPatchJobs(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::ListPatchJobsRequest* request, ::google::cloud::osconfig::v1::ListPatchJobsResponse* response);
    // Get a list of instance details for a given patch job.
    virtual ::grpc::Status ListPatchJobInstanceDetails(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest* request, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse* response);
    // Create an OS Config patch deployment.
    virtual ::grpc::Status CreatePatchDeployment(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response);
    // Get an OS Config patch deployment.
    virtual ::grpc::Status GetPatchDeployment(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response);
    // Get a page of OS Config patch deployments.
    virtual ::grpc::Status ListPatchDeployments(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest* request, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse* response);
    // Delete an OS Config patch deployment.
    virtual ::grpc::Status DeletePatchDeployment(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest* request, ::google::protobuf::Empty* response);
    // Update an OS Config patch deployment.
    virtual ::grpc::Status UpdatePatchDeployment(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response);
    // Change state of patch deployment to "PAUSED".
    // Patch deployment in paused state doesn't generate patch jobs.
    virtual ::grpc::Status PausePatchDeployment(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response);
    // Change state of patch deployment back to "ACTIVE".
    // Patch deployment in active state continues to generate patch jobs.
    virtual ::grpc::Status ResumePatchDeployment(::grpc::ServerContext* context, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ExecutePatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ExecutePatchJob() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ExecutePatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExecutePatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExecutePatchJob(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::ExecutePatchJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::PatchJob>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPatchJob() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetPatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetPatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPatchJob(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::GetPatchJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::PatchJob>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CancelPatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CancelPatchJob() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CancelPatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelPatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CancelPatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelPatchJob(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::CancelPatchJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::PatchJob>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPatchJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPatchJobs() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ListPatchJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPatchJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchJobsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPatchJobs(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::ListPatchJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::ListPatchJobsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPatchJobInstanceDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPatchJobInstanceDetails() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_ListPatchJobInstanceDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPatchJobInstanceDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPatchJobInstanceDetails(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreatePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreatePatchDeployment() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_CreatePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePatchDeployment(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::PatchDeployment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPatchDeployment() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetPatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPatchDeployment(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::GetPatchDeploymentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::PatchDeployment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPatchDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPatchDeployments() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_ListPatchDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPatchDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPatchDeployments(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeletePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeletePatchDeployment() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_DeletePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePatchDeployment(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdatePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdatePatchDeployment() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_UpdatePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePatchDeployment(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::PatchDeployment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_PausePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_PausePatchDeployment() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_PausePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PausePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPausePatchDeployment(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::PausePatchDeploymentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::PatchDeployment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ResumePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ResumePatchDeployment() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_ResumePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResumePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResumePatchDeployment(::grpc::ServerContext* context, ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::osconfig::v1::PatchDeployment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ExecutePatchJob<WithAsyncMethod_GetPatchJob<WithAsyncMethod_CancelPatchJob<WithAsyncMethod_ListPatchJobs<WithAsyncMethod_ListPatchJobInstanceDetails<WithAsyncMethod_CreatePatchDeployment<WithAsyncMethod_GetPatchDeployment<WithAsyncMethod_ListPatchDeployments<WithAsyncMethod_DeletePatchDeployment<WithAsyncMethod_UpdatePatchDeployment<WithAsyncMethod_PausePatchDeployment<WithAsyncMethod_ResumePatchDeployment<Service > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ExecutePatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ExecutePatchJob() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ExecutePatchJobRequest, ::google::cloud::osconfig::v1::PatchJob>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response) { return this->ExecutePatchJob(context, request, response); }));}
    void SetMessageAllocatorFor_ExecutePatchJob(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::ExecutePatchJobRequest, ::google::cloud::osconfig::v1::PatchJob>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ExecutePatchJobRequest, ::google::cloud::osconfig::v1::PatchJob>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ExecutePatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExecutePatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExecutePatchJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetPatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPatchJob() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::GetPatchJobRequest, ::google::cloud::osconfig::v1::PatchJob>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::GetPatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response) { return this->GetPatchJob(context, request, response); }));}
    void SetMessageAllocatorFor_GetPatchJob(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::GetPatchJobRequest, ::google::cloud::osconfig::v1::PatchJob>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::GetPatchJobRequest, ::google::cloud::osconfig::v1::PatchJob>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetPatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPatchJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetPatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CancelPatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CancelPatchJob() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::CancelPatchJobRequest, ::google::cloud::osconfig::v1::PatchJob>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::CancelPatchJobRequest* request, ::google::cloud::osconfig::v1::PatchJob* response) { return this->CancelPatchJob(context, request, response); }));}
    void SetMessageAllocatorFor_CancelPatchJob(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::CancelPatchJobRequest, ::google::cloud::osconfig::v1::PatchJob>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::CancelPatchJobRequest, ::google::cloud::osconfig::v1::PatchJob>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CancelPatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelPatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CancelPatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelPatchJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::CancelPatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPatchJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPatchJobs() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ListPatchJobsRequest, ::google::cloud::osconfig::v1::ListPatchJobsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::ListPatchJobsRequest* request, ::google::cloud::osconfig::v1::ListPatchJobsResponse* response) { return this->ListPatchJobs(context, request, response); }));}
    void SetMessageAllocatorFor_ListPatchJobs(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::ListPatchJobsRequest, ::google::cloud::osconfig::v1::ListPatchJobsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ListPatchJobsRequest, ::google::cloud::osconfig::v1::ListPatchJobsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPatchJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPatchJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchJobsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPatchJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchJobsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchJobsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPatchJobInstanceDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPatchJobInstanceDetails() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest* request, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse* response) { return this->ListPatchJobInstanceDetails(context, request, response); }));}
    void SetMessageAllocatorFor_ListPatchJobInstanceDetails(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPatchJobInstanceDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPatchJobInstanceDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPatchJobInstanceDetails(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreatePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreatePatchDeployment() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response) { return this->CreatePatchDeployment(context, request, response); }));}
    void SetMessageAllocatorFor_CreatePatchDeployment(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreatePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePatchDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetPatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPatchDeployment() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::GetPatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response) { return this->GetPatchDeployment(context, request, response); }));}
    void SetMessageAllocatorFor_GetPatchDeployment(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::GetPatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::GetPatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPatchDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPatchDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPatchDeployments() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest* request, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse* response) { return this->ListPatchDeployments(context, request, response); }));}
    void SetMessageAllocatorFor_ListPatchDeployments(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPatchDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPatchDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPatchDeployments(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeletePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeletePatchDeployment() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest* request, ::google::protobuf::Empty* response) { return this->DeletePatchDeployment(context, request, response); }));}
    void SetMessageAllocatorFor_DeletePatchDeployment(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeletePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePatchDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdatePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdatePatchDeployment() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response) { return this->UpdatePatchDeployment(context, request, response); }));}
    void SetMessageAllocatorFor_UpdatePatchDeployment(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdatePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePatchDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_PausePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_PausePatchDeployment() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::PausePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response) { return this->PausePatchDeployment(context, request, response); }));}
    void SetMessageAllocatorFor_PausePatchDeployment(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::PausePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::PausePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_PausePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PausePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PausePatchDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ResumePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ResumePatchDeployment() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest* request, ::google::cloud::osconfig::v1::PatchDeployment* response) { return this->ResumePatchDeployment(context, request, response); }));}
    void SetMessageAllocatorFor_ResumePatchDeployment(
        ::grpc::MessageAllocator< ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ResumePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResumePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResumePatchDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ExecutePatchJob<WithCallbackMethod_GetPatchJob<WithCallbackMethod_CancelPatchJob<WithCallbackMethod_ListPatchJobs<WithCallbackMethod_ListPatchJobInstanceDetails<WithCallbackMethod_CreatePatchDeployment<WithCallbackMethod_GetPatchDeployment<WithCallbackMethod_ListPatchDeployments<WithCallbackMethod_DeletePatchDeployment<WithCallbackMethod_UpdatePatchDeployment<WithCallbackMethod_PausePatchDeployment<WithCallbackMethod_ResumePatchDeployment<Service > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ExecutePatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ExecutePatchJob() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ExecutePatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExecutePatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetPatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPatchJob() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetPatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetPatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CancelPatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CancelPatchJob() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CancelPatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelPatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CancelPatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPatchJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPatchJobs() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ListPatchJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPatchJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchJobsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPatchJobInstanceDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPatchJobInstanceDetails() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_ListPatchJobInstanceDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPatchJobInstanceDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreatePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreatePatchDeployment() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_CreatePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetPatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPatchDeployment() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetPatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPatchDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPatchDeployments() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_ListPatchDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPatchDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeletePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeletePatchDeployment() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_DeletePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdatePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdatePatchDeployment() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_UpdatePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_PausePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_PausePatchDeployment() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_PausePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PausePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ResumePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ResumePatchDeployment() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_ResumePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResumePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ExecutePatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ExecutePatchJob() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ExecutePatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExecutePatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExecutePatchJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPatchJob() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetPatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetPatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPatchJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CancelPatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CancelPatchJob() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CancelPatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelPatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CancelPatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelPatchJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPatchJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPatchJobs() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ListPatchJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPatchJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchJobsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPatchJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPatchJobInstanceDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPatchJobInstanceDetails() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_ListPatchJobInstanceDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPatchJobInstanceDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPatchJobInstanceDetails(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreatePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreatePatchDeployment() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_CreatePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePatchDeployment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPatchDeployment() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetPatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPatchDeployment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPatchDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPatchDeployments() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_ListPatchDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPatchDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPatchDeployments(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeletePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeletePatchDeployment() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_DeletePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePatchDeployment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdatePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdatePatchDeployment() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_UpdatePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePatchDeployment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_PausePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_PausePatchDeployment() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_PausePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PausePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPausePatchDeployment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ResumePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ResumePatchDeployment() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_ResumePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResumePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResumePatchDeployment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ExecutePatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ExecutePatchJob() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ExecutePatchJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_ExecutePatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExecutePatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExecutePatchJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPatchJob() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPatchJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetPatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPatchJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CancelPatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CancelPatchJob() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CancelPatchJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_CancelPatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelPatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CancelPatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelPatchJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPatchJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPatchJobs() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPatchJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPatchJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPatchJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchJobsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPatchJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPatchJobInstanceDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPatchJobInstanceDetails() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPatchJobInstanceDetails(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPatchJobInstanceDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPatchJobInstanceDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPatchJobInstanceDetails(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreatePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreatePatchDeployment() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreatePatchDeployment(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreatePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePatchDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPatchDeployment() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPatchDeployment(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPatchDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPatchDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPatchDeployments() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPatchDeployments(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPatchDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPatchDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPatchDeployments(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeletePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeletePatchDeployment() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeletePatchDeployment(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeletePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePatchDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdatePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdatePatchDeployment() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdatePatchDeployment(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdatePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePatchDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_PausePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_PausePatchDeployment() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->PausePatchDeployment(context, request, response); }));
    }
    ~WithRawCallbackMethod_PausePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PausePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PausePatchDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ResumePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ResumePatchDeployment() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ResumePatchDeployment(context, request, response); }));
    }
    ~WithRawCallbackMethod_ResumePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResumePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResumePatchDeployment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ExecutePatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ExecutePatchJob() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::ExecutePatchJobRequest, ::google::cloud::osconfig::v1::PatchJob>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::ExecutePatchJobRequest, ::google::cloud::osconfig::v1::PatchJob>* streamer) {
                       return this->StreamedExecutePatchJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ExecutePatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ExecutePatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ExecutePatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExecutePatchJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::ExecutePatchJobRequest,::google::cloud::osconfig::v1::PatchJob>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPatchJob() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::GetPatchJobRequest, ::google::cloud::osconfig::v1::PatchJob>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::GetPatchJobRequest, ::google::cloud::osconfig::v1::PatchJob>* streamer) {
                       return this->StreamedGetPatchJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetPatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPatchJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::GetPatchJobRequest,::google::cloud::osconfig::v1::PatchJob>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CancelPatchJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CancelPatchJob() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::CancelPatchJobRequest, ::google::cloud::osconfig::v1::PatchJob>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::CancelPatchJobRequest, ::google::cloud::osconfig::v1::PatchJob>* streamer) {
                       return this->StreamedCancelPatchJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CancelPatchJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CancelPatchJob(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CancelPatchJobRequest* /*request*/, ::google::cloud::osconfig::v1::PatchJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCancelPatchJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::CancelPatchJobRequest,::google::cloud::osconfig::v1::PatchJob>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPatchJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPatchJobs() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::ListPatchJobsRequest, ::google::cloud::osconfig::v1::ListPatchJobsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::ListPatchJobsRequest, ::google::cloud::osconfig::v1::ListPatchJobsResponse>* streamer) {
                       return this->StreamedListPatchJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPatchJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPatchJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchJobsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPatchJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::ListPatchJobsRequest,::google::cloud::osconfig::v1::ListPatchJobsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPatchJobInstanceDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPatchJobInstanceDetails() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>* streamer) {
                       return this->StreamedListPatchJobInstanceDetails(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPatchJobInstanceDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPatchJobInstanceDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPatchJobInstanceDetails(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest,::google::cloud::osconfig::v1::ListPatchJobInstanceDetailsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreatePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreatePatchDeployment() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>* streamer) {
                       return this->StreamedCreatePatchDeployment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreatePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreatePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreatePatchDeployment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::CreatePatchDeploymentRequest,::google::cloud::osconfig::v1::PatchDeployment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPatchDeployment() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::GetPatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::GetPatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>* streamer) {
                       return this->StreamedGetPatchDeployment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::GetPatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPatchDeployment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::GetPatchDeploymentRequest,::google::cloud::osconfig::v1::PatchDeployment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPatchDeployments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPatchDeployments() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>* streamer) {
                       return this->StreamedListPatchDeployments(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPatchDeployments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPatchDeployments(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest* /*request*/, ::google::cloud::osconfig::v1::ListPatchDeploymentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPatchDeployments(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::ListPatchDeploymentsRequest,::google::cloud::osconfig::v1::ListPatchDeploymentsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeletePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeletePatchDeployment() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeletePatchDeployment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeletePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeletePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeletePatchDeployment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::DeletePatchDeploymentRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdatePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdatePatchDeployment() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>* streamer) {
                       return this->StreamedUpdatePatchDeployment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdatePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdatePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdatePatchDeployment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::UpdatePatchDeploymentRequest,::google::cloud::osconfig::v1::PatchDeployment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_PausePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_PausePatchDeployment() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::PausePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::PausePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>* streamer) {
                       return this->StreamedPausePatchDeployment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_PausePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status PausePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::PausePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPausePatchDeployment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::PausePatchDeploymentRequest,::google::cloud::osconfig::v1::PatchDeployment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ResumePatchDeployment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ResumePatchDeployment() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest, ::google::cloud::osconfig::v1::PatchDeployment>* streamer) {
                       return this->StreamedResumePatchDeployment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ResumePatchDeployment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ResumePatchDeployment(::grpc::ServerContext* /*context*/, const ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest* /*request*/, ::google::cloud::osconfig::v1::PatchDeployment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResumePatchDeployment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::osconfig::v1::ResumePatchDeploymentRequest,::google::cloud::osconfig::v1::PatchDeployment>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ExecutePatchJob<WithStreamedUnaryMethod_GetPatchJob<WithStreamedUnaryMethod_CancelPatchJob<WithStreamedUnaryMethod_ListPatchJobs<WithStreamedUnaryMethod_ListPatchJobInstanceDetails<WithStreamedUnaryMethod_CreatePatchDeployment<WithStreamedUnaryMethod_GetPatchDeployment<WithStreamedUnaryMethod_ListPatchDeployments<WithStreamedUnaryMethod_DeletePatchDeployment<WithStreamedUnaryMethod_UpdatePatchDeployment<WithStreamedUnaryMethod_PausePatchDeployment<WithStreamedUnaryMethod_ResumePatchDeployment<Service > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ExecutePatchJob<WithStreamedUnaryMethod_GetPatchJob<WithStreamedUnaryMethod_CancelPatchJob<WithStreamedUnaryMethod_ListPatchJobs<WithStreamedUnaryMethod_ListPatchJobInstanceDetails<WithStreamedUnaryMethod_CreatePatchDeployment<WithStreamedUnaryMethod_GetPatchDeployment<WithStreamedUnaryMethod_ListPatchDeployments<WithStreamedUnaryMethod_DeletePatchDeployment<WithStreamedUnaryMethod_UpdatePatchDeployment<WithStreamedUnaryMethod_PausePatchDeployment<WithStreamedUnaryMethod_ResumePatchDeployment<Service > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace osconfig
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fosconfig_2fv1_2fosconfig_5fservice_2eproto__INCLUDED
