// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/talent/v4/company_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_TALENT_V4_COMPANY_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_TALENT_V4_COMPANY_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/talent/v4/company_service.grpc.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace talent_v4 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class CompanyServiceConnectionIdempotencyPolicy {
 public:
  virtual ~CompanyServiceConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<CompanyServiceConnectionIdempotencyPolicy> clone()
      const;

  virtual google::cloud::Idempotency CreateCompany(
      google::cloud::talent::v4::CreateCompanyRequest const& request);

  virtual google::cloud::Idempotency GetCompany(
      google::cloud::talent::v4::GetCompanyRequest const& request);

  virtual google::cloud::Idempotency UpdateCompany(
      google::cloud::talent::v4::UpdateCompanyRequest const& request);

  virtual google::cloud::Idempotency DeleteCompany(
      google::cloud::talent::v4::DeleteCompanyRequest const& request);

  virtual google::cloud::Idempotency ListCompanies(
      google::cloud::talent::v4::ListCompaniesRequest request);

  virtual google::cloud::Idempotency GetOperation(
      google::longrunning::GetOperationRequest const& request);
};

std::unique_ptr<CompanyServiceConnectionIdempotencyPolicy>
MakeDefaultCompanyServiceConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace talent_v4
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_TALENT_V4_COMPANY_CONNECTION_IDEMPOTENCY_POLICY_H
