// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/channel/v1/service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fchannel_2fv1_2fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fchannel_2fv1_2fservice_2eproto__INCLUDED

#include "google/cloud/channel/v1/service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace channel {
namespace v1 {

// CloudChannelService lets Google cloud resellers and distributors manage
// their customers, channel partners, entitlements, and reports.
//
// Using this service:
// 1. Resellers and distributors can manage a customer entity.
// 2. Distributors can register an authorized reseller in their channel and
//    provide them with delegated admin access.
// 3. Resellers and distributors can manage customer entitlements.
//
// CloudChannelService exposes the following resources:
// - [Customer][google.cloud.channel.v1.Customer]s: An entity-usually an
// enterprise-managed by a reseller or distributor.
//
// - [Entitlement][google.cloud.channel.v1.Entitlement]s: An entity that
// provides a customer with the means to use a service. Entitlements are created
// or updated as a result of a successful fulfillment.
//
// - [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink]s: An
// entity that identifies links between distributors and their indirect
// resellers in a channel.
class CloudChannelService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.channel.v1.CloudChannelService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // List [Customer][google.cloud.channel.v1.Customer]s.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    //
    // Return value:
    // List of [Customer][google.cloud.channel.v1.Customer]s, or an empty list if
    // there are no customers.
    virtual ::grpc::Status ListCustomers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomersRequest& request, ::google::cloud::channel::v1::ListCustomersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListCustomersResponse>> AsyncListCustomers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListCustomersResponse>>(AsyncListCustomersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListCustomersResponse>> PrepareAsyncListCustomers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListCustomersResponse>>(PrepareAsyncListCustomersRaw(context, request, cq));
    }
    // Returns the requested [Customer][google.cloud.channel.v1.Customer]
    // resource.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: The customer resource doesn't exist. Usually the result of an
    // invalid name parameter.
    //
    // Return value:
    // The [Customer][google.cloud.channel.v1.Customer] resource.
    virtual ::grpc::Status GetCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRequest& request, ::google::cloud::channel::v1::Customer* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>> AsyncGetCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>>(AsyncGetCustomerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>> PrepareAsyncGetCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>>(PrepareAsyncGetCustomerRaw(context, request, cq));
    }
    // Confirms the existence of Cloud Identity accounts based on the domain and
    // if the Cloud Identity accounts are owned by the reseller.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * INVALID_VALUE: Invalid domain value in the request.
    //
    // Return value:
    // A list of
    // [CloudIdentityCustomerAccount][google.cloud.channel.v1.CloudIdentityCustomerAccount]
    // resources for the domain (may be empty)
    //
    // Note: in the v1alpha1 version of the API, a NOT_FOUND error returns if
    // no
    // [CloudIdentityCustomerAccount][google.cloud.channel.v1.CloudIdentityCustomerAccount]
    // resources match the domain.
    virtual ::grpc::Status CheckCloudIdentityAccountsExist(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest& request, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>> AsyncCheckCloudIdentityAccountsExist(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>>(AsyncCheckCloudIdentityAccountsExistRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>> PrepareAsyncCheckCloudIdentityAccountsExist(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>>(PrepareAsyncCheckCloudIdentityAccountsExistRaw(context, request, cq));
    }
    // Creates a new [Customer][google.cloud.channel.v1.Customer] resource under
    // the reseller or distributor account.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED:
    //     * The reseller account making the request is different from the
    //     reseller account in the API request.
    //     * You are not authorized to create a customer. See
    //     https://support.google.com/channelservices/answer/9759265
    // * INVALID_ARGUMENT:
    //     * Required request parameters are missing or invalid.
    //     * Domain field value doesn't match the primary email domain.
    //
    // Return value:
    // The newly created [Customer][google.cloud.channel.v1.Customer] resource.
    virtual ::grpc::Status CreateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRequest& request, ::google::cloud::channel::v1::Customer* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>> AsyncCreateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>>(AsyncCreateCustomerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>> PrepareAsyncCreateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>>(PrepareAsyncCreateCustomerRaw(context, request, cq));
    }
    // Updates an existing [Customer][google.cloud.channel.v1.Customer] resource
    // for the reseller or distributor.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: No [Customer][google.cloud.channel.v1.Customer] resource found
    // for the name in the request.
    //
    // Return value:
    // The updated [Customer][google.cloud.channel.v1.Customer] resource.
    virtual ::grpc::Status UpdateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRequest& request, ::google::cloud::channel::v1::Customer* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>> AsyncUpdateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>>(AsyncUpdateCustomerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>> PrepareAsyncUpdateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>>(PrepareAsyncUpdateCustomerRaw(context, request, cq));
    }
    // Deletes the given [Customer][google.cloud.channel.v1.Customer] permanently.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The account making the request does not own
    // this customer.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * FAILED_PRECONDITION: The customer has existing entitlements.
    // * NOT_FOUND: No [Customer][google.cloud.channel.v1.Customer] resource found
    // for the name in the request.
    virtual ::grpc::Status DeleteCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteCustomerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteCustomerRaw(context, request, cq));
    }
    // Imports a [Customer][google.cloud.channel.v1.Customer] from the Cloud
    // Identity associated with the provided Cloud Identity ID or domain before a
    // TransferEntitlements call. If a linked Customer already exists and
    // overwrite_if_exists is true, it will update that Customer's data.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED:
    //     * The reseller account making the request is different from the
    //     reseller account in the API request.
    //     * You are not authorized to import the customer. See
    //     https://support.google.com/channelservices/answer/9759265
    // * NOT_FOUND: Cloud Identity doesn't exist or was deleted.
    // * INVALID_ARGUMENT: Required parameters are missing, or the auth_token is
    // expired or invalid.
    // * ALREADY_EXISTS: A customer already exists and has conflicting critical
    // fields. Requires an overwrite.
    //
    // Return value:
    // The [Customer][google.cloud.channel.v1.Customer].
    virtual ::grpc::Status ImportCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ImportCustomerRequest& request, ::google::cloud::channel::v1::Customer* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>> AsyncImportCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ImportCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>>(AsyncImportCustomerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>> PrepareAsyncImportCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ImportCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>>(PrepareAsyncImportCustomerRaw(context, request, cq));
    }
    // Creates a Cloud Identity for the given customer using the customer's
    // information, or the information provided here.
    //
    // Possible error codes:
    //
    // *  PERMISSION_DENIED:
    //      * The customer doesn't belong to the reseller.
    //      * You are not authorized to provision cloud identity id. See
    //      https://support.google.com/channelservices/answer/9759265
    // *  INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // *  NOT_FOUND: The customer was not found.
    // *  ALREADY_EXISTS: The customer's primary email already exists. Retry
    //    after changing the customer's primary contact email.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata contains an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status ProvisionCloudIdentity(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncProvisionCloudIdentity(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncProvisionCloudIdentityRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncProvisionCloudIdentity(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncProvisionCloudIdentityRaw(context, request, cq));
    }
    // Lists [Entitlement][google.cloud.channel.v1.Entitlement]s belonging to a
    // customer.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    //
    // Return value:
    // A list of the customer's
    // [Entitlement][google.cloud.channel.v1.Entitlement]s.
    virtual ::grpc::Status ListEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementsRequest& request, ::google::cloud::channel::v1::ListEntitlementsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListEntitlementsResponse>> AsyncListEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListEntitlementsResponse>>(AsyncListEntitlementsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListEntitlementsResponse>> PrepareAsyncListEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListEntitlementsResponse>>(PrepareAsyncListEntitlementsRaw(context, request, cq));
    }
    // List [TransferableSku][google.cloud.channel.v1.TransferableSku]s of a
    // customer based on the Cloud Identity ID or Customer Name in the request.
    //
    // Use this method to list the entitlements information of an
    // unowned customer. You should provide the customer's
    // Cloud Identity ID or Customer Name.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED:
    //     * The customer doesn't belong to the reseller and has no auth token.
    //     * The supplied auth token is invalid.
    //     * The reseller account making the request is different
    //     from the reseller account in the query.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    //
    // Return value:
    // A list of the customer's
    // [TransferableSku][google.cloud.channel.v1.TransferableSku].
    virtual ::grpc::Status ListTransferableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableSkusRequest& request, ::google::cloud::channel::v1::ListTransferableSkusResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListTransferableSkusResponse>> AsyncListTransferableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListTransferableSkusResponse>>(AsyncListTransferableSkusRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListTransferableSkusResponse>> PrepareAsyncListTransferableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListTransferableSkusResponse>>(PrepareAsyncListTransferableSkusRaw(context, request, cq));
    }
    // List [TransferableOffer][google.cloud.channel.v1.TransferableOffer]s of a
    // customer based on Cloud Identity ID or Customer Name in the request.
    //
    // Use this method when a reseller gets the entitlement information of an
    // unowned customer. The reseller should provide the customer's
    // Cloud Identity ID or Customer Name.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED:
    //     * The customer doesn't belong to the reseller and has no auth token.
    //     * The customer provided incorrect reseller information when generating
    //     auth token.
    //     * The reseller account making the request is different
    //     from the reseller account in the query.
    //     * The reseller is not authorized to transact on this Product. See
    //     https://support.google.com/channelservices/answer/9759265
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    //
    // Return value:
    // List of [TransferableOffer][google.cloud.channel.v1.TransferableOffer] for
    // the given customer and SKU.
    virtual ::grpc::Status ListTransferableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableOffersRequest& request, ::google::cloud::channel::v1::ListTransferableOffersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListTransferableOffersResponse>> AsyncListTransferableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableOffersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListTransferableOffersResponse>>(AsyncListTransferableOffersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListTransferableOffersResponse>> PrepareAsyncListTransferableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableOffersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListTransferableOffersResponse>>(PrepareAsyncListTransferableOffersRaw(context, request, cq));
    }
    // Returns the requested [Entitlement][google.cloud.channel.v1.Entitlement]
    // resource.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: The customer entitlement was not found.
    //
    // Return value:
    // The requested [Entitlement][google.cloud.channel.v1.Entitlement] resource.
    virtual ::grpc::Status GetEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetEntitlementRequest& request, ::google::cloud::channel::v1::Entitlement* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Entitlement>> AsyncGetEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Entitlement>>(AsyncGetEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Entitlement>> PrepareAsyncGetEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Entitlement>>(PrepareAsyncGetEntitlementRaw(context, request, cq));
    }
    // Creates an entitlement for a customer.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED:
    //     * The customer doesn't belong to the reseller.
    //     * The reseller is not authorized to transact on this Product. See
    //     https://support.google.com/channelservices/answer/9759265
    // * INVALID_ARGUMENT:
    //     * Required request parameters are missing or invalid.
    //     * There is already a customer entitlement for a SKU from the same
    //     product family.
    // * INVALID_VALUE: Make sure the OfferId is valid. If it is, contact
    // Google Channel support for further troubleshooting.
    // * NOT_FOUND: The customer or offer resource was not found.
    // * ALREADY_EXISTS:
    //     * The SKU was already purchased for the customer.
    //     * The customer's primary email already exists. Retry
    //     after changing the customer's primary contact email.
    // * CONDITION_NOT_MET or FAILED_PRECONDITION:
    //     * The domain required for purchasing a SKU has not been verified.
    //     * A pre-requisite SKU required to purchase an Add-On SKU is missing.
    //     For example, Google Workspace Business Starter is required to purchase
    //     Vault or Drive.
    //     * (Developer accounts only) Reseller and resold domain must meet the
    //     following naming requirements:
    //         * Domain names must start with goog-test.
    //         * Domain names must include the reseller domain.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status CreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateEntitlementRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateEntitlementRaw(context, request, cq));
    }
    // Change parameters of the entitlement.
    //
    // An entitlement update is a long-running operation and it updates the
    // entitlement as a result of fulfillment.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // For example, the number of seats being changed is greater than the allowed
    // number of max seats, or decreasing seats for a commitment based plan.
    // * NOT_FOUND: Entitlement resource not found.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status ChangeParameters(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeParametersRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncChangeParameters(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeParametersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncChangeParametersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncChangeParameters(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeParametersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncChangeParametersRaw(context, request, cq));
    }
    // Updates the renewal settings for an existing customer entitlement.
    //
    // An entitlement update is a long-running operation and it updates the
    // entitlement as a result of fulfillment.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: Entitlement resource not found.
    // * NOT_COMMITMENT_PLAN: Renewal Settings are only applicable for a
    // commitment plan. Can't enable or disable renewals for non-commitment plans.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    //   Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status ChangeRenewalSettings(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncChangeRenewalSettings(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncChangeRenewalSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncChangeRenewalSettings(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncChangeRenewalSettingsRaw(context, request, cq));
    }
    // Updates the Offer for an existing customer entitlement.
    //
    // An entitlement update is a long-running operation and it updates the
    // entitlement as a result of fulfillment.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: Offer or Entitlement resource not found.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status ChangeOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeOfferRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncChangeOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeOfferRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncChangeOfferRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncChangeOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeOfferRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncChangeOfferRaw(context, request, cq));
    }
    // Starts paid service for a trial entitlement.
    //
    // Starts paid service for a trial entitlement immediately. This method is
    // only applicable if a plan is set up for a trial entitlement but has some
    // trial days remaining.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: Entitlement resource not found.
    // * FAILED_PRECONDITION/NOT_IN_TRIAL: This method only works for
    // entitlement on trial plans.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status StartPaidService(::grpc::ClientContext* context, const ::google::cloud::channel::v1::StartPaidServiceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncStartPaidService(::grpc::ClientContext* context, const ::google::cloud::channel::v1::StartPaidServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncStartPaidServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncStartPaidService(::grpc::ClientContext* context, const ::google::cloud::channel::v1::StartPaidServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncStartPaidServiceRaw(context, request, cq));
    }
    // Suspends a previously fulfilled entitlement.
    //
    // An entitlement suspension is a long-running operation.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: Entitlement resource not found.
    // * NOT_ACTIVE: Entitlement is not active.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status SuspendEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::SuspendEntitlementRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncSuspendEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::SuspendEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncSuspendEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncSuspendEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::SuspendEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncSuspendEntitlementRaw(context, request, cq));
    }
    // Cancels a previously fulfilled entitlement.
    //
    // An entitlement cancellation is a long-running operation.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * FAILED_PRECONDITION: There are Google Cloud projects linked to the
    // Google Cloud entitlement's Cloud Billing subaccount.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: Entitlement resource not found.
    // * DELETION_TYPE_NOT_ALLOWED: Cancel is only allowed for Google Workspace
    // add-ons, or entitlements for Google Cloud's development platform.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The response will contain
    // google.protobuf.Empty on success. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status CancelEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CancelEntitlementRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCancelEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CancelEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCancelEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCancelEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CancelEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCancelEntitlementRaw(context, request, cq));
    }
    // Activates a previously suspended entitlement. Entitlements suspended for
    // pending ToS acceptance can't be activated using this method.
    //
    // An entitlement activation is a long-running operation and it updates
    // the state of the customer entitlement.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: Entitlement resource not found.
    // * SUSPENSION_NOT_RESELLER_INITIATED: Can only activate reseller-initiated
    // suspensions and entitlements that have accepted the TOS.
    // * NOT_SUSPENDED: Can only activate suspended entitlements not in an ACTIVE
    // state.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status ActivateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ActivateEntitlementRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncActivateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ActivateEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncActivateEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncActivateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ActivateEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncActivateEntitlementRaw(context, request, cq));
    }
    // Transfers customer entitlements to new reseller.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED:
    //     * The customer doesn't belong to the reseller.
    //     * The reseller is not authorized to transact on this Product. See
    //     https://support.google.com/channelservices/answer/9759265
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: The customer or offer resource was not found.
    // * ALREADY_EXISTS: The SKU was already transferred for the customer.
    // * CONDITION_NOT_MET or FAILED_PRECONDITION:
    //     * The SKU requires domain verification to transfer, but the domain is
    //     not verified.
    //     * An Add-On SKU (example, Vault or Drive) is missing the
    //     pre-requisite SKU (example, G Suite Basic).
    //     * (Developer accounts only) Reseller and resold domain must meet the
    //     following naming requirements:
    //         * Domain names must start with goog-test.
    //         * Domain names must include the reseller domain.
    //     * Specify all transferring entitlements.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status TransferEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncTransferEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncTransferEntitlementsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncTransferEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncTransferEntitlementsRaw(context, request, cq));
    }
    // Transfers customer entitlements from their current reseller to Google.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: The customer or offer resource was not found.
    // * ALREADY_EXISTS: The SKU was already transferred for the customer.
    // * CONDITION_NOT_MET or FAILED_PRECONDITION:
    //     * The SKU requires domain verification to transfer, but the domain is
    //     not verified.
    //     * An Add-On SKU (example, Vault or Drive) is missing the
    //     pre-requisite SKU (example, G Suite Basic).
    //     * (Developer accounts only) Reseller and resold domain must meet the
    //     following naming requirements:
    //         * Domain names must start with goog-test.
    //         * Domain names must include the reseller domain.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The response will contain
    // google.protobuf.Empty on success. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status TransferEntitlementsToGoogle(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncTransferEntitlementsToGoogle(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncTransferEntitlementsToGoogleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncTransferEntitlementsToGoogle(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncTransferEntitlementsToGoogleRaw(context, request, cq));
    }
    // List [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink]s
    // belonging to a distributor. You must be a distributor to call this method.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    //
    // Return value:
    // The list of the distributor account's
    // [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink] resources.
    virtual ::grpc::Status ListChannelPartnerLinks(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest& request, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>> AsyncListChannelPartnerLinks(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>>(AsyncListChannelPartnerLinksRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>> PrepareAsyncListChannelPartnerLinks(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>>(PrepareAsyncListChannelPartnerLinksRaw(context, request, cq));
    }
    // Returns the requested
    // [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink] resource.
    // You must be a distributor to call this method.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: ChannelPartnerLink resource not found because of an
    // invalid channel partner link name.
    //
    // Return value:
    // The [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink]
    // resource.
    virtual ::grpc::Status GetChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest& request, ::google::cloud::channel::v1::ChannelPartnerLink* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>> AsyncGetChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>>(AsyncGetChannelPartnerLinkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>> PrepareAsyncGetChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>>(PrepareAsyncGetChannelPartnerLinkRaw(context, request, cq));
    }
    // Initiates a channel partner link between a distributor and a reseller, or
    // between resellers in an n-tier reseller channel.
    // Invited partners need to follow the invite_link_uri provided in the
    // response to accept. After accepting the invitation, a link is set up
    // between the two parties.
    // You must be a distributor to call this method.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * ALREADY_EXISTS: The ChannelPartnerLink sent in the request already
    // exists.
    // * NOT_FOUND: No Cloud Identity customer exists for provided domain.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The new [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink]
    // resource.
    virtual ::grpc::Status CreateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest& request, ::google::cloud::channel::v1::ChannelPartnerLink* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>> AsyncCreateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>>(AsyncCreateChannelPartnerLinkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>> PrepareAsyncCreateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>>(PrepareAsyncCreateChannelPartnerLinkRaw(context, request, cq));
    }
    // Updates a channel partner link. Distributors call this method to change a
    // link's status. For example, to suspend a partner link.
    // You must be a distributor to call this method.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT:
    //     * Required request parameters are missing or invalid.
    //     * Link state cannot change from invited to active or suspended.
    //     * Cannot send reseller_cloud_identity_id, invite_url, or name in update
    //     mask.
    // * NOT_FOUND: ChannelPartnerLink resource not found.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The updated
    // [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink] resource.
    virtual ::grpc::Status UpdateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest& request, ::google::cloud::channel::v1::ChannelPartnerLink* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>> AsyncUpdateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>>(AsyncUpdateChannelPartnerLinkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>> PrepareAsyncUpdateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>>(PrepareAsyncUpdateChannelPartnerLinkRaw(context, request, cq));
    }
    // Gets information about how a Reseller modifies their bill before sending
    // it to a Customer.
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different.
    // * NOT_FOUND: The
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // was not found.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // resource, otherwise returns an error.
    virtual ::grpc::Status GetCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest& request, ::google::cloud::channel::v1::CustomerRepricingConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>> AsyncGetCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>>(AsyncGetCustomerRepricingConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>> PrepareAsyncGetCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>>(PrepareAsyncGetCustomerRepricingConfigRaw(context, request, cq));
    }
    // Lists information about how a Reseller modifies their bill before sending
    // it to a Customer.
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different.
    // * NOT_FOUND: The
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // specified does not exist or is not associated with the given account.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // resources. The data for each resource is displayed in the ascending order
    // of:
    //
    // * Customer ID
    // * [RepricingConfig.EntitlementGranularity.entitlement][google.cloud.channel.v1.RepricingConfig.EntitlementGranularity.entitlement]
    // * [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
    // * [CustomerRepricingConfig.update_time][google.cloud.channel.v1.CustomerRepricingConfig.update_time]
    //
    // If unsuccessful, returns an error.
    virtual ::grpc::Status ListCustomerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest& request, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>> AsyncListCustomerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>>(AsyncListCustomerRepricingConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>> PrepareAsyncListCustomerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>>(PrepareAsyncListCustomerRepricingConfigsRaw(context, request, cq));
    }
    // Creates a CustomerRepricingConfig. Call this method to set modifications
    // for a specific customer's bill. You can only create configs if the
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
    // is a future month. If needed, you can create a config for the current
    // month, with some restrictions.
    //
    // When creating a config for a future month, make sure there are no existing
    // configs for that
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
    //
    // The following restrictions are for creating configs in the current month.
    //
    // * This functionality is reserved for recovering from an erroneous config,
    // and should not be used for regular business cases.
    // * The new config will not modify exports used with other configs.
    // Changes to the config may be immediate, but may take up to 24 hours.
    // * There is a limit of ten configs for any
    // [RepricingConfig.EntitlementGranularity.entitlement][google.cloud.channel.v1.RepricingConfig.EntitlementGranularity.entitlement],
    // for any
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
    // * The contained
    // [CustomerRepricingConfig.repricing_config][google.cloud.channel.v1.CustomerRepricingConfig.repricing_config]
    // value must be different from the value used in the current config for a
    // [RepricingConfig.EntitlementGranularity.entitlement][google.cloud.channel.v1.RepricingConfig.EntitlementGranularity.entitlement].
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different.
    // * INVALID_ARGUMENT: Missing or invalid required parameters in the
    // request. Also displays if the updated config is for the current month or
    // past months.
    // * NOT_FOUND: The
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // specified does not exist or is not associated with the given account.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the updated
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // resource, otherwise returns an error.
    virtual ::grpc::Status CreateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest& request, ::google::cloud::channel::v1::CustomerRepricingConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>> AsyncCreateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>>(AsyncCreateCustomerRepricingConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>> PrepareAsyncCreateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>>(PrepareAsyncCreateCustomerRepricingConfigRaw(context, request, cq));
    }
    // Updates a CustomerRepricingConfig. Call this method to set modifications
    // for a specific customer's bill. This method overwrites the existing
    // CustomerRepricingConfig.
    //
    // You can only update configs if the
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
    // is a future month. To make changes to configs for the current month, use
    // [CreateCustomerRepricingConfig][google.cloud.channel.v1.CloudChannelService.CreateCustomerRepricingConfig],
    // taking note of its restrictions. You cannot update the
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
    //
    // When updating a config in the future:
    //
    // * This config must already exist.
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different.
    // * INVALID_ARGUMENT: Missing or invalid required parameters in the
    // request. Also displays if the updated config is for the current month or
    // past months.
    // * NOT_FOUND: The
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // specified does not exist or is not associated with the given account.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the updated
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // resource, otherwise returns an error.
    virtual ::grpc::Status UpdateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest& request, ::google::cloud::channel::v1::CustomerRepricingConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>> AsyncUpdateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>>(AsyncUpdateCustomerRepricingConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>> PrepareAsyncUpdateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>>(PrepareAsyncUpdateCustomerRepricingConfigRaw(context, request, cq));
    }
    // Deletes the given
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // permanently. You can only delete configs if their
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
    // is set to a date after the current month.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The account making the request does not own
    // this customer.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * FAILED_PRECONDITION: The
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // is active or in the past.
    // * NOT_FOUND: No
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // found for the name in the request.
    virtual ::grpc::Status DeleteCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteCustomerRepricingConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteCustomerRepricingConfigRaw(context, request, cq));
    }
    // Gets information about how a Distributor modifies their bill before sending
    // it to a ChannelPartner.
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different.
    // * NOT_FOUND: The
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // was not found.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // resource, otherwise returns an error.
    virtual ::grpc::Status GetChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest& request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>> AsyncGetChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>>(AsyncGetChannelPartnerRepricingConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>> PrepareAsyncGetChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>>(PrepareAsyncGetChannelPartnerRepricingConfigRaw(context, request, cq));
    }
    // Lists information about how a Reseller modifies their bill before sending
    // it to a ChannelPartner.
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different.
    // * NOT_FOUND: The
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // specified does not exist or is not associated with the given account.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // resources. The data for each resource is displayed in the ascending order
    // of:
    //
    // * Channel Partner ID
    // * [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
    // * [ChannelPartnerRepricingConfig.update_time][google.cloud.channel.v1.ChannelPartnerRepricingConfig.update_time]
    //
    // If unsuccessful, returns an error.
    virtual ::grpc::Status ListChannelPartnerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest& request, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>> AsyncListChannelPartnerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>>(AsyncListChannelPartnerRepricingConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>> PrepareAsyncListChannelPartnerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>>(PrepareAsyncListChannelPartnerRepricingConfigsRaw(context, request, cq));
    }
    // Creates a ChannelPartnerRepricingConfig. Call this method to set
    // modifications for a specific ChannelPartner's bill. You can only create
    // configs if the
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
    // is a future month. If needed, you can create a config for the current
    // month, with some restrictions.
    //
    // When creating a config for a future month, make sure there are no existing
    // configs for that
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
    //
    // The following restrictions are for creating configs in the current month.
    //
    // * This functionality is reserved for recovering from an erroneous config,
    // and should not be used for regular business cases.
    // * The new config will not modify exports used with other configs.
    // Changes to the config may be immediate, but may take up to 24 hours.
    // * There is a limit of ten configs for any ChannelPartner or
    // [RepricingConfig.EntitlementGranularity.entitlement][google.cloud.channel.v1.RepricingConfig.EntitlementGranularity.entitlement],
    // for any
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
    // * The contained
    // [ChannelPartnerRepricingConfig.repricing_config][google.cloud.channel.v1.ChannelPartnerRepricingConfig.repricing_config]
    // value must be different from the value used in the current config for a
    // ChannelPartner.
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different.
    // * INVALID_ARGUMENT: Missing or invalid required parameters in the
    // request. Also displays if the updated config is for the current month or
    // past months.
    // * NOT_FOUND: The
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // specified does not exist or is not associated with the given account.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the updated
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // resource, otherwise returns an error.
    virtual ::grpc::Status CreateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest& request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>> AsyncCreateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>>(AsyncCreateChannelPartnerRepricingConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>> PrepareAsyncCreateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>>(PrepareAsyncCreateChannelPartnerRepricingConfigRaw(context, request, cq));
    }
    // Updates a ChannelPartnerRepricingConfig. Call this method to set
    // modifications for a specific ChannelPartner's bill. This method overwrites
    // the existing CustomerRepricingConfig.
    //
    // You can only update configs if the
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
    // is a future month. To make changes to configs for the current month, use
    // [CreateChannelPartnerRepricingConfig][google.cloud.channel.v1.CloudChannelService.CreateChannelPartnerRepricingConfig],
    // taking note of its restrictions. You cannot update the
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
    //
    // When updating a config in the future:
    //
    // * This config must already exist.
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different.
    // * INVALID_ARGUMENT: Missing or invalid required parameters in the
    // request. Also displays if the updated config is for the current month or
    // past months.
    // * NOT_FOUND: The
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // specified does not exist or is not associated with the given account.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the updated
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // resource, otherwise returns an error.
    virtual ::grpc::Status UpdateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest& request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>> AsyncUpdateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>>(AsyncUpdateChannelPartnerRepricingConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>> PrepareAsyncUpdateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>>(PrepareAsyncUpdateChannelPartnerRepricingConfigRaw(context, request, cq));
    }
    // Deletes the given
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // permanently. You can only delete configs if their
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
    // is set to a date after the current month.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The account making the request does not own
    // this customer.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * FAILED_PRECONDITION: The
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // is active or in the past.
    // * NOT_FOUND: No
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // found for the name in the request.
    virtual ::grpc::Status DeleteChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteChannelPartnerRepricingConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteChannelPartnerRepricingConfigRaw(context, request, cq));
    }
    // Lists the Rebilling supported SKU groups the account is authorized to
    // sell.
    // Reference: https://cloud.google.com/skus/sku-groups
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different, or the account doesn't exist.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the [SkuGroup][google.cloud.channel.v1.SkuGroup] resources.
    // The data for each resource is displayed in the alphabetical order of SKU
    // group display name.
    // The data for each resource is displayed in the ascending order of
    // [SkuGroup.display_name][google.cloud.channel.v1.SkuGroup.display_name]
    //
    // If unsuccessful, returns an error.
    virtual ::grpc::Status ListSkuGroups(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupsRequest& request, ::google::cloud::channel::v1::ListSkuGroupsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkuGroupsResponse>> AsyncListSkuGroups(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkuGroupsResponse>>(AsyncListSkuGroupsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkuGroupsResponse>> PrepareAsyncListSkuGroups(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkuGroupsResponse>>(PrepareAsyncListSkuGroupsRaw(context, request, cq));
    }
    // Lists the Billable SKUs in a given SKU group.
    //
    // Possible error codes:
    // PERMISSION_DENIED: If the account making the request and the account
    // being queried for are different, or the account doesn't exist.
    // INVALID_ARGUMENT: Missing or invalid required parameters in the
    // request.
    // INTERNAL: Any non-user error related to technical issue in the
    // backend. In this case, contact cloud channel support.
    //
    // Return Value:
    // If successful, the [BillableSku][google.cloud.channel.v1.BillableSku]
    // resources. The data for each resource is displayed in the ascending order
    // of:
    //
    // * [BillableSku.service_display_name][google.cloud.channel.v1.BillableSku.service_display_name]
    // * [BillableSku.sku_display_name][google.cloud.channel.v1.BillableSku.sku_display_name]
    //
    // If unsuccessful, returns an error.
    virtual ::grpc::Status ListSkuGroupBillableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest& request, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>> AsyncListSkuGroupBillableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>>(AsyncListSkuGroupBillableSkusRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>> PrepareAsyncListSkuGroupBillableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>>(PrepareAsyncListSkuGroupBillableSkusRaw(context, request, cq));
    }
    // Returns the requested [Offer][google.cloud.channel.v1.Offer] resource.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The entitlement doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: Entitlement or offer was not found.
    //
    // Return value:
    // The [Offer][google.cloud.channel.v1.Offer] resource.
    virtual ::grpc::Status LookupOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::LookupOfferRequest& request, ::google::cloud::channel::v1::Offer* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Offer>> AsyncLookupOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::LookupOfferRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Offer>>(AsyncLookupOfferRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Offer>> PrepareAsyncLookupOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::LookupOfferRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Offer>>(PrepareAsyncLookupOfferRaw(context, request, cq));
    }
    // Lists the Products the reseller is authorized to sell.
    //
    // Possible error codes:
    //
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    virtual ::grpc::Status ListProducts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListProductsRequest& request, ::google::cloud::channel::v1::ListProductsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListProductsResponse>> AsyncListProducts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListProductsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListProductsResponse>>(AsyncListProductsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListProductsResponse>> PrepareAsyncListProducts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListProductsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListProductsResponse>>(PrepareAsyncListProductsRaw(context, request, cq));
    }
    // Lists the SKUs for a product the reseller is authorized to sell.
    //
    // Possible error codes:
    //
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    virtual ::grpc::Status ListSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkusRequest& request, ::google::cloud::channel::v1::ListSkusResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkusResponse>> AsyncListSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkusResponse>>(AsyncListSkusRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkusResponse>> PrepareAsyncListSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkusResponse>>(PrepareAsyncListSkusRaw(context, request, cq));
    }
    // Lists the Offers the reseller can sell.
    //
    // Possible error codes:
    //
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    virtual ::grpc::Status ListOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListOffersRequest& request, ::google::cloud::channel::v1::ListOffersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListOffersResponse>> AsyncListOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListOffersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListOffersResponse>>(AsyncListOffersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListOffersResponse>> PrepareAsyncListOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListOffersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListOffersResponse>>(PrepareAsyncListOffersRaw(context, request, cq));
    }
    // Lists the following:
    //
    // * SKUs that you can purchase for a customer
    // * SKUs that you can upgrade or downgrade for an entitlement.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    virtual ::grpc::Status ListPurchasableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableSkusRequest& request, ::google::cloud::channel::v1::ListPurchasableSkusResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListPurchasableSkusResponse>> AsyncListPurchasableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListPurchasableSkusResponse>>(AsyncListPurchasableSkusRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListPurchasableSkusResponse>> PrepareAsyncListPurchasableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListPurchasableSkusResponse>>(PrepareAsyncListPurchasableSkusRaw(context, request, cq));
    }
    // Lists the following:
    //
    // * Offers that you can purchase for a customer.
    // * Offers that you can change for an entitlement.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED:
    //     * The customer doesn't belong to the reseller
    //     * The reseller is not authorized to transact on this Product. See
    //     https://support.google.com/channelservices/answer/9759265
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    virtual ::grpc::Status ListPurchasableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableOffersRequest& request, ::google::cloud::channel::v1::ListPurchasableOffersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListPurchasableOffersResponse>> AsyncListPurchasableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableOffersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListPurchasableOffersResponse>>(AsyncListPurchasableOffersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListPurchasableOffersResponse>> PrepareAsyncListPurchasableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableOffersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListPurchasableOffersResponse>>(PrepareAsyncListPurchasableOffersRaw(context, request, cq));
    }
    // Lists the billing accounts that are eligible to purchase particular SKUs
    // for a given customer.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    //
    // Return value:
    // Based on the provided list of SKUs, returns a list of SKU groups that must
    // be purchased using the same billing account and the billing accounts
    // eligible to purchase each SKU group.
    virtual ::grpc::Status QueryEligibleBillingAccounts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest& request, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>> AsyncQueryEligibleBillingAccounts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>>(AsyncQueryEligibleBillingAccountsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>> PrepareAsyncQueryEligibleBillingAccounts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>>(PrepareAsyncQueryEligibleBillingAccountsRaw(context, request, cq));
    }
    // Registers a service account with subscriber privileges on the Cloud Pub/Sub
    // topic for this Channel Services account. After you create a
    // subscriber, you get the events through
    // [SubscriberEvent][google.cloud.channel.v1.SubscriberEvent]
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request and the
    // provided reseller account are different, or the impersonated user
    // is not a super admin.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The topic name with the registered service email address.
    virtual ::grpc::Status RegisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RegisterSubscriberRequest& request, ::google::cloud::channel::v1::RegisterSubscriberResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::RegisterSubscriberResponse>> AsyncRegisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RegisterSubscriberRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::RegisterSubscriberResponse>>(AsyncRegisterSubscriberRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::RegisterSubscriberResponse>> PrepareAsyncRegisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RegisterSubscriberRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::RegisterSubscriberResponse>>(PrepareAsyncRegisterSubscriberRaw(context, request, cq));
    }
    // Unregisters a service account with subscriber privileges on the Cloud
    // Pub/Sub topic created for this Channel Services account. If there are no
    // service accounts left with subscriber privileges, this deletes the topic.
    // You can call ListSubscribers to check for these accounts.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request and the
    // provided reseller account are different, or the impersonated user
    // is not a super admin.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: The topic resource doesn't exist.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The topic name that unregistered the service email address.
    // Returns a success response if the service email address wasn't registered
    // with the topic.
    virtual ::grpc::Status UnregisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UnregisterSubscriberRequest& request, ::google::cloud::channel::v1::UnregisterSubscriberResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::UnregisterSubscriberResponse>> AsyncUnregisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UnregisterSubscriberRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::UnregisterSubscriberResponse>>(AsyncUnregisterSubscriberRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::UnregisterSubscriberResponse>> PrepareAsyncUnregisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UnregisterSubscriberRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::UnregisterSubscriberResponse>>(PrepareAsyncUnregisterSubscriberRaw(context, request, cq));
    }
    // Lists service accounts with subscriber privileges on the Cloud Pub/Sub
    // topic created for this Channel Services account.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request and the
    // provided reseller account are different, or the impersonated user
    // is not a super admin.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: The topic resource doesn't exist.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // A list of service email addresses.
    virtual ::grpc::Status ListSubscribers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSubscribersRequest& request, ::google::cloud::channel::v1::ListSubscribersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSubscribersResponse>> AsyncListSubscribers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSubscribersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSubscribersResponse>>(AsyncListSubscribersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSubscribersResponse>> PrepareAsyncListSubscribers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSubscribersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSubscribersResponse>>(PrepareAsyncListSubscribersRaw(context, request, cq));
    }
    // List entitlement history.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request and the
    // provided reseller account are different.
    // * INVALID_ARGUMENT: Missing or invalid required fields in the request.
    // * NOT_FOUND: The parent resource doesn't exist. Usually the result of an
    // invalid name parameter.
    // * INTERNAL: Any non-user error related to a technical issue in the backend.
    // In this case, contact CloudChannel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // In this case, contact Cloud Channel support.
    //
    // Return value:
    // List of [EntitlementChange][google.cloud.channel.v1.EntitlementChange]s.
    virtual ::grpc::Status ListEntitlementChanges(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementChangesRequest& request, ::google::cloud::channel::v1::ListEntitlementChangesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListEntitlementChangesResponse>> AsyncListEntitlementChanges(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementChangesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListEntitlementChangesResponse>>(AsyncListEntitlementChangesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListEntitlementChangesResponse>> PrepareAsyncListEntitlementChanges(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementChangesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListEntitlementChangesResponse>>(PrepareAsyncListEntitlementChangesRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // List [Customer][google.cloud.channel.v1.Customer]s.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The reseller account making the request is different
      // from the reseller account in the API request.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      //
      // Return value:
      // List of [Customer][google.cloud.channel.v1.Customer]s, or an empty list if
      // there are no customers.
      virtual void ListCustomers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomersRequest* request, ::google::cloud::channel::v1::ListCustomersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListCustomers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomersRequest* request, ::google::cloud::channel::v1::ListCustomersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the requested [Customer][google.cloud.channel.v1.Customer]
      // resource.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The reseller account making the request is different
      // from the reseller account in the API request.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * NOT_FOUND: The customer resource doesn't exist. Usually the result of an
      // invalid name parameter.
      //
      // Return value:
      // The [Customer][google.cloud.channel.v1.Customer] resource.
      virtual void GetCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRequest* request, ::google::cloud::channel::v1::Customer* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRequest* request, ::google::cloud::channel::v1::Customer* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Confirms the existence of Cloud Identity accounts based on the domain and
      // if the Cloud Identity accounts are owned by the reseller.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The reseller account making the request is different
      // from the reseller account in the API request.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * INVALID_VALUE: Invalid domain value in the request.
      //
      // Return value:
      // A list of
      // [CloudIdentityCustomerAccount][google.cloud.channel.v1.CloudIdentityCustomerAccount]
      // resources for the domain (may be empty)
      //
      // Note: in the v1alpha1 version of the API, a NOT_FOUND error returns if
      // no
      // [CloudIdentityCustomerAccount][google.cloud.channel.v1.CloudIdentityCustomerAccount]
      // resources match the domain.
      virtual void CheckCloudIdentityAccountsExist(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest* request, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CheckCloudIdentityAccountsExist(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest* request, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new [Customer][google.cloud.channel.v1.Customer] resource under
      // the reseller or distributor account.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED:
      //     * The reseller account making the request is different from the
      //     reseller account in the API request.
      //     * You are not authorized to create a customer. See
      //     https://support.google.com/channelservices/answer/9759265
      // * INVALID_ARGUMENT:
      //     * Required request parameters are missing or invalid.
      //     * Domain field value doesn't match the primary email domain.
      //
      // Return value:
      // The newly created [Customer][google.cloud.channel.v1.Customer] resource.
      virtual void CreateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRequest* request, ::google::cloud::channel::v1::Customer* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRequest* request, ::google::cloud::channel::v1::Customer* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an existing [Customer][google.cloud.channel.v1.Customer] resource
      // for the reseller or distributor.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The reseller account making the request is different
      // from the reseller account in the API request.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * NOT_FOUND: No [Customer][google.cloud.channel.v1.Customer] resource found
      // for the name in the request.
      //
      // Return value:
      // The updated [Customer][google.cloud.channel.v1.Customer] resource.
      virtual void UpdateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRequest* request, ::google::cloud::channel::v1::Customer* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRequest* request, ::google::cloud::channel::v1::Customer* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the given [Customer][google.cloud.channel.v1.Customer] permanently.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The account making the request does not own
      // this customer.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * FAILED_PRECONDITION: The customer has existing entitlements.
      // * NOT_FOUND: No [Customer][google.cloud.channel.v1.Customer] resource found
      // for the name in the request.
      virtual void DeleteCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Imports a [Customer][google.cloud.channel.v1.Customer] from the Cloud
      // Identity associated with the provided Cloud Identity ID or domain before a
      // TransferEntitlements call. If a linked Customer already exists and
      // overwrite_if_exists is true, it will update that Customer's data.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED:
      //     * The reseller account making the request is different from the
      //     reseller account in the API request.
      //     * You are not authorized to import the customer. See
      //     https://support.google.com/channelservices/answer/9759265
      // * NOT_FOUND: Cloud Identity doesn't exist or was deleted.
      // * INVALID_ARGUMENT: Required parameters are missing, or the auth_token is
      // expired or invalid.
      // * ALREADY_EXISTS: A customer already exists and has conflicting critical
      // fields. Requires an overwrite.
      //
      // Return value:
      // The [Customer][google.cloud.channel.v1.Customer].
      virtual void ImportCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ImportCustomerRequest* request, ::google::cloud::channel::v1::Customer* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ImportCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ImportCustomerRequest* request, ::google::cloud::channel::v1::Customer* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a Cloud Identity for the given customer using the customer's
      // information, or the information provided here.
      //
      // Possible error codes:
      //
      // *  PERMISSION_DENIED:
      //      * The customer doesn't belong to the reseller.
      //      * You are not authorized to provision cloud identity id. See
      //      https://support.google.com/channelservices/answer/9759265
      // *  INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // *  NOT_FOUND: The customer was not found.
      // *  ALREADY_EXISTS: The customer's primary email already exists. Retry
      //    after changing the customer's primary contact email.
      // * INTERNAL: Any non-user error related to a technical issue in the
      // backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      // Contact Cloud Channel support.
      //
      // Return value:
      // The ID of a long-running operation.
      //
      // To get the results of the operation, call the GetOperation method of
      // CloudChannelOperationsService. The Operation metadata contains an
      // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
      virtual void ProvisionCloudIdentity(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ProvisionCloudIdentity(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists [Entitlement][google.cloud.channel.v1.Entitlement]s belonging to a
      // customer.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      //
      // Return value:
      // A list of the customer's
      // [Entitlement][google.cloud.channel.v1.Entitlement]s.
      virtual void ListEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementsRequest* request, ::google::cloud::channel::v1::ListEntitlementsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementsRequest* request, ::google::cloud::channel::v1::ListEntitlementsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List [TransferableSku][google.cloud.channel.v1.TransferableSku]s of a
      // customer based on the Cloud Identity ID or Customer Name in the request.
      //
      // Use this method to list the entitlements information of an
      // unowned customer. You should provide the customer's
      // Cloud Identity ID or Customer Name.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED:
      //     * The customer doesn't belong to the reseller and has no auth token.
      //     * The supplied auth token is invalid.
      //     * The reseller account making the request is different
      //     from the reseller account in the query.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      //
      // Return value:
      // A list of the customer's
      // [TransferableSku][google.cloud.channel.v1.TransferableSku].
      virtual void ListTransferableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableSkusRequest* request, ::google::cloud::channel::v1::ListTransferableSkusResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTransferableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableSkusRequest* request, ::google::cloud::channel::v1::ListTransferableSkusResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List [TransferableOffer][google.cloud.channel.v1.TransferableOffer]s of a
      // customer based on Cloud Identity ID or Customer Name in the request.
      //
      // Use this method when a reseller gets the entitlement information of an
      // unowned customer. The reseller should provide the customer's
      // Cloud Identity ID or Customer Name.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED:
      //     * The customer doesn't belong to the reseller and has no auth token.
      //     * The customer provided incorrect reseller information when generating
      //     auth token.
      //     * The reseller account making the request is different
      //     from the reseller account in the query.
      //     * The reseller is not authorized to transact on this Product. See
      //     https://support.google.com/channelservices/answer/9759265
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      //
      // Return value:
      // List of [TransferableOffer][google.cloud.channel.v1.TransferableOffer] for
      // the given customer and SKU.
      virtual void ListTransferableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableOffersRequest* request, ::google::cloud::channel::v1::ListTransferableOffersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTransferableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableOffersRequest* request, ::google::cloud::channel::v1::ListTransferableOffersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the requested [Entitlement][google.cloud.channel.v1.Entitlement]
      // resource.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * NOT_FOUND: The customer entitlement was not found.
      //
      // Return value:
      // The requested [Entitlement][google.cloud.channel.v1.Entitlement] resource.
      virtual void GetEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetEntitlementRequest* request, ::google::cloud::channel::v1::Entitlement* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetEntitlementRequest* request, ::google::cloud::channel::v1::Entitlement* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an entitlement for a customer.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED:
      //     * The customer doesn't belong to the reseller.
      //     * The reseller is not authorized to transact on this Product. See
      //     https://support.google.com/channelservices/answer/9759265
      // * INVALID_ARGUMENT:
      //     * Required request parameters are missing or invalid.
      //     * There is already a customer entitlement for a SKU from the same
      //     product family.
      // * INVALID_VALUE: Make sure the OfferId is valid. If it is, contact
      // Google Channel support for further troubleshooting.
      // * NOT_FOUND: The customer or offer resource was not found.
      // * ALREADY_EXISTS:
      //     * The SKU was already purchased for the customer.
      //     * The customer's primary email already exists. Retry
      //     after changing the customer's primary contact email.
      // * CONDITION_NOT_MET or FAILED_PRECONDITION:
      //     * The domain required for purchasing a SKU has not been verified.
      //     * A pre-requisite SKU required to purchase an Add-On SKU is missing.
      //     For example, Google Workspace Business Starter is required to purchase
      //     Vault or Drive.
      //     * (Developer accounts only) Reseller and resold domain must meet the
      //     following naming requirements:
      //         * Domain names must start with goog-test.
      //         * Domain names must include the reseller domain.
      // * INTERNAL: Any non-user error related to a technical issue in the
      // backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      // Contact Cloud Channel support.
      //
      // Return value:
      // The ID of a long-running operation.
      //
      // To get the results of the operation, call the GetOperation method of
      // CloudChannelOperationsService. The Operation metadata will contain an
      // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
      virtual void CreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateEntitlementRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateEntitlementRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Change parameters of the entitlement.
      //
      // An entitlement update is a long-running operation and it updates the
      // entitlement as a result of fulfillment.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // For example, the number of seats being changed is greater than the allowed
      // number of max seats, or decreasing seats for a commitment based plan.
      // * NOT_FOUND: Entitlement resource not found.
      // * INTERNAL: Any non-user error related to a technical issue in the
      // backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      // Contact Cloud Channel support.
      //
      // Return value:
      // The ID of a long-running operation.
      //
      // To get the results of the operation, call the GetOperation method of
      // CloudChannelOperationsService. The Operation metadata will contain an
      // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
      virtual void ChangeParameters(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeParametersRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ChangeParameters(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeParametersRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the renewal settings for an existing customer entitlement.
      //
      // An entitlement update is a long-running operation and it updates the
      // entitlement as a result of fulfillment.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * NOT_FOUND: Entitlement resource not found.
      // * NOT_COMMITMENT_PLAN: Renewal Settings are only applicable for a
      // commitment plan. Can't enable or disable renewals for non-commitment plans.
      // * INTERNAL: Any non-user error related to a technical issue in the
      // backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      //   Contact Cloud Channel support.
      //
      // Return value:
      // The ID of a long-running operation.
      //
      // To get the results of the operation, call the GetOperation method of
      // CloudChannelOperationsService. The Operation metadata will contain an
      // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
      virtual void ChangeRenewalSettings(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ChangeRenewalSettings(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the Offer for an existing customer entitlement.
      //
      // An entitlement update is a long-running operation and it updates the
      // entitlement as a result of fulfillment.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * NOT_FOUND: Offer or Entitlement resource not found.
      // * INTERNAL: Any non-user error related to a technical issue in the
      // backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      // Contact Cloud Channel support.
      //
      // Return value:
      // The ID of a long-running operation.
      //
      // To get the results of the operation, call the GetOperation method of
      // CloudChannelOperationsService. The Operation metadata will contain an
      // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
      virtual void ChangeOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeOfferRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ChangeOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeOfferRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Starts paid service for a trial entitlement.
      //
      // Starts paid service for a trial entitlement immediately. This method is
      // only applicable if a plan is set up for a trial entitlement but has some
      // trial days remaining.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * NOT_FOUND: Entitlement resource not found.
      // * FAILED_PRECONDITION/NOT_IN_TRIAL: This method only works for
      // entitlement on trial plans.
      // * INTERNAL: Any non-user error related to a technical issue in the
      // backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      // Contact Cloud Channel support.
      //
      // Return value:
      // The ID of a long-running operation.
      //
      // To get the results of the operation, call the GetOperation method of
      // CloudChannelOperationsService. The Operation metadata will contain an
      // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
      virtual void StartPaidService(::grpc::ClientContext* context, const ::google::cloud::channel::v1::StartPaidServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void StartPaidService(::grpc::ClientContext* context, const ::google::cloud::channel::v1::StartPaidServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Suspends a previously fulfilled entitlement.
      //
      // An entitlement suspension is a long-running operation.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * NOT_FOUND: Entitlement resource not found.
      // * NOT_ACTIVE: Entitlement is not active.
      // * INTERNAL: Any non-user error related to a technical issue in the
      // backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      // Contact Cloud Channel support.
      //
      // Return value:
      // The ID of a long-running operation.
      //
      // To get the results of the operation, call the GetOperation method of
      // CloudChannelOperationsService. The Operation metadata will contain an
      // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
      virtual void SuspendEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::SuspendEntitlementRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SuspendEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::SuspendEntitlementRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Cancels a previously fulfilled entitlement.
      //
      // An entitlement cancellation is a long-running operation.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The reseller account making the request is different
      // from the reseller account in the API request.
      // * FAILED_PRECONDITION: There are Google Cloud projects linked to the
      // Google Cloud entitlement's Cloud Billing subaccount.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * NOT_FOUND: Entitlement resource not found.
      // * DELETION_TYPE_NOT_ALLOWED: Cancel is only allowed for Google Workspace
      // add-ons, or entitlements for Google Cloud's development platform.
      // * INTERNAL: Any non-user error related to a technical issue in the
      // backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      // Contact Cloud Channel support.
      //
      // Return value:
      // The ID of a long-running operation.
      //
      // To get the results of the operation, call the GetOperation method of
      // CloudChannelOperationsService. The response will contain
      // google.protobuf.Empty on success. The Operation metadata will contain an
      // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
      virtual void CancelEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CancelEntitlementRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CancelEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CancelEntitlementRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Activates a previously suspended entitlement. Entitlements suspended for
      // pending ToS acceptance can't be activated using this method.
      //
      // An entitlement activation is a long-running operation and it updates
      // the state of the customer entitlement.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The reseller account making the request is different
      // from the reseller account in the API request.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * NOT_FOUND: Entitlement resource not found.
      // * SUSPENSION_NOT_RESELLER_INITIATED: Can only activate reseller-initiated
      // suspensions and entitlements that have accepted the TOS.
      // * NOT_SUSPENDED: Can only activate suspended entitlements not in an ACTIVE
      // state.
      // * INTERNAL: Any non-user error related to a technical issue in the
      // backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      // Contact Cloud Channel support.
      //
      // Return value:
      // The ID of a long-running operation.
      //
      // To get the results of the operation, call the GetOperation method of
      // CloudChannelOperationsService. The Operation metadata will contain an
      // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
      virtual void ActivateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ActivateEntitlementRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ActivateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ActivateEntitlementRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Transfers customer entitlements to new reseller.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED:
      //     * The customer doesn't belong to the reseller.
      //     * The reseller is not authorized to transact on this Product. See
      //     https://support.google.com/channelservices/answer/9759265
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * NOT_FOUND: The customer or offer resource was not found.
      // * ALREADY_EXISTS: The SKU was already transferred for the customer.
      // * CONDITION_NOT_MET or FAILED_PRECONDITION:
      //     * The SKU requires domain verification to transfer, but the domain is
      //     not verified.
      //     * An Add-On SKU (example, Vault or Drive) is missing the
      //     pre-requisite SKU (example, G Suite Basic).
      //     * (Developer accounts only) Reseller and resold domain must meet the
      //     following naming requirements:
      //         * Domain names must start with goog-test.
      //         * Domain names must include the reseller domain.
      //     * Specify all transferring entitlements.
      // * INTERNAL: Any non-user error related to a technical issue in the
      // backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      // Contact Cloud Channel support.
      //
      // Return value:
      // The ID of a long-running operation.
      //
      // To get the results of the operation, call the GetOperation method of
      // CloudChannelOperationsService. The Operation metadata will contain an
      // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
      virtual void TransferEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TransferEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Transfers customer entitlements from their current reseller to Google.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * NOT_FOUND: The customer or offer resource was not found.
      // * ALREADY_EXISTS: The SKU was already transferred for the customer.
      // * CONDITION_NOT_MET or FAILED_PRECONDITION:
      //     * The SKU requires domain verification to transfer, but the domain is
      //     not verified.
      //     * An Add-On SKU (example, Vault or Drive) is missing the
      //     pre-requisite SKU (example, G Suite Basic).
      //     * (Developer accounts only) Reseller and resold domain must meet the
      //     following naming requirements:
      //         * Domain names must start with goog-test.
      //         * Domain names must include the reseller domain.
      // * INTERNAL: Any non-user error related to a technical issue in the
      // backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      // Contact Cloud Channel support.
      //
      // Return value:
      // The ID of a long-running operation.
      //
      // To get the results of the operation, call the GetOperation method of
      // CloudChannelOperationsService. The response will contain
      // google.protobuf.Empty on success. The Operation metadata will contain an
      // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
      virtual void TransferEntitlementsToGoogle(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TransferEntitlementsToGoogle(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink]s
      // belonging to a distributor. You must be a distributor to call this method.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The reseller account making the request is different
      // from the reseller account in the API request.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      //
      // Return value:
      // The list of the distributor account's
      // [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink] resources.
      virtual void ListChannelPartnerLinks(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest* request, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListChannelPartnerLinks(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest* request, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the requested
      // [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink] resource.
      // You must be a distributor to call this method.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The reseller account making the request is different
      // from the reseller account in the API request.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * NOT_FOUND: ChannelPartnerLink resource not found because of an
      // invalid channel partner link name.
      //
      // Return value:
      // The [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink]
      // resource.
      virtual void GetChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Initiates a channel partner link between a distributor and a reseller, or
      // between resellers in an n-tier reseller channel.
      // Invited partners need to follow the invite_link_uri provided in the
      // response to accept. After accepting the invitation, a link is set up
      // between the two parties.
      // You must be a distributor to call this method.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The reseller account making the request is different
      // from the reseller account in the API request.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * ALREADY_EXISTS: The ChannelPartnerLink sent in the request already
      // exists.
      // * NOT_FOUND: No Cloud Identity customer exists for provided domain.
      // * INTERNAL: Any non-user error related to a technical issue in the
      // backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      // Contact Cloud Channel support.
      //
      // Return value:
      // The new [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink]
      // resource.
      virtual void CreateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a channel partner link. Distributors call this method to change a
      // link's status. For example, to suspend a partner link.
      // You must be a distributor to call this method.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The reseller account making the request is different
      // from the reseller account in the API request.
      // * INVALID_ARGUMENT:
      //     * Required request parameters are missing or invalid.
      //     * Link state cannot change from invited to active or suspended.
      //     * Cannot send reseller_cloud_identity_id, invite_url, or name in update
      //     mask.
      // * NOT_FOUND: ChannelPartnerLink resource not found.
      // * INTERNAL: Any non-user error related to a technical issue in the
      // backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      // Contact Cloud Channel support.
      //
      // Return value:
      // The updated
      // [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink] resource.
      virtual void UpdateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets information about how a Reseller modifies their bill before sending
      // it to a Customer.
      //
      // Possible Error Codes:
      //
      // * PERMISSION_DENIED: If the account making the request and the account
      // being queried are different.
      // * NOT_FOUND: The
      // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
      // was not found.
      // * INTERNAL: Any non-user error related to technical issues in the
      // backend. In this case, contact Cloud Channel support.
      //
      // Return Value:
      // If successful, the
      // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
      // resource, otherwise returns an error.
      virtual void GetCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists information about how a Reseller modifies their bill before sending
      // it to a Customer.
      //
      // Possible Error Codes:
      //
      // * PERMISSION_DENIED: If the account making the request and the account
      // being queried are different.
      // * NOT_FOUND: The
      // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
      // specified does not exist or is not associated with the given account.
      // * INTERNAL: Any non-user error related to technical issues in the
      // backend. In this case, contact Cloud Channel support.
      //
      // Return Value:
      // If successful, the
      // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
      // resources. The data for each resource is displayed in the ascending order
      // of:
      //
      // * Customer ID
      // * [RepricingConfig.EntitlementGranularity.entitlement][google.cloud.channel.v1.RepricingConfig.EntitlementGranularity.entitlement]
      // * [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
      // * [CustomerRepricingConfig.update_time][google.cloud.channel.v1.CustomerRepricingConfig.update_time]
      //
      // If unsuccessful, returns an error.
      virtual void ListCustomerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest* request, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListCustomerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest* request, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a CustomerRepricingConfig. Call this method to set modifications
      // for a specific customer's bill. You can only create configs if the
      // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
      // is a future month. If needed, you can create a config for the current
      // month, with some restrictions.
      //
      // When creating a config for a future month, make sure there are no existing
      // configs for that
      // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
      //
      // The following restrictions are for creating configs in the current month.
      //
      // * This functionality is reserved for recovering from an erroneous config,
      // and should not be used for regular business cases.
      // * The new config will not modify exports used with other configs.
      // Changes to the config may be immediate, but may take up to 24 hours.
      // * There is a limit of ten configs for any
      // [RepricingConfig.EntitlementGranularity.entitlement][google.cloud.channel.v1.RepricingConfig.EntitlementGranularity.entitlement],
      // for any
      // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
      // * The contained
      // [CustomerRepricingConfig.repricing_config][google.cloud.channel.v1.CustomerRepricingConfig.repricing_config]
      // value must be different from the value used in the current config for a
      // [RepricingConfig.EntitlementGranularity.entitlement][google.cloud.channel.v1.RepricingConfig.EntitlementGranularity.entitlement].
      //
      // Possible Error Codes:
      //
      // * PERMISSION_DENIED: If the account making the request and the account
      // being queried are different.
      // * INVALID_ARGUMENT: Missing or invalid required parameters in the
      // request. Also displays if the updated config is for the current month or
      // past months.
      // * NOT_FOUND: The
      // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
      // specified does not exist or is not associated with the given account.
      // * INTERNAL: Any non-user error related to technical issues in the
      // backend. In this case, contact Cloud Channel support.
      //
      // Return Value:
      // If successful, the updated
      // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
      // resource, otherwise returns an error.
      virtual void CreateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a CustomerRepricingConfig. Call this method to set modifications
      // for a specific customer's bill. This method overwrites the existing
      // CustomerRepricingConfig.
      //
      // You can only update configs if the
      // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
      // is a future month. To make changes to configs for the current month, use
      // [CreateCustomerRepricingConfig][google.cloud.channel.v1.CloudChannelService.CreateCustomerRepricingConfig],
      // taking note of its restrictions. You cannot update the
      // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
      //
      // When updating a config in the future:
      //
      // * This config must already exist.
      //
      // Possible Error Codes:
      //
      // * PERMISSION_DENIED: If the account making the request and the account
      // being queried are different.
      // * INVALID_ARGUMENT: Missing or invalid required parameters in the
      // request. Also displays if the updated config is for the current month or
      // past months.
      // * NOT_FOUND: The
      // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
      // specified does not exist or is not associated with the given account.
      // * INTERNAL: Any non-user error related to technical issues in the
      // backend. In this case, contact Cloud Channel support.
      //
      // Return Value:
      // If successful, the updated
      // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
      // resource, otherwise returns an error.
      virtual void UpdateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the given
      // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
      // permanently. You can only delete configs if their
      // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
      // is set to a date after the current month.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The account making the request does not own
      // this customer.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * FAILED_PRECONDITION: The
      // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
      // is active or in the past.
      // * NOT_FOUND: No
      // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
      // found for the name in the request.
      virtual void DeleteCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets information about how a Distributor modifies their bill before sending
      // it to a ChannelPartner.
      //
      // Possible Error Codes:
      //
      // * PERMISSION_DENIED: If the account making the request and the account
      // being queried are different.
      // * NOT_FOUND: The
      // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
      // was not found.
      // * INTERNAL: Any non-user error related to technical issues in the
      // backend. In this case, contact Cloud Channel support.
      //
      // Return Value:
      // If successful, the
      // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
      // resource, otherwise returns an error.
      virtual void GetChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists information about how a Reseller modifies their bill before sending
      // it to a ChannelPartner.
      //
      // Possible Error Codes:
      //
      // * PERMISSION_DENIED: If the account making the request and the account
      // being queried are different.
      // * NOT_FOUND: The
      // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
      // specified does not exist or is not associated with the given account.
      // * INTERNAL: Any non-user error related to technical issues in the
      // backend. In this case, contact Cloud Channel support.
      //
      // Return Value:
      // If successful, the
      // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
      // resources. The data for each resource is displayed in the ascending order
      // of:
      //
      // * Channel Partner ID
      // * [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
      // * [ChannelPartnerRepricingConfig.update_time][google.cloud.channel.v1.ChannelPartnerRepricingConfig.update_time]
      //
      // If unsuccessful, returns an error.
      virtual void ListChannelPartnerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest* request, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListChannelPartnerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest* request, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a ChannelPartnerRepricingConfig. Call this method to set
      // modifications for a specific ChannelPartner's bill. You can only create
      // configs if the
      // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
      // is a future month. If needed, you can create a config for the current
      // month, with some restrictions.
      //
      // When creating a config for a future month, make sure there are no existing
      // configs for that
      // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
      //
      // The following restrictions are for creating configs in the current month.
      //
      // * This functionality is reserved for recovering from an erroneous config,
      // and should not be used for regular business cases.
      // * The new config will not modify exports used with other configs.
      // Changes to the config may be immediate, but may take up to 24 hours.
      // * There is a limit of ten configs for any ChannelPartner or
      // [RepricingConfig.EntitlementGranularity.entitlement][google.cloud.channel.v1.RepricingConfig.EntitlementGranularity.entitlement],
      // for any
      // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
      // * The contained
      // [ChannelPartnerRepricingConfig.repricing_config][google.cloud.channel.v1.ChannelPartnerRepricingConfig.repricing_config]
      // value must be different from the value used in the current config for a
      // ChannelPartner.
      //
      // Possible Error Codes:
      //
      // * PERMISSION_DENIED: If the account making the request and the account
      // being queried are different.
      // * INVALID_ARGUMENT: Missing or invalid required parameters in the
      // request. Also displays if the updated config is for the current month or
      // past months.
      // * NOT_FOUND: The
      // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
      // specified does not exist or is not associated with the given account.
      // * INTERNAL: Any non-user error related to technical issues in the
      // backend. In this case, contact Cloud Channel support.
      //
      // Return Value:
      // If successful, the updated
      // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
      // resource, otherwise returns an error.
      virtual void CreateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a ChannelPartnerRepricingConfig. Call this method to set
      // modifications for a specific ChannelPartner's bill. This method overwrites
      // the existing CustomerRepricingConfig.
      //
      // You can only update configs if the
      // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
      // is a future month. To make changes to configs for the current month, use
      // [CreateChannelPartnerRepricingConfig][google.cloud.channel.v1.CloudChannelService.CreateChannelPartnerRepricingConfig],
      // taking note of its restrictions. You cannot update the
      // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
      //
      // When updating a config in the future:
      //
      // * This config must already exist.
      //
      // Possible Error Codes:
      //
      // * PERMISSION_DENIED: If the account making the request and the account
      // being queried are different.
      // * INVALID_ARGUMENT: Missing or invalid required parameters in the
      // request. Also displays if the updated config is for the current month or
      // past months.
      // * NOT_FOUND: The
      // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
      // specified does not exist or is not associated with the given account.
      // * INTERNAL: Any non-user error related to technical issues in the
      // backend. In this case, contact Cloud Channel support.
      //
      // Return Value:
      // If successful, the updated
      // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
      // resource, otherwise returns an error.
      virtual void UpdateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the given
      // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
      // permanently. You can only delete configs if their
      // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
      // is set to a date after the current month.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The account making the request does not own
      // this customer.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * FAILED_PRECONDITION: The
      // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
      // is active or in the past.
      // * NOT_FOUND: No
      // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
      // found for the name in the request.
      virtual void DeleteChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the Rebilling supported SKU groups the account is authorized to
      // sell.
      // Reference: https://cloud.google.com/skus/sku-groups
      //
      // Possible Error Codes:
      //
      // * PERMISSION_DENIED: If the account making the request and the account
      // being queried are different, or the account doesn't exist.
      // * INTERNAL: Any non-user error related to technical issues in the
      // backend. In this case, contact Cloud Channel support.
      //
      // Return Value:
      // If successful, the [SkuGroup][google.cloud.channel.v1.SkuGroup] resources.
      // The data for each resource is displayed in the alphabetical order of SKU
      // group display name.
      // The data for each resource is displayed in the ascending order of
      // [SkuGroup.display_name][google.cloud.channel.v1.SkuGroup.display_name]
      //
      // If unsuccessful, returns an error.
      virtual void ListSkuGroups(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupsRequest* request, ::google::cloud::channel::v1::ListSkuGroupsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSkuGroups(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupsRequest* request, ::google::cloud::channel::v1::ListSkuGroupsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the Billable SKUs in a given SKU group.
      //
      // Possible error codes:
      // PERMISSION_DENIED: If the account making the request and the account
      // being queried for are different, or the account doesn't exist.
      // INVALID_ARGUMENT: Missing or invalid required parameters in the
      // request.
      // INTERNAL: Any non-user error related to technical issue in the
      // backend. In this case, contact cloud channel support.
      //
      // Return Value:
      // If successful, the [BillableSku][google.cloud.channel.v1.BillableSku]
      // resources. The data for each resource is displayed in the ascending order
      // of:
      //
      // * [BillableSku.service_display_name][google.cloud.channel.v1.BillableSku.service_display_name]
      // * [BillableSku.sku_display_name][google.cloud.channel.v1.BillableSku.sku_display_name]
      //
      // If unsuccessful, returns an error.
      virtual void ListSkuGroupBillableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest* request, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSkuGroupBillableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest* request, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the requested [Offer][google.cloud.channel.v1.Offer] resource.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The entitlement doesn't belong to the reseller.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * NOT_FOUND: Entitlement or offer was not found.
      //
      // Return value:
      // The [Offer][google.cloud.channel.v1.Offer] resource.
      virtual void LookupOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::LookupOfferRequest* request, ::google::cloud::channel::v1::Offer* response, std::function<void(::grpc::Status)>) = 0;
      virtual void LookupOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::LookupOfferRequest* request, ::google::cloud::channel::v1::Offer* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the Products the reseller is authorized to sell.
      //
      // Possible error codes:
      //
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      virtual void ListProducts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListProductsRequest* request, ::google::cloud::channel::v1::ListProductsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListProducts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListProductsRequest* request, ::google::cloud::channel::v1::ListProductsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the SKUs for a product the reseller is authorized to sell.
      //
      // Possible error codes:
      //
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      virtual void ListSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkusRequest* request, ::google::cloud::channel::v1::ListSkusResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkusRequest* request, ::google::cloud::channel::v1::ListSkusResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the Offers the reseller can sell.
      //
      // Possible error codes:
      //
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      virtual void ListOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListOffersRequest* request, ::google::cloud::channel::v1::ListOffersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListOffersRequest* request, ::google::cloud::channel::v1::ListOffersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the following:
      //
      // * SKUs that you can purchase for a customer
      // * SKUs that you can upgrade or downgrade for an entitlement.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      virtual void ListPurchasableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableSkusRequest* request, ::google::cloud::channel::v1::ListPurchasableSkusResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPurchasableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableSkusRequest* request, ::google::cloud::channel::v1::ListPurchasableSkusResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the following:
      //
      // * Offers that you can purchase for a customer.
      // * Offers that you can change for an entitlement.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED:
      //     * The customer doesn't belong to the reseller
      //     * The reseller is not authorized to transact on this Product. See
      //     https://support.google.com/channelservices/answer/9759265
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      virtual void ListPurchasableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableOffersRequest* request, ::google::cloud::channel::v1::ListPurchasableOffersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPurchasableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableOffersRequest* request, ::google::cloud::channel::v1::ListPurchasableOffersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the billing accounts that are eligible to purchase particular SKUs
      // for a given customer.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      //
      // Return value:
      // Based on the provided list of SKUs, returns a list of SKU groups that must
      // be purchased using the same billing account and the billing accounts
      // eligible to purchase each SKU group.
      virtual void QueryEligibleBillingAccounts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest* request, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void QueryEligibleBillingAccounts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest* request, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Registers a service account with subscriber privileges on the Cloud Pub/Sub
      // topic for this Channel Services account. After you create a
      // subscriber, you get the events through
      // [SubscriberEvent][google.cloud.channel.v1.SubscriberEvent]
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The reseller account making the request and the
      // provided reseller account are different, or the impersonated user
      // is not a super admin.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * INTERNAL: Any non-user error related to a technical issue in the
      // backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      // Contact Cloud Channel support.
      //
      // Return value:
      // The topic name with the registered service email address.
      virtual void RegisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RegisterSubscriberRequest* request, ::google::cloud::channel::v1::RegisterSubscriberResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RegisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RegisterSubscriberRequest* request, ::google::cloud::channel::v1::RegisterSubscriberResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Unregisters a service account with subscriber privileges on the Cloud
      // Pub/Sub topic created for this Channel Services account. If there are no
      // service accounts left with subscriber privileges, this deletes the topic.
      // You can call ListSubscribers to check for these accounts.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The reseller account making the request and the
      // provided reseller account are different, or the impersonated user
      // is not a super admin.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * NOT_FOUND: The topic resource doesn't exist.
      // * INTERNAL: Any non-user error related to a technical issue in the
      // backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      // Contact Cloud Channel support.
      //
      // Return value:
      // The topic name that unregistered the service email address.
      // Returns a success response if the service email address wasn't registered
      // with the topic.
      virtual void UnregisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UnregisterSubscriberRequest* request, ::google::cloud::channel::v1::UnregisterSubscriberResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UnregisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UnregisterSubscriberRequest* request, ::google::cloud::channel::v1::UnregisterSubscriberResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists service accounts with subscriber privileges on the Cloud Pub/Sub
      // topic created for this Channel Services account.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The reseller account making the request and the
      // provided reseller account are different, or the impersonated user
      // is not a super admin.
      // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
      // * NOT_FOUND: The topic resource doesn't exist.
      // * INTERNAL: Any non-user error related to a technical issue in the
      // backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      // Contact Cloud Channel support.
      //
      // Return value:
      // A list of service email addresses.
      virtual void ListSubscribers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSubscribersRequest* request, ::google::cloud::channel::v1::ListSubscribersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSubscribers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSubscribersRequest* request, ::google::cloud::channel::v1::ListSubscribersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List entitlement history.
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The reseller account making the request and the
      // provided reseller account are different.
      // * INVALID_ARGUMENT: Missing or invalid required fields in the request.
      // * NOT_FOUND: The parent resource doesn't exist. Usually the result of an
      // invalid name parameter.
      // * INTERNAL: Any non-user error related to a technical issue in the backend.
      // In this case, contact CloudChannel support.
      // * UNKNOWN: Any non-user error related to a technical issue in the backend.
      // In this case, contact Cloud Channel support.
      //
      // Return value:
      // List of [EntitlementChange][google.cloud.channel.v1.EntitlementChange]s.
      virtual void ListEntitlementChanges(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementChangesRequest* request, ::google::cloud::channel::v1::ListEntitlementChangesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListEntitlementChanges(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementChangesRequest* request, ::google::cloud::channel::v1::ListEntitlementChangesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListCustomersResponse>* AsyncListCustomersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListCustomersResponse>* PrepareAsyncListCustomersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>* AsyncGetCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>* PrepareAsyncGetCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>* AsyncCheckCloudIdentityAccountsExistRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>* PrepareAsyncCheckCloudIdentityAccountsExistRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>* AsyncCreateCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>* PrepareAsyncCreateCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>* AsyncUpdateCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>* PrepareAsyncUpdateCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>* AsyncImportCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ImportCustomerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Customer>* PrepareAsyncImportCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ImportCustomerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncProvisionCloudIdentityRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncProvisionCloudIdentityRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListEntitlementsResponse>* AsyncListEntitlementsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListEntitlementsResponse>* PrepareAsyncListEntitlementsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListTransferableSkusResponse>* AsyncListTransferableSkusRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableSkusRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListTransferableSkusResponse>* PrepareAsyncListTransferableSkusRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableSkusRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListTransferableOffersResponse>* AsyncListTransferableOffersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableOffersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListTransferableOffersResponse>* PrepareAsyncListTransferableOffersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableOffersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Entitlement>* AsyncGetEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Entitlement>* PrepareAsyncGetEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncChangeParametersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeParametersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncChangeParametersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeParametersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncChangeRenewalSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncChangeRenewalSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncChangeOfferRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeOfferRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncChangeOfferRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeOfferRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncStartPaidServiceRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::StartPaidServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncStartPaidServiceRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::StartPaidServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncSuspendEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::SuspendEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncSuspendEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::SuspendEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCancelEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CancelEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCancelEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CancelEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncActivateEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ActivateEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncActivateEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ActivateEntitlementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncTransferEntitlementsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncTransferEntitlementsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncTransferEntitlementsToGoogleRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncTransferEntitlementsToGoogleRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>* AsyncListChannelPartnerLinksRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>* PrepareAsyncListChannelPartnerLinksRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>* AsyncGetChannelPartnerLinkRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>* PrepareAsyncGetChannelPartnerLinkRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>* AsyncCreateChannelPartnerLinkRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>* PrepareAsyncCreateChannelPartnerLinkRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>* AsyncUpdateChannelPartnerLinkRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerLink>* PrepareAsyncUpdateChannelPartnerLinkRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>* AsyncGetCustomerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>* PrepareAsyncGetCustomerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>* AsyncListCustomerRepricingConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>* PrepareAsyncListCustomerRepricingConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>* AsyncCreateCustomerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>* PrepareAsyncCreateCustomerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>* AsyncUpdateCustomerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::CustomerRepricingConfig>* PrepareAsyncUpdateCustomerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteCustomerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteCustomerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* AsyncGetChannelPartnerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* PrepareAsyncGetChannelPartnerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>* AsyncListChannelPartnerRepricingConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>* PrepareAsyncListChannelPartnerRepricingConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* AsyncCreateChannelPartnerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* PrepareAsyncCreateChannelPartnerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* AsyncUpdateChannelPartnerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* PrepareAsyncUpdateChannelPartnerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteChannelPartnerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteChannelPartnerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkuGroupsResponse>* AsyncListSkuGroupsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkuGroupsResponse>* PrepareAsyncListSkuGroupsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>* AsyncListSkuGroupBillableSkusRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>* PrepareAsyncListSkuGroupBillableSkusRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Offer>* AsyncLookupOfferRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::LookupOfferRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::Offer>* PrepareAsyncLookupOfferRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::LookupOfferRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListProductsResponse>* AsyncListProductsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListProductsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListProductsResponse>* PrepareAsyncListProductsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListProductsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkusResponse>* AsyncListSkusRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkusRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSkusResponse>* PrepareAsyncListSkusRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkusRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListOffersResponse>* AsyncListOffersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListOffersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListOffersResponse>* PrepareAsyncListOffersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListOffersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListPurchasableSkusResponse>* AsyncListPurchasableSkusRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableSkusRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListPurchasableSkusResponse>* PrepareAsyncListPurchasableSkusRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableSkusRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListPurchasableOffersResponse>* AsyncListPurchasableOffersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableOffersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListPurchasableOffersResponse>* PrepareAsyncListPurchasableOffersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableOffersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>* AsyncQueryEligibleBillingAccountsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>* PrepareAsyncQueryEligibleBillingAccountsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::RegisterSubscriberResponse>* AsyncRegisterSubscriberRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RegisterSubscriberRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::RegisterSubscriberResponse>* PrepareAsyncRegisterSubscriberRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RegisterSubscriberRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::UnregisterSubscriberResponse>* AsyncUnregisterSubscriberRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UnregisterSubscriberRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::UnregisterSubscriberResponse>* PrepareAsyncUnregisterSubscriberRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UnregisterSubscriberRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSubscribersResponse>* AsyncListSubscribersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSubscribersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListSubscribersResponse>* PrepareAsyncListSubscribersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSubscribersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListEntitlementChangesResponse>* AsyncListEntitlementChangesRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementChangesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListEntitlementChangesResponse>* PrepareAsyncListEntitlementChangesRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementChangesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListCustomers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomersRequest& request, ::google::cloud::channel::v1::ListCustomersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListCustomersResponse>> AsyncListCustomers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListCustomersResponse>>(AsyncListCustomersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListCustomersResponse>> PrepareAsyncListCustomers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListCustomersResponse>>(PrepareAsyncListCustomersRaw(context, request, cq));
    }
    ::grpc::Status GetCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRequest& request, ::google::cloud::channel::v1::Customer* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>> AsyncGetCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>>(AsyncGetCustomerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>> PrepareAsyncGetCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>>(PrepareAsyncGetCustomerRaw(context, request, cq));
    }
    ::grpc::Status CheckCloudIdentityAccountsExist(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest& request, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>> AsyncCheckCloudIdentityAccountsExist(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>>(AsyncCheckCloudIdentityAccountsExistRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>> PrepareAsyncCheckCloudIdentityAccountsExist(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>>(PrepareAsyncCheckCloudIdentityAccountsExistRaw(context, request, cq));
    }
    ::grpc::Status CreateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRequest& request, ::google::cloud::channel::v1::Customer* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>> AsyncCreateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>>(AsyncCreateCustomerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>> PrepareAsyncCreateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>>(PrepareAsyncCreateCustomerRaw(context, request, cq));
    }
    ::grpc::Status UpdateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRequest& request, ::google::cloud::channel::v1::Customer* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>> AsyncUpdateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>>(AsyncUpdateCustomerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>> PrepareAsyncUpdateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>>(PrepareAsyncUpdateCustomerRaw(context, request, cq));
    }
    ::grpc::Status DeleteCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteCustomerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteCustomerRaw(context, request, cq));
    }
    ::grpc::Status ImportCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ImportCustomerRequest& request, ::google::cloud::channel::v1::Customer* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>> AsyncImportCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ImportCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>>(AsyncImportCustomerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>> PrepareAsyncImportCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ImportCustomerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>>(PrepareAsyncImportCustomerRaw(context, request, cq));
    }
    ::grpc::Status ProvisionCloudIdentity(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncProvisionCloudIdentity(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncProvisionCloudIdentityRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncProvisionCloudIdentity(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncProvisionCloudIdentityRaw(context, request, cq));
    }
    ::grpc::Status ListEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementsRequest& request, ::google::cloud::channel::v1::ListEntitlementsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListEntitlementsResponse>> AsyncListEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListEntitlementsResponse>>(AsyncListEntitlementsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListEntitlementsResponse>> PrepareAsyncListEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListEntitlementsResponse>>(PrepareAsyncListEntitlementsRaw(context, request, cq));
    }
    ::grpc::Status ListTransferableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableSkusRequest& request, ::google::cloud::channel::v1::ListTransferableSkusResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListTransferableSkusResponse>> AsyncListTransferableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListTransferableSkusResponse>>(AsyncListTransferableSkusRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListTransferableSkusResponse>> PrepareAsyncListTransferableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListTransferableSkusResponse>>(PrepareAsyncListTransferableSkusRaw(context, request, cq));
    }
    ::grpc::Status ListTransferableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableOffersRequest& request, ::google::cloud::channel::v1::ListTransferableOffersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListTransferableOffersResponse>> AsyncListTransferableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableOffersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListTransferableOffersResponse>>(AsyncListTransferableOffersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListTransferableOffersResponse>> PrepareAsyncListTransferableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableOffersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListTransferableOffersResponse>>(PrepareAsyncListTransferableOffersRaw(context, request, cq));
    }
    ::grpc::Status GetEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetEntitlementRequest& request, ::google::cloud::channel::v1::Entitlement* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Entitlement>> AsyncGetEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Entitlement>>(AsyncGetEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Entitlement>> PrepareAsyncGetEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Entitlement>>(PrepareAsyncGetEntitlementRaw(context, request, cq));
    }
    ::grpc::Status CreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateEntitlementRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateEntitlementRaw(context, request, cq));
    }
    ::grpc::Status ChangeParameters(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeParametersRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncChangeParameters(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeParametersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncChangeParametersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncChangeParameters(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeParametersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncChangeParametersRaw(context, request, cq));
    }
    ::grpc::Status ChangeRenewalSettings(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncChangeRenewalSettings(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncChangeRenewalSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncChangeRenewalSettings(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncChangeRenewalSettingsRaw(context, request, cq));
    }
    ::grpc::Status ChangeOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeOfferRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncChangeOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeOfferRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncChangeOfferRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncChangeOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeOfferRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncChangeOfferRaw(context, request, cq));
    }
    ::grpc::Status StartPaidService(::grpc::ClientContext* context, const ::google::cloud::channel::v1::StartPaidServiceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncStartPaidService(::grpc::ClientContext* context, const ::google::cloud::channel::v1::StartPaidServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncStartPaidServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncStartPaidService(::grpc::ClientContext* context, const ::google::cloud::channel::v1::StartPaidServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncStartPaidServiceRaw(context, request, cq));
    }
    ::grpc::Status SuspendEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::SuspendEntitlementRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncSuspendEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::SuspendEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncSuspendEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncSuspendEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::SuspendEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncSuspendEntitlementRaw(context, request, cq));
    }
    ::grpc::Status CancelEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CancelEntitlementRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCancelEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CancelEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCancelEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCancelEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CancelEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCancelEntitlementRaw(context, request, cq));
    }
    ::grpc::Status ActivateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ActivateEntitlementRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncActivateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ActivateEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncActivateEntitlementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncActivateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ActivateEntitlementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncActivateEntitlementRaw(context, request, cq));
    }
    ::grpc::Status TransferEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncTransferEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncTransferEntitlementsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncTransferEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncTransferEntitlementsRaw(context, request, cq));
    }
    ::grpc::Status TransferEntitlementsToGoogle(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncTransferEntitlementsToGoogle(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncTransferEntitlementsToGoogleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncTransferEntitlementsToGoogle(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncTransferEntitlementsToGoogleRaw(context, request, cq));
    }
    ::grpc::Status ListChannelPartnerLinks(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest& request, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>> AsyncListChannelPartnerLinks(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>>(AsyncListChannelPartnerLinksRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>> PrepareAsyncListChannelPartnerLinks(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>>(PrepareAsyncListChannelPartnerLinksRaw(context, request, cq));
    }
    ::grpc::Status GetChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest& request, ::google::cloud::channel::v1::ChannelPartnerLink* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>> AsyncGetChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>>(AsyncGetChannelPartnerLinkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>> PrepareAsyncGetChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>>(PrepareAsyncGetChannelPartnerLinkRaw(context, request, cq));
    }
    ::grpc::Status CreateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest& request, ::google::cloud::channel::v1::ChannelPartnerLink* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>> AsyncCreateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>>(AsyncCreateChannelPartnerLinkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>> PrepareAsyncCreateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>>(PrepareAsyncCreateChannelPartnerLinkRaw(context, request, cq));
    }
    ::grpc::Status UpdateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest& request, ::google::cloud::channel::v1::ChannelPartnerLink* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>> AsyncUpdateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>>(AsyncUpdateChannelPartnerLinkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>> PrepareAsyncUpdateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>>(PrepareAsyncUpdateChannelPartnerLinkRaw(context, request, cq));
    }
    ::grpc::Status GetCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest& request, ::google::cloud::channel::v1::CustomerRepricingConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>> AsyncGetCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>>(AsyncGetCustomerRepricingConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>> PrepareAsyncGetCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>>(PrepareAsyncGetCustomerRepricingConfigRaw(context, request, cq));
    }
    ::grpc::Status ListCustomerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest& request, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>> AsyncListCustomerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>>(AsyncListCustomerRepricingConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>> PrepareAsyncListCustomerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>>(PrepareAsyncListCustomerRepricingConfigsRaw(context, request, cq));
    }
    ::grpc::Status CreateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest& request, ::google::cloud::channel::v1::CustomerRepricingConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>> AsyncCreateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>>(AsyncCreateCustomerRepricingConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>> PrepareAsyncCreateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>>(PrepareAsyncCreateCustomerRepricingConfigRaw(context, request, cq));
    }
    ::grpc::Status UpdateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest& request, ::google::cloud::channel::v1::CustomerRepricingConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>> AsyncUpdateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>>(AsyncUpdateCustomerRepricingConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>> PrepareAsyncUpdateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>>(PrepareAsyncUpdateCustomerRepricingConfigRaw(context, request, cq));
    }
    ::grpc::Status DeleteCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteCustomerRepricingConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteCustomerRepricingConfigRaw(context, request, cq));
    }
    ::grpc::Status GetChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest& request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>> AsyncGetChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>>(AsyncGetChannelPartnerRepricingConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>> PrepareAsyncGetChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>>(PrepareAsyncGetChannelPartnerRepricingConfigRaw(context, request, cq));
    }
    ::grpc::Status ListChannelPartnerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest& request, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>> AsyncListChannelPartnerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>>(AsyncListChannelPartnerRepricingConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>> PrepareAsyncListChannelPartnerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>>(PrepareAsyncListChannelPartnerRepricingConfigsRaw(context, request, cq));
    }
    ::grpc::Status CreateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest& request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>> AsyncCreateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>>(AsyncCreateChannelPartnerRepricingConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>> PrepareAsyncCreateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>>(PrepareAsyncCreateChannelPartnerRepricingConfigRaw(context, request, cq));
    }
    ::grpc::Status UpdateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest& request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>> AsyncUpdateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>>(AsyncUpdateChannelPartnerRepricingConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>> PrepareAsyncUpdateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>>(PrepareAsyncUpdateChannelPartnerRepricingConfigRaw(context, request, cq));
    }
    ::grpc::Status DeleteChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteChannelPartnerRepricingConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteChannelPartnerRepricingConfigRaw(context, request, cq));
    }
    ::grpc::Status ListSkuGroups(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupsRequest& request, ::google::cloud::channel::v1::ListSkuGroupsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkuGroupsResponse>> AsyncListSkuGroups(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkuGroupsResponse>>(AsyncListSkuGroupsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkuGroupsResponse>> PrepareAsyncListSkuGroups(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkuGroupsResponse>>(PrepareAsyncListSkuGroupsRaw(context, request, cq));
    }
    ::grpc::Status ListSkuGroupBillableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest& request, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>> AsyncListSkuGroupBillableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>>(AsyncListSkuGroupBillableSkusRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>> PrepareAsyncListSkuGroupBillableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>>(PrepareAsyncListSkuGroupBillableSkusRaw(context, request, cq));
    }
    ::grpc::Status LookupOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::LookupOfferRequest& request, ::google::cloud::channel::v1::Offer* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Offer>> AsyncLookupOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::LookupOfferRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Offer>>(AsyncLookupOfferRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Offer>> PrepareAsyncLookupOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::LookupOfferRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Offer>>(PrepareAsyncLookupOfferRaw(context, request, cq));
    }
    ::grpc::Status ListProducts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListProductsRequest& request, ::google::cloud::channel::v1::ListProductsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListProductsResponse>> AsyncListProducts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListProductsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListProductsResponse>>(AsyncListProductsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListProductsResponse>> PrepareAsyncListProducts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListProductsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListProductsResponse>>(PrepareAsyncListProductsRaw(context, request, cq));
    }
    ::grpc::Status ListSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkusRequest& request, ::google::cloud::channel::v1::ListSkusResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkusResponse>> AsyncListSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkusResponse>>(AsyncListSkusRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkusResponse>> PrepareAsyncListSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkusResponse>>(PrepareAsyncListSkusRaw(context, request, cq));
    }
    ::grpc::Status ListOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListOffersRequest& request, ::google::cloud::channel::v1::ListOffersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListOffersResponse>> AsyncListOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListOffersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListOffersResponse>>(AsyncListOffersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListOffersResponse>> PrepareAsyncListOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListOffersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListOffersResponse>>(PrepareAsyncListOffersRaw(context, request, cq));
    }
    ::grpc::Status ListPurchasableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableSkusRequest& request, ::google::cloud::channel::v1::ListPurchasableSkusResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListPurchasableSkusResponse>> AsyncListPurchasableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListPurchasableSkusResponse>>(AsyncListPurchasableSkusRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListPurchasableSkusResponse>> PrepareAsyncListPurchasableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableSkusRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListPurchasableSkusResponse>>(PrepareAsyncListPurchasableSkusRaw(context, request, cq));
    }
    ::grpc::Status ListPurchasableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableOffersRequest& request, ::google::cloud::channel::v1::ListPurchasableOffersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListPurchasableOffersResponse>> AsyncListPurchasableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableOffersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListPurchasableOffersResponse>>(AsyncListPurchasableOffersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListPurchasableOffersResponse>> PrepareAsyncListPurchasableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableOffersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListPurchasableOffersResponse>>(PrepareAsyncListPurchasableOffersRaw(context, request, cq));
    }
    ::grpc::Status QueryEligibleBillingAccounts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest& request, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>> AsyncQueryEligibleBillingAccounts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>>(AsyncQueryEligibleBillingAccountsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>> PrepareAsyncQueryEligibleBillingAccounts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>>(PrepareAsyncQueryEligibleBillingAccountsRaw(context, request, cq));
    }
    ::grpc::Status RegisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RegisterSubscriberRequest& request, ::google::cloud::channel::v1::RegisterSubscriberResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::RegisterSubscriberResponse>> AsyncRegisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RegisterSubscriberRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::RegisterSubscriberResponse>>(AsyncRegisterSubscriberRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::RegisterSubscriberResponse>> PrepareAsyncRegisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RegisterSubscriberRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::RegisterSubscriberResponse>>(PrepareAsyncRegisterSubscriberRaw(context, request, cq));
    }
    ::grpc::Status UnregisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UnregisterSubscriberRequest& request, ::google::cloud::channel::v1::UnregisterSubscriberResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::UnregisterSubscriberResponse>> AsyncUnregisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UnregisterSubscriberRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::UnregisterSubscriberResponse>>(AsyncUnregisterSubscriberRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::UnregisterSubscriberResponse>> PrepareAsyncUnregisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UnregisterSubscriberRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::UnregisterSubscriberResponse>>(PrepareAsyncUnregisterSubscriberRaw(context, request, cq));
    }
    ::grpc::Status ListSubscribers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSubscribersRequest& request, ::google::cloud::channel::v1::ListSubscribersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSubscribersResponse>> AsyncListSubscribers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSubscribersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSubscribersResponse>>(AsyncListSubscribersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSubscribersResponse>> PrepareAsyncListSubscribers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSubscribersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSubscribersResponse>>(PrepareAsyncListSubscribersRaw(context, request, cq));
    }
    ::grpc::Status ListEntitlementChanges(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementChangesRequest& request, ::google::cloud::channel::v1::ListEntitlementChangesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListEntitlementChangesResponse>> AsyncListEntitlementChanges(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementChangesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListEntitlementChangesResponse>>(AsyncListEntitlementChangesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListEntitlementChangesResponse>> PrepareAsyncListEntitlementChanges(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementChangesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListEntitlementChangesResponse>>(PrepareAsyncListEntitlementChangesRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListCustomers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomersRequest* request, ::google::cloud::channel::v1::ListCustomersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListCustomers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomersRequest* request, ::google::cloud::channel::v1::ListCustomersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRequest* request, ::google::cloud::channel::v1::Customer* response, std::function<void(::grpc::Status)>) override;
      void GetCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRequest* request, ::google::cloud::channel::v1::Customer* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CheckCloudIdentityAccountsExist(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest* request, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse* response, std::function<void(::grpc::Status)>) override;
      void CheckCloudIdentityAccountsExist(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest* request, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRequest* request, ::google::cloud::channel::v1::Customer* response, std::function<void(::grpc::Status)>) override;
      void CreateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRequest* request, ::google::cloud::channel::v1::Customer* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRequest* request, ::google::cloud::channel::v1::Customer* response, std::function<void(::grpc::Status)>) override;
      void UpdateCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRequest* request, ::google::cloud::channel::v1::Customer* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ImportCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ImportCustomerRequest* request, ::google::cloud::channel::v1::Customer* response, std::function<void(::grpc::Status)>) override;
      void ImportCustomer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ImportCustomerRequest* request, ::google::cloud::channel::v1::Customer* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ProvisionCloudIdentity(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ProvisionCloudIdentity(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementsRequest* request, ::google::cloud::channel::v1::ListEntitlementsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementsRequest* request, ::google::cloud::channel::v1::ListEntitlementsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTransferableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableSkusRequest* request, ::google::cloud::channel::v1::ListTransferableSkusResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTransferableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableSkusRequest* request, ::google::cloud::channel::v1::ListTransferableSkusResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTransferableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableOffersRequest* request, ::google::cloud::channel::v1::ListTransferableOffersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTransferableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableOffersRequest* request, ::google::cloud::channel::v1::ListTransferableOffersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetEntitlementRequest* request, ::google::cloud::channel::v1::Entitlement* response, std::function<void(::grpc::Status)>) override;
      void GetEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetEntitlementRequest* request, ::google::cloud::channel::v1::Entitlement* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateEntitlementRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateEntitlementRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ChangeParameters(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeParametersRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ChangeParameters(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeParametersRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ChangeRenewalSettings(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ChangeRenewalSettings(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ChangeOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeOfferRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ChangeOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeOfferRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void StartPaidService(::grpc::ClientContext* context, const ::google::cloud::channel::v1::StartPaidServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void StartPaidService(::grpc::ClientContext* context, const ::google::cloud::channel::v1::StartPaidServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SuspendEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::SuspendEntitlementRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void SuspendEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::SuspendEntitlementRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CancelEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CancelEntitlementRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CancelEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CancelEntitlementRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ActivateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ActivateEntitlementRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ActivateEntitlement(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ActivateEntitlementRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TransferEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void TransferEntitlements(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TransferEntitlementsToGoogle(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void TransferEntitlementsToGoogle(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListChannelPartnerLinks(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest* request, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse* response, std::function<void(::grpc::Status)>) override;
      void ListChannelPartnerLinks(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest* request, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response, std::function<void(::grpc::Status)>) override;
      void GetChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response, std::function<void(::grpc::Status)>) override;
      void CreateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response, std::function<void(::grpc::Status)>) override;
      void UpdateChannelPartnerLink(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response, std::function<void(::grpc::Status)>) override;
      void GetCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListCustomerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest* request, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListCustomerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest* request, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response, std::function<void(::grpc::Status)>) override;
      void CreateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response, std::function<void(::grpc::Status)>) override;
      void UpdateCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteCustomerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response, std::function<void(::grpc::Status)>) override;
      void GetChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListChannelPartnerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest* request, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListChannelPartnerRepricingConfigs(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest* request, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response, std::function<void(::grpc::Status)>) override;
      void CreateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response, std::function<void(::grpc::Status)>) override;
      void UpdateChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteChannelPartnerRepricingConfig(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSkuGroups(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupsRequest* request, ::google::cloud::channel::v1::ListSkuGroupsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSkuGroups(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupsRequest* request, ::google::cloud::channel::v1::ListSkuGroupsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSkuGroupBillableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest* request, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSkuGroupBillableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest* request, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void LookupOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::LookupOfferRequest* request, ::google::cloud::channel::v1::Offer* response, std::function<void(::grpc::Status)>) override;
      void LookupOffer(::grpc::ClientContext* context, const ::google::cloud::channel::v1::LookupOfferRequest* request, ::google::cloud::channel::v1::Offer* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListProducts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListProductsRequest* request, ::google::cloud::channel::v1::ListProductsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListProducts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListProductsRequest* request, ::google::cloud::channel::v1::ListProductsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkusRequest* request, ::google::cloud::channel::v1::ListSkusResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkusRequest* request, ::google::cloud::channel::v1::ListSkusResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListOffersRequest* request, ::google::cloud::channel::v1::ListOffersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListOffersRequest* request, ::google::cloud::channel::v1::ListOffersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPurchasableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableSkusRequest* request, ::google::cloud::channel::v1::ListPurchasableSkusResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPurchasableSkus(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableSkusRequest* request, ::google::cloud::channel::v1::ListPurchasableSkusResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPurchasableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableOffersRequest* request, ::google::cloud::channel::v1::ListPurchasableOffersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPurchasableOffers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableOffersRequest* request, ::google::cloud::channel::v1::ListPurchasableOffersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void QueryEligibleBillingAccounts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest* request, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse* response, std::function<void(::grpc::Status)>) override;
      void QueryEligibleBillingAccounts(::grpc::ClientContext* context, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest* request, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RegisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RegisterSubscriberRequest* request, ::google::cloud::channel::v1::RegisterSubscriberResponse* response, std::function<void(::grpc::Status)>) override;
      void RegisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RegisterSubscriberRequest* request, ::google::cloud::channel::v1::RegisterSubscriberResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UnregisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UnregisterSubscriberRequest* request, ::google::cloud::channel::v1::UnregisterSubscriberResponse* response, std::function<void(::grpc::Status)>) override;
      void UnregisterSubscriber(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UnregisterSubscriberRequest* request, ::google::cloud::channel::v1::UnregisterSubscriberResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSubscribers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSubscribersRequest* request, ::google::cloud::channel::v1::ListSubscribersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSubscribers(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSubscribersRequest* request, ::google::cloud::channel::v1::ListSubscribersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListEntitlementChanges(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementChangesRequest* request, ::google::cloud::channel::v1::ListEntitlementChangesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListEntitlementChanges(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementChangesRequest* request, ::google::cloud::channel::v1::ListEntitlementChangesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListCustomersResponse>* AsyncListCustomersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListCustomersResponse>* PrepareAsyncListCustomersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>* AsyncGetCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>* PrepareAsyncGetCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>* AsyncCheckCloudIdentityAccountsExistRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>* PrepareAsyncCheckCloudIdentityAccountsExistRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>* AsyncCreateCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>* PrepareAsyncCreateCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>* AsyncUpdateCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>* PrepareAsyncUpdateCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>* AsyncImportCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ImportCustomerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Customer>* PrepareAsyncImportCustomerRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ImportCustomerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncProvisionCloudIdentityRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncProvisionCloudIdentityRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListEntitlementsResponse>* AsyncListEntitlementsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListEntitlementsResponse>* PrepareAsyncListEntitlementsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListTransferableSkusResponse>* AsyncListTransferableSkusRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableSkusRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListTransferableSkusResponse>* PrepareAsyncListTransferableSkusRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableSkusRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListTransferableOffersResponse>* AsyncListTransferableOffersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableOffersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListTransferableOffersResponse>* PrepareAsyncListTransferableOffersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListTransferableOffersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Entitlement>* AsyncGetEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Entitlement>* PrepareAsyncGetEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncChangeParametersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeParametersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncChangeParametersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeParametersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncChangeRenewalSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncChangeRenewalSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncChangeOfferRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeOfferRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncChangeOfferRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ChangeOfferRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncStartPaidServiceRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::StartPaidServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncStartPaidServiceRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::StartPaidServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncSuspendEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::SuspendEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncSuspendEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::SuspendEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCancelEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CancelEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCancelEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CancelEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncActivateEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ActivateEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncActivateEntitlementRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ActivateEntitlementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncTransferEntitlementsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncTransferEntitlementsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncTransferEntitlementsToGoogleRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncTransferEntitlementsToGoogleRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>* AsyncListChannelPartnerLinksRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>* PrepareAsyncListChannelPartnerLinksRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>* AsyncGetChannelPartnerLinkRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>* PrepareAsyncGetChannelPartnerLinkRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>* AsyncCreateChannelPartnerLinkRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>* PrepareAsyncCreateChannelPartnerLinkRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>* AsyncUpdateChannelPartnerLinkRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerLink>* PrepareAsyncUpdateChannelPartnerLinkRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>* AsyncGetCustomerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>* PrepareAsyncGetCustomerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>* AsyncListCustomerRepricingConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>* PrepareAsyncListCustomerRepricingConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>* AsyncCreateCustomerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>* PrepareAsyncCreateCustomerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>* AsyncUpdateCustomerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::CustomerRepricingConfig>* PrepareAsyncUpdateCustomerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteCustomerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteCustomerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* AsyncGetChannelPartnerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* PrepareAsyncGetChannelPartnerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>* AsyncListChannelPartnerRepricingConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>* PrepareAsyncListChannelPartnerRepricingConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* AsyncCreateChannelPartnerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* PrepareAsyncCreateChannelPartnerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* AsyncUpdateChannelPartnerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* PrepareAsyncUpdateChannelPartnerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteChannelPartnerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteChannelPartnerRepricingConfigRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkuGroupsResponse>* AsyncListSkuGroupsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkuGroupsResponse>* PrepareAsyncListSkuGroupsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>* AsyncListSkuGroupBillableSkusRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>* PrepareAsyncListSkuGroupBillableSkusRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Offer>* AsyncLookupOfferRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::LookupOfferRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::Offer>* PrepareAsyncLookupOfferRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::LookupOfferRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListProductsResponse>* AsyncListProductsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListProductsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListProductsResponse>* PrepareAsyncListProductsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListProductsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkusResponse>* AsyncListSkusRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkusRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSkusResponse>* PrepareAsyncListSkusRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSkusRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListOffersResponse>* AsyncListOffersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListOffersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListOffersResponse>* PrepareAsyncListOffersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListOffersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListPurchasableSkusResponse>* AsyncListPurchasableSkusRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableSkusRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListPurchasableSkusResponse>* PrepareAsyncListPurchasableSkusRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableSkusRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListPurchasableOffersResponse>* AsyncListPurchasableOffersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableOffersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListPurchasableOffersResponse>* PrepareAsyncListPurchasableOffersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListPurchasableOffersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>* AsyncQueryEligibleBillingAccountsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>* PrepareAsyncQueryEligibleBillingAccountsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::RegisterSubscriberResponse>* AsyncRegisterSubscriberRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RegisterSubscriberRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::RegisterSubscriberResponse>* PrepareAsyncRegisterSubscriberRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RegisterSubscriberRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::UnregisterSubscriberResponse>* AsyncUnregisterSubscriberRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UnregisterSubscriberRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::UnregisterSubscriberResponse>* PrepareAsyncUnregisterSubscriberRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::UnregisterSubscriberRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSubscribersResponse>* AsyncListSubscribersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSubscribersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListSubscribersResponse>* PrepareAsyncListSubscribersRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListSubscribersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListEntitlementChangesResponse>* AsyncListEntitlementChangesRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementChangesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListEntitlementChangesResponse>* PrepareAsyncListEntitlementChangesRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListEntitlementChangesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListCustomers_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCustomer_;
    const ::grpc::internal::RpcMethod rpcmethod_CheckCloudIdentityAccountsExist_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCustomer_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCustomer_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteCustomer_;
    const ::grpc::internal::RpcMethod rpcmethod_ImportCustomer_;
    const ::grpc::internal::RpcMethod rpcmethod_ProvisionCloudIdentity_;
    const ::grpc::internal::RpcMethod rpcmethod_ListEntitlements_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTransferableSkus_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTransferableOffers_;
    const ::grpc::internal::RpcMethod rpcmethod_GetEntitlement_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateEntitlement_;
    const ::grpc::internal::RpcMethod rpcmethod_ChangeParameters_;
    const ::grpc::internal::RpcMethod rpcmethod_ChangeRenewalSettings_;
    const ::grpc::internal::RpcMethod rpcmethod_ChangeOffer_;
    const ::grpc::internal::RpcMethod rpcmethod_StartPaidService_;
    const ::grpc::internal::RpcMethod rpcmethod_SuspendEntitlement_;
    const ::grpc::internal::RpcMethod rpcmethod_CancelEntitlement_;
    const ::grpc::internal::RpcMethod rpcmethod_ActivateEntitlement_;
    const ::grpc::internal::RpcMethod rpcmethod_TransferEntitlements_;
    const ::grpc::internal::RpcMethod rpcmethod_TransferEntitlementsToGoogle_;
    const ::grpc::internal::RpcMethod rpcmethod_ListChannelPartnerLinks_;
    const ::grpc::internal::RpcMethod rpcmethod_GetChannelPartnerLink_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateChannelPartnerLink_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateChannelPartnerLink_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCustomerRepricingConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_ListCustomerRepricingConfigs_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCustomerRepricingConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCustomerRepricingConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteCustomerRepricingConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_GetChannelPartnerRepricingConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_ListChannelPartnerRepricingConfigs_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateChannelPartnerRepricingConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateChannelPartnerRepricingConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteChannelPartnerRepricingConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSkuGroups_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSkuGroupBillableSkus_;
    const ::grpc::internal::RpcMethod rpcmethod_LookupOffer_;
    const ::grpc::internal::RpcMethod rpcmethod_ListProducts_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSkus_;
    const ::grpc::internal::RpcMethod rpcmethod_ListOffers_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPurchasableSkus_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPurchasableOffers_;
    const ::grpc::internal::RpcMethod rpcmethod_QueryEligibleBillingAccounts_;
    const ::grpc::internal::RpcMethod rpcmethod_RegisterSubscriber_;
    const ::grpc::internal::RpcMethod rpcmethod_UnregisterSubscriber_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSubscribers_;
    const ::grpc::internal::RpcMethod rpcmethod_ListEntitlementChanges_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // List [Customer][google.cloud.channel.v1.Customer]s.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    //
    // Return value:
    // List of [Customer][google.cloud.channel.v1.Customer]s, or an empty list if
    // there are no customers.
    virtual ::grpc::Status ListCustomers(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListCustomersRequest* request, ::google::cloud::channel::v1::ListCustomersResponse* response);
    // Returns the requested [Customer][google.cloud.channel.v1.Customer]
    // resource.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: The customer resource doesn't exist. Usually the result of an
    // invalid name parameter.
    //
    // Return value:
    // The [Customer][google.cloud.channel.v1.Customer] resource.
    virtual ::grpc::Status GetCustomer(::grpc::ServerContext* context, const ::google::cloud::channel::v1::GetCustomerRequest* request, ::google::cloud::channel::v1::Customer* response);
    // Confirms the existence of Cloud Identity accounts based on the domain and
    // if the Cloud Identity accounts are owned by the reseller.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * INVALID_VALUE: Invalid domain value in the request.
    //
    // Return value:
    // A list of
    // [CloudIdentityCustomerAccount][google.cloud.channel.v1.CloudIdentityCustomerAccount]
    // resources for the domain (may be empty)
    //
    // Note: in the v1alpha1 version of the API, a NOT_FOUND error returns if
    // no
    // [CloudIdentityCustomerAccount][google.cloud.channel.v1.CloudIdentityCustomerAccount]
    // resources match the domain.
    virtual ::grpc::Status CheckCloudIdentityAccountsExist(::grpc::ServerContext* context, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest* request, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse* response);
    // Creates a new [Customer][google.cloud.channel.v1.Customer] resource under
    // the reseller or distributor account.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED:
    //     * The reseller account making the request is different from the
    //     reseller account in the API request.
    //     * You are not authorized to create a customer. See
    //     https://support.google.com/channelservices/answer/9759265
    // * INVALID_ARGUMENT:
    //     * Required request parameters are missing or invalid.
    //     * Domain field value doesn't match the primary email domain.
    //
    // Return value:
    // The newly created [Customer][google.cloud.channel.v1.Customer] resource.
    virtual ::grpc::Status CreateCustomer(::grpc::ServerContext* context, const ::google::cloud::channel::v1::CreateCustomerRequest* request, ::google::cloud::channel::v1::Customer* response);
    // Updates an existing [Customer][google.cloud.channel.v1.Customer] resource
    // for the reseller or distributor.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: No [Customer][google.cloud.channel.v1.Customer] resource found
    // for the name in the request.
    //
    // Return value:
    // The updated [Customer][google.cloud.channel.v1.Customer] resource.
    virtual ::grpc::Status UpdateCustomer(::grpc::ServerContext* context, const ::google::cloud::channel::v1::UpdateCustomerRequest* request, ::google::cloud::channel::v1::Customer* response);
    // Deletes the given [Customer][google.cloud.channel.v1.Customer] permanently.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The account making the request does not own
    // this customer.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * FAILED_PRECONDITION: The customer has existing entitlements.
    // * NOT_FOUND: No [Customer][google.cloud.channel.v1.Customer] resource found
    // for the name in the request.
    virtual ::grpc::Status DeleteCustomer(::grpc::ServerContext* context, const ::google::cloud::channel::v1::DeleteCustomerRequest* request, ::google::protobuf::Empty* response);
    // Imports a [Customer][google.cloud.channel.v1.Customer] from the Cloud
    // Identity associated with the provided Cloud Identity ID or domain before a
    // TransferEntitlements call. If a linked Customer already exists and
    // overwrite_if_exists is true, it will update that Customer's data.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED:
    //     * The reseller account making the request is different from the
    //     reseller account in the API request.
    //     * You are not authorized to import the customer. See
    //     https://support.google.com/channelservices/answer/9759265
    // * NOT_FOUND: Cloud Identity doesn't exist or was deleted.
    // * INVALID_ARGUMENT: Required parameters are missing, or the auth_token is
    // expired or invalid.
    // * ALREADY_EXISTS: A customer already exists and has conflicting critical
    // fields. Requires an overwrite.
    //
    // Return value:
    // The [Customer][google.cloud.channel.v1.Customer].
    virtual ::grpc::Status ImportCustomer(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ImportCustomerRequest* request, ::google::cloud::channel::v1::Customer* response);
    // Creates a Cloud Identity for the given customer using the customer's
    // information, or the information provided here.
    //
    // Possible error codes:
    //
    // *  PERMISSION_DENIED:
    //      * The customer doesn't belong to the reseller.
    //      * You are not authorized to provision cloud identity id. See
    //      https://support.google.com/channelservices/answer/9759265
    // *  INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // *  NOT_FOUND: The customer was not found.
    // *  ALREADY_EXISTS: The customer's primary email already exists. Retry
    //    after changing the customer's primary contact email.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata contains an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status ProvisionCloudIdentity(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest* request, ::google::longrunning::Operation* response);
    // Lists [Entitlement][google.cloud.channel.v1.Entitlement]s belonging to a
    // customer.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    //
    // Return value:
    // A list of the customer's
    // [Entitlement][google.cloud.channel.v1.Entitlement]s.
    virtual ::grpc::Status ListEntitlements(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListEntitlementsRequest* request, ::google::cloud::channel::v1::ListEntitlementsResponse* response);
    // List [TransferableSku][google.cloud.channel.v1.TransferableSku]s of a
    // customer based on the Cloud Identity ID or Customer Name in the request.
    //
    // Use this method to list the entitlements information of an
    // unowned customer. You should provide the customer's
    // Cloud Identity ID or Customer Name.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED:
    //     * The customer doesn't belong to the reseller and has no auth token.
    //     * The supplied auth token is invalid.
    //     * The reseller account making the request is different
    //     from the reseller account in the query.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    //
    // Return value:
    // A list of the customer's
    // [TransferableSku][google.cloud.channel.v1.TransferableSku].
    virtual ::grpc::Status ListTransferableSkus(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListTransferableSkusRequest* request, ::google::cloud::channel::v1::ListTransferableSkusResponse* response);
    // List [TransferableOffer][google.cloud.channel.v1.TransferableOffer]s of a
    // customer based on Cloud Identity ID or Customer Name in the request.
    //
    // Use this method when a reseller gets the entitlement information of an
    // unowned customer. The reseller should provide the customer's
    // Cloud Identity ID or Customer Name.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED:
    //     * The customer doesn't belong to the reseller and has no auth token.
    //     * The customer provided incorrect reseller information when generating
    //     auth token.
    //     * The reseller account making the request is different
    //     from the reseller account in the query.
    //     * The reseller is not authorized to transact on this Product. See
    //     https://support.google.com/channelservices/answer/9759265
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    //
    // Return value:
    // List of [TransferableOffer][google.cloud.channel.v1.TransferableOffer] for
    // the given customer and SKU.
    virtual ::grpc::Status ListTransferableOffers(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListTransferableOffersRequest* request, ::google::cloud::channel::v1::ListTransferableOffersResponse* response);
    // Returns the requested [Entitlement][google.cloud.channel.v1.Entitlement]
    // resource.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: The customer entitlement was not found.
    //
    // Return value:
    // The requested [Entitlement][google.cloud.channel.v1.Entitlement] resource.
    virtual ::grpc::Status GetEntitlement(::grpc::ServerContext* context, const ::google::cloud::channel::v1::GetEntitlementRequest* request, ::google::cloud::channel::v1::Entitlement* response);
    // Creates an entitlement for a customer.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED:
    //     * The customer doesn't belong to the reseller.
    //     * The reseller is not authorized to transact on this Product. See
    //     https://support.google.com/channelservices/answer/9759265
    // * INVALID_ARGUMENT:
    //     * Required request parameters are missing or invalid.
    //     * There is already a customer entitlement for a SKU from the same
    //     product family.
    // * INVALID_VALUE: Make sure the OfferId is valid. If it is, contact
    // Google Channel support for further troubleshooting.
    // * NOT_FOUND: The customer or offer resource was not found.
    // * ALREADY_EXISTS:
    //     * The SKU was already purchased for the customer.
    //     * The customer's primary email already exists. Retry
    //     after changing the customer's primary contact email.
    // * CONDITION_NOT_MET or FAILED_PRECONDITION:
    //     * The domain required for purchasing a SKU has not been verified.
    //     * A pre-requisite SKU required to purchase an Add-On SKU is missing.
    //     For example, Google Workspace Business Starter is required to purchase
    //     Vault or Drive.
    //     * (Developer accounts only) Reseller and resold domain must meet the
    //     following naming requirements:
    //         * Domain names must start with goog-test.
    //         * Domain names must include the reseller domain.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status CreateEntitlement(::grpc::ServerContext* context, const ::google::cloud::channel::v1::CreateEntitlementRequest* request, ::google::longrunning::Operation* response);
    // Change parameters of the entitlement.
    //
    // An entitlement update is a long-running operation and it updates the
    // entitlement as a result of fulfillment.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // For example, the number of seats being changed is greater than the allowed
    // number of max seats, or decreasing seats for a commitment based plan.
    // * NOT_FOUND: Entitlement resource not found.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status ChangeParameters(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ChangeParametersRequest* request, ::google::longrunning::Operation* response);
    // Updates the renewal settings for an existing customer entitlement.
    //
    // An entitlement update is a long-running operation and it updates the
    // entitlement as a result of fulfillment.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: Entitlement resource not found.
    // * NOT_COMMITMENT_PLAN: Renewal Settings are only applicable for a
    // commitment plan. Can't enable or disable renewals for non-commitment plans.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    //   Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status ChangeRenewalSettings(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest* request, ::google::longrunning::Operation* response);
    // Updates the Offer for an existing customer entitlement.
    //
    // An entitlement update is a long-running operation and it updates the
    // entitlement as a result of fulfillment.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: Offer or Entitlement resource not found.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status ChangeOffer(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ChangeOfferRequest* request, ::google::longrunning::Operation* response);
    // Starts paid service for a trial entitlement.
    //
    // Starts paid service for a trial entitlement immediately. This method is
    // only applicable if a plan is set up for a trial entitlement but has some
    // trial days remaining.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: Entitlement resource not found.
    // * FAILED_PRECONDITION/NOT_IN_TRIAL: This method only works for
    // entitlement on trial plans.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status StartPaidService(::grpc::ServerContext* context, const ::google::cloud::channel::v1::StartPaidServiceRequest* request, ::google::longrunning::Operation* response);
    // Suspends a previously fulfilled entitlement.
    //
    // An entitlement suspension is a long-running operation.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: Entitlement resource not found.
    // * NOT_ACTIVE: Entitlement is not active.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status SuspendEntitlement(::grpc::ServerContext* context, const ::google::cloud::channel::v1::SuspendEntitlementRequest* request, ::google::longrunning::Operation* response);
    // Cancels a previously fulfilled entitlement.
    //
    // An entitlement cancellation is a long-running operation.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * FAILED_PRECONDITION: There are Google Cloud projects linked to the
    // Google Cloud entitlement's Cloud Billing subaccount.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: Entitlement resource not found.
    // * DELETION_TYPE_NOT_ALLOWED: Cancel is only allowed for Google Workspace
    // add-ons, or entitlements for Google Cloud's development platform.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The response will contain
    // google.protobuf.Empty on success. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status CancelEntitlement(::grpc::ServerContext* context, const ::google::cloud::channel::v1::CancelEntitlementRequest* request, ::google::longrunning::Operation* response);
    // Activates a previously suspended entitlement. Entitlements suspended for
    // pending ToS acceptance can't be activated using this method.
    //
    // An entitlement activation is a long-running operation and it updates
    // the state of the customer entitlement.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: Entitlement resource not found.
    // * SUSPENSION_NOT_RESELLER_INITIATED: Can only activate reseller-initiated
    // suspensions and entitlements that have accepted the TOS.
    // * NOT_SUSPENDED: Can only activate suspended entitlements not in an ACTIVE
    // state.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status ActivateEntitlement(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ActivateEntitlementRequest* request, ::google::longrunning::Operation* response);
    // Transfers customer entitlements to new reseller.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED:
    //     * The customer doesn't belong to the reseller.
    //     * The reseller is not authorized to transact on this Product. See
    //     https://support.google.com/channelservices/answer/9759265
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: The customer or offer resource was not found.
    // * ALREADY_EXISTS: The SKU was already transferred for the customer.
    // * CONDITION_NOT_MET or FAILED_PRECONDITION:
    //     * The SKU requires domain verification to transfer, but the domain is
    //     not verified.
    //     * An Add-On SKU (example, Vault or Drive) is missing the
    //     pre-requisite SKU (example, G Suite Basic).
    //     * (Developer accounts only) Reseller and resold domain must meet the
    //     following naming requirements:
    //         * Domain names must start with goog-test.
    //         * Domain names must include the reseller domain.
    //     * Specify all transferring entitlements.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status TransferEntitlements(::grpc::ServerContext* context, const ::google::cloud::channel::v1::TransferEntitlementsRequest* request, ::google::longrunning::Operation* response);
    // Transfers customer entitlements from their current reseller to Google.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: The customer or offer resource was not found.
    // * ALREADY_EXISTS: The SKU was already transferred for the customer.
    // * CONDITION_NOT_MET or FAILED_PRECONDITION:
    //     * The SKU requires domain verification to transfer, but the domain is
    //     not verified.
    //     * An Add-On SKU (example, Vault or Drive) is missing the
    //     pre-requisite SKU (example, G Suite Basic).
    //     * (Developer accounts only) Reseller and resold domain must meet the
    //     following naming requirements:
    //         * Domain names must start with goog-test.
    //         * Domain names must include the reseller domain.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The response will contain
    // google.protobuf.Empty on success. The Operation metadata will contain an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    virtual ::grpc::Status TransferEntitlementsToGoogle(::grpc::ServerContext* context, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest* request, ::google::longrunning::Operation* response);
    // List [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink]s
    // belonging to a distributor. You must be a distributor to call this method.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    //
    // Return value:
    // The list of the distributor account's
    // [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink] resources.
    virtual ::grpc::Status ListChannelPartnerLinks(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest* request, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse* response);
    // Returns the requested
    // [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink] resource.
    // You must be a distributor to call this method.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: ChannelPartnerLink resource not found because of an
    // invalid channel partner link name.
    //
    // Return value:
    // The [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink]
    // resource.
    virtual ::grpc::Status GetChannelPartnerLink(::grpc::ServerContext* context, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response);
    // Initiates a channel partner link between a distributor and a reseller, or
    // between resellers in an n-tier reseller channel.
    // Invited partners need to follow the invite_link_uri provided in the
    // response to accept. After accepting the invitation, a link is set up
    // between the two parties.
    // You must be a distributor to call this method.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * ALREADY_EXISTS: The ChannelPartnerLink sent in the request already
    // exists.
    // * NOT_FOUND: No Cloud Identity customer exists for provided domain.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The new [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink]
    // resource.
    virtual ::grpc::Status CreateChannelPartnerLink(::grpc::ServerContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response);
    // Updates a channel partner link. Distributors call this method to change a
    // link's status. For example, to suspend a partner link.
    // You must be a distributor to call this method.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request is different
    // from the reseller account in the API request.
    // * INVALID_ARGUMENT:
    //     * Required request parameters are missing or invalid.
    //     * Link state cannot change from invited to active or suspended.
    //     * Cannot send reseller_cloud_identity_id, invite_url, or name in update
    //     mask.
    // * NOT_FOUND: ChannelPartnerLink resource not found.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The updated
    // [ChannelPartnerLink][google.cloud.channel.v1.ChannelPartnerLink] resource.
    virtual ::grpc::Status UpdateChannelPartnerLink(::grpc::ServerContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response);
    // Gets information about how a Reseller modifies their bill before sending
    // it to a Customer.
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different.
    // * NOT_FOUND: The
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // was not found.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // resource, otherwise returns an error.
    virtual ::grpc::Status GetCustomerRepricingConfig(::grpc::ServerContext* context, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response);
    // Lists information about how a Reseller modifies their bill before sending
    // it to a Customer.
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different.
    // * NOT_FOUND: The
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // specified does not exist or is not associated with the given account.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // resources. The data for each resource is displayed in the ascending order
    // of:
    //
    // * Customer ID
    // * [RepricingConfig.EntitlementGranularity.entitlement][google.cloud.channel.v1.RepricingConfig.EntitlementGranularity.entitlement]
    // * [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
    // * [CustomerRepricingConfig.update_time][google.cloud.channel.v1.CustomerRepricingConfig.update_time]
    //
    // If unsuccessful, returns an error.
    virtual ::grpc::Status ListCustomerRepricingConfigs(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest* request, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse* response);
    // Creates a CustomerRepricingConfig. Call this method to set modifications
    // for a specific customer's bill. You can only create configs if the
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
    // is a future month. If needed, you can create a config for the current
    // month, with some restrictions.
    //
    // When creating a config for a future month, make sure there are no existing
    // configs for that
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
    //
    // The following restrictions are for creating configs in the current month.
    //
    // * This functionality is reserved for recovering from an erroneous config,
    // and should not be used for regular business cases.
    // * The new config will not modify exports used with other configs.
    // Changes to the config may be immediate, but may take up to 24 hours.
    // * There is a limit of ten configs for any
    // [RepricingConfig.EntitlementGranularity.entitlement][google.cloud.channel.v1.RepricingConfig.EntitlementGranularity.entitlement],
    // for any
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
    // * The contained
    // [CustomerRepricingConfig.repricing_config][google.cloud.channel.v1.CustomerRepricingConfig.repricing_config]
    // value must be different from the value used in the current config for a
    // [RepricingConfig.EntitlementGranularity.entitlement][google.cloud.channel.v1.RepricingConfig.EntitlementGranularity.entitlement].
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different.
    // * INVALID_ARGUMENT: Missing or invalid required parameters in the
    // request. Also displays if the updated config is for the current month or
    // past months.
    // * NOT_FOUND: The
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // specified does not exist or is not associated with the given account.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the updated
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // resource, otherwise returns an error.
    virtual ::grpc::Status CreateCustomerRepricingConfig(::grpc::ServerContext* context, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response);
    // Updates a CustomerRepricingConfig. Call this method to set modifications
    // for a specific customer's bill. This method overwrites the existing
    // CustomerRepricingConfig.
    //
    // You can only update configs if the
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
    // is a future month. To make changes to configs for the current month, use
    // [CreateCustomerRepricingConfig][google.cloud.channel.v1.CloudChannelService.CreateCustomerRepricingConfig],
    // taking note of its restrictions. You cannot update the
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
    //
    // When updating a config in the future:
    //
    // * This config must already exist.
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different.
    // * INVALID_ARGUMENT: Missing or invalid required parameters in the
    // request. Also displays if the updated config is for the current month or
    // past months.
    // * NOT_FOUND: The
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // specified does not exist or is not associated with the given account.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the updated
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // resource, otherwise returns an error.
    virtual ::grpc::Status UpdateCustomerRepricingConfig(::grpc::ServerContext* context, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response);
    // Deletes the given
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // permanently. You can only delete configs if their
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
    // is set to a date after the current month.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The account making the request does not own
    // this customer.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * FAILED_PRECONDITION: The
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // is active or in the past.
    // * NOT_FOUND: No
    // [CustomerRepricingConfig][google.cloud.channel.v1.CustomerRepricingConfig]
    // found for the name in the request.
    virtual ::grpc::Status DeleteCustomerRepricingConfig(::grpc::ServerContext* context, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest* request, ::google::protobuf::Empty* response);
    // Gets information about how a Distributor modifies their bill before sending
    // it to a ChannelPartner.
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different.
    // * NOT_FOUND: The
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // was not found.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // resource, otherwise returns an error.
    virtual ::grpc::Status GetChannelPartnerRepricingConfig(::grpc::ServerContext* context, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response);
    // Lists information about how a Reseller modifies their bill before sending
    // it to a ChannelPartner.
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different.
    // * NOT_FOUND: The
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // specified does not exist or is not associated with the given account.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // resources. The data for each resource is displayed in the ascending order
    // of:
    //
    // * Channel Partner ID
    // * [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
    // * [ChannelPartnerRepricingConfig.update_time][google.cloud.channel.v1.ChannelPartnerRepricingConfig.update_time]
    //
    // If unsuccessful, returns an error.
    virtual ::grpc::Status ListChannelPartnerRepricingConfigs(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest* request, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse* response);
    // Creates a ChannelPartnerRepricingConfig. Call this method to set
    // modifications for a specific ChannelPartner's bill. You can only create
    // configs if the
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
    // is a future month. If needed, you can create a config for the current
    // month, with some restrictions.
    //
    // When creating a config for a future month, make sure there are no existing
    // configs for that
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
    //
    // The following restrictions are for creating configs in the current month.
    //
    // * This functionality is reserved for recovering from an erroneous config,
    // and should not be used for regular business cases.
    // * The new config will not modify exports used with other configs.
    // Changes to the config may be immediate, but may take up to 24 hours.
    // * There is a limit of ten configs for any ChannelPartner or
    // [RepricingConfig.EntitlementGranularity.entitlement][google.cloud.channel.v1.RepricingConfig.EntitlementGranularity.entitlement],
    // for any
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
    // * The contained
    // [ChannelPartnerRepricingConfig.repricing_config][google.cloud.channel.v1.ChannelPartnerRepricingConfig.repricing_config]
    // value must be different from the value used in the current config for a
    // ChannelPartner.
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different.
    // * INVALID_ARGUMENT: Missing or invalid required parameters in the
    // request. Also displays if the updated config is for the current month or
    // past months.
    // * NOT_FOUND: The
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // specified does not exist or is not associated with the given account.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the updated
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // resource, otherwise returns an error.
    virtual ::grpc::Status CreateChannelPartnerRepricingConfig(::grpc::ServerContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response);
    // Updates a ChannelPartnerRepricingConfig. Call this method to set
    // modifications for a specific ChannelPartner's bill. This method overwrites
    // the existing CustomerRepricingConfig.
    //
    // You can only update configs if the
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
    // is a future month. To make changes to configs for the current month, use
    // [CreateChannelPartnerRepricingConfig][google.cloud.channel.v1.CloudChannelService.CreateChannelPartnerRepricingConfig],
    // taking note of its restrictions. You cannot update the
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month].
    //
    // When updating a config in the future:
    //
    // * This config must already exist.
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different.
    // * INVALID_ARGUMENT: Missing or invalid required parameters in the
    // request. Also displays if the updated config is for the current month or
    // past months.
    // * NOT_FOUND: The
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // specified does not exist or is not associated with the given account.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the updated
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // resource, otherwise returns an error.
    virtual ::grpc::Status UpdateChannelPartnerRepricingConfig(::grpc::ServerContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response);
    // Deletes the given
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // permanently. You can only delete configs if their
    // [RepricingConfig.effective_invoice_month][google.cloud.channel.v1.RepricingConfig.effective_invoice_month]
    // is set to a date after the current month.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The account making the request does not own
    // this customer.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * FAILED_PRECONDITION: The
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // is active or in the past.
    // * NOT_FOUND: No
    // [ChannelPartnerRepricingConfig][google.cloud.channel.v1.ChannelPartnerRepricingConfig]
    // found for the name in the request.
    virtual ::grpc::Status DeleteChannelPartnerRepricingConfig(::grpc::ServerContext* context, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest* request, ::google::protobuf::Empty* response);
    // Lists the Rebilling supported SKU groups the account is authorized to
    // sell.
    // Reference: https://cloud.google.com/skus/sku-groups
    //
    // Possible Error Codes:
    //
    // * PERMISSION_DENIED: If the account making the request and the account
    // being queried are different, or the account doesn't exist.
    // * INTERNAL: Any non-user error related to technical issues in the
    // backend. In this case, contact Cloud Channel support.
    //
    // Return Value:
    // If successful, the [SkuGroup][google.cloud.channel.v1.SkuGroup] resources.
    // The data for each resource is displayed in the alphabetical order of SKU
    // group display name.
    // The data for each resource is displayed in the ascending order of
    // [SkuGroup.display_name][google.cloud.channel.v1.SkuGroup.display_name]
    //
    // If unsuccessful, returns an error.
    virtual ::grpc::Status ListSkuGroups(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListSkuGroupsRequest* request, ::google::cloud::channel::v1::ListSkuGroupsResponse* response);
    // Lists the Billable SKUs in a given SKU group.
    //
    // Possible error codes:
    // PERMISSION_DENIED: If the account making the request and the account
    // being queried for are different, or the account doesn't exist.
    // INVALID_ARGUMENT: Missing or invalid required parameters in the
    // request.
    // INTERNAL: Any non-user error related to technical issue in the
    // backend. In this case, contact cloud channel support.
    //
    // Return Value:
    // If successful, the [BillableSku][google.cloud.channel.v1.BillableSku]
    // resources. The data for each resource is displayed in the ascending order
    // of:
    //
    // * [BillableSku.service_display_name][google.cloud.channel.v1.BillableSku.service_display_name]
    // * [BillableSku.sku_display_name][google.cloud.channel.v1.BillableSku.sku_display_name]
    //
    // If unsuccessful, returns an error.
    virtual ::grpc::Status ListSkuGroupBillableSkus(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest* request, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse* response);
    // Returns the requested [Offer][google.cloud.channel.v1.Offer] resource.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The entitlement doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: Entitlement or offer was not found.
    //
    // Return value:
    // The [Offer][google.cloud.channel.v1.Offer] resource.
    virtual ::grpc::Status LookupOffer(::grpc::ServerContext* context, const ::google::cloud::channel::v1::LookupOfferRequest* request, ::google::cloud::channel::v1::Offer* response);
    // Lists the Products the reseller is authorized to sell.
    //
    // Possible error codes:
    //
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    virtual ::grpc::Status ListProducts(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListProductsRequest* request, ::google::cloud::channel::v1::ListProductsResponse* response);
    // Lists the SKUs for a product the reseller is authorized to sell.
    //
    // Possible error codes:
    //
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    virtual ::grpc::Status ListSkus(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListSkusRequest* request, ::google::cloud::channel::v1::ListSkusResponse* response);
    // Lists the Offers the reseller can sell.
    //
    // Possible error codes:
    //
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    virtual ::grpc::Status ListOffers(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListOffersRequest* request, ::google::cloud::channel::v1::ListOffersResponse* response);
    // Lists the following:
    //
    // * SKUs that you can purchase for a customer
    // * SKUs that you can upgrade or downgrade for an entitlement.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    virtual ::grpc::Status ListPurchasableSkus(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListPurchasableSkusRequest* request, ::google::cloud::channel::v1::ListPurchasableSkusResponse* response);
    // Lists the following:
    //
    // * Offers that you can purchase for a customer.
    // * Offers that you can change for an entitlement.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED:
    //     * The customer doesn't belong to the reseller
    //     * The reseller is not authorized to transact on this Product. See
    //     https://support.google.com/channelservices/answer/9759265
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    virtual ::grpc::Status ListPurchasableOffers(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListPurchasableOffersRequest* request, ::google::cloud::channel::v1::ListPurchasableOffersResponse* response);
    // Lists the billing accounts that are eligible to purchase particular SKUs
    // for a given customer.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The customer doesn't belong to the reseller.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    //
    // Return value:
    // Based on the provided list of SKUs, returns a list of SKU groups that must
    // be purchased using the same billing account and the billing accounts
    // eligible to purchase each SKU group.
    virtual ::grpc::Status QueryEligibleBillingAccounts(::grpc::ServerContext* context, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest* request, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse* response);
    // Registers a service account with subscriber privileges on the Cloud Pub/Sub
    // topic for this Channel Services account. After you create a
    // subscriber, you get the events through
    // [SubscriberEvent][google.cloud.channel.v1.SubscriberEvent]
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request and the
    // provided reseller account are different, or the impersonated user
    // is not a super admin.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The topic name with the registered service email address.
    virtual ::grpc::Status RegisterSubscriber(::grpc::ServerContext* context, const ::google::cloud::channel::v1::RegisterSubscriberRequest* request, ::google::cloud::channel::v1::RegisterSubscriberResponse* response);
    // Unregisters a service account with subscriber privileges on the Cloud
    // Pub/Sub topic created for this Channel Services account. If there are no
    // service accounts left with subscriber privileges, this deletes the topic.
    // You can call ListSubscribers to check for these accounts.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request and the
    // provided reseller account are different, or the impersonated user
    // is not a super admin.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: The topic resource doesn't exist.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // The topic name that unregistered the service email address.
    // Returns a success response if the service email address wasn't registered
    // with the topic.
    virtual ::grpc::Status UnregisterSubscriber(::grpc::ServerContext* context, const ::google::cloud::channel::v1::UnregisterSubscriberRequest* request, ::google::cloud::channel::v1::UnregisterSubscriberResponse* response);
    // Lists service accounts with subscriber privileges on the Cloud Pub/Sub
    // topic created for this Channel Services account.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request and the
    // provided reseller account are different, or the impersonated user
    // is not a super admin.
    // * INVALID_ARGUMENT: Required request parameters are missing or invalid.
    // * NOT_FOUND: The topic resource doesn't exist.
    // * INTERNAL: Any non-user error related to a technical issue in the
    // backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // Contact Cloud Channel support.
    //
    // Return value:
    // A list of service email addresses.
    virtual ::grpc::Status ListSubscribers(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListSubscribersRequest* request, ::google::cloud::channel::v1::ListSubscribersResponse* response);
    // List entitlement history.
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The reseller account making the request and the
    // provided reseller account are different.
    // * INVALID_ARGUMENT: Missing or invalid required fields in the request.
    // * NOT_FOUND: The parent resource doesn't exist. Usually the result of an
    // invalid name parameter.
    // * INTERNAL: Any non-user error related to a technical issue in the backend.
    // In this case, contact CloudChannel support.
    // * UNKNOWN: Any non-user error related to a technical issue in the backend.
    // In this case, contact Cloud Channel support.
    //
    // Return value:
    // List of [EntitlementChange][google.cloud.channel.v1.EntitlementChange]s.
    virtual ::grpc::Status ListEntitlementChanges(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListEntitlementChangesRequest* request, ::google::cloud::channel::v1::ListEntitlementChangesResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListCustomers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListCustomers() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListCustomers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListCustomersRequest* /*request*/, ::google::cloud::channel::v1::ListCustomersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCustomers(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListCustomersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListCustomersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCustomer() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCustomer(::grpc::ServerContext* context, ::google::cloud::channel::v1::GetCustomerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::Customer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CheckCloudIdentityAccountsExist : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CheckCloudIdentityAccountsExist() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CheckCloudIdentityAccountsExist() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CheckCloudIdentityAccountsExist(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest* /*request*/, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCheckCloudIdentityAccountsExist(::grpc::ServerContext* context, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCustomer() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_CreateCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCustomer(::grpc::ServerContext* context, ::google::cloud::channel::v1::CreateCustomerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::Customer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCustomer() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCustomer(::grpc::ServerContext* context, ::google::cloud::channel::v1::UpdateCustomerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::Customer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteCustomer() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_DeleteCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteCustomerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCustomer(::grpc::ServerContext* context, ::google::cloud::channel::v1::DeleteCustomerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ImportCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ImportCustomer() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_ImportCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ImportCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportCustomer(::grpc::ServerContext* context, ::google::cloud::channel::v1::ImportCustomerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::Customer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ProvisionCloudIdentity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ProvisionCloudIdentity() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_ProvisionCloudIdentity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProvisionCloudIdentity(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestProvisionCloudIdentity(::grpc::ServerContext* context, ::google::cloud::channel::v1::ProvisionCloudIdentityRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListEntitlements() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_ListEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListEntitlementsRequest* /*request*/, ::google::cloud::channel::v1::ListEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEntitlements(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListEntitlementsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListEntitlementsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTransferableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTransferableSkus() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_ListTransferableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTransferableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListTransferableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListTransferableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTransferableSkus(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListTransferableSkusRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListTransferableSkusResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTransferableOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTransferableOffers() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_ListTransferableOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTransferableOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListTransferableOffersRequest* /*request*/, ::google::cloud::channel::v1::ListTransferableOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTransferableOffers(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListTransferableOffersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListTransferableOffersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetEntitlement() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_GetEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetEntitlementRequest* /*request*/, ::google::cloud::channel::v1::Entitlement* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEntitlement(::grpc::ServerContext* context, ::google::cloud::channel::v1::GetEntitlementRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::Entitlement>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateEntitlement() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_CreateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEntitlement(::grpc::ServerContext* context, ::google::cloud::channel::v1::CreateEntitlementRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ChangeParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ChangeParameters() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_ChangeParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ChangeParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeParametersRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestChangeParameters(::grpc::ServerContext* context, ::google::cloud::channel::v1::ChangeParametersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ChangeRenewalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ChangeRenewalSettings() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_ChangeRenewalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ChangeRenewalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestChangeRenewalSettings(::grpc::ServerContext* context, ::google::cloud::channel::v1::ChangeRenewalSettingsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ChangeOffer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ChangeOffer() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_ChangeOffer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ChangeOffer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeOfferRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestChangeOffer(::grpc::ServerContext* context, ::google::cloud::channel::v1::ChangeOfferRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_StartPaidService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_StartPaidService() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_StartPaidService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartPaidService(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::StartPaidServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStartPaidService(::grpc::ServerContext* context, ::google::cloud::channel::v1::StartPaidServiceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SuspendEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SuspendEntitlement() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_SuspendEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SuspendEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::SuspendEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSuspendEntitlement(::grpc::ServerContext* context, ::google::cloud::channel::v1::SuspendEntitlementRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CancelEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CancelEntitlement() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_CancelEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CancelEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelEntitlement(::grpc::ServerContext* context, ::google::cloud::channel::v1::CancelEntitlementRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ActivateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ActivateEntitlement() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_ActivateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ActivateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ActivateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestActivateEntitlement(::grpc::ServerContext* context, ::google::cloud::channel::v1::ActivateEntitlementRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TransferEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TransferEntitlements() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_TransferEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TransferEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::TransferEntitlementsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTransferEntitlements(::grpc::ServerContext* context, ::google::cloud::channel::v1::TransferEntitlementsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TransferEntitlementsToGoogle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TransferEntitlementsToGoogle() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_TransferEntitlementsToGoogle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TransferEntitlementsToGoogle(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTransferEntitlementsToGoogle(::grpc::ServerContext* context, ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListChannelPartnerLinks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListChannelPartnerLinks() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_ListChannelPartnerLinks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListChannelPartnerLinks(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest* /*request*/, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListChannelPartnerLinks(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListChannelPartnerLinksRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetChannelPartnerLink() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_GetChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetChannelPartnerLink(::grpc::ServerContext* context, ::google::cloud::channel::v1::GetChannelPartnerLinkRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ChannelPartnerLink>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateChannelPartnerLink() {
      ::grpc::Service::MarkMethodAsync(24);
    }
    ~WithAsyncMethod_CreateChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateChannelPartnerLink(::grpc::ServerContext* context, ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ChannelPartnerLink>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateChannelPartnerLink() {
      ::grpc::Service::MarkMethodAsync(25);
    }
    ~WithAsyncMethod_UpdateChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateChannelPartnerLink(::grpc::ServerContext* context, ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ChannelPartnerLink>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodAsync(26);
    }
    ~WithAsyncMethod_GetCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCustomerRepricingConfig(::grpc::ServerContext* context, ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::CustomerRepricingConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListCustomerRepricingConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListCustomerRepricingConfigs() {
      ::grpc::Service::MarkMethodAsync(27);
    }
    ~WithAsyncMethod_ListCustomerRepricingConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomerRepricingConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest* /*request*/, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCustomerRepricingConfigs(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodAsync(28);
    }
    ~WithAsyncMethod_CreateCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCustomerRepricingConfig(::grpc::ServerContext* context, ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::CustomerRepricingConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodAsync(29);
    }
    ~WithAsyncMethod_UpdateCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCustomerRepricingConfig(::grpc::ServerContext* context, ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::CustomerRepricingConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodAsync(30);
    }
    ~WithAsyncMethod_DeleteCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCustomerRepricingConfig(::grpc::ServerContext* context, ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodAsync(31);
    }
    ~WithAsyncMethod_GetChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetChannelPartnerRepricingConfig(::grpc::ServerContext* context, ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListChannelPartnerRepricingConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListChannelPartnerRepricingConfigs() {
      ::grpc::Service::MarkMethodAsync(32);
    }
    ~WithAsyncMethod_ListChannelPartnerRepricingConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListChannelPartnerRepricingConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest* /*request*/, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListChannelPartnerRepricingConfigs(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodAsync(33);
    }
    ~WithAsyncMethod_CreateChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateChannelPartnerRepricingConfig(::grpc::ServerContext* context, ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodAsync(34);
    }
    ~WithAsyncMethod_UpdateChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateChannelPartnerRepricingConfig(::grpc::ServerContext* context, ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(34, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodAsync(35);
    }
    ~WithAsyncMethod_DeleteChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteChannelPartnerRepricingConfig(::grpc::ServerContext* context, ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(35, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSkuGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSkuGroups() {
      ::grpc::Service::MarkMethodAsync(36);
    }
    ~WithAsyncMethod_ListSkuGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkuGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkuGroupsRequest* /*request*/, ::google::cloud::channel::v1::ListSkuGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSkuGroups(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListSkuGroupsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListSkuGroupsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(36, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSkuGroupBillableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSkuGroupBillableSkus() {
      ::grpc::Service::MarkMethodAsync(37);
    }
    ~WithAsyncMethod_ListSkuGroupBillableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkuGroupBillableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSkuGroupBillableSkus(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(37, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_LookupOffer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_LookupOffer() {
      ::grpc::Service::MarkMethodAsync(38);
    }
    ~WithAsyncMethod_LookupOffer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupOffer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::LookupOfferRequest* /*request*/, ::google::cloud::channel::v1::Offer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestLookupOffer(::grpc::ServerContext* context, ::google::cloud::channel::v1::LookupOfferRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::Offer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(38, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListProducts() {
      ::grpc::Service::MarkMethodAsync(39);
    }
    ~WithAsyncMethod_ListProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListProductsRequest* /*request*/, ::google::cloud::channel::v1::ListProductsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProducts(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListProductsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListProductsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(39, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSkus() {
      ::grpc::Service::MarkMethodAsync(40);
    }
    ~WithAsyncMethod_ListSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkusRequest* /*request*/, ::google::cloud::channel::v1::ListSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSkus(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListSkusRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListSkusResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(40, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListOffers() {
      ::grpc::Service::MarkMethodAsync(41);
    }
    ~WithAsyncMethod_ListOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListOffersRequest* /*request*/, ::google::cloud::channel::v1::ListOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListOffers(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListOffersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListOffersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(41, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPurchasableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPurchasableSkus() {
      ::grpc::Service::MarkMethodAsync(42);
    }
    ~WithAsyncMethod_ListPurchasableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPurchasableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListPurchasableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListPurchasableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPurchasableSkus(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListPurchasableSkusRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListPurchasableSkusResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(42, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPurchasableOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPurchasableOffers() {
      ::grpc::Service::MarkMethodAsync(43);
    }
    ~WithAsyncMethod_ListPurchasableOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPurchasableOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListPurchasableOffersRequest* /*request*/, ::google::cloud::channel::v1::ListPurchasableOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPurchasableOffers(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListPurchasableOffersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListPurchasableOffersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(43, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_QueryEligibleBillingAccounts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_QueryEligibleBillingAccounts() {
      ::grpc::Service::MarkMethodAsync(44);
    }
    ~WithAsyncMethod_QueryEligibleBillingAccounts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status QueryEligibleBillingAccounts(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest* /*request*/, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestQueryEligibleBillingAccounts(::grpc::ServerContext* context, ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(44, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RegisterSubscriber : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RegisterSubscriber() {
      ::grpc::Service::MarkMethodAsync(45);
    }
    ~WithAsyncMethod_RegisterSubscriber() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RegisterSubscriber(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::RegisterSubscriberRequest* /*request*/, ::google::cloud::channel::v1::RegisterSubscriberResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRegisterSubscriber(::grpc::ServerContext* context, ::google::cloud::channel::v1::RegisterSubscriberRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::RegisterSubscriberResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(45, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UnregisterSubscriber : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UnregisterSubscriber() {
      ::grpc::Service::MarkMethodAsync(46);
    }
    ~WithAsyncMethod_UnregisterSubscriber() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UnregisterSubscriber(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UnregisterSubscriberRequest* /*request*/, ::google::cloud::channel::v1::UnregisterSubscriberResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUnregisterSubscriber(::grpc::ServerContext* context, ::google::cloud::channel::v1::UnregisterSubscriberRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::UnregisterSubscriberResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(46, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSubscribers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSubscribers() {
      ::grpc::Service::MarkMethodAsync(47);
    }
    ~WithAsyncMethod_ListSubscribers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubscribers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSubscribersRequest* /*request*/, ::google::cloud::channel::v1::ListSubscribersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSubscribers(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListSubscribersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListSubscribersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(47, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListEntitlementChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListEntitlementChanges() {
      ::grpc::Service::MarkMethodAsync(48);
    }
    ~WithAsyncMethod_ListEntitlementChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntitlementChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListEntitlementChangesRequest* /*request*/, ::google::cloud::channel::v1::ListEntitlementChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEntitlementChanges(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListEntitlementChangesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListEntitlementChangesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(48, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListCustomers<WithAsyncMethod_GetCustomer<WithAsyncMethod_CheckCloudIdentityAccountsExist<WithAsyncMethod_CreateCustomer<WithAsyncMethod_UpdateCustomer<WithAsyncMethod_DeleteCustomer<WithAsyncMethod_ImportCustomer<WithAsyncMethod_ProvisionCloudIdentity<WithAsyncMethod_ListEntitlements<WithAsyncMethod_ListTransferableSkus<WithAsyncMethod_ListTransferableOffers<WithAsyncMethod_GetEntitlement<WithAsyncMethod_CreateEntitlement<WithAsyncMethod_ChangeParameters<WithAsyncMethod_ChangeRenewalSettings<WithAsyncMethod_ChangeOffer<WithAsyncMethod_StartPaidService<WithAsyncMethod_SuspendEntitlement<WithAsyncMethod_CancelEntitlement<WithAsyncMethod_ActivateEntitlement<WithAsyncMethod_TransferEntitlements<WithAsyncMethod_TransferEntitlementsToGoogle<WithAsyncMethod_ListChannelPartnerLinks<WithAsyncMethod_GetChannelPartnerLink<WithAsyncMethod_CreateChannelPartnerLink<WithAsyncMethod_UpdateChannelPartnerLink<WithAsyncMethod_GetCustomerRepricingConfig<WithAsyncMethod_ListCustomerRepricingConfigs<WithAsyncMethod_CreateCustomerRepricingConfig<WithAsyncMethod_UpdateCustomerRepricingConfig<WithAsyncMethod_DeleteCustomerRepricingConfig<WithAsyncMethod_GetChannelPartnerRepricingConfig<WithAsyncMethod_ListChannelPartnerRepricingConfigs<WithAsyncMethod_CreateChannelPartnerRepricingConfig<WithAsyncMethod_UpdateChannelPartnerRepricingConfig<WithAsyncMethod_DeleteChannelPartnerRepricingConfig<WithAsyncMethod_ListSkuGroups<WithAsyncMethod_ListSkuGroupBillableSkus<WithAsyncMethod_LookupOffer<WithAsyncMethod_ListProducts<WithAsyncMethod_ListSkus<WithAsyncMethod_ListOffers<WithAsyncMethod_ListPurchasableSkus<WithAsyncMethod_ListPurchasableOffers<WithAsyncMethod_QueryEligibleBillingAccounts<WithAsyncMethod_RegisterSubscriber<WithAsyncMethod_UnregisterSubscriber<WithAsyncMethod_ListSubscribers<WithAsyncMethod_ListEntitlementChanges<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListCustomers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListCustomers() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListCustomersRequest, ::google::cloud::channel::v1::ListCustomersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListCustomersRequest* request, ::google::cloud::channel::v1::ListCustomersResponse* response) { return this->ListCustomers(context, request, response); }));}
    void SetMessageAllocatorFor_ListCustomers(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListCustomersRequest, ::google::cloud::channel::v1::ListCustomersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListCustomersRequest, ::google::cloud::channel::v1::ListCustomersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListCustomers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListCustomersRequest* /*request*/, ::google::cloud::channel::v1::ListCustomersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCustomers(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListCustomersRequest* /*request*/, ::google::cloud::channel::v1::ListCustomersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCustomer() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::GetCustomerRequest, ::google::cloud::channel::v1::Customer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::GetCustomerRequest* request, ::google::cloud::channel::v1::Customer* response) { return this->GetCustomer(context, request, response); }));}
    void SetMessageAllocatorFor_GetCustomer(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::GetCustomerRequest, ::google::cloud::channel::v1::Customer>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::GetCustomerRequest, ::google::cloud::channel::v1::Customer>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCustomer(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::GetCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CheckCloudIdentityAccountsExist : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CheckCloudIdentityAccountsExist() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest* request, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse* response) { return this->CheckCloudIdentityAccountsExist(context, request, response); }));}
    void SetMessageAllocatorFor_CheckCloudIdentityAccountsExist(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CheckCloudIdentityAccountsExist() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CheckCloudIdentityAccountsExist(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest* /*request*/, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CheckCloudIdentityAccountsExist(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest* /*request*/, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCustomer() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::CreateCustomerRequest, ::google::cloud::channel::v1::Customer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::CreateCustomerRequest* request, ::google::cloud::channel::v1::Customer* response) { return this->CreateCustomer(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCustomer(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::CreateCustomerRequest, ::google::cloud::channel::v1::Customer>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::CreateCustomerRequest, ::google::cloud::channel::v1::Customer>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCustomer(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::CreateCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCustomer() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::UpdateCustomerRequest, ::google::cloud::channel::v1::Customer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::UpdateCustomerRequest* request, ::google::cloud::channel::v1::Customer* response) { return this->UpdateCustomer(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCustomer(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::UpdateCustomerRequest, ::google::cloud::channel::v1::Customer>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::UpdateCustomerRequest, ::google::cloud::channel::v1::Customer>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCustomer(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteCustomer() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::DeleteCustomerRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::DeleteCustomerRequest* request, ::google::protobuf::Empty* response) { return this->DeleteCustomer(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteCustomer(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::DeleteCustomerRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::DeleteCustomerRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteCustomerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCustomer(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteCustomerRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ImportCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ImportCustomer() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ImportCustomerRequest, ::google::cloud::channel::v1::Customer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ImportCustomerRequest* request, ::google::cloud::channel::v1::Customer* response) { return this->ImportCustomer(context, request, response); }));}
    void SetMessageAllocatorFor_ImportCustomer(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ImportCustomerRequest, ::google::cloud::channel::v1::Customer>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ImportCustomerRequest, ::google::cloud::channel::v1::Customer>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ImportCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ImportCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportCustomer(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ImportCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ProvisionCloudIdentity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ProvisionCloudIdentity() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ProvisionCloudIdentityRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest* request, ::google::longrunning::Operation* response) { return this->ProvisionCloudIdentity(context, request, response); }));}
    void SetMessageAllocatorFor_ProvisionCloudIdentity(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ProvisionCloudIdentityRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ProvisionCloudIdentityRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ProvisionCloudIdentity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProvisionCloudIdentity(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ProvisionCloudIdentity(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListEntitlements() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListEntitlementsRequest, ::google::cloud::channel::v1::ListEntitlementsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListEntitlementsRequest* request, ::google::cloud::channel::v1::ListEntitlementsResponse* response) { return this->ListEntitlements(context, request, response); }));}
    void SetMessageAllocatorFor_ListEntitlements(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListEntitlementsRequest, ::google::cloud::channel::v1::ListEntitlementsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListEntitlementsRequest, ::google::cloud::channel::v1::ListEntitlementsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListEntitlementsRequest* /*request*/, ::google::cloud::channel::v1::ListEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEntitlements(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListEntitlementsRequest* /*request*/, ::google::cloud::channel::v1::ListEntitlementsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTransferableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTransferableSkus() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListTransferableSkusRequest, ::google::cloud::channel::v1::ListTransferableSkusResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListTransferableSkusRequest* request, ::google::cloud::channel::v1::ListTransferableSkusResponse* response) { return this->ListTransferableSkus(context, request, response); }));}
    void SetMessageAllocatorFor_ListTransferableSkus(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListTransferableSkusRequest, ::google::cloud::channel::v1::ListTransferableSkusResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListTransferableSkusRequest, ::google::cloud::channel::v1::ListTransferableSkusResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTransferableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTransferableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListTransferableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListTransferableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTransferableSkus(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListTransferableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListTransferableSkusResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTransferableOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTransferableOffers() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListTransferableOffersRequest, ::google::cloud::channel::v1::ListTransferableOffersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListTransferableOffersRequest* request, ::google::cloud::channel::v1::ListTransferableOffersResponse* response) { return this->ListTransferableOffers(context, request, response); }));}
    void SetMessageAllocatorFor_ListTransferableOffers(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListTransferableOffersRequest, ::google::cloud::channel::v1::ListTransferableOffersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListTransferableOffersRequest, ::google::cloud::channel::v1::ListTransferableOffersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTransferableOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTransferableOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListTransferableOffersRequest* /*request*/, ::google::cloud::channel::v1::ListTransferableOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTransferableOffers(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListTransferableOffersRequest* /*request*/, ::google::cloud::channel::v1::ListTransferableOffersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetEntitlement() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::GetEntitlementRequest, ::google::cloud::channel::v1::Entitlement>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::GetEntitlementRequest* request, ::google::cloud::channel::v1::Entitlement* response) { return this->GetEntitlement(context, request, response); }));}
    void SetMessageAllocatorFor_GetEntitlement(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::GetEntitlementRequest, ::google::cloud::channel::v1::Entitlement>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::GetEntitlementRequest, ::google::cloud::channel::v1::Entitlement>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetEntitlementRequest* /*request*/, ::google::cloud::channel::v1::Entitlement* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::GetEntitlementRequest* /*request*/, ::google::cloud::channel::v1::Entitlement* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateEntitlement() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::CreateEntitlementRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::CreateEntitlementRequest* request, ::google::longrunning::Operation* response) { return this->CreateEntitlement(context, request, response); }));}
    void SetMessageAllocatorFor_CreateEntitlement(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::CreateEntitlementRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::CreateEntitlementRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::CreateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ChangeParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ChangeParameters() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ChangeParametersRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ChangeParametersRequest* request, ::google::longrunning::Operation* response) { return this->ChangeParameters(context, request, response); }));}
    void SetMessageAllocatorFor_ChangeParameters(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ChangeParametersRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ChangeParametersRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ChangeParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ChangeParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeParametersRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ChangeParameters(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeParametersRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ChangeRenewalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ChangeRenewalSettings() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ChangeRenewalSettingsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest* request, ::google::longrunning::Operation* response) { return this->ChangeRenewalSettings(context, request, response); }));}
    void SetMessageAllocatorFor_ChangeRenewalSettings(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ChangeRenewalSettingsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ChangeRenewalSettingsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ChangeRenewalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ChangeRenewalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ChangeRenewalSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ChangeOffer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ChangeOffer() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ChangeOfferRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ChangeOfferRequest* request, ::google::longrunning::Operation* response) { return this->ChangeOffer(context, request, response); }));}
    void SetMessageAllocatorFor_ChangeOffer(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ChangeOfferRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ChangeOfferRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ChangeOffer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ChangeOffer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeOfferRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ChangeOffer(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeOfferRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_StartPaidService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_StartPaidService() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::StartPaidServiceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::StartPaidServiceRequest* request, ::google::longrunning::Operation* response) { return this->StartPaidService(context, request, response); }));}
    void SetMessageAllocatorFor_StartPaidService(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::StartPaidServiceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::StartPaidServiceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_StartPaidService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartPaidService(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::StartPaidServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StartPaidService(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::StartPaidServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SuspendEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SuspendEntitlement() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::SuspendEntitlementRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::SuspendEntitlementRequest* request, ::google::longrunning::Operation* response) { return this->SuspendEntitlement(context, request, response); }));}
    void SetMessageAllocatorFor_SuspendEntitlement(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::SuspendEntitlementRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::SuspendEntitlementRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SuspendEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SuspendEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::SuspendEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SuspendEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::SuspendEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CancelEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CancelEntitlement() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::CancelEntitlementRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::CancelEntitlementRequest* request, ::google::longrunning::Operation* response) { return this->CancelEntitlement(context, request, response); }));}
    void SetMessageAllocatorFor_CancelEntitlement(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::CancelEntitlementRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::CancelEntitlementRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CancelEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CancelEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::CancelEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ActivateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ActivateEntitlement() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ActivateEntitlementRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ActivateEntitlementRequest* request, ::google::longrunning::Operation* response) { return this->ActivateEntitlement(context, request, response); }));}
    void SetMessageAllocatorFor_ActivateEntitlement(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ActivateEntitlementRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ActivateEntitlementRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ActivateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ActivateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ActivateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ActivateEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ActivateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TransferEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TransferEntitlements() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::TransferEntitlementsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::TransferEntitlementsRequest* request, ::google::longrunning::Operation* response) { return this->TransferEntitlements(context, request, response); }));}
    void SetMessageAllocatorFor_TransferEntitlements(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::TransferEntitlementsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::TransferEntitlementsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TransferEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TransferEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::TransferEntitlementsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TransferEntitlements(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::TransferEntitlementsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TransferEntitlementsToGoogle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TransferEntitlementsToGoogle() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest* request, ::google::longrunning::Operation* response) { return this->TransferEntitlementsToGoogle(context, request, response); }));}
    void SetMessageAllocatorFor_TransferEntitlementsToGoogle(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TransferEntitlementsToGoogle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TransferEntitlementsToGoogle(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TransferEntitlementsToGoogle(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListChannelPartnerLinks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListChannelPartnerLinks() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListChannelPartnerLinksRequest, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest* request, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse* response) { return this->ListChannelPartnerLinks(context, request, response); }));}
    void SetMessageAllocatorFor_ListChannelPartnerLinks(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListChannelPartnerLinksRequest, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListChannelPartnerLinksRequest, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListChannelPartnerLinks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListChannelPartnerLinks(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest* /*request*/, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListChannelPartnerLinks(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest* /*request*/, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetChannelPartnerLink() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::GetChannelPartnerLinkRequest, ::google::cloud::channel::v1::ChannelPartnerLink>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response) { return this->GetChannelPartnerLink(context, request, response); }));}
    void SetMessageAllocatorFor_GetChannelPartnerLink(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::GetChannelPartnerLinkRequest, ::google::cloud::channel::v1::ChannelPartnerLink>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::GetChannelPartnerLinkRequest, ::google::cloud::channel::v1::ChannelPartnerLink>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetChannelPartnerLink(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateChannelPartnerLink() {
      ::grpc::Service::MarkMethodCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest, ::google::cloud::channel::v1::ChannelPartnerLink>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response) { return this->CreateChannelPartnerLink(context, request, response); }));}
    void SetMessageAllocatorFor_CreateChannelPartnerLink(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest, ::google::cloud::channel::v1::ChannelPartnerLink>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(24);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest, ::google::cloud::channel::v1::ChannelPartnerLink>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateChannelPartnerLink(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateChannelPartnerLink() {
      ::grpc::Service::MarkMethodCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest, ::google::cloud::channel::v1::ChannelPartnerLink>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest* request, ::google::cloud::channel::v1::ChannelPartnerLink* response) { return this->UpdateChannelPartnerLink(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateChannelPartnerLink(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest, ::google::cloud::channel::v1::ChannelPartnerLink>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(25);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest, ::google::cloud::channel::v1::ChannelPartnerLink>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateChannelPartnerLink(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest, ::google::cloud::channel::v1::CustomerRepricingConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response) { return this->GetCustomerRepricingConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetCustomerRepricingConfig(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest, ::google::cloud::channel::v1::CustomerRepricingConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(26);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest, ::google::cloud::channel::v1::CustomerRepricingConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCustomerRepricingConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListCustomerRepricingConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListCustomerRepricingConfigs() {
      ::grpc::Service::MarkMethodCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest* request, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse* response) { return this->ListCustomerRepricingConfigs(context, request, response); }));}
    void SetMessageAllocatorFor_ListCustomerRepricingConfigs(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(27);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListCustomerRepricingConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomerRepricingConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest* /*request*/, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCustomerRepricingConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest* /*request*/, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest, ::google::cloud::channel::v1::CustomerRepricingConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response) { return this->CreateCustomerRepricingConfig(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCustomerRepricingConfig(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest, ::google::cloud::channel::v1::CustomerRepricingConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(28);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest, ::google::cloud::channel::v1::CustomerRepricingConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCustomerRepricingConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest, ::google::cloud::channel::v1::CustomerRepricingConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest* request, ::google::cloud::channel::v1::CustomerRepricingConfig* response) { return this->UpdateCustomerRepricingConfig(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCustomerRepricingConfig(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest, ::google::cloud::channel::v1::CustomerRepricingConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(29);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest, ::google::cloud::channel::v1::CustomerRepricingConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCustomerRepricingConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest* request, ::google::protobuf::Empty* response) { return this->DeleteCustomerRepricingConfig(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteCustomerRepricingConfig(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(30);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCustomerRepricingConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response) { return this->GetChannelPartnerRepricingConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetChannelPartnerRepricingConfig(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(31);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetChannelPartnerRepricingConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListChannelPartnerRepricingConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListChannelPartnerRepricingConfigs() {
      ::grpc::Service::MarkMethodCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest* request, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse* response) { return this->ListChannelPartnerRepricingConfigs(context, request, response); }));}
    void SetMessageAllocatorFor_ListChannelPartnerRepricingConfigs(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(32);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListChannelPartnerRepricingConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListChannelPartnerRepricingConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest* /*request*/, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListChannelPartnerRepricingConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest* /*request*/, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response) { return this->CreateChannelPartnerRepricingConfig(context, request, response); }));}
    void SetMessageAllocatorFor_CreateChannelPartnerRepricingConfig(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(33);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateChannelPartnerRepricingConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodCallback(34,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest* request, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* response) { return this->UpdateChannelPartnerRepricingConfig(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateChannelPartnerRepricingConfig(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(34);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateChannelPartnerRepricingConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodCallback(35,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest* request, ::google::protobuf::Empty* response) { return this->DeleteChannelPartnerRepricingConfig(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteChannelPartnerRepricingConfig(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(35);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteChannelPartnerRepricingConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSkuGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSkuGroups() {
      ::grpc::Service::MarkMethodCallback(36,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListSkuGroupsRequest, ::google::cloud::channel::v1::ListSkuGroupsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListSkuGroupsRequest* request, ::google::cloud::channel::v1::ListSkuGroupsResponse* response) { return this->ListSkuGroups(context, request, response); }));}
    void SetMessageAllocatorFor_ListSkuGroups(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListSkuGroupsRequest, ::google::cloud::channel::v1::ListSkuGroupsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(36);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListSkuGroupsRequest, ::google::cloud::channel::v1::ListSkuGroupsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSkuGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkuGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkuGroupsRequest* /*request*/, ::google::cloud::channel::v1::ListSkuGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSkuGroups(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkuGroupsRequest* /*request*/, ::google::cloud::channel::v1::ListSkuGroupsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSkuGroupBillableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSkuGroupBillableSkus() {
      ::grpc::Service::MarkMethodCallback(37,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest* request, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse* response) { return this->ListSkuGroupBillableSkus(context, request, response); }));}
    void SetMessageAllocatorFor_ListSkuGroupBillableSkus(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(37);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSkuGroupBillableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkuGroupBillableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSkuGroupBillableSkus(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_LookupOffer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_LookupOffer() {
      ::grpc::Service::MarkMethodCallback(38,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::LookupOfferRequest, ::google::cloud::channel::v1::Offer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::LookupOfferRequest* request, ::google::cloud::channel::v1::Offer* response) { return this->LookupOffer(context, request, response); }));}
    void SetMessageAllocatorFor_LookupOffer(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::LookupOfferRequest, ::google::cloud::channel::v1::Offer>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(38);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::LookupOfferRequest, ::google::cloud::channel::v1::Offer>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_LookupOffer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupOffer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::LookupOfferRequest* /*request*/, ::google::cloud::channel::v1::Offer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* LookupOffer(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::LookupOfferRequest* /*request*/, ::google::cloud::channel::v1::Offer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListProducts() {
      ::grpc::Service::MarkMethodCallback(39,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListProductsRequest, ::google::cloud::channel::v1::ListProductsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListProductsRequest* request, ::google::cloud::channel::v1::ListProductsResponse* response) { return this->ListProducts(context, request, response); }));}
    void SetMessageAllocatorFor_ListProducts(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListProductsRequest, ::google::cloud::channel::v1::ListProductsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(39);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListProductsRequest, ::google::cloud::channel::v1::ListProductsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListProductsRequest* /*request*/, ::google::cloud::channel::v1::ListProductsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProducts(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListProductsRequest* /*request*/, ::google::cloud::channel::v1::ListProductsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSkus() {
      ::grpc::Service::MarkMethodCallback(40,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListSkusRequest, ::google::cloud::channel::v1::ListSkusResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListSkusRequest* request, ::google::cloud::channel::v1::ListSkusResponse* response) { return this->ListSkus(context, request, response); }));}
    void SetMessageAllocatorFor_ListSkus(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListSkusRequest, ::google::cloud::channel::v1::ListSkusResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(40);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListSkusRequest, ::google::cloud::channel::v1::ListSkusResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkusRequest* /*request*/, ::google::cloud::channel::v1::ListSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSkus(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkusRequest* /*request*/, ::google::cloud::channel::v1::ListSkusResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListOffers() {
      ::grpc::Service::MarkMethodCallback(41,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListOffersRequest, ::google::cloud::channel::v1::ListOffersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListOffersRequest* request, ::google::cloud::channel::v1::ListOffersResponse* response) { return this->ListOffers(context, request, response); }));}
    void SetMessageAllocatorFor_ListOffers(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListOffersRequest, ::google::cloud::channel::v1::ListOffersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(41);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListOffersRequest, ::google::cloud::channel::v1::ListOffersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListOffersRequest* /*request*/, ::google::cloud::channel::v1::ListOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListOffers(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListOffersRequest* /*request*/, ::google::cloud::channel::v1::ListOffersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPurchasableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPurchasableSkus() {
      ::grpc::Service::MarkMethodCallback(42,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListPurchasableSkusRequest, ::google::cloud::channel::v1::ListPurchasableSkusResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListPurchasableSkusRequest* request, ::google::cloud::channel::v1::ListPurchasableSkusResponse* response) { return this->ListPurchasableSkus(context, request, response); }));}
    void SetMessageAllocatorFor_ListPurchasableSkus(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListPurchasableSkusRequest, ::google::cloud::channel::v1::ListPurchasableSkusResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(42);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListPurchasableSkusRequest, ::google::cloud::channel::v1::ListPurchasableSkusResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPurchasableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPurchasableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListPurchasableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListPurchasableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPurchasableSkus(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListPurchasableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListPurchasableSkusResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPurchasableOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPurchasableOffers() {
      ::grpc::Service::MarkMethodCallback(43,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListPurchasableOffersRequest, ::google::cloud::channel::v1::ListPurchasableOffersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListPurchasableOffersRequest* request, ::google::cloud::channel::v1::ListPurchasableOffersResponse* response) { return this->ListPurchasableOffers(context, request, response); }));}
    void SetMessageAllocatorFor_ListPurchasableOffers(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListPurchasableOffersRequest, ::google::cloud::channel::v1::ListPurchasableOffersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(43);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListPurchasableOffersRequest, ::google::cloud::channel::v1::ListPurchasableOffersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPurchasableOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPurchasableOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListPurchasableOffersRequest* /*request*/, ::google::cloud::channel::v1::ListPurchasableOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPurchasableOffers(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListPurchasableOffersRequest* /*request*/, ::google::cloud::channel::v1::ListPurchasableOffersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_QueryEligibleBillingAccounts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_QueryEligibleBillingAccounts() {
      ::grpc::Service::MarkMethodCallback(44,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest* request, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse* response) { return this->QueryEligibleBillingAccounts(context, request, response); }));}
    void SetMessageAllocatorFor_QueryEligibleBillingAccounts(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(44);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_QueryEligibleBillingAccounts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status QueryEligibleBillingAccounts(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest* /*request*/, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* QueryEligibleBillingAccounts(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest* /*request*/, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RegisterSubscriber : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RegisterSubscriber() {
      ::grpc::Service::MarkMethodCallback(45,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::RegisterSubscriberRequest, ::google::cloud::channel::v1::RegisterSubscriberResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::RegisterSubscriberRequest* request, ::google::cloud::channel::v1::RegisterSubscriberResponse* response) { return this->RegisterSubscriber(context, request, response); }));}
    void SetMessageAllocatorFor_RegisterSubscriber(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::RegisterSubscriberRequest, ::google::cloud::channel::v1::RegisterSubscriberResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(45);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::RegisterSubscriberRequest, ::google::cloud::channel::v1::RegisterSubscriberResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RegisterSubscriber() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RegisterSubscriber(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::RegisterSubscriberRequest* /*request*/, ::google::cloud::channel::v1::RegisterSubscriberResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RegisterSubscriber(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::RegisterSubscriberRequest* /*request*/, ::google::cloud::channel::v1::RegisterSubscriberResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UnregisterSubscriber : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UnregisterSubscriber() {
      ::grpc::Service::MarkMethodCallback(46,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::UnregisterSubscriberRequest, ::google::cloud::channel::v1::UnregisterSubscriberResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::UnregisterSubscriberRequest* request, ::google::cloud::channel::v1::UnregisterSubscriberResponse* response) { return this->UnregisterSubscriber(context, request, response); }));}
    void SetMessageAllocatorFor_UnregisterSubscriber(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::UnregisterSubscriberRequest, ::google::cloud::channel::v1::UnregisterSubscriberResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(46);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::UnregisterSubscriberRequest, ::google::cloud::channel::v1::UnregisterSubscriberResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UnregisterSubscriber() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UnregisterSubscriber(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UnregisterSubscriberRequest* /*request*/, ::google::cloud::channel::v1::UnregisterSubscriberResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UnregisterSubscriber(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::UnregisterSubscriberRequest* /*request*/, ::google::cloud::channel::v1::UnregisterSubscriberResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSubscribers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSubscribers() {
      ::grpc::Service::MarkMethodCallback(47,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListSubscribersRequest, ::google::cloud::channel::v1::ListSubscribersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListSubscribersRequest* request, ::google::cloud::channel::v1::ListSubscribersResponse* response) { return this->ListSubscribers(context, request, response); }));}
    void SetMessageAllocatorFor_ListSubscribers(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListSubscribersRequest, ::google::cloud::channel::v1::ListSubscribersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(47);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListSubscribersRequest, ::google::cloud::channel::v1::ListSubscribersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSubscribers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubscribers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSubscribersRequest* /*request*/, ::google::cloud::channel::v1::ListSubscribersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSubscribers(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListSubscribersRequest* /*request*/, ::google::cloud::channel::v1::ListSubscribersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListEntitlementChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListEntitlementChanges() {
      ::grpc::Service::MarkMethodCallback(48,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListEntitlementChangesRequest, ::google::cloud::channel::v1::ListEntitlementChangesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListEntitlementChangesRequest* request, ::google::cloud::channel::v1::ListEntitlementChangesResponse* response) { return this->ListEntitlementChanges(context, request, response); }));}
    void SetMessageAllocatorFor_ListEntitlementChanges(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListEntitlementChangesRequest, ::google::cloud::channel::v1::ListEntitlementChangesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(48);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListEntitlementChangesRequest, ::google::cloud::channel::v1::ListEntitlementChangesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListEntitlementChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntitlementChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListEntitlementChangesRequest* /*request*/, ::google::cloud::channel::v1::ListEntitlementChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEntitlementChanges(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListEntitlementChangesRequest* /*request*/, ::google::cloud::channel::v1::ListEntitlementChangesResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListCustomers<WithCallbackMethod_GetCustomer<WithCallbackMethod_CheckCloudIdentityAccountsExist<WithCallbackMethod_CreateCustomer<WithCallbackMethod_UpdateCustomer<WithCallbackMethod_DeleteCustomer<WithCallbackMethod_ImportCustomer<WithCallbackMethod_ProvisionCloudIdentity<WithCallbackMethod_ListEntitlements<WithCallbackMethod_ListTransferableSkus<WithCallbackMethod_ListTransferableOffers<WithCallbackMethod_GetEntitlement<WithCallbackMethod_CreateEntitlement<WithCallbackMethod_ChangeParameters<WithCallbackMethod_ChangeRenewalSettings<WithCallbackMethod_ChangeOffer<WithCallbackMethod_StartPaidService<WithCallbackMethod_SuspendEntitlement<WithCallbackMethod_CancelEntitlement<WithCallbackMethod_ActivateEntitlement<WithCallbackMethod_TransferEntitlements<WithCallbackMethod_TransferEntitlementsToGoogle<WithCallbackMethod_ListChannelPartnerLinks<WithCallbackMethod_GetChannelPartnerLink<WithCallbackMethod_CreateChannelPartnerLink<WithCallbackMethod_UpdateChannelPartnerLink<WithCallbackMethod_GetCustomerRepricingConfig<WithCallbackMethod_ListCustomerRepricingConfigs<WithCallbackMethod_CreateCustomerRepricingConfig<WithCallbackMethod_UpdateCustomerRepricingConfig<WithCallbackMethod_DeleteCustomerRepricingConfig<WithCallbackMethod_GetChannelPartnerRepricingConfig<WithCallbackMethod_ListChannelPartnerRepricingConfigs<WithCallbackMethod_CreateChannelPartnerRepricingConfig<WithCallbackMethod_UpdateChannelPartnerRepricingConfig<WithCallbackMethod_DeleteChannelPartnerRepricingConfig<WithCallbackMethod_ListSkuGroups<WithCallbackMethod_ListSkuGroupBillableSkus<WithCallbackMethod_LookupOffer<WithCallbackMethod_ListProducts<WithCallbackMethod_ListSkus<WithCallbackMethod_ListOffers<WithCallbackMethod_ListPurchasableSkus<WithCallbackMethod_ListPurchasableOffers<WithCallbackMethod_QueryEligibleBillingAccounts<WithCallbackMethod_RegisterSubscriber<WithCallbackMethod_UnregisterSubscriber<WithCallbackMethod_ListSubscribers<WithCallbackMethod_ListEntitlementChanges<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListCustomers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListCustomers() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListCustomers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListCustomersRequest* /*request*/, ::google::cloud::channel::v1::ListCustomersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCustomer() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CheckCloudIdentityAccountsExist : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CheckCloudIdentityAccountsExist() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CheckCloudIdentityAccountsExist() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CheckCloudIdentityAccountsExist(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest* /*request*/, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCustomer() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_CreateCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCustomer() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteCustomer() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_DeleteCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteCustomerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ImportCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ImportCustomer() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_ImportCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ImportCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ProvisionCloudIdentity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ProvisionCloudIdentity() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_ProvisionCloudIdentity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProvisionCloudIdentity(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListEntitlements() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_ListEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListEntitlementsRequest* /*request*/, ::google::cloud::channel::v1::ListEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTransferableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTransferableSkus() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_ListTransferableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTransferableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListTransferableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListTransferableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTransferableOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTransferableOffers() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_ListTransferableOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTransferableOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListTransferableOffersRequest* /*request*/, ::google::cloud::channel::v1::ListTransferableOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetEntitlement() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_GetEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetEntitlementRequest* /*request*/, ::google::cloud::channel::v1::Entitlement* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateEntitlement() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_CreateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ChangeParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ChangeParameters() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_ChangeParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ChangeParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeParametersRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ChangeRenewalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ChangeRenewalSettings() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_ChangeRenewalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ChangeRenewalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ChangeOffer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ChangeOffer() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_ChangeOffer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ChangeOffer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeOfferRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_StartPaidService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_StartPaidService() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_StartPaidService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartPaidService(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::StartPaidServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SuspendEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SuspendEntitlement() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_SuspendEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SuspendEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::SuspendEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CancelEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CancelEntitlement() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_CancelEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CancelEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ActivateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ActivateEntitlement() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_ActivateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ActivateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ActivateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TransferEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TransferEntitlements() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_TransferEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TransferEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::TransferEntitlementsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TransferEntitlementsToGoogle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TransferEntitlementsToGoogle() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_TransferEntitlementsToGoogle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TransferEntitlementsToGoogle(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListChannelPartnerLinks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListChannelPartnerLinks() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_ListChannelPartnerLinks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListChannelPartnerLinks(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest* /*request*/, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetChannelPartnerLink() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_GetChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateChannelPartnerLink() {
      ::grpc::Service::MarkMethodGeneric(24);
    }
    ~WithGenericMethod_CreateChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateChannelPartnerLink() {
      ::grpc::Service::MarkMethodGeneric(25);
    }
    ~WithGenericMethod_UpdateChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodGeneric(26);
    }
    ~WithGenericMethod_GetCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListCustomerRepricingConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListCustomerRepricingConfigs() {
      ::grpc::Service::MarkMethodGeneric(27);
    }
    ~WithGenericMethod_ListCustomerRepricingConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomerRepricingConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest* /*request*/, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodGeneric(28);
    }
    ~WithGenericMethod_CreateCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodGeneric(29);
    }
    ~WithGenericMethod_UpdateCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodGeneric(30);
    }
    ~WithGenericMethod_DeleteCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodGeneric(31);
    }
    ~WithGenericMethod_GetChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListChannelPartnerRepricingConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListChannelPartnerRepricingConfigs() {
      ::grpc::Service::MarkMethodGeneric(32);
    }
    ~WithGenericMethod_ListChannelPartnerRepricingConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListChannelPartnerRepricingConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest* /*request*/, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodGeneric(33);
    }
    ~WithGenericMethod_CreateChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodGeneric(34);
    }
    ~WithGenericMethod_UpdateChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodGeneric(35);
    }
    ~WithGenericMethod_DeleteChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSkuGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSkuGroups() {
      ::grpc::Service::MarkMethodGeneric(36);
    }
    ~WithGenericMethod_ListSkuGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkuGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkuGroupsRequest* /*request*/, ::google::cloud::channel::v1::ListSkuGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSkuGroupBillableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSkuGroupBillableSkus() {
      ::grpc::Service::MarkMethodGeneric(37);
    }
    ~WithGenericMethod_ListSkuGroupBillableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkuGroupBillableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_LookupOffer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_LookupOffer() {
      ::grpc::Service::MarkMethodGeneric(38);
    }
    ~WithGenericMethod_LookupOffer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupOffer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::LookupOfferRequest* /*request*/, ::google::cloud::channel::v1::Offer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListProducts() {
      ::grpc::Service::MarkMethodGeneric(39);
    }
    ~WithGenericMethod_ListProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListProductsRequest* /*request*/, ::google::cloud::channel::v1::ListProductsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSkus() {
      ::grpc::Service::MarkMethodGeneric(40);
    }
    ~WithGenericMethod_ListSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkusRequest* /*request*/, ::google::cloud::channel::v1::ListSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListOffers() {
      ::grpc::Service::MarkMethodGeneric(41);
    }
    ~WithGenericMethod_ListOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListOffersRequest* /*request*/, ::google::cloud::channel::v1::ListOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPurchasableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPurchasableSkus() {
      ::grpc::Service::MarkMethodGeneric(42);
    }
    ~WithGenericMethod_ListPurchasableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPurchasableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListPurchasableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListPurchasableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPurchasableOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPurchasableOffers() {
      ::grpc::Service::MarkMethodGeneric(43);
    }
    ~WithGenericMethod_ListPurchasableOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPurchasableOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListPurchasableOffersRequest* /*request*/, ::google::cloud::channel::v1::ListPurchasableOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_QueryEligibleBillingAccounts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_QueryEligibleBillingAccounts() {
      ::grpc::Service::MarkMethodGeneric(44);
    }
    ~WithGenericMethod_QueryEligibleBillingAccounts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status QueryEligibleBillingAccounts(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest* /*request*/, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RegisterSubscriber : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RegisterSubscriber() {
      ::grpc::Service::MarkMethodGeneric(45);
    }
    ~WithGenericMethod_RegisterSubscriber() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RegisterSubscriber(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::RegisterSubscriberRequest* /*request*/, ::google::cloud::channel::v1::RegisterSubscriberResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UnregisterSubscriber : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UnregisterSubscriber() {
      ::grpc::Service::MarkMethodGeneric(46);
    }
    ~WithGenericMethod_UnregisterSubscriber() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UnregisterSubscriber(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UnregisterSubscriberRequest* /*request*/, ::google::cloud::channel::v1::UnregisterSubscriberResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSubscribers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSubscribers() {
      ::grpc::Service::MarkMethodGeneric(47);
    }
    ~WithGenericMethod_ListSubscribers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubscribers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSubscribersRequest* /*request*/, ::google::cloud::channel::v1::ListSubscribersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListEntitlementChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListEntitlementChanges() {
      ::grpc::Service::MarkMethodGeneric(48);
    }
    ~WithGenericMethod_ListEntitlementChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntitlementChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListEntitlementChangesRequest* /*request*/, ::google::cloud::channel::v1::ListEntitlementChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListCustomers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListCustomers() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListCustomers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListCustomersRequest* /*request*/, ::google::cloud::channel::v1::ListCustomersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCustomers(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCustomer() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCustomer(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CheckCloudIdentityAccountsExist : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CheckCloudIdentityAccountsExist() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CheckCloudIdentityAccountsExist() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CheckCloudIdentityAccountsExist(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest* /*request*/, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCheckCloudIdentityAccountsExist(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCustomer() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_CreateCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCustomer(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCustomer() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCustomer(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteCustomer() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_DeleteCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteCustomerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCustomer(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ImportCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ImportCustomer() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_ImportCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ImportCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportCustomer(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ProvisionCloudIdentity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ProvisionCloudIdentity() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_ProvisionCloudIdentity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProvisionCloudIdentity(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestProvisionCloudIdentity(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListEntitlements() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_ListEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListEntitlementsRequest* /*request*/, ::google::cloud::channel::v1::ListEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEntitlements(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTransferableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTransferableSkus() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_ListTransferableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTransferableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListTransferableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListTransferableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTransferableSkus(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTransferableOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTransferableOffers() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_ListTransferableOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTransferableOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListTransferableOffersRequest* /*request*/, ::google::cloud::channel::v1::ListTransferableOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTransferableOffers(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetEntitlement() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_GetEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetEntitlementRequest* /*request*/, ::google::cloud::channel::v1::Entitlement* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEntitlement(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateEntitlement() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_CreateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEntitlement(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ChangeParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ChangeParameters() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_ChangeParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ChangeParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeParametersRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestChangeParameters(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ChangeRenewalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ChangeRenewalSettings() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_ChangeRenewalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ChangeRenewalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestChangeRenewalSettings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ChangeOffer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ChangeOffer() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_ChangeOffer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ChangeOffer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeOfferRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestChangeOffer(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_StartPaidService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_StartPaidService() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_StartPaidService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartPaidService(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::StartPaidServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStartPaidService(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SuspendEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SuspendEntitlement() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_SuspendEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SuspendEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::SuspendEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSuspendEntitlement(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CancelEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CancelEntitlement() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_CancelEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CancelEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCancelEntitlement(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ActivateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ActivateEntitlement() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_ActivateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ActivateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ActivateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestActivateEntitlement(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TransferEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TransferEntitlements() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_TransferEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TransferEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::TransferEntitlementsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTransferEntitlements(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TransferEntitlementsToGoogle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TransferEntitlementsToGoogle() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_TransferEntitlementsToGoogle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TransferEntitlementsToGoogle(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTransferEntitlementsToGoogle(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListChannelPartnerLinks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListChannelPartnerLinks() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_ListChannelPartnerLinks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListChannelPartnerLinks(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest* /*request*/, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListChannelPartnerLinks(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetChannelPartnerLink() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_GetChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetChannelPartnerLink(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateChannelPartnerLink() {
      ::grpc::Service::MarkMethodRaw(24);
    }
    ~WithRawMethod_CreateChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateChannelPartnerLink(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateChannelPartnerLink() {
      ::grpc::Service::MarkMethodRaw(25);
    }
    ~WithRawMethod_UpdateChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateChannelPartnerLink(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodRaw(26);
    }
    ~WithRawMethod_GetCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCustomerRepricingConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListCustomerRepricingConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListCustomerRepricingConfigs() {
      ::grpc::Service::MarkMethodRaw(27);
    }
    ~WithRawMethod_ListCustomerRepricingConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomerRepricingConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest* /*request*/, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCustomerRepricingConfigs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodRaw(28);
    }
    ~WithRawMethod_CreateCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCustomerRepricingConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodRaw(29);
    }
    ~WithRawMethod_UpdateCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCustomerRepricingConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodRaw(30);
    }
    ~WithRawMethod_DeleteCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCustomerRepricingConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodRaw(31);
    }
    ~WithRawMethod_GetChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetChannelPartnerRepricingConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListChannelPartnerRepricingConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListChannelPartnerRepricingConfigs() {
      ::grpc::Service::MarkMethodRaw(32);
    }
    ~WithRawMethod_ListChannelPartnerRepricingConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListChannelPartnerRepricingConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest* /*request*/, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListChannelPartnerRepricingConfigs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodRaw(33);
    }
    ~WithRawMethod_CreateChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateChannelPartnerRepricingConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodRaw(34);
    }
    ~WithRawMethod_UpdateChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateChannelPartnerRepricingConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(34, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodRaw(35);
    }
    ~WithRawMethod_DeleteChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteChannelPartnerRepricingConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(35, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSkuGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSkuGroups() {
      ::grpc::Service::MarkMethodRaw(36);
    }
    ~WithRawMethod_ListSkuGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkuGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkuGroupsRequest* /*request*/, ::google::cloud::channel::v1::ListSkuGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSkuGroups(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(36, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSkuGroupBillableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSkuGroupBillableSkus() {
      ::grpc::Service::MarkMethodRaw(37);
    }
    ~WithRawMethod_ListSkuGroupBillableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkuGroupBillableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSkuGroupBillableSkus(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(37, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_LookupOffer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_LookupOffer() {
      ::grpc::Service::MarkMethodRaw(38);
    }
    ~WithRawMethod_LookupOffer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupOffer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::LookupOfferRequest* /*request*/, ::google::cloud::channel::v1::Offer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestLookupOffer(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(38, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListProducts() {
      ::grpc::Service::MarkMethodRaw(39);
    }
    ~WithRawMethod_ListProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListProductsRequest* /*request*/, ::google::cloud::channel::v1::ListProductsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProducts(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(39, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSkus() {
      ::grpc::Service::MarkMethodRaw(40);
    }
    ~WithRawMethod_ListSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkusRequest* /*request*/, ::google::cloud::channel::v1::ListSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSkus(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(40, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListOffers() {
      ::grpc::Service::MarkMethodRaw(41);
    }
    ~WithRawMethod_ListOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListOffersRequest* /*request*/, ::google::cloud::channel::v1::ListOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListOffers(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(41, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPurchasableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPurchasableSkus() {
      ::grpc::Service::MarkMethodRaw(42);
    }
    ~WithRawMethod_ListPurchasableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPurchasableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListPurchasableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListPurchasableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPurchasableSkus(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(42, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPurchasableOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPurchasableOffers() {
      ::grpc::Service::MarkMethodRaw(43);
    }
    ~WithRawMethod_ListPurchasableOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPurchasableOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListPurchasableOffersRequest* /*request*/, ::google::cloud::channel::v1::ListPurchasableOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPurchasableOffers(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(43, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_QueryEligibleBillingAccounts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_QueryEligibleBillingAccounts() {
      ::grpc::Service::MarkMethodRaw(44);
    }
    ~WithRawMethod_QueryEligibleBillingAccounts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status QueryEligibleBillingAccounts(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest* /*request*/, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestQueryEligibleBillingAccounts(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(44, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RegisterSubscriber : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RegisterSubscriber() {
      ::grpc::Service::MarkMethodRaw(45);
    }
    ~WithRawMethod_RegisterSubscriber() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RegisterSubscriber(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::RegisterSubscriberRequest* /*request*/, ::google::cloud::channel::v1::RegisterSubscriberResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRegisterSubscriber(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(45, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UnregisterSubscriber : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UnregisterSubscriber() {
      ::grpc::Service::MarkMethodRaw(46);
    }
    ~WithRawMethod_UnregisterSubscriber() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UnregisterSubscriber(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UnregisterSubscriberRequest* /*request*/, ::google::cloud::channel::v1::UnregisterSubscriberResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUnregisterSubscriber(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(46, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSubscribers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSubscribers() {
      ::grpc::Service::MarkMethodRaw(47);
    }
    ~WithRawMethod_ListSubscribers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubscribers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSubscribersRequest* /*request*/, ::google::cloud::channel::v1::ListSubscribersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSubscribers(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(47, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListEntitlementChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListEntitlementChanges() {
      ::grpc::Service::MarkMethodRaw(48);
    }
    ~WithRawMethod_ListEntitlementChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntitlementChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListEntitlementChangesRequest* /*request*/, ::google::cloud::channel::v1::ListEntitlementChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEntitlementChanges(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(48, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListCustomers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListCustomers() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListCustomers(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListCustomers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListCustomersRequest* /*request*/, ::google::cloud::channel::v1::ListCustomersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCustomers(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCustomer() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCustomer(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCustomer(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CheckCloudIdentityAccountsExist : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CheckCloudIdentityAccountsExist() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CheckCloudIdentityAccountsExist(context, request, response); }));
    }
    ~WithRawCallbackMethod_CheckCloudIdentityAccountsExist() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CheckCloudIdentityAccountsExist(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest* /*request*/, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CheckCloudIdentityAccountsExist(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCustomer() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCustomer(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCustomer(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCustomer() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCustomer(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCustomer(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteCustomer() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteCustomer(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteCustomerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCustomer(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ImportCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ImportCustomer() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ImportCustomer(context, request, response); }));
    }
    ~WithRawCallbackMethod_ImportCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ImportCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportCustomer(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ProvisionCloudIdentity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ProvisionCloudIdentity() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ProvisionCloudIdentity(context, request, response); }));
    }
    ~WithRawCallbackMethod_ProvisionCloudIdentity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ProvisionCloudIdentity(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ProvisionCloudIdentity(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListEntitlements() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListEntitlements(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListEntitlementsRequest* /*request*/, ::google::cloud::channel::v1::ListEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEntitlements(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTransferableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTransferableSkus() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTransferableSkus(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTransferableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTransferableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListTransferableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListTransferableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTransferableSkus(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTransferableOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTransferableOffers() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTransferableOffers(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTransferableOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTransferableOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListTransferableOffersRequest* /*request*/, ::google::cloud::channel::v1::ListTransferableOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTransferableOffers(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetEntitlement() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetEntitlement(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetEntitlementRequest* /*request*/, ::google::cloud::channel::v1::Entitlement* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateEntitlement() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateEntitlement(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ChangeParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ChangeParameters() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ChangeParameters(context, request, response); }));
    }
    ~WithRawCallbackMethod_ChangeParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ChangeParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeParametersRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ChangeParameters(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ChangeRenewalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ChangeRenewalSettings() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ChangeRenewalSettings(context, request, response); }));
    }
    ~WithRawCallbackMethod_ChangeRenewalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ChangeRenewalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ChangeRenewalSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ChangeOffer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ChangeOffer() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ChangeOffer(context, request, response); }));
    }
    ~WithRawCallbackMethod_ChangeOffer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ChangeOffer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeOfferRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ChangeOffer(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_StartPaidService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_StartPaidService() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->StartPaidService(context, request, response); }));
    }
    ~WithRawCallbackMethod_StartPaidService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartPaidService(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::StartPaidServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StartPaidService(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SuspendEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SuspendEntitlement() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SuspendEntitlement(context, request, response); }));
    }
    ~WithRawCallbackMethod_SuspendEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SuspendEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::SuspendEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SuspendEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CancelEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CancelEntitlement() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CancelEntitlement(context, request, response); }));
    }
    ~WithRawCallbackMethod_CancelEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CancelEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CancelEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CancelEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ActivateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ActivateEntitlement() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ActivateEntitlement(context, request, response); }));
    }
    ~WithRawCallbackMethod_ActivateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ActivateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ActivateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ActivateEntitlement(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TransferEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TransferEntitlements() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TransferEntitlements(context, request, response); }));
    }
    ~WithRawCallbackMethod_TransferEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TransferEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::TransferEntitlementsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TransferEntitlements(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TransferEntitlementsToGoogle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TransferEntitlementsToGoogle() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TransferEntitlementsToGoogle(context, request, response); }));
    }
    ~WithRawCallbackMethod_TransferEntitlementsToGoogle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TransferEntitlementsToGoogle(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TransferEntitlementsToGoogle(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListChannelPartnerLinks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListChannelPartnerLinks() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListChannelPartnerLinks(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListChannelPartnerLinks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListChannelPartnerLinks(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest* /*request*/, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListChannelPartnerLinks(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetChannelPartnerLink() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetChannelPartnerLink(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetChannelPartnerLink(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateChannelPartnerLink() {
      ::grpc::Service::MarkMethodRawCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateChannelPartnerLink(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateChannelPartnerLink(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateChannelPartnerLink() {
      ::grpc::Service::MarkMethodRawCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateChannelPartnerLink(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateChannelPartnerLink(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodRawCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCustomerRepricingConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCustomerRepricingConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListCustomerRepricingConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListCustomerRepricingConfigs() {
      ::grpc::Service::MarkMethodRawCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListCustomerRepricingConfigs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListCustomerRepricingConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCustomerRepricingConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest* /*request*/, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCustomerRepricingConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodRawCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCustomerRepricingConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCustomerRepricingConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodRawCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCustomerRepricingConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCustomerRepricingConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodRawCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteCustomerRepricingConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCustomerRepricingConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodRawCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetChannelPartnerRepricingConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetChannelPartnerRepricingConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListChannelPartnerRepricingConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListChannelPartnerRepricingConfigs() {
      ::grpc::Service::MarkMethodRawCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListChannelPartnerRepricingConfigs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListChannelPartnerRepricingConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListChannelPartnerRepricingConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest* /*request*/, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListChannelPartnerRepricingConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodRawCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateChannelPartnerRepricingConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateChannelPartnerRepricingConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodRawCallback(34,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateChannelPartnerRepricingConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateChannelPartnerRepricingConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodRawCallback(35,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteChannelPartnerRepricingConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteChannelPartnerRepricingConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSkuGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSkuGroups() {
      ::grpc::Service::MarkMethodRawCallback(36,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSkuGroups(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSkuGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkuGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkuGroupsRequest* /*request*/, ::google::cloud::channel::v1::ListSkuGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSkuGroups(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSkuGroupBillableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSkuGroupBillableSkus() {
      ::grpc::Service::MarkMethodRawCallback(37,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSkuGroupBillableSkus(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSkuGroupBillableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkuGroupBillableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSkuGroupBillableSkus(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_LookupOffer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_LookupOffer() {
      ::grpc::Service::MarkMethodRawCallback(38,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->LookupOffer(context, request, response); }));
    }
    ~WithRawCallbackMethod_LookupOffer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupOffer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::LookupOfferRequest* /*request*/, ::google::cloud::channel::v1::Offer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* LookupOffer(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListProducts() {
      ::grpc::Service::MarkMethodRawCallback(39,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListProducts(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListProductsRequest* /*request*/, ::google::cloud::channel::v1::ListProductsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProducts(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSkus() {
      ::grpc::Service::MarkMethodRawCallback(40,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSkus(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkusRequest* /*request*/, ::google::cloud::channel::v1::ListSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSkus(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListOffers() {
      ::grpc::Service::MarkMethodRawCallback(41,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListOffers(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListOffersRequest* /*request*/, ::google::cloud::channel::v1::ListOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListOffers(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPurchasableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPurchasableSkus() {
      ::grpc::Service::MarkMethodRawCallback(42,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPurchasableSkus(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPurchasableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPurchasableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListPurchasableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListPurchasableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPurchasableSkus(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPurchasableOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPurchasableOffers() {
      ::grpc::Service::MarkMethodRawCallback(43,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPurchasableOffers(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPurchasableOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPurchasableOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListPurchasableOffersRequest* /*request*/, ::google::cloud::channel::v1::ListPurchasableOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPurchasableOffers(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_QueryEligibleBillingAccounts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_QueryEligibleBillingAccounts() {
      ::grpc::Service::MarkMethodRawCallback(44,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->QueryEligibleBillingAccounts(context, request, response); }));
    }
    ~WithRawCallbackMethod_QueryEligibleBillingAccounts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status QueryEligibleBillingAccounts(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest* /*request*/, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* QueryEligibleBillingAccounts(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RegisterSubscriber : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RegisterSubscriber() {
      ::grpc::Service::MarkMethodRawCallback(45,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RegisterSubscriber(context, request, response); }));
    }
    ~WithRawCallbackMethod_RegisterSubscriber() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RegisterSubscriber(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::RegisterSubscriberRequest* /*request*/, ::google::cloud::channel::v1::RegisterSubscriberResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RegisterSubscriber(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UnregisterSubscriber : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UnregisterSubscriber() {
      ::grpc::Service::MarkMethodRawCallback(46,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UnregisterSubscriber(context, request, response); }));
    }
    ~WithRawCallbackMethod_UnregisterSubscriber() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UnregisterSubscriber(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UnregisterSubscriberRequest* /*request*/, ::google::cloud::channel::v1::UnregisterSubscriberResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UnregisterSubscriber(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSubscribers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSubscribers() {
      ::grpc::Service::MarkMethodRawCallback(47,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSubscribers(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSubscribers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubscribers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSubscribersRequest* /*request*/, ::google::cloud::channel::v1::ListSubscribersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSubscribers(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListEntitlementChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListEntitlementChanges() {
      ::grpc::Service::MarkMethodRawCallback(48,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListEntitlementChanges(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListEntitlementChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntitlementChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListEntitlementChangesRequest* /*request*/, ::google::cloud::channel::v1::ListEntitlementChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEntitlementChanges(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListCustomers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListCustomers() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListCustomersRequest, ::google::cloud::channel::v1::ListCustomersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListCustomersRequest, ::google::cloud::channel::v1::ListCustomersResponse>* streamer) {
                       return this->StreamedListCustomers(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListCustomers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListCustomers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListCustomersRequest* /*request*/, ::google::cloud::channel::v1::ListCustomersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListCustomers(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListCustomersRequest,::google::cloud::channel::v1::ListCustomersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCustomer() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::GetCustomerRequest, ::google::cloud::channel::v1::Customer>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::GetCustomerRequest, ::google::cloud::channel::v1::Customer>* streamer) {
                       return this->StreamedGetCustomer(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCustomer(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::GetCustomerRequest,::google::cloud::channel::v1::Customer>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CheckCloudIdentityAccountsExist : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CheckCloudIdentityAccountsExist() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>* streamer) {
                       return this->StreamedCheckCloudIdentityAccountsExist(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CheckCloudIdentityAccountsExist() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CheckCloudIdentityAccountsExist(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest* /*request*/, ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCheckCloudIdentityAccountsExist(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::CheckCloudIdentityAccountsExistRequest,::google::cloud::channel::v1::CheckCloudIdentityAccountsExistResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCustomer() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::CreateCustomerRequest, ::google::cloud::channel::v1::Customer>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::CreateCustomerRequest, ::google::cloud::channel::v1::Customer>* streamer) {
                       return this->StreamedCreateCustomer(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCustomer(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::CreateCustomerRequest,::google::cloud::channel::v1::Customer>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCustomer() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::UpdateCustomerRequest, ::google::cloud::channel::v1::Customer>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::UpdateCustomerRequest, ::google::cloud::channel::v1::Customer>* streamer) {
                       return this->StreamedUpdateCustomer(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCustomer(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::UpdateCustomerRequest,::google::cloud::channel::v1::Customer>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteCustomer() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::DeleteCustomerRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::DeleteCustomerRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteCustomer(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteCustomerRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteCustomer(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::DeleteCustomerRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ImportCustomer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ImportCustomer() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ImportCustomerRequest, ::google::cloud::channel::v1::Customer>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ImportCustomerRequest, ::google::cloud::channel::v1::Customer>* streamer) {
                       return this->StreamedImportCustomer(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ImportCustomer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ImportCustomer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ImportCustomerRequest* /*request*/, ::google::cloud::channel::v1::Customer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedImportCustomer(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ImportCustomerRequest,::google::cloud::channel::v1::Customer>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ProvisionCloudIdentity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ProvisionCloudIdentity() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ProvisionCloudIdentityRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ProvisionCloudIdentityRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedProvisionCloudIdentity(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ProvisionCloudIdentity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ProvisionCloudIdentity(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ProvisionCloudIdentityRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedProvisionCloudIdentity(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ProvisionCloudIdentityRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListEntitlements() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListEntitlementsRequest, ::google::cloud::channel::v1::ListEntitlementsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListEntitlementsRequest, ::google::cloud::channel::v1::ListEntitlementsResponse>* streamer) {
                       return this->StreamedListEntitlements(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListEntitlementsRequest* /*request*/, ::google::cloud::channel::v1::ListEntitlementsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListEntitlements(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListEntitlementsRequest,::google::cloud::channel::v1::ListEntitlementsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTransferableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTransferableSkus() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListTransferableSkusRequest, ::google::cloud::channel::v1::ListTransferableSkusResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListTransferableSkusRequest, ::google::cloud::channel::v1::ListTransferableSkusResponse>* streamer) {
                       return this->StreamedListTransferableSkus(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTransferableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTransferableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListTransferableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListTransferableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTransferableSkus(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListTransferableSkusRequest,::google::cloud::channel::v1::ListTransferableSkusResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTransferableOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTransferableOffers() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListTransferableOffersRequest, ::google::cloud::channel::v1::ListTransferableOffersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListTransferableOffersRequest, ::google::cloud::channel::v1::ListTransferableOffersResponse>* streamer) {
                       return this->StreamedListTransferableOffers(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTransferableOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTransferableOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListTransferableOffersRequest* /*request*/, ::google::cloud::channel::v1::ListTransferableOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTransferableOffers(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListTransferableOffersRequest,::google::cloud::channel::v1::ListTransferableOffersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetEntitlement() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::GetEntitlementRequest, ::google::cloud::channel::v1::Entitlement>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::GetEntitlementRequest, ::google::cloud::channel::v1::Entitlement>* streamer) {
                       return this->StreamedGetEntitlement(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetEntitlementRequest* /*request*/, ::google::cloud::channel::v1::Entitlement* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetEntitlement(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::GetEntitlementRequest,::google::cloud::channel::v1::Entitlement>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateEntitlement() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::CreateEntitlementRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::CreateEntitlementRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateEntitlement(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateEntitlement(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::CreateEntitlementRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ChangeParameters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ChangeParameters() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ChangeParametersRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ChangeParametersRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedChangeParameters(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ChangeParameters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ChangeParameters(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeParametersRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedChangeParameters(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ChangeParametersRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ChangeRenewalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ChangeRenewalSettings() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ChangeRenewalSettingsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ChangeRenewalSettingsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedChangeRenewalSettings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ChangeRenewalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ChangeRenewalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeRenewalSettingsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedChangeRenewalSettings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ChangeRenewalSettingsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ChangeOffer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ChangeOffer() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ChangeOfferRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ChangeOfferRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedChangeOffer(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ChangeOffer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ChangeOffer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ChangeOfferRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedChangeOffer(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ChangeOfferRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_StartPaidService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_StartPaidService() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::StartPaidServiceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::StartPaidServiceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedStartPaidService(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_StartPaidService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status StartPaidService(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::StartPaidServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedStartPaidService(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::StartPaidServiceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SuspendEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SuspendEntitlement() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::SuspendEntitlementRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::SuspendEntitlementRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedSuspendEntitlement(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SuspendEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SuspendEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::SuspendEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSuspendEntitlement(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::SuspendEntitlementRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CancelEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CancelEntitlement() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::CancelEntitlementRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::CancelEntitlementRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCancelEntitlement(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CancelEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CancelEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CancelEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCancelEntitlement(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::CancelEntitlementRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ActivateEntitlement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ActivateEntitlement() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ActivateEntitlementRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ActivateEntitlementRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedActivateEntitlement(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ActivateEntitlement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ActivateEntitlement(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ActivateEntitlementRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedActivateEntitlement(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ActivateEntitlementRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TransferEntitlements : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TransferEntitlements() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::TransferEntitlementsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::TransferEntitlementsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedTransferEntitlements(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TransferEntitlements() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TransferEntitlements(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::TransferEntitlementsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTransferEntitlements(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::TransferEntitlementsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TransferEntitlementsToGoogle : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TransferEntitlementsToGoogle() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedTransferEntitlementsToGoogle(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TransferEntitlementsToGoogle() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TransferEntitlementsToGoogle(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTransferEntitlementsToGoogle(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::TransferEntitlementsToGoogleRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListChannelPartnerLinks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListChannelPartnerLinks() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListChannelPartnerLinksRequest, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListChannelPartnerLinksRequest, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse>* streamer) {
                       return this->StreamedListChannelPartnerLinks(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListChannelPartnerLinks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListChannelPartnerLinks(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListChannelPartnerLinksRequest* /*request*/, ::google::cloud::channel::v1::ListChannelPartnerLinksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListChannelPartnerLinks(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListChannelPartnerLinksRequest,::google::cloud::channel::v1::ListChannelPartnerLinksResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetChannelPartnerLink() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::GetChannelPartnerLinkRequest, ::google::cloud::channel::v1::ChannelPartnerLink>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::GetChannelPartnerLinkRequest, ::google::cloud::channel::v1::ChannelPartnerLink>* streamer) {
                       return this->StreamedGetChannelPartnerLink(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetChannelPartnerLink(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::GetChannelPartnerLinkRequest,::google::cloud::channel::v1::ChannelPartnerLink>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateChannelPartnerLink() {
      ::grpc::Service::MarkMethodStreamed(24,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest, ::google::cloud::channel::v1::ChannelPartnerLink>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest, ::google::cloud::channel::v1::ChannelPartnerLink>* streamer) {
                       return this->StreamedCreateChannelPartnerLink(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateChannelPartnerLink(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::CreateChannelPartnerLinkRequest,::google::cloud::channel::v1::ChannelPartnerLink>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateChannelPartnerLink : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateChannelPartnerLink() {
      ::grpc::Service::MarkMethodStreamed(25,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest, ::google::cloud::channel::v1::ChannelPartnerLink>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest, ::google::cloud::channel::v1::ChannelPartnerLink>* streamer) {
                       return this->StreamedUpdateChannelPartnerLink(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateChannelPartnerLink() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateChannelPartnerLink(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerLink* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateChannelPartnerLink(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::UpdateChannelPartnerLinkRequest,::google::cloud::channel::v1::ChannelPartnerLink>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodStreamed(26,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest, ::google::cloud::channel::v1::CustomerRepricingConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest, ::google::cloud::channel::v1::CustomerRepricingConfig>* streamer) {
                       return this->StreamedGetCustomerRepricingConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCustomerRepricingConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::GetCustomerRepricingConfigRequest,::google::cloud::channel::v1::CustomerRepricingConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListCustomerRepricingConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListCustomerRepricingConfigs() {
      ::grpc::Service::MarkMethodStreamed(27,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>* streamer) {
                       return this->StreamedListCustomerRepricingConfigs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListCustomerRepricingConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListCustomerRepricingConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest* /*request*/, ::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListCustomerRepricingConfigs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListCustomerRepricingConfigsRequest,::google::cloud::channel::v1::ListCustomerRepricingConfigsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodStreamed(28,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest, ::google::cloud::channel::v1::CustomerRepricingConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest, ::google::cloud::channel::v1::CustomerRepricingConfig>* streamer) {
                       return this->StreamedCreateCustomerRepricingConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCustomerRepricingConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::CreateCustomerRepricingConfigRequest,::google::cloud::channel::v1::CustomerRepricingConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodStreamed(29,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest, ::google::cloud::channel::v1::CustomerRepricingConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest, ::google::cloud::channel::v1::CustomerRepricingConfig>* streamer) {
                       return this->StreamedUpdateCustomerRepricingConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::CustomerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCustomerRepricingConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::UpdateCustomerRepricingConfigRequest,::google::cloud::channel::v1::CustomerRepricingConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteCustomerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteCustomerRepricingConfig() {
      ::grpc::Service::MarkMethodStreamed(30,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteCustomerRepricingConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteCustomerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteCustomerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteCustomerRepricingConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::DeleteCustomerRepricingConfigRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodStreamed(31,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* streamer) {
                       return this->StreamedGetChannelPartnerRepricingConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetChannelPartnerRepricingConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::GetChannelPartnerRepricingConfigRequest,::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListChannelPartnerRepricingConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListChannelPartnerRepricingConfigs() {
      ::grpc::Service::MarkMethodStreamed(32,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>* streamer) {
                       return this->StreamedListChannelPartnerRepricingConfigs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListChannelPartnerRepricingConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListChannelPartnerRepricingConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest* /*request*/, ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListChannelPartnerRepricingConfigs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsRequest,::google::cloud::channel::v1::ListChannelPartnerRepricingConfigsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodStreamed(33,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* streamer) {
                       return this->StreamedCreateChannelPartnerRepricingConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateChannelPartnerRepricingConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::CreateChannelPartnerRepricingConfigRequest,::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodStreamed(34,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* streamer) {
                       return this->StreamedUpdateChannelPartnerRepricingConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest* /*request*/, ::google::cloud::channel::v1::ChannelPartnerRepricingConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateChannelPartnerRepricingConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::UpdateChannelPartnerRepricingConfigRequest,::google::cloud::channel::v1::ChannelPartnerRepricingConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteChannelPartnerRepricingConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteChannelPartnerRepricingConfig() {
      ::grpc::Service::MarkMethodStreamed(35,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteChannelPartnerRepricingConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteChannelPartnerRepricingConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteChannelPartnerRepricingConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteChannelPartnerRepricingConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::DeleteChannelPartnerRepricingConfigRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSkuGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSkuGroups() {
      ::grpc::Service::MarkMethodStreamed(36,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListSkuGroupsRequest, ::google::cloud::channel::v1::ListSkuGroupsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListSkuGroupsRequest, ::google::cloud::channel::v1::ListSkuGroupsResponse>* streamer) {
                       return this->StreamedListSkuGroups(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSkuGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSkuGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkuGroupsRequest* /*request*/, ::google::cloud::channel::v1::ListSkuGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSkuGroups(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListSkuGroupsRequest,::google::cloud::channel::v1::ListSkuGroupsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSkuGroupBillableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSkuGroupBillableSkus() {
      ::grpc::Service::MarkMethodStreamed(37,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>* streamer) {
                       return this->StreamedListSkuGroupBillableSkus(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSkuGroupBillableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSkuGroupBillableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSkuGroupBillableSkus(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListSkuGroupBillableSkusRequest,::google::cloud::channel::v1::ListSkuGroupBillableSkusResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_LookupOffer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_LookupOffer() {
      ::grpc::Service::MarkMethodStreamed(38,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::LookupOfferRequest, ::google::cloud::channel::v1::Offer>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::LookupOfferRequest, ::google::cloud::channel::v1::Offer>* streamer) {
                       return this->StreamedLookupOffer(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_LookupOffer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status LookupOffer(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::LookupOfferRequest* /*request*/, ::google::cloud::channel::v1::Offer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedLookupOffer(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::LookupOfferRequest,::google::cloud::channel::v1::Offer>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListProducts() {
      ::grpc::Service::MarkMethodStreamed(39,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListProductsRequest, ::google::cloud::channel::v1::ListProductsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListProductsRequest, ::google::cloud::channel::v1::ListProductsResponse>* streamer) {
                       return this->StreamedListProducts(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListProductsRequest* /*request*/, ::google::cloud::channel::v1::ListProductsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListProducts(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListProductsRequest,::google::cloud::channel::v1::ListProductsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSkus() {
      ::grpc::Service::MarkMethodStreamed(40,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListSkusRequest, ::google::cloud::channel::v1::ListSkusResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListSkusRequest, ::google::cloud::channel::v1::ListSkusResponse>* streamer) {
                       return this->StreamedListSkus(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSkusRequest* /*request*/, ::google::cloud::channel::v1::ListSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSkus(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListSkusRequest,::google::cloud::channel::v1::ListSkusResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListOffers() {
      ::grpc::Service::MarkMethodStreamed(41,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListOffersRequest, ::google::cloud::channel::v1::ListOffersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListOffersRequest, ::google::cloud::channel::v1::ListOffersResponse>* streamer) {
                       return this->StreamedListOffers(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListOffersRequest* /*request*/, ::google::cloud::channel::v1::ListOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListOffers(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListOffersRequest,::google::cloud::channel::v1::ListOffersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPurchasableSkus : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPurchasableSkus() {
      ::grpc::Service::MarkMethodStreamed(42,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListPurchasableSkusRequest, ::google::cloud::channel::v1::ListPurchasableSkusResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListPurchasableSkusRequest, ::google::cloud::channel::v1::ListPurchasableSkusResponse>* streamer) {
                       return this->StreamedListPurchasableSkus(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPurchasableSkus() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPurchasableSkus(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListPurchasableSkusRequest* /*request*/, ::google::cloud::channel::v1::ListPurchasableSkusResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPurchasableSkus(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListPurchasableSkusRequest,::google::cloud::channel::v1::ListPurchasableSkusResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPurchasableOffers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPurchasableOffers() {
      ::grpc::Service::MarkMethodStreamed(43,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListPurchasableOffersRequest, ::google::cloud::channel::v1::ListPurchasableOffersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListPurchasableOffersRequest, ::google::cloud::channel::v1::ListPurchasableOffersResponse>* streamer) {
                       return this->StreamedListPurchasableOffers(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPurchasableOffers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPurchasableOffers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListPurchasableOffersRequest* /*request*/, ::google::cloud::channel::v1::ListPurchasableOffersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPurchasableOffers(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListPurchasableOffersRequest,::google::cloud::channel::v1::ListPurchasableOffersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_QueryEligibleBillingAccounts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_QueryEligibleBillingAccounts() {
      ::grpc::Service::MarkMethodStreamed(44,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>* streamer) {
                       return this->StreamedQueryEligibleBillingAccounts(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_QueryEligibleBillingAccounts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status QueryEligibleBillingAccounts(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest* /*request*/, ::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedQueryEligibleBillingAccounts(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::QueryEligibleBillingAccountsRequest,::google::cloud::channel::v1::QueryEligibleBillingAccountsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RegisterSubscriber : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RegisterSubscriber() {
      ::grpc::Service::MarkMethodStreamed(45,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::RegisterSubscriberRequest, ::google::cloud::channel::v1::RegisterSubscriberResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::RegisterSubscriberRequest, ::google::cloud::channel::v1::RegisterSubscriberResponse>* streamer) {
                       return this->StreamedRegisterSubscriber(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RegisterSubscriber() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RegisterSubscriber(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::RegisterSubscriberRequest* /*request*/, ::google::cloud::channel::v1::RegisterSubscriberResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRegisterSubscriber(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::RegisterSubscriberRequest,::google::cloud::channel::v1::RegisterSubscriberResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UnregisterSubscriber : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UnregisterSubscriber() {
      ::grpc::Service::MarkMethodStreamed(46,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::UnregisterSubscriberRequest, ::google::cloud::channel::v1::UnregisterSubscriberResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::UnregisterSubscriberRequest, ::google::cloud::channel::v1::UnregisterSubscriberResponse>* streamer) {
                       return this->StreamedUnregisterSubscriber(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UnregisterSubscriber() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UnregisterSubscriber(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::UnregisterSubscriberRequest* /*request*/, ::google::cloud::channel::v1::UnregisterSubscriberResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUnregisterSubscriber(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::UnregisterSubscriberRequest,::google::cloud::channel::v1::UnregisterSubscriberResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSubscribers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSubscribers() {
      ::grpc::Service::MarkMethodStreamed(47,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListSubscribersRequest, ::google::cloud::channel::v1::ListSubscribersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListSubscribersRequest, ::google::cloud::channel::v1::ListSubscribersResponse>* streamer) {
                       return this->StreamedListSubscribers(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSubscribers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSubscribers(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListSubscribersRequest* /*request*/, ::google::cloud::channel::v1::ListSubscribersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSubscribers(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListSubscribersRequest,::google::cloud::channel::v1::ListSubscribersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListEntitlementChanges : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListEntitlementChanges() {
      ::grpc::Service::MarkMethodStreamed(48,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListEntitlementChangesRequest, ::google::cloud::channel::v1::ListEntitlementChangesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListEntitlementChangesRequest, ::google::cloud::channel::v1::ListEntitlementChangesResponse>* streamer) {
                       return this->StreamedListEntitlementChanges(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListEntitlementChanges() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListEntitlementChanges(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListEntitlementChangesRequest* /*request*/, ::google::cloud::channel::v1::ListEntitlementChangesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListEntitlementChanges(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListEntitlementChangesRequest,::google::cloud::channel::v1::ListEntitlementChangesResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListCustomers<WithStreamedUnaryMethod_GetCustomer<WithStreamedUnaryMethod_CheckCloudIdentityAccountsExist<WithStreamedUnaryMethod_CreateCustomer<WithStreamedUnaryMethod_UpdateCustomer<WithStreamedUnaryMethod_DeleteCustomer<WithStreamedUnaryMethod_ImportCustomer<WithStreamedUnaryMethod_ProvisionCloudIdentity<WithStreamedUnaryMethod_ListEntitlements<WithStreamedUnaryMethod_ListTransferableSkus<WithStreamedUnaryMethod_ListTransferableOffers<WithStreamedUnaryMethod_GetEntitlement<WithStreamedUnaryMethod_CreateEntitlement<WithStreamedUnaryMethod_ChangeParameters<WithStreamedUnaryMethod_ChangeRenewalSettings<WithStreamedUnaryMethod_ChangeOffer<WithStreamedUnaryMethod_StartPaidService<WithStreamedUnaryMethod_SuspendEntitlement<WithStreamedUnaryMethod_CancelEntitlement<WithStreamedUnaryMethod_ActivateEntitlement<WithStreamedUnaryMethod_TransferEntitlements<WithStreamedUnaryMethod_TransferEntitlementsToGoogle<WithStreamedUnaryMethod_ListChannelPartnerLinks<WithStreamedUnaryMethod_GetChannelPartnerLink<WithStreamedUnaryMethod_CreateChannelPartnerLink<WithStreamedUnaryMethod_UpdateChannelPartnerLink<WithStreamedUnaryMethod_GetCustomerRepricingConfig<WithStreamedUnaryMethod_ListCustomerRepricingConfigs<WithStreamedUnaryMethod_CreateCustomerRepricingConfig<WithStreamedUnaryMethod_UpdateCustomerRepricingConfig<WithStreamedUnaryMethod_DeleteCustomerRepricingConfig<WithStreamedUnaryMethod_GetChannelPartnerRepricingConfig<WithStreamedUnaryMethod_ListChannelPartnerRepricingConfigs<WithStreamedUnaryMethod_CreateChannelPartnerRepricingConfig<WithStreamedUnaryMethod_UpdateChannelPartnerRepricingConfig<WithStreamedUnaryMethod_DeleteChannelPartnerRepricingConfig<WithStreamedUnaryMethod_ListSkuGroups<WithStreamedUnaryMethod_ListSkuGroupBillableSkus<WithStreamedUnaryMethod_LookupOffer<WithStreamedUnaryMethod_ListProducts<WithStreamedUnaryMethod_ListSkus<WithStreamedUnaryMethod_ListOffers<WithStreamedUnaryMethod_ListPurchasableSkus<WithStreamedUnaryMethod_ListPurchasableOffers<WithStreamedUnaryMethod_QueryEligibleBillingAccounts<WithStreamedUnaryMethod_RegisterSubscriber<WithStreamedUnaryMethod_UnregisterSubscriber<WithStreamedUnaryMethod_ListSubscribers<WithStreamedUnaryMethod_ListEntitlementChanges<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListCustomers<WithStreamedUnaryMethod_GetCustomer<WithStreamedUnaryMethod_CheckCloudIdentityAccountsExist<WithStreamedUnaryMethod_CreateCustomer<WithStreamedUnaryMethod_UpdateCustomer<WithStreamedUnaryMethod_DeleteCustomer<WithStreamedUnaryMethod_ImportCustomer<WithStreamedUnaryMethod_ProvisionCloudIdentity<WithStreamedUnaryMethod_ListEntitlements<WithStreamedUnaryMethod_ListTransferableSkus<WithStreamedUnaryMethod_ListTransferableOffers<WithStreamedUnaryMethod_GetEntitlement<WithStreamedUnaryMethod_CreateEntitlement<WithStreamedUnaryMethod_ChangeParameters<WithStreamedUnaryMethod_ChangeRenewalSettings<WithStreamedUnaryMethod_ChangeOffer<WithStreamedUnaryMethod_StartPaidService<WithStreamedUnaryMethod_SuspendEntitlement<WithStreamedUnaryMethod_CancelEntitlement<WithStreamedUnaryMethod_ActivateEntitlement<WithStreamedUnaryMethod_TransferEntitlements<WithStreamedUnaryMethod_TransferEntitlementsToGoogle<WithStreamedUnaryMethod_ListChannelPartnerLinks<WithStreamedUnaryMethod_GetChannelPartnerLink<WithStreamedUnaryMethod_CreateChannelPartnerLink<WithStreamedUnaryMethod_UpdateChannelPartnerLink<WithStreamedUnaryMethod_GetCustomerRepricingConfig<WithStreamedUnaryMethod_ListCustomerRepricingConfigs<WithStreamedUnaryMethod_CreateCustomerRepricingConfig<WithStreamedUnaryMethod_UpdateCustomerRepricingConfig<WithStreamedUnaryMethod_DeleteCustomerRepricingConfig<WithStreamedUnaryMethod_GetChannelPartnerRepricingConfig<WithStreamedUnaryMethod_ListChannelPartnerRepricingConfigs<WithStreamedUnaryMethod_CreateChannelPartnerRepricingConfig<WithStreamedUnaryMethod_UpdateChannelPartnerRepricingConfig<WithStreamedUnaryMethod_DeleteChannelPartnerRepricingConfig<WithStreamedUnaryMethod_ListSkuGroups<WithStreamedUnaryMethod_ListSkuGroupBillableSkus<WithStreamedUnaryMethod_LookupOffer<WithStreamedUnaryMethod_ListProducts<WithStreamedUnaryMethod_ListSkus<WithStreamedUnaryMethod_ListOffers<WithStreamedUnaryMethod_ListPurchasableSkus<WithStreamedUnaryMethod_ListPurchasableOffers<WithStreamedUnaryMethod_QueryEligibleBillingAccounts<WithStreamedUnaryMethod_RegisterSubscriber<WithStreamedUnaryMethod_UnregisterSubscriber<WithStreamedUnaryMethod_ListSubscribers<WithStreamedUnaryMethod_ListEntitlementChanges<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace channel
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fchannel_2fv1_2fservice_2eproto__INCLUDED
