// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/edgenetwork/v1/service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fedgenetwork_2fv1_2fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fedgenetwork_2fv1_2fservice_2eproto__INCLUDED

#include "google/cloud/edgenetwork/v1/service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace edgenetwork {
namespace v1 {

// EdgeNetwork API provides managed, highly available cloud dynamic network
// configuration service to the GEC customer to enable edge application and
// network function solutions. This allows the customers to easily define and
// configure the network setup and property to meet the workload requirement.
class EdgeNetwork final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.edgenetwork.v1.EdgeNetwork";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // InitializeZone will initialize resources for a zone in a project.
    virtual ::grpc::Status InitializeZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest& request, ::google::cloud::edgenetwork::v1::InitializeZoneResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::InitializeZoneResponse>> AsyncInitializeZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::InitializeZoneResponse>>(AsyncInitializeZoneRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::InitializeZoneResponse>> PrepareAsyncInitializeZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::InitializeZoneResponse>>(PrepareAsyncInitializeZoneRaw(context, request, cq));
    }
    // Deprecated: not implemented.
    // Lists Zones in a given project and location.
    virtual ::grpc::Status ListZones(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListZonesRequest& request, ::google::cloud::edgenetwork::v1::ListZonesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListZonesResponse>> AsyncListZones(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListZonesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListZonesResponse>>(AsyncListZonesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListZonesResponse>> PrepareAsyncListZones(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListZonesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListZonesResponse>>(PrepareAsyncListZonesRaw(context, request, cq));
    }
    // Deprecated: not implemented.
    // Gets details of a single Zone.
    virtual ::grpc::Status GetZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetZoneRequest& request, ::google::cloud::edgenetwork::v1::Zone* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Zone>> AsyncGetZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Zone>>(AsyncGetZoneRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Zone>> PrepareAsyncGetZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Zone>>(PrepareAsyncGetZoneRaw(context, request, cq));
    }
    // Lists Networks in a given project and location.
    virtual ::grpc::Status ListNetworks(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListNetworksRequest& request, ::google::cloud::edgenetwork::v1::ListNetworksResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListNetworksResponse>> AsyncListNetworks(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListNetworksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListNetworksResponse>>(AsyncListNetworksRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListNetworksResponse>> PrepareAsyncListNetworks(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListNetworksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListNetworksResponse>>(PrepareAsyncListNetworksRaw(context, request, cq));
    }
    // Gets details of a single Network.
    virtual ::grpc::Status GetNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetNetworkRequest& request, ::google::cloud::edgenetwork::v1::Network* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Network>> AsyncGetNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Network>>(AsyncGetNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Network>> PrepareAsyncGetNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Network>>(PrepareAsyncGetNetworkRaw(context, request, cq));
    }
    // Get the diagnostics of a single network resource.
    virtual ::grpc::Status DiagnoseNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest& request, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>> AsyncDiagnoseNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>>(AsyncDiagnoseNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>> PrepareAsyncDiagnoseNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>>(PrepareAsyncDiagnoseNetworkRaw(context, request, cq));
    }
    // Creates a new Network in a given project and location.
    virtual ::grpc::Status CreateNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateNetworkRaw(context, request, cq));
    }
    // Deletes a single Network.
    virtual ::grpc::Status DeleteNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteNetworkRaw(context, request, cq));
    }
    // Lists Subnets in a given project and location.
    virtual ::grpc::Status ListSubnets(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest& request, ::google::cloud::edgenetwork::v1::ListSubnetsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListSubnetsResponse>> AsyncListSubnets(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListSubnetsResponse>>(AsyncListSubnetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListSubnetsResponse>> PrepareAsyncListSubnets(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListSubnetsResponse>>(PrepareAsyncListSubnetsRaw(context, request, cq));
    }
    // Gets details of a single Subnet.
    virtual ::grpc::Status GetSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetSubnetRequest& request, ::google::cloud::edgenetwork::v1::Subnet* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Subnet>> AsyncGetSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Subnet>>(AsyncGetSubnetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Subnet>> PrepareAsyncGetSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Subnet>>(PrepareAsyncGetSubnetRaw(context, request, cq));
    }
    // Creates a new Subnet in a given project and location.
    virtual ::grpc::Status CreateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateSubnetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateSubnetRaw(context, request, cq));
    }
    // Updates the parameters of a single Subnet.
    virtual ::grpc::Status UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateSubnetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateSubnetRaw(context, request, cq));
    }
    // Deletes a single Subnet.
    virtual ::grpc::Status DeleteSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteSubnetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteSubnetRaw(context, request, cq));
    }
    // Lists Interconnects in a given project and location.
    virtual ::grpc::Status ListInterconnects(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest& request, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>> AsyncListInterconnects(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>>(AsyncListInterconnectsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>> PrepareAsyncListInterconnects(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>>(PrepareAsyncListInterconnectsRaw(context, request, cq));
    }
    // Gets details of a single Interconnect.
    virtual ::grpc::Status GetInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest& request, ::google::cloud::edgenetwork::v1::Interconnect* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Interconnect>> AsyncGetInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Interconnect>>(AsyncGetInterconnectRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Interconnect>> PrepareAsyncGetInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Interconnect>>(PrepareAsyncGetInterconnectRaw(context, request, cq));
    }
    // Get the diagnostics of a single interconnect resource.
    virtual ::grpc::Status DiagnoseInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest& request, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>> AsyncDiagnoseInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>>(AsyncDiagnoseInterconnectRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>> PrepareAsyncDiagnoseInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>>(PrepareAsyncDiagnoseInterconnectRaw(context, request, cq));
    }
    // Lists InterconnectAttachments in a given project and location.
    virtual ::grpc::Status ListInterconnectAttachments(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest& request, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>> AsyncListInterconnectAttachments(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>>(AsyncListInterconnectAttachmentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>> PrepareAsyncListInterconnectAttachments(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>>(PrepareAsyncListInterconnectAttachmentsRaw(context, request, cq));
    }
    // Gets details of a single InterconnectAttachment.
    virtual ::grpc::Status GetInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest& request, ::google::cloud::edgenetwork::v1::InterconnectAttachment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::InterconnectAttachment>> AsyncGetInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::InterconnectAttachment>>(AsyncGetInterconnectAttachmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::InterconnectAttachment>> PrepareAsyncGetInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::InterconnectAttachment>>(PrepareAsyncGetInterconnectAttachmentRaw(context, request, cq));
    }
    // Creates a new InterconnectAttachment in a given project and location.
    virtual ::grpc::Status CreateInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateInterconnectAttachmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateInterconnectAttachmentRaw(context, request, cq));
    }
    // Deletes a single InterconnectAttachment.
    virtual ::grpc::Status DeleteInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteInterconnectAttachmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteInterconnectAttachmentRaw(context, request, cq));
    }
    // Lists Routers in a given project and location.
    virtual ::grpc::Status ListRouters(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListRoutersRequest& request, ::google::cloud::edgenetwork::v1::ListRoutersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListRoutersResponse>> AsyncListRouters(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListRoutersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListRoutersResponse>>(AsyncListRoutersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListRoutersResponse>> PrepareAsyncListRouters(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListRoutersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListRoutersResponse>>(PrepareAsyncListRoutersRaw(context, request, cq));
    }
    // Gets details of a single Router.
    virtual ::grpc::Status GetRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetRouterRequest& request, ::google::cloud::edgenetwork::v1::Router* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Router>> AsyncGetRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Router>>(AsyncGetRouterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Router>> PrepareAsyncGetRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Router>>(PrepareAsyncGetRouterRaw(context, request, cq));
    }
    // Get the diagnostics of a single router resource.
    virtual ::grpc::Status DiagnoseRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest& request, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>> AsyncDiagnoseRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>>(AsyncDiagnoseRouterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>> PrepareAsyncDiagnoseRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>>(PrepareAsyncDiagnoseRouterRaw(context, request, cq));
    }
    // Creates a new Router in a given project and location.
    virtual ::grpc::Status CreateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateRouterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateRouterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateRouterRaw(context, request, cq));
    }
    // Updates the parameters of a single Router.
    virtual ::grpc::Status UpdateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateRouterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateRouterRaw(context, request, cq));
    }
    // Deletes a single Router.
    virtual ::grpc::Status DeleteRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteRouterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteRouterRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // InitializeZone will initialize resources for a zone in a project.
      virtual void InitializeZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest* request, ::google::cloud::edgenetwork::v1::InitializeZoneResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void InitializeZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest* request, ::google::cloud::edgenetwork::v1::InitializeZoneResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deprecated: not implemented.
      // Lists Zones in a given project and location.
      virtual void ListZones(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListZonesRequest* request, ::google::cloud::edgenetwork::v1::ListZonesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListZones(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListZonesRequest* request, ::google::cloud::edgenetwork::v1::ListZonesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deprecated: not implemented.
      // Gets details of a single Zone.
      virtual void GetZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetZoneRequest* request, ::google::cloud::edgenetwork::v1::Zone* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetZoneRequest* request, ::google::cloud::edgenetwork::v1::Zone* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Networks in a given project and location.
      virtual void ListNetworks(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListNetworksRequest* request, ::google::cloud::edgenetwork::v1::ListNetworksResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListNetworks(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListNetworksRequest* request, ::google::cloud::edgenetwork::v1::ListNetworksResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single Network.
      virtual void GetNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetNetworkRequest* request, ::google::cloud::edgenetwork::v1::Network* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetNetworkRequest* request, ::google::cloud::edgenetwork::v1::Network* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get the diagnostics of a single network resource.
      virtual void DiagnoseNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DiagnoseNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Network in a given project and location.
      virtual void CreateNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single Network.
      virtual void DeleteNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Subnets in a given project and location.
      virtual void ListSubnets(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest* request, ::google::cloud::edgenetwork::v1::ListSubnetsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSubnets(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest* request, ::google::cloud::edgenetwork::v1::ListSubnetsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single Subnet.
      virtual void GetSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetSubnetRequest* request, ::google::cloud::edgenetwork::v1::Subnet* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetSubnetRequest* request, ::google::cloud::edgenetwork::v1::Subnet* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Subnet in a given project and location.
      virtual void CreateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single Subnet.
      virtual void UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single Subnet.
      virtual void DeleteSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Interconnects in a given project and location.
      virtual void ListInterconnects(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest* request, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListInterconnects(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest* request, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single Interconnect.
      virtual void GetInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest* request, ::google::cloud::edgenetwork::v1::Interconnect* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest* request, ::google::cloud::edgenetwork::v1::Interconnect* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get the diagnostics of a single interconnect resource.
      virtual void DiagnoseInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DiagnoseInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists InterconnectAttachments in a given project and location.
      virtual void ListInterconnectAttachments(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest* request, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListInterconnectAttachments(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest* request, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single InterconnectAttachment.
      virtual void GetInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest* request, ::google::cloud::edgenetwork::v1::InterconnectAttachment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest* request, ::google::cloud::edgenetwork::v1::InterconnectAttachment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new InterconnectAttachment in a given project and location.
      virtual void CreateInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single InterconnectAttachment.
      virtual void DeleteInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Routers in a given project and location.
      virtual void ListRouters(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListRoutersRequest* request, ::google::cloud::edgenetwork::v1::ListRoutersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListRouters(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListRoutersRequest* request, ::google::cloud::edgenetwork::v1::ListRoutersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single Router.
      virtual void GetRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetRouterRequest* request, ::google::cloud::edgenetwork::v1::Router* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetRouterRequest* request, ::google::cloud::edgenetwork::v1::Router* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get the diagnostics of a single router resource.
      virtual void DiagnoseRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DiagnoseRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Router in a given project and location.
      virtual void CreateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateRouterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateRouterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single Router.
      virtual void UpdateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single Router.
      virtual void DeleteRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::InitializeZoneResponse>* AsyncInitializeZoneRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::InitializeZoneResponse>* PrepareAsyncInitializeZoneRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListZonesResponse>* AsyncListZonesRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListZonesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListZonesResponse>* PrepareAsyncListZonesRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListZonesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Zone>* AsyncGetZoneRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetZoneRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Zone>* PrepareAsyncGetZoneRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetZoneRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListNetworksResponse>* AsyncListNetworksRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListNetworksRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListNetworksResponse>* PrepareAsyncListNetworksRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListNetworksRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Network>* AsyncGetNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Network>* PrepareAsyncGetNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>* AsyncDiagnoseNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>* PrepareAsyncDiagnoseNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListSubnetsResponse>* AsyncListSubnetsRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListSubnetsResponse>* PrepareAsyncListSubnetsRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Subnet>* AsyncGetSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Subnet>* PrepareAsyncGetSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>* AsyncListInterconnectsRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>* PrepareAsyncListInterconnectsRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Interconnect>* AsyncGetInterconnectRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Interconnect>* PrepareAsyncGetInterconnectRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>* AsyncDiagnoseInterconnectRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>* PrepareAsyncDiagnoseInterconnectRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>* AsyncListInterconnectAttachmentsRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>* PrepareAsyncListInterconnectAttachmentsRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::InterconnectAttachment>* AsyncGetInterconnectAttachmentRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::InterconnectAttachment>* PrepareAsyncGetInterconnectAttachmentRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateInterconnectAttachmentRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateInterconnectAttachmentRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteInterconnectAttachmentRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteInterconnectAttachmentRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListRoutersResponse>* AsyncListRoutersRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListRoutersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::ListRoutersResponse>* PrepareAsyncListRoutersRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListRoutersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Router>* AsyncGetRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetRouterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::Router>* PrepareAsyncGetRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetRouterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>* AsyncDiagnoseRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>* PrepareAsyncDiagnoseRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateRouterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateRouterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status InitializeZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest& request, ::google::cloud::edgenetwork::v1::InitializeZoneResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::InitializeZoneResponse>> AsyncInitializeZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::InitializeZoneResponse>>(AsyncInitializeZoneRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::InitializeZoneResponse>> PrepareAsyncInitializeZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::InitializeZoneResponse>>(PrepareAsyncInitializeZoneRaw(context, request, cq));
    }
    ::grpc::Status ListZones(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListZonesRequest& request, ::google::cloud::edgenetwork::v1::ListZonesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListZonesResponse>> AsyncListZones(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListZonesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListZonesResponse>>(AsyncListZonesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListZonesResponse>> PrepareAsyncListZones(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListZonesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListZonesResponse>>(PrepareAsyncListZonesRaw(context, request, cq));
    }
    ::grpc::Status GetZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetZoneRequest& request, ::google::cloud::edgenetwork::v1::Zone* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Zone>> AsyncGetZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Zone>>(AsyncGetZoneRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Zone>> PrepareAsyncGetZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetZoneRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Zone>>(PrepareAsyncGetZoneRaw(context, request, cq));
    }
    ::grpc::Status ListNetworks(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListNetworksRequest& request, ::google::cloud::edgenetwork::v1::ListNetworksResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListNetworksResponse>> AsyncListNetworks(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListNetworksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListNetworksResponse>>(AsyncListNetworksRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListNetworksResponse>> PrepareAsyncListNetworks(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListNetworksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListNetworksResponse>>(PrepareAsyncListNetworksRaw(context, request, cq));
    }
    ::grpc::Status GetNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetNetworkRequest& request, ::google::cloud::edgenetwork::v1::Network* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Network>> AsyncGetNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Network>>(AsyncGetNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Network>> PrepareAsyncGetNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Network>>(PrepareAsyncGetNetworkRaw(context, request, cq));
    }
    ::grpc::Status DiagnoseNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest& request, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>> AsyncDiagnoseNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>>(AsyncDiagnoseNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>> PrepareAsyncDiagnoseNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>>(PrepareAsyncDiagnoseNetworkRaw(context, request, cq));
    }
    ::grpc::Status CreateNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateNetworkRaw(context, request, cq));
    }
    ::grpc::Status DeleteNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteNetworkRaw(context, request, cq));
    }
    ::grpc::Status ListSubnets(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest& request, ::google::cloud::edgenetwork::v1::ListSubnetsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListSubnetsResponse>> AsyncListSubnets(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListSubnetsResponse>>(AsyncListSubnetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListSubnetsResponse>> PrepareAsyncListSubnets(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListSubnetsResponse>>(PrepareAsyncListSubnetsRaw(context, request, cq));
    }
    ::grpc::Status GetSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetSubnetRequest& request, ::google::cloud::edgenetwork::v1::Subnet* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Subnet>> AsyncGetSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Subnet>>(AsyncGetSubnetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Subnet>> PrepareAsyncGetSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Subnet>>(PrepareAsyncGetSubnetRaw(context, request, cq));
    }
    ::grpc::Status CreateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateSubnetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateSubnetRaw(context, request, cq));
    }
    ::grpc::Status UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateSubnetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateSubnetRaw(context, request, cq));
    }
    ::grpc::Status DeleteSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteSubnetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteSubnetRaw(context, request, cq));
    }
    ::grpc::Status ListInterconnects(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest& request, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>> AsyncListInterconnects(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>>(AsyncListInterconnectsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>> PrepareAsyncListInterconnects(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>>(PrepareAsyncListInterconnectsRaw(context, request, cq));
    }
    ::grpc::Status GetInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest& request, ::google::cloud::edgenetwork::v1::Interconnect* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Interconnect>> AsyncGetInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Interconnect>>(AsyncGetInterconnectRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Interconnect>> PrepareAsyncGetInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Interconnect>>(PrepareAsyncGetInterconnectRaw(context, request, cq));
    }
    ::grpc::Status DiagnoseInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest& request, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>> AsyncDiagnoseInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>>(AsyncDiagnoseInterconnectRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>> PrepareAsyncDiagnoseInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>>(PrepareAsyncDiagnoseInterconnectRaw(context, request, cq));
    }
    ::grpc::Status ListInterconnectAttachments(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest& request, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>> AsyncListInterconnectAttachments(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>>(AsyncListInterconnectAttachmentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>> PrepareAsyncListInterconnectAttachments(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>>(PrepareAsyncListInterconnectAttachmentsRaw(context, request, cq));
    }
    ::grpc::Status GetInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest& request, ::google::cloud::edgenetwork::v1::InterconnectAttachment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::InterconnectAttachment>> AsyncGetInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::InterconnectAttachment>>(AsyncGetInterconnectAttachmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::InterconnectAttachment>> PrepareAsyncGetInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::InterconnectAttachment>>(PrepareAsyncGetInterconnectAttachmentRaw(context, request, cq));
    }
    ::grpc::Status CreateInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateInterconnectAttachmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateInterconnectAttachmentRaw(context, request, cq));
    }
    ::grpc::Status DeleteInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteInterconnectAttachmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteInterconnectAttachmentRaw(context, request, cq));
    }
    ::grpc::Status ListRouters(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListRoutersRequest& request, ::google::cloud::edgenetwork::v1::ListRoutersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListRoutersResponse>> AsyncListRouters(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListRoutersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListRoutersResponse>>(AsyncListRoutersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListRoutersResponse>> PrepareAsyncListRouters(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListRoutersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListRoutersResponse>>(PrepareAsyncListRoutersRaw(context, request, cq));
    }
    ::grpc::Status GetRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetRouterRequest& request, ::google::cloud::edgenetwork::v1::Router* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Router>> AsyncGetRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Router>>(AsyncGetRouterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Router>> PrepareAsyncGetRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Router>>(PrepareAsyncGetRouterRaw(context, request, cq));
    }
    ::grpc::Status DiagnoseRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest& request, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>> AsyncDiagnoseRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>>(AsyncDiagnoseRouterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>> PrepareAsyncDiagnoseRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>>(PrepareAsyncDiagnoseRouterRaw(context, request, cq));
    }
    ::grpc::Status CreateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateRouterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateRouterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateRouterRaw(context, request, cq));
    }
    ::grpc::Status UpdateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateRouterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateRouterRaw(context, request, cq));
    }
    ::grpc::Status DeleteRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteRouterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteRouterRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void InitializeZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest* request, ::google::cloud::edgenetwork::v1::InitializeZoneResponse* response, std::function<void(::grpc::Status)>) override;
      void InitializeZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest* request, ::google::cloud::edgenetwork::v1::InitializeZoneResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListZones(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListZonesRequest* request, ::google::cloud::edgenetwork::v1::ListZonesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListZones(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListZonesRequest* request, ::google::cloud::edgenetwork::v1::ListZonesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetZoneRequest* request, ::google::cloud::edgenetwork::v1::Zone* response, std::function<void(::grpc::Status)>) override;
      void GetZone(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetZoneRequest* request, ::google::cloud::edgenetwork::v1::Zone* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListNetworks(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListNetworksRequest* request, ::google::cloud::edgenetwork::v1::ListNetworksResponse* response, std::function<void(::grpc::Status)>) override;
      void ListNetworks(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListNetworksRequest* request, ::google::cloud::edgenetwork::v1::ListNetworksResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetNetworkRequest* request, ::google::cloud::edgenetwork::v1::Network* response, std::function<void(::grpc::Status)>) override;
      void GetNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetNetworkRequest* request, ::google::cloud::edgenetwork::v1::Network* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DiagnoseNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse* response, std::function<void(::grpc::Status)>) override;
      void DiagnoseNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteNetwork(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSubnets(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest* request, ::google::cloud::edgenetwork::v1::ListSubnetsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSubnets(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest* request, ::google::cloud::edgenetwork::v1::ListSubnetsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetSubnetRequest* request, ::google::cloud::edgenetwork::v1::Subnet* response, std::function<void(::grpc::Status)>) override;
      void GetSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetSubnetRequest* request, ::google::cloud::edgenetwork::v1::Subnet* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteSubnet(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListInterconnects(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest* request, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListInterconnects(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest* request, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest* request, ::google::cloud::edgenetwork::v1::Interconnect* response, std::function<void(::grpc::Status)>) override;
      void GetInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest* request, ::google::cloud::edgenetwork::v1::Interconnect* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DiagnoseInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse* response, std::function<void(::grpc::Status)>) override;
      void DiagnoseInterconnect(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListInterconnectAttachments(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest* request, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListInterconnectAttachments(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest* request, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest* request, ::google::cloud::edgenetwork::v1::InterconnectAttachment* response, std::function<void(::grpc::Status)>) override;
      void GetInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest* request, ::google::cloud::edgenetwork::v1::InterconnectAttachment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteInterconnectAttachment(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListRouters(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListRoutersRequest* request, ::google::cloud::edgenetwork::v1::ListRoutersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListRouters(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListRoutersRequest* request, ::google::cloud::edgenetwork::v1::ListRoutersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetRouterRequest* request, ::google::cloud::edgenetwork::v1::Router* response, std::function<void(::grpc::Status)>) override;
      void GetRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetRouterRequest* request, ::google::cloud::edgenetwork::v1::Router* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DiagnoseRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse* response, std::function<void(::grpc::Status)>) override;
      void DiagnoseRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateRouterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateRouterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteRouter(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::InitializeZoneResponse>* AsyncInitializeZoneRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::InitializeZoneResponse>* PrepareAsyncInitializeZoneRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListZonesResponse>* AsyncListZonesRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListZonesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListZonesResponse>* PrepareAsyncListZonesRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListZonesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Zone>* AsyncGetZoneRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetZoneRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Zone>* PrepareAsyncGetZoneRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetZoneRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListNetworksResponse>* AsyncListNetworksRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListNetworksRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListNetworksResponse>* PrepareAsyncListNetworksRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListNetworksRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Network>* AsyncGetNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Network>* PrepareAsyncGetNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>* AsyncDiagnoseNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>* PrepareAsyncDiagnoseNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListSubnetsResponse>* AsyncListSubnetsRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListSubnetsResponse>* PrepareAsyncListSubnetsRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Subnet>* AsyncGetSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Subnet>* PrepareAsyncGetSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>* AsyncListInterconnectsRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>* PrepareAsyncListInterconnectsRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Interconnect>* AsyncGetInterconnectRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Interconnect>* PrepareAsyncGetInterconnectRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>* AsyncDiagnoseInterconnectRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>* PrepareAsyncDiagnoseInterconnectRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>* AsyncListInterconnectAttachmentsRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>* PrepareAsyncListInterconnectAttachmentsRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::InterconnectAttachment>* AsyncGetInterconnectAttachmentRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::InterconnectAttachment>* PrepareAsyncGetInterconnectAttachmentRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateInterconnectAttachmentRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateInterconnectAttachmentRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteInterconnectAttachmentRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteInterconnectAttachmentRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListRoutersResponse>* AsyncListRoutersRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListRoutersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::ListRoutersResponse>* PrepareAsyncListRoutersRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::ListRoutersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Router>* AsyncGetRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetRouterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::Router>* PrepareAsyncGetRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::GetRouterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>* AsyncDiagnoseRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>* PrepareAsyncDiagnoseRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateRouterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::CreateRouterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteRouterRaw(::grpc::ClientContext* context, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_InitializeZone_;
    const ::grpc::internal::RpcMethod rpcmethod_ListZones_;
    const ::grpc::internal::RpcMethod rpcmethod_GetZone_;
    const ::grpc::internal::RpcMethod rpcmethod_ListNetworks_;
    const ::grpc::internal::RpcMethod rpcmethod_GetNetwork_;
    const ::grpc::internal::RpcMethod rpcmethod_DiagnoseNetwork_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateNetwork_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteNetwork_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSubnets_;
    const ::grpc::internal::RpcMethod rpcmethod_GetSubnet_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateSubnet_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateSubnet_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteSubnet_;
    const ::grpc::internal::RpcMethod rpcmethod_ListInterconnects_;
    const ::grpc::internal::RpcMethod rpcmethod_GetInterconnect_;
    const ::grpc::internal::RpcMethod rpcmethod_DiagnoseInterconnect_;
    const ::grpc::internal::RpcMethod rpcmethod_ListInterconnectAttachments_;
    const ::grpc::internal::RpcMethod rpcmethod_GetInterconnectAttachment_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateInterconnectAttachment_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteInterconnectAttachment_;
    const ::grpc::internal::RpcMethod rpcmethod_ListRouters_;
    const ::grpc::internal::RpcMethod rpcmethod_GetRouter_;
    const ::grpc::internal::RpcMethod rpcmethod_DiagnoseRouter_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateRouter_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateRouter_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteRouter_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // InitializeZone will initialize resources for a zone in a project.
    virtual ::grpc::Status InitializeZone(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest* request, ::google::cloud::edgenetwork::v1::InitializeZoneResponse* response);
    // Deprecated: not implemented.
    // Lists Zones in a given project and location.
    virtual ::grpc::Status ListZones(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::ListZonesRequest* request, ::google::cloud::edgenetwork::v1::ListZonesResponse* response);
    // Deprecated: not implemented.
    // Gets details of a single Zone.
    virtual ::grpc::Status GetZone(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::GetZoneRequest* request, ::google::cloud::edgenetwork::v1::Zone* response);
    // Lists Networks in a given project and location.
    virtual ::grpc::Status ListNetworks(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::ListNetworksRequest* request, ::google::cloud::edgenetwork::v1::ListNetworksResponse* response);
    // Gets details of a single Network.
    virtual ::grpc::Status GetNetwork(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::GetNetworkRequest* request, ::google::cloud::edgenetwork::v1::Network* response);
    // Get the diagnostics of a single network resource.
    virtual ::grpc::Status DiagnoseNetwork(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse* response);
    // Creates a new Network in a given project and location.
    virtual ::grpc::Status CreateNetwork(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single Network.
    virtual ::grpc::Status DeleteNetwork(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest* request, ::google::longrunning::Operation* response);
    // Lists Subnets in a given project and location.
    virtual ::grpc::Status ListSubnets(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest* request, ::google::cloud::edgenetwork::v1::ListSubnetsResponse* response);
    // Gets details of a single Subnet.
    virtual ::grpc::Status GetSubnet(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::GetSubnetRequest* request, ::google::cloud::edgenetwork::v1::Subnet* response);
    // Creates a new Subnet in a given project and location.
    virtual ::grpc::Status CreateSubnet(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a single Subnet.
    virtual ::grpc::Status UpdateSubnet(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single Subnet.
    virtual ::grpc::Status DeleteSubnet(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest* request, ::google::longrunning::Operation* response);
    // Lists Interconnects in a given project and location.
    virtual ::grpc::Status ListInterconnects(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest* request, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse* response);
    // Gets details of a single Interconnect.
    virtual ::grpc::Status GetInterconnect(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest* request, ::google::cloud::edgenetwork::v1::Interconnect* response);
    // Get the diagnostics of a single interconnect resource.
    virtual ::grpc::Status DiagnoseInterconnect(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse* response);
    // Lists InterconnectAttachments in a given project and location.
    virtual ::grpc::Status ListInterconnectAttachments(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest* request, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse* response);
    // Gets details of a single InterconnectAttachment.
    virtual ::grpc::Status GetInterconnectAttachment(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest* request, ::google::cloud::edgenetwork::v1::InterconnectAttachment* response);
    // Creates a new InterconnectAttachment in a given project and location.
    virtual ::grpc::Status CreateInterconnectAttachment(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single InterconnectAttachment.
    virtual ::grpc::Status DeleteInterconnectAttachment(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest* request, ::google::longrunning::Operation* response);
    // Lists Routers in a given project and location.
    virtual ::grpc::Status ListRouters(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::ListRoutersRequest* request, ::google::cloud::edgenetwork::v1::ListRoutersResponse* response);
    // Gets details of a single Router.
    virtual ::grpc::Status GetRouter(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::GetRouterRequest* request, ::google::cloud::edgenetwork::v1::Router* response);
    // Get the diagnostics of a single router resource.
    virtual ::grpc::Status DiagnoseRouter(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse* response);
    // Creates a new Router in a given project and location.
    virtual ::grpc::Status CreateRouter(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::CreateRouterRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a single Router.
    virtual ::grpc::Status UpdateRouter(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single Router.
    virtual ::grpc::Status DeleteRouter(::grpc::ServerContext* context, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_InitializeZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_InitializeZone() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_InitializeZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InitializeZone(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest* /*request*/, ::google::cloud::edgenetwork::v1::InitializeZoneResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInitializeZone(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::InitializeZoneRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::edgenetwork::v1::InitializeZoneResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListZones : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListZones() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListZones() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListZones(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListZonesRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListZonesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListZones(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::ListZonesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::edgenetwork::v1::ListZonesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetZone() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetZone(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetZoneRequest* /*request*/, ::google::cloud::edgenetwork::v1::Zone* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetZone(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::GetZoneRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::edgenetwork::v1::Zone>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListNetworks() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ListNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListNetworksRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNetworks(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::ListNetworksRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::edgenetwork::v1::ListNetworksResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetNetwork() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_GetNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetNetworkRequest* /*request*/, ::google::cloud::edgenetwork::v1::Network* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNetwork(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::GetNetworkRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::edgenetwork::v1::Network>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DiagnoseNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DiagnoseNetwork() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_DiagnoseNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDiagnoseNetwork(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateNetwork() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_CreateNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateNetwork(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::CreateNetworkRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteNetwork() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_DeleteNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteNetwork(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::DeleteNetworkRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSubnets() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSubnets(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::ListSubnetsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::edgenetwork::v1::ListSubnetsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetSubnet() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetSubnetRequest* /*request*/, ::google::cloud::edgenetwork::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSubnet(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::GetSubnetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::edgenetwork::v1::Subnet>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateSubnet() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_CreateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSubnet(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::CreateSubnetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSubnet(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::UpdateSubnetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteSubnet() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_DeleteSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSubnet(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::DeleteSubnetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListInterconnects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListInterconnects() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_ListInterconnects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInterconnects(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInterconnects(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::ListInterconnectsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetInterconnect : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetInterconnect() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_GetInterconnect() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInterconnect(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest* /*request*/, ::google::cloud::edgenetwork::v1::Interconnect* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInterconnect(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::GetInterconnectRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::edgenetwork::v1::Interconnect>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DiagnoseInterconnect : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DiagnoseInterconnect() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_DiagnoseInterconnect() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseInterconnect(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDiagnoseInterconnect(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListInterconnectAttachments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListInterconnectAttachments() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_ListInterconnectAttachments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInterconnectAttachments(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInterconnectAttachments(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetInterconnectAttachment() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_GetInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest* /*request*/, ::google::cloud::edgenetwork::v1::InterconnectAttachment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInterconnectAttachment(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::edgenetwork::v1::InterconnectAttachment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateInterconnectAttachment() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_CreateInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInterconnectAttachment(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteInterconnectAttachment() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_DeleteInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInterconnectAttachment(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListRouters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListRouters() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_ListRouters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRouters(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListRoutersRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListRoutersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRouters(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::ListRoutersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::edgenetwork::v1::ListRoutersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetRouter() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_GetRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetRouterRequest* /*request*/, ::google::cloud::edgenetwork::v1::Router* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRouter(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::GetRouterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::edgenetwork::v1::Router>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DiagnoseRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DiagnoseRouter() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_DiagnoseRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDiagnoseRouter(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateRouter() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_CreateRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRouter(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::CreateRouterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateRouter() {
      ::grpc::Service::MarkMethodAsync(24);
    }
    ~WithAsyncMethod_UpdateRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateRouter(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::UpdateRouterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteRouter() {
      ::grpc::Service::MarkMethodAsync(25);
    }
    ~WithAsyncMethod_DeleteRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteRouter(::grpc::ServerContext* context, ::google::cloud::edgenetwork::v1::DeleteRouterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_InitializeZone<WithAsyncMethod_ListZones<WithAsyncMethod_GetZone<WithAsyncMethod_ListNetworks<WithAsyncMethod_GetNetwork<WithAsyncMethod_DiagnoseNetwork<WithAsyncMethod_CreateNetwork<WithAsyncMethod_DeleteNetwork<WithAsyncMethod_ListSubnets<WithAsyncMethod_GetSubnet<WithAsyncMethod_CreateSubnet<WithAsyncMethod_UpdateSubnet<WithAsyncMethod_DeleteSubnet<WithAsyncMethod_ListInterconnects<WithAsyncMethod_GetInterconnect<WithAsyncMethod_DiagnoseInterconnect<WithAsyncMethod_ListInterconnectAttachments<WithAsyncMethod_GetInterconnectAttachment<WithAsyncMethod_CreateInterconnectAttachment<WithAsyncMethod_DeleteInterconnectAttachment<WithAsyncMethod_ListRouters<WithAsyncMethod_GetRouter<WithAsyncMethod_DiagnoseRouter<WithAsyncMethod_CreateRouter<WithAsyncMethod_UpdateRouter<WithAsyncMethod_DeleteRouter<Service > > > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_InitializeZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_InitializeZone() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::InitializeZoneRequest, ::google::cloud::edgenetwork::v1::InitializeZoneResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest* request, ::google::cloud::edgenetwork::v1::InitializeZoneResponse* response) { return this->InitializeZone(context, request, response); }));}
    void SetMessageAllocatorFor_InitializeZone(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::InitializeZoneRequest, ::google::cloud::edgenetwork::v1::InitializeZoneResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::InitializeZoneRequest, ::google::cloud::edgenetwork::v1::InitializeZoneResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_InitializeZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InitializeZone(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest* /*request*/, ::google::cloud::edgenetwork::v1::InitializeZoneResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* InitializeZone(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest* /*request*/, ::google::cloud::edgenetwork::v1::InitializeZoneResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListZones : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListZones() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::ListZonesRequest, ::google::cloud::edgenetwork::v1::ListZonesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::ListZonesRequest* request, ::google::cloud::edgenetwork::v1::ListZonesResponse* response) { return this->ListZones(context, request, response); }));}
    void SetMessageAllocatorFor_ListZones(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::ListZonesRequest, ::google::cloud::edgenetwork::v1::ListZonesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::ListZonesRequest, ::google::cloud::edgenetwork::v1::ListZonesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListZones() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListZones(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListZonesRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListZonesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListZones(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListZonesRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListZonesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetZone() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::GetZoneRequest, ::google::cloud::edgenetwork::v1::Zone>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::GetZoneRequest* request, ::google::cloud::edgenetwork::v1::Zone* response) { return this->GetZone(context, request, response); }));}
    void SetMessageAllocatorFor_GetZone(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::GetZoneRequest, ::google::cloud::edgenetwork::v1::Zone>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::GetZoneRequest, ::google::cloud::edgenetwork::v1::Zone>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetZone(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetZoneRequest* /*request*/, ::google::cloud::edgenetwork::v1::Zone* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetZone(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetZoneRequest* /*request*/, ::google::cloud::edgenetwork::v1::Zone* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListNetworks() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::ListNetworksRequest, ::google::cloud::edgenetwork::v1::ListNetworksResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::ListNetworksRequest* request, ::google::cloud::edgenetwork::v1::ListNetworksResponse* response) { return this->ListNetworks(context, request, response); }));}
    void SetMessageAllocatorFor_ListNetworks(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::ListNetworksRequest, ::google::cloud::edgenetwork::v1::ListNetworksResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::ListNetworksRequest, ::google::cloud::edgenetwork::v1::ListNetworksResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListNetworksRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNetworks(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListNetworksRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListNetworksResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetNetwork() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::GetNetworkRequest, ::google::cloud::edgenetwork::v1::Network>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::GetNetworkRequest* request, ::google::cloud::edgenetwork::v1::Network* response) { return this->GetNetwork(context, request, response); }));}
    void SetMessageAllocatorFor_GetNetwork(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::GetNetworkRequest, ::google::cloud::edgenetwork::v1::Network>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::GetNetworkRequest, ::google::cloud::edgenetwork::v1::Network>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetNetworkRequest* /*request*/, ::google::cloud::edgenetwork::v1::Network* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetNetworkRequest* /*request*/, ::google::cloud::edgenetwork::v1::Network* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DiagnoseNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DiagnoseNetwork() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse* response) { return this->DiagnoseNetwork(context, request, response); }));}
    void SetMessageAllocatorFor_DiagnoseNetwork(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DiagnoseNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DiagnoseNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateNetwork() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::CreateNetworkRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest* request, ::google::longrunning::Operation* response) { return this->CreateNetwork(context, request, response); }));}
    void SetMessageAllocatorFor_CreateNetwork(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::CreateNetworkRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::CreateNetworkRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteNetwork() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::DeleteNetworkRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest* request, ::google::longrunning::Operation* response) { return this->DeleteNetwork(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteNetwork(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::DeleteNetworkRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::DeleteNetworkRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSubnets() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::ListSubnetsRequest, ::google::cloud::edgenetwork::v1::ListSubnetsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest* request, ::google::cloud::edgenetwork::v1::ListSubnetsResponse* response) { return this->ListSubnets(context, request, response); }));}
    void SetMessageAllocatorFor_ListSubnets(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::ListSubnetsRequest, ::google::cloud::edgenetwork::v1::ListSubnetsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::ListSubnetsRequest, ::google::cloud::edgenetwork::v1::ListSubnetsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSubnets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListSubnetsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetSubnet() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::GetSubnetRequest, ::google::cloud::edgenetwork::v1::Subnet>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::GetSubnetRequest* request, ::google::cloud::edgenetwork::v1::Subnet* response) { return this->GetSubnet(context, request, response); }));}
    void SetMessageAllocatorFor_GetSubnet(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::GetSubnetRequest, ::google::cloud::edgenetwork::v1::Subnet>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::GetSubnetRequest, ::google::cloud::edgenetwork::v1::Subnet>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetSubnetRequest* /*request*/, ::google::cloud::edgenetwork::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSubnet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetSubnetRequest* /*request*/, ::google::cloud::edgenetwork::v1::Subnet* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateSubnet() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::CreateSubnetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest* request, ::google::longrunning::Operation* response) { return this->CreateSubnet(context, request, response); }));}
    void SetMessageAllocatorFor_CreateSubnet(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::CreateSubnetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::CreateSubnetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSubnet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::UpdateSubnetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response) { return this->UpdateSubnet(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateSubnet(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::UpdateSubnetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::UpdateSubnetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSubnet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteSubnet() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::DeleteSubnetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest* request, ::google::longrunning::Operation* response) { return this->DeleteSubnet(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteSubnet(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::DeleteSubnetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::DeleteSubnetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSubnet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListInterconnects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListInterconnects() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::ListInterconnectsRequest, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest* request, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse* response) { return this->ListInterconnects(context, request, response); }));}
    void SetMessageAllocatorFor_ListInterconnects(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::ListInterconnectsRequest, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::ListInterconnectsRequest, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListInterconnects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInterconnects(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInterconnects(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetInterconnect : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetInterconnect() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::GetInterconnectRequest, ::google::cloud::edgenetwork::v1::Interconnect>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest* request, ::google::cloud::edgenetwork::v1::Interconnect* response) { return this->GetInterconnect(context, request, response); }));}
    void SetMessageAllocatorFor_GetInterconnect(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::GetInterconnectRequest, ::google::cloud::edgenetwork::v1::Interconnect>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::GetInterconnectRequest, ::google::cloud::edgenetwork::v1::Interconnect>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetInterconnect() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInterconnect(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest* /*request*/, ::google::cloud::edgenetwork::v1::Interconnect* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInterconnect(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest* /*request*/, ::google::cloud::edgenetwork::v1::Interconnect* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DiagnoseInterconnect : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DiagnoseInterconnect() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse* response) { return this->DiagnoseInterconnect(context, request, response); }));}
    void SetMessageAllocatorFor_DiagnoseInterconnect(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DiagnoseInterconnect() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseInterconnect(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DiagnoseInterconnect(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListInterconnectAttachments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListInterconnectAttachments() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest* request, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse* response) { return this->ListInterconnectAttachments(context, request, response); }));}
    void SetMessageAllocatorFor_ListInterconnectAttachments(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListInterconnectAttachments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInterconnectAttachments(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInterconnectAttachments(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetInterconnectAttachment() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest, ::google::cloud::edgenetwork::v1::InterconnectAttachment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest* request, ::google::cloud::edgenetwork::v1::InterconnectAttachment* response) { return this->GetInterconnectAttachment(context, request, response); }));}
    void SetMessageAllocatorFor_GetInterconnectAttachment(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest, ::google::cloud::edgenetwork::v1::InterconnectAttachment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest, ::google::cloud::edgenetwork::v1::InterconnectAttachment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest* /*request*/, ::google::cloud::edgenetwork::v1::InterconnectAttachment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInterconnectAttachment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest* /*request*/, ::google::cloud::edgenetwork::v1::InterconnectAttachment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateInterconnectAttachment() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest* request, ::google::longrunning::Operation* response) { return this->CreateInterconnectAttachment(context, request, response); }));}
    void SetMessageAllocatorFor_CreateInterconnectAttachment(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInterconnectAttachment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteInterconnectAttachment() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest* request, ::google::longrunning::Operation* response) { return this->DeleteInterconnectAttachment(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteInterconnectAttachment(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInterconnectAttachment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListRouters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListRouters() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::ListRoutersRequest, ::google::cloud::edgenetwork::v1::ListRoutersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::ListRoutersRequest* request, ::google::cloud::edgenetwork::v1::ListRoutersResponse* response) { return this->ListRouters(context, request, response); }));}
    void SetMessageAllocatorFor_ListRouters(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::ListRoutersRequest, ::google::cloud::edgenetwork::v1::ListRoutersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::ListRoutersRequest, ::google::cloud::edgenetwork::v1::ListRoutersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListRouters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRouters(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListRoutersRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListRoutersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRouters(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListRoutersRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListRoutersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetRouter() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::GetRouterRequest, ::google::cloud::edgenetwork::v1::Router>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::GetRouterRequest* request, ::google::cloud::edgenetwork::v1::Router* response) { return this->GetRouter(context, request, response); }));}
    void SetMessageAllocatorFor_GetRouter(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::GetRouterRequest, ::google::cloud::edgenetwork::v1::Router>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::GetRouterRequest, ::google::cloud::edgenetwork::v1::Router>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetRouterRequest* /*request*/, ::google::cloud::edgenetwork::v1::Router* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRouter(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetRouterRequest* /*request*/, ::google::cloud::edgenetwork::v1::Router* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DiagnoseRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DiagnoseRouter() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest* request, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse* response) { return this->DiagnoseRouter(context, request, response); }));}
    void SetMessageAllocatorFor_DiagnoseRouter(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DiagnoseRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DiagnoseRouter(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateRouter() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::CreateRouterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::CreateRouterRequest* request, ::google::longrunning::Operation* response) { return this->CreateRouter(context, request, response); }));}
    void SetMessageAllocatorFor_CreateRouter(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::CreateRouterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::CreateRouterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRouter(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateRouter() {
      ::grpc::Service::MarkMethodCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::UpdateRouterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest* request, ::google::longrunning::Operation* response) { return this->UpdateRouter(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateRouter(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::UpdateRouterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(24);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::UpdateRouterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateRouter(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteRouter() {
      ::grpc::Service::MarkMethodCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::DeleteRouterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest* request, ::google::longrunning::Operation* response) { return this->DeleteRouter(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteRouter(
        ::grpc::MessageAllocator< ::google::cloud::edgenetwork::v1::DeleteRouterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(25);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::edgenetwork::v1::DeleteRouterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteRouter(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_InitializeZone<WithCallbackMethod_ListZones<WithCallbackMethod_GetZone<WithCallbackMethod_ListNetworks<WithCallbackMethod_GetNetwork<WithCallbackMethod_DiagnoseNetwork<WithCallbackMethod_CreateNetwork<WithCallbackMethod_DeleteNetwork<WithCallbackMethod_ListSubnets<WithCallbackMethod_GetSubnet<WithCallbackMethod_CreateSubnet<WithCallbackMethod_UpdateSubnet<WithCallbackMethod_DeleteSubnet<WithCallbackMethod_ListInterconnects<WithCallbackMethod_GetInterconnect<WithCallbackMethod_DiagnoseInterconnect<WithCallbackMethod_ListInterconnectAttachments<WithCallbackMethod_GetInterconnectAttachment<WithCallbackMethod_CreateInterconnectAttachment<WithCallbackMethod_DeleteInterconnectAttachment<WithCallbackMethod_ListRouters<WithCallbackMethod_GetRouter<WithCallbackMethod_DiagnoseRouter<WithCallbackMethod_CreateRouter<WithCallbackMethod_UpdateRouter<WithCallbackMethod_DeleteRouter<Service > > > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_InitializeZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_InitializeZone() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_InitializeZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InitializeZone(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest* /*request*/, ::google::cloud::edgenetwork::v1::InitializeZoneResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListZones : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListZones() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListZones() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListZones(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListZonesRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListZonesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetZone() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetZone(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetZoneRequest* /*request*/, ::google::cloud::edgenetwork::v1::Zone* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListNetworks() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ListNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListNetworksRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetNetwork() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_GetNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetNetworkRequest* /*request*/, ::google::cloud::edgenetwork::v1::Network* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DiagnoseNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DiagnoseNetwork() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_DiagnoseNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateNetwork() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_CreateNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteNetwork() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_DeleteNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSubnets() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetSubnet() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetSubnetRequest* /*request*/, ::google::cloud::edgenetwork::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateSubnet() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_CreateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteSubnet() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_DeleteSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListInterconnects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListInterconnects() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_ListInterconnects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInterconnects(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetInterconnect : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetInterconnect() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_GetInterconnect() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInterconnect(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest* /*request*/, ::google::cloud::edgenetwork::v1::Interconnect* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DiagnoseInterconnect : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DiagnoseInterconnect() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_DiagnoseInterconnect() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseInterconnect(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListInterconnectAttachments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListInterconnectAttachments() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_ListInterconnectAttachments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInterconnectAttachments(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetInterconnectAttachment() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_GetInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest* /*request*/, ::google::cloud::edgenetwork::v1::InterconnectAttachment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateInterconnectAttachment() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_CreateInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteInterconnectAttachment() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_DeleteInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListRouters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListRouters() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_ListRouters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRouters(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListRoutersRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListRoutersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetRouter() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_GetRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetRouterRequest* /*request*/, ::google::cloud::edgenetwork::v1::Router* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DiagnoseRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DiagnoseRouter() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_DiagnoseRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateRouter() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_CreateRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateRouter() {
      ::grpc::Service::MarkMethodGeneric(24);
    }
    ~WithGenericMethod_UpdateRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteRouter() {
      ::grpc::Service::MarkMethodGeneric(25);
    }
    ~WithGenericMethod_DeleteRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_InitializeZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_InitializeZone() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_InitializeZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InitializeZone(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest* /*request*/, ::google::cloud::edgenetwork::v1::InitializeZoneResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInitializeZone(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListZones : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListZones() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListZones() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListZones(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListZonesRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListZonesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListZones(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetZone() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetZone(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetZoneRequest* /*request*/, ::google::cloud::edgenetwork::v1::Zone* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetZone(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListNetworks() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ListNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListNetworksRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNetworks(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetNetwork() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_GetNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetNetworkRequest* /*request*/, ::google::cloud::edgenetwork::v1::Network* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNetwork(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DiagnoseNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DiagnoseNetwork() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_DiagnoseNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDiagnoseNetwork(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateNetwork() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_CreateNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateNetwork(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteNetwork() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_DeleteNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteNetwork(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSubnets() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSubnets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetSubnet() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetSubnetRequest* /*request*/, ::google::cloud::edgenetwork::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSubnet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateSubnet() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_CreateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSubnet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSubnet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteSubnet() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_DeleteSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSubnet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListInterconnects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListInterconnects() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_ListInterconnects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInterconnects(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInterconnects(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetInterconnect : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetInterconnect() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_GetInterconnect() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInterconnect(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest* /*request*/, ::google::cloud::edgenetwork::v1::Interconnect* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInterconnect(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DiagnoseInterconnect : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DiagnoseInterconnect() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_DiagnoseInterconnect() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseInterconnect(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDiagnoseInterconnect(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListInterconnectAttachments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListInterconnectAttachments() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_ListInterconnectAttachments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInterconnectAttachments(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInterconnectAttachments(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetInterconnectAttachment() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_GetInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest* /*request*/, ::google::cloud::edgenetwork::v1::InterconnectAttachment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInterconnectAttachment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateInterconnectAttachment() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_CreateInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInterconnectAttachment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteInterconnectAttachment() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_DeleteInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInterconnectAttachment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListRouters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListRouters() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_ListRouters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRouters(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListRoutersRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListRoutersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRouters(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetRouter() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_GetRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetRouterRequest* /*request*/, ::google::cloud::edgenetwork::v1::Router* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRouter(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DiagnoseRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DiagnoseRouter() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_DiagnoseRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDiagnoseRouter(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateRouter() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_CreateRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateRouter(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateRouter() {
      ::grpc::Service::MarkMethodRaw(24);
    }
    ~WithRawMethod_UpdateRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateRouter(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteRouter() {
      ::grpc::Service::MarkMethodRaw(25);
    }
    ~WithRawMethod_DeleteRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteRouter(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_InitializeZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_InitializeZone() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->InitializeZone(context, request, response); }));
    }
    ~WithRawCallbackMethod_InitializeZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InitializeZone(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest* /*request*/, ::google::cloud::edgenetwork::v1::InitializeZoneResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* InitializeZone(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListZones : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListZones() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListZones(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListZones() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListZones(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListZonesRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListZonesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListZones(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetZone() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetZone(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetZone(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetZoneRequest* /*request*/, ::google::cloud::edgenetwork::v1::Zone* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetZone(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListNetworks() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListNetworks(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListNetworksRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNetworks(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetNetwork() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetNetwork(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetNetworkRequest* /*request*/, ::google::cloud::edgenetwork::v1::Network* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DiagnoseNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DiagnoseNetwork() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DiagnoseNetwork(context, request, response); }));
    }
    ~WithRawCallbackMethod_DiagnoseNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DiagnoseNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateNetwork() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateNetwork(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteNetwork() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteNetwork(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSubnets() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSubnets(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSubnets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetSubnet() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetSubnet(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetSubnetRequest* /*request*/, ::google::cloud::edgenetwork::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSubnet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateSubnet() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateSubnet(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSubnet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateSubnet(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSubnet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteSubnet() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteSubnet(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSubnet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListInterconnects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListInterconnects() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListInterconnects(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListInterconnects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInterconnects(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInterconnects(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetInterconnect : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetInterconnect() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetInterconnect(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetInterconnect() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInterconnect(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest* /*request*/, ::google::cloud::edgenetwork::v1::Interconnect* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInterconnect(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DiagnoseInterconnect : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DiagnoseInterconnect() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DiagnoseInterconnect(context, request, response); }));
    }
    ~WithRawCallbackMethod_DiagnoseInterconnect() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseInterconnect(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DiagnoseInterconnect(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListInterconnectAttachments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListInterconnectAttachments() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListInterconnectAttachments(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListInterconnectAttachments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInterconnectAttachments(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInterconnectAttachments(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetInterconnectAttachment() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetInterconnectAttachment(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest* /*request*/, ::google::cloud::edgenetwork::v1::InterconnectAttachment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInterconnectAttachment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateInterconnectAttachment() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateInterconnectAttachment(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInterconnectAttachment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteInterconnectAttachment() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteInterconnectAttachment(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInterconnectAttachment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListRouters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListRouters() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListRouters(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListRouters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRouters(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListRoutersRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListRoutersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRouters(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetRouter() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetRouter(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetRouterRequest* /*request*/, ::google::cloud::edgenetwork::v1::Router* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRouter(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DiagnoseRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DiagnoseRouter() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DiagnoseRouter(context, request, response); }));
    }
    ~WithRawCallbackMethod_DiagnoseRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DiagnoseRouter(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateRouter() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateRouter(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateRouter(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateRouter() {
      ::grpc::Service::MarkMethodRawCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateRouter(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateRouter(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteRouter() {
      ::grpc::Service::MarkMethodRawCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteRouter(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteRouter(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_InitializeZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_InitializeZone() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::InitializeZoneRequest, ::google::cloud::edgenetwork::v1::InitializeZoneResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::InitializeZoneRequest, ::google::cloud::edgenetwork::v1::InitializeZoneResponse>* streamer) {
                       return this->StreamedInitializeZone(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_InitializeZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status InitializeZone(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::InitializeZoneRequest* /*request*/, ::google::cloud::edgenetwork::v1::InitializeZoneResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedInitializeZone(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::InitializeZoneRequest,::google::cloud::edgenetwork::v1::InitializeZoneResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListZones : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListZones() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::ListZonesRequest, ::google::cloud::edgenetwork::v1::ListZonesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::ListZonesRequest, ::google::cloud::edgenetwork::v1::ListZonesResponse>* streamer) {
                       return this->StreamedListZones(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListZones() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListZones(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListZonesRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListZonesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListZones(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::ListZonesRequest,::google::cloud::edgenetwork::v1::ListZonesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetZone : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetZone() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::GetZoneRequest, ::google::cloud::edgenetwork::v1::Zone>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::GetZoneRequest, ::google::cloud::edgenetwork::v1::Zone>* streamer) {
                       return this->StreamedGetZone(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetZone() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetZone(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetZoneRequest* /*request*/, ::google::cloud::edgenetwork::v1::Zone* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetZone(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::GetZoneRequest,::google::cloud::edgenetwork::v1::Zone>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListNetworks() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::ListNetworksRequest, ::google::cloud::edgenetwork::v1::ListNetworksResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::ListNetworksRequest, ::google::cloud::edgenetwork::v1::ListNetworksResponse>* streamer) {
                       return this->StreamedListNetworks(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListNetworksRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListNetworks(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::ListNetworksRequest,::google::cloud::edgenetwork::v1::ListNetworksResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetNetwork() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::GetNetworkRequest, ::google::cloud::edgenetwork::v1::Network>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::GetNetworkRequest, ::google::cloud::edgenetwork::v1::Network>* streamer) {
                       return this->StreamedGetNetwork(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetNetworkRequest* /*request*/, ::google::cloud::edgenetwork::v1::Network* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetNetwork(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::GetNetworkRequest,::google::cloud::edgenetwork::v1::Network>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DiagnoseNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DiagnoseNetwork() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>* streamer) {
                       return this->StreamedDiagnoseNetwork(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DiagnoseNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DiagnoseNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDiagnoseNetwork(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::DiagnoseNetworkRequest,::google::cloud::edgenetwork::v1::DiagnoseNetworkResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateNetwork() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::CreateNetworkRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::CreateNetworkRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateNetwork(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateNetwork(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::CreateNetworkRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteNetwork() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::DeleteNetworkRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::DeleteNetworkRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteNetwork(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteNetwork(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::DeleteNetworkRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSubnets() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::ListSubnetsRequest, ::google::cloud::edgenetwork::v1::ListSubnetsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::ListSubnetsRequest, ::google::cloud::edgenetwork::v1::ListSubnetsResponse>* streamer) {
                       return this->StreamedListSubnets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListSubnetsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSubnets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::ListSubnetsRequest,::google::cloud::edgenetwork::v1::ListSubnetsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetSubnet() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::GetSubnetRequest, ::google::cloud::edgenetwork::v1::Subnet>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::GetSubnetRequest, ::google::cloud::edgenetwork::v1::Subnet>* streamer) {
                       return this->StreamedGetSubnet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetSubnetRequest* /*request*/, ::google::cloud::edgenetwork::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetSubnet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::GetSubnetRequest,::google::cloud::edgenetwork::v1::Subnet>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateSubnet() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::CreateSubnetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::CreateSubnetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateSubnet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateSubnet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::CreateSubnetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::UpdateSubnetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::UpdateSubnetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateSubnet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateSubnet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::UpdateSubnetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteSubnet() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::DeleteSubnetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::DeleteSubnetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteSubnet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteSubnet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::DeleteSubnetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListInterconnects : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListInterconnects() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::ListInterconnectsRequest, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::ListInterconnectsRequest, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse>* streamer) {
                       return this->StreamedListInterconnects(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListInterconnects() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListInterconnects(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListInterconnectsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListInterconnectsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListInterconnects(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::ListInterconnectsRequest,::google::cloud::edgenetwork::v1::ListInterconnectsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetInterconnect : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetInterconnect() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::GetInterconnectRequest, ::google::cloud::edgenetwork::v1::Interconnect>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::GetInterconnectRequest, ::google::cloud::edgenetwork::v1::Interconnect>* streamer) {
                       return this->StreamedGetInterconnect(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetInterconnect() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetInterconnect(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetInterconnectRequest* /*request*/, ::google::cloud::edgenetwork::v1::Interconnect* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetInterconnect(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::GetInterconnectRequest,::google::cloud::edgenetwork::v1::Interconnect>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DiagnoseInterconnect : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DiagnoseInterconnect() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>* streamer) {
                       return this->StreamedDiagnoseInterconnect(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DiagnoseInterconnect() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DiagnoseInterconnect(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDiagnoseInterconnect(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::DiagnoseInterconnectRequest,::google::cloud::edgenetwork::v1::DiagnoseInterconnectResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListInterconnectAttachments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListInterconnectAttachments() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>* streamer) {
                       return this->StreamedListInterconnectAttachments(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListInterconnectAttachments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListInterconnectAttachments(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListInterconnectAttachments(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsRequest,::google::cloud::edgenetwork::v1::ListInterconnectAttachmentsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetInterconnectAttachment() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest, ::google::cloud::edgenetwork::v1::InterconnectAttachment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest, ::google::cloud::edgenetwork::v1::InterconnectAttachment>* streamer) {
                       return this->StreamedGetInterconnectAttachment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest* /*request*/, ::google::cloud::edgenetwork::v1::InterconnectAttachment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetInterconnectAttachment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::GetInterconnectAttachmentRequest,::google::cloud::edgenetwork::v1::InterconnectAttachment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateInterconnectAttachment() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateInterconnectAttachment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateInterconnectAttachment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::CreateInterconnectAttachmentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteInterconnectAttachment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteInterconnectAttachment() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteInterconnectAttachment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteInterconnectAttachment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteInterconnectAttachment(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteInterconnectAttachment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::DeleteInterconnectAttachmentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListRouters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListRouters() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::ListRoutersRequest, ::google::cloud::edgenetwork::v1::ListRoutersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::ListRoutersRequest, ::google::cloud::edgenetwork::v1::ListRoutersResponse>* streamer) {
                       return this->StreamedListRouters(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListRouters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListRouters(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::ListRoutersRequest* /*request*/, ::google::cloud::edgenetwork::v1::ListRoutersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListRouters(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::ListRoutersRequest,::google::cloud::edgenetwork::v1::ListRoutersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetRouter() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::GetRouterRequest, ::google::cloud::edgenetwork::v1::Router>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::GetRouterRequest, ::google::cloud::edgenetwork::v1::Router>* streamer) {
                       return this->StreamedGetRouter(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::GetRouterRequest* /*request*/, ::google::cloud::edgenetwork::v1::Router* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetRouter(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::GetRouterRequest,::google::cloud::edgenetwork::v1::Router>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DiagnoseRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DiagnoseRouter() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>* streamer) {
                       return this->StreamedDiagnoseRouter(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DiagnoseRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DiagnoseRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest* /*request*/, ::google::cloud::edgenetwork::v1::DiagnoseRouterResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDiagnoseRouter(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::DiagnoseRouterRequest,::google::cloud::edgenetwork::v1::DiagnoseRouterResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateRouter() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::CreateRouterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::CreateRouterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateRouter(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::CreateRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateRouter(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::CreateRouterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateRouter() {
      ::grpc::Service::MarkMethodStreamed(24,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::UpdateRouterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::UpdateRouterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateRouter(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::UpdateRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateRouter(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::UpdateRouterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteRouter : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteRouter() {
      ::grpc::Service::MarkMethodStreamed(25,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::edgenetwork::v1::DeleteRouterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::edgenetwork::v1::DeleteRouterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteRouter(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteRouter() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteRouter(::grpc::ServerContext* /*context*/, const ::google::cloud::edgenetwork::v1::DeleteRouterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteRouter(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::edgenetwork::v1::DeleteRouterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_InitializeZone<WithStreamedUnaryMethod_ListZones<WithStreamedUnaryMethod_GetZone<WithStreamedUnaryMethod_ListNetworks<WithStreamedUnaryMethod_GetNetwork<WithStreamedUnaryMethod_DiagnoseNetwork<WithStreamedUnaryMethod_CreateNetwork<WithStreamedUnaryMethod_DeleteNetwork<WithStreamedUnaryMethod_ListSubnets<WithStreamedUnaryMethod_GetSubnet<WithStreamedUnaryMethod_CreateSubnet<WithStreamedUnaryMethod_UpdateSubnet<WithStreamedUnaryMethod_DeleteSubnet<WithStreamedUnaryMethod_ListInterconnects<WithStreamedUnaryMethod_GetInterconnect<WithStreamedUnaryMethod_DiagnoseInterconnect<WithStreamedUnaryMethod_ListInterconnectAttachments<WithStreamedUnaryMethod_GetInterconnectAttachment<WithStreamedUnaryMethod_CreateInterconnectAttachment<WithStreamedUnaryMethod_DeleteInterconnectAttachment<WithStreamedUnaryMethod_ListRouters<WithStreamedUnaryMethod_GetRouter<WithStreamedUnaryMethod_DiagnoseRouter<WithStreamedUnaryMethod_CreateRouter<WithStreamedUnaryMethod_UpdateRouter<WithStreamedUnaryMethod_DeleteRouter<Service > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_InitializeZone<WithStreamedUnaryMethod_ListZones<WithStreamedUnaryMethod_GetZone<WithStreamedUnaryMethod_ListNetworks<WithStreamedUnaryMethod_GetNetwork<WithStreamedUnaryMethod_DiagnoseNetwork<WithStreamedUnaryMethod_CreateNetwork<WithStreamedUnaryMethod_DeleteNetwork<WithStreamedUnaryMethod_ListSubnets<WithStreamedUnaryMethod_GetSubnet<WithStreamedUnaryMethod_CreateSubnet<WithStreamedUnaryMethod_UpdateSubnet<WithStreamedUnaryMethod_DeleteSubnet<WithStreamedUnaryMethod_ListInterconnects<WithStreamedUnaryMethod_GetInterconnect<WithStreamedUnaryMethod_DiagnoseInterconnect<WithStreamedUnaryMethod_ListInterconnectAttachments<WithStreamedUnaryMethod_GetInterconnectAttachment<WithStreamedUnaryMethod_CreateInterconnectAttachment<WithStreamedUnaryMethod_DeleteInterconnectAttachment<WithStreamedUnaryMethod_ListRouters<WithStreamedUnaryMethod_GetRouter<WithStreamedUnaryMethod_DiagnoseRouter<WithStreamedUnaryMethod_CreateRouter<WithStreamedUnaryMethod_UpdateRouter<WithStreamedUnaryMethod_DeleteRouter<Service > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace edgenetwork
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fedgenetwork_2fv1_2fservice_2eproto__INCLUDED
