// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/vmwareengine/v1/vmwareengine.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fvmwareengine_2fv1_2fvmwareengine_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fvmwareengine_2fv1_2fvmwareengine_2eproto__INCLUDED

#include "google/cloud/vmwareengine/v1/vmwareengine.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace vmwareengine {
namespace v1 {

// VMwareEngine manages VMware's private clusters in the Cloud.
class VmwareEngine final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.vmwareengine.v1.VmwareEngine";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists `PrivateCloud` resources in a given project and location.
    virtual ::grpc::Status ListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>> AsyncListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>>(AsyncListPrivateCloudsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>> PrepareAsyncListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>>(PrepareAsyncListPrivateCloudsRaw(context, request, cq));
    }
    // Retrieves a `PrivateCloud` resource by its resource name.
    virtual ::grpc::Status GetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::google::cloud::vmwareengine::v1::PrivateCloud* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateCloud>> AsyncGetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateCloud>>(AsyncGetPrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateCloud>> PrepareAsyncGetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateCloud>>(PrepareAsyncGetPrivateCloudRaw(context, request, cq));
    }
    // Creates a new `PrivateCloud` resource in a given project and location.
    // Private clouds of type `STANDARD` and
    // `TIME_LIMITED` are zonal resources, `STRETCHED` private clouds are
    // regional.
    // Creating a private cloud also creates a [management
    // cluster](https://cloud.google.com/vmware-engine/docs/concepts-vmware-components)
    // for that private cloud.
    virtual ::grpc::Status CreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreatePrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreatePrivateCloudRaw(context, request, cq));
    }
    // Modifies a `PrivateCloud` resource. Only the following fields can be
    // updated: `description`.
    // Only fields specified in `updateMask` are applied.
    //
    // During operation processing, the resource is temporarily in the `ACTIVE`
    // state before the operation fully completes. For that period of time, you
    // can't update the resource. Use the operation status to determine when the
    // processing fully completes.
    virtual ::grpc::Status UpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdatePrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdatePrivateCloudRaw(context, request, cq));
    }
    // Schedules a `PrivateCloud` resource for deletion.
    //
    // A `PrivateCloud` resource scheduled for deletion has `PrivateCloud.state`
    // set to `DELETED` and `expireTime` set to the time when deletion is final
    // and can no longer be reversed. The delete operation is marked as done
    // as soon as the `PrivateCloud` is successfully scheduled for deletion
    // (this also applies when `delayHours` is set to zero), and the operation is
    // not kept in pending state until `PrivateCloud` is purged.
    // `PrivateCloud` can be restored using `UndeletePrivateCloud` method before
    // the `expireTime` elapses. When `expireTime` is reached, deletion is final
    // and all private cloud resources are irreversibly removed and billing stops.
    // During the final removal process, `PrivateCloud.state` is set to `PURGING`.
    // `PrivateCloud` can be polled using standard `GET` method for the whole
    // period of deletion and purging. It will not be returned only
    // when it is completely purged.
    virtual ::grpc::Status DeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeletePrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeletePrivateCloudRaw(context, request, cq));
    }
    // Restores a private cloud that was previously scheduled for deletion by
    // `DeletePrivateCloud`. A `PrivateCloud` resource scheduled for deletion has
    // `PrivateCloud.state` set to `DELETED` and `PrivateCloud.expireTime` set to
    // the time when deletion can no longer be reversed.
    virtual ::grpc::Status UndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUndeletePrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUndeletePrivateCloudRaw(context, request, cq));
    }
    // Lists `Cluster` resources in a given private cloud.
    virtual ::grpc::Status ListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::google::cloud::vmwareengine::v1::ListClustersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListClustersResponse>> AsyncListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListClustersResponse>>(AsyncListClustersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListClustersResponse>> PrepareAsyncListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListClustersResponse>>(PrepareAsyncListClustersRaw(context, request, cq));
    }
    // Retrieves a `Cluster` resource by its resource name.
    virtual ::grpc::Status GetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::google::cloud::vmwareengine::v1::Cluster* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Cluster>> AsyncGetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Cluster>>(AsyncGetClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Cluster>> PrepareAsyncGetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Cluster>>(PrepareAsyncGetClusterRaw(context, request, cq));
    }
    // Creates a new cluster in a given private cloud.
    // Creating a new cluster provides additional nodes for
    // use in the parent private cloud and requires sufficient [node
    // quota](https://cloud.google.com/vmware-engine/quotas).
    virtual ::grpc::Status CreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateClusterRaw(context, request, cq));
    }
    // Modifies a `Cluster` resource. Only fields specified in `updateMask` are
    // applied.
    //
    // During operation processing, the resource is temporarily in the `ACTIVE`
    // state before the operation fully completes. For that period of time, you
    // can't update the resource. Use the operation status to determine when the
    // processing fully completes.
    virtual ::grpc::Status UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateClusterRaw(context, request, cq));
    }
    // Deletes a `Cluster` resource. To avoid unintended data loss, migrate or
    // gracefully shut down any workloads running on the cluster before deletion.
    // You cannot delete the management cluster of a private cloud using this
    // method.
    virtual ::grpc::Status DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteClusterRaw(context, request, cq));
    }
    // Lists nodes in a given cluster.
    virtual ::grpc::Status ListNodes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodesRequest& request, ::google::cloud::vmwareengine::v1::ListNodesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodesResponse>> AsyncListNodes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodesResponse>>(AsyncListNodesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodesResponse>> PrepareAsyncListNodes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodesResponse>>(PrepareAsyncListNodesRaw(context, request, cq));
    }
    // Gets details of a single node.
    virtual ::grpc::Status GetNode(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeRequest& request, ::google::cloud::vmwareengine::v1::Node* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Node>> AsyncGetNode(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Node>>(AsyncGetNodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Node>> PrepareAsyncGetNode(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Node>>(PrepareAsyncGetNodeRaw(context, request, cq));
    }
    // Lists external IP addresses assigned to VMware workload VMs in a given
    // private cloud.
    virtual ::grpc::Status ListExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest& request, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>> AsyncListExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>>(AsyncListExternalAddressesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>> PrepareAsyncListExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>>(PrepareAsyncListExternalAddressesRaw(context, request, cq));
    }
    // Lists external IP addresses assigned to VMware workload VMs within the
    // scope of the given network policy.
    virtual ::grpc::Status FetchNetworkPolicyExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest& request, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>> AsyncFetchNetworkPolicyExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>>(AsyncFetchNetworkPolicyExternalAddressesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>> PrepareAsyncFetchNetworkPolicyExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>>(PrepareAsyncFetchNetworkPolicyExternalAddressesRaw(context, request, cq));
    }
    // Gets details of a single external IP address.
    virtual ::grpc::Status GetExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest& request, ::google::cloud::vmwareengine::v1::ExternalAddress* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ExternalAddress>> AsyncGetExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ExternalAddress>>(AsyncGetExternalAddressRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ExternalAddress>> PrepareAsyncGetExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ExternalAddress>>(PrepareAsyncGetExternalAddressRaw(context, request, cq));
    }
    // Creates a new `ExternalAddress` resource in a given private cloud. The
    // network policy that corresponds to the private cloud must have the external
    // IP address network service enabled (`NetworkPolicy.external_ip`).
    virtual ::grpc::Status CreateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateExternalAddressRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateExternalAddressRaw(context, request, cq));
    }
    // Updates the parameters of a single external IP address.
    // Only fields specified in `update_mask` are applied.
    //
    // During operation processing, the resource is temporarily in the `ACTIVE`
    // state before the operation fully completes. For that period of time, you
    // can't update the resource. Use the operation status to determine when the
    // processing fully completes.
    virtual ::grpc::Status UpdateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateExternalAddressRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateExternalAddressRaw(context, request, cq));
    }
    // Deletes a single external IP address. When you delete an external IP
    // address, connectivity between the external IP address and the corresponding
    // internal IP address is lost.
    virtual ::grpc::Status DeleteExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteExternalAddressRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteExternalAddressRaw(context, request, cq));
    }
    // Lists subnets in a given private cloud.
    virtual ::grpc::Status ListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>> AsyncListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>>(AsyncListSubnetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>> PrepareAsyncListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>>(PrepareAsyncListSubnetsRaw(context, request, cq));
    }
    // Gets details of a single subnet.
    virtual ::grpc::Status GetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::google::cloud::vmwareengine::v1::Subnet* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Subnet>> AsyncGetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Subnet>>(AsyncGetSubnetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Subnet>> PrepareAsyncGetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Subnet>>(PrepareAsyncGetSubnetRaw(context, request, cq));
    }
    // Updates the parameters of a single subnet. Only fields specified in
    // `update_mask` are applied.
    //
    // *Note*: This API is synchronous and always returns a successful
    // `google.longrunning.Operation` (LRO). The returned LRO will only have
    // `done` and `response` fields.
    virtual ::grpc::Status UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateSubnetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateSubnetRaw(context, request, cq));
    }
    // Lists `ExternalAccessRule` resources in the specified network policy.
    virtual ::grpc::Status ListExternalAccessRules(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest& request, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>> AsyncListExternalAccessRules(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>>(AsyncListExternalAccessRulesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>> PrepareAsyncListExternalAccessRules(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>>(PrepareAsyncListExternalAccessRulesRaw(context, request, cq));
    }
    // Gets details of a single external access rule.
    virtual ::grpc::Status GetExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest& request, ::google::cloud::vmwareengine::v1::ExternalAccessRule* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ExternalAccessRule>> AsyncGetExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ExternalAccessRule>>(AsyncGetExternalAccessRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ExternalAccessRule>> PrepareAsyncGetExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ExternalAccessRule>>(PrepareAsyncGetExternalAccessRuleRaw(context, request, cq));
    }
    // Creates a new external access rule in a given network policy.
    virtual ::grpc::Status CreateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateExternalAccessRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateExternalAccessRuleRaw(context, request, cq));
    }
    // Updates the parameters of a single external access rule.
    // Only fields specified in `update_mask` are applied.
    virtual ::grpc::Status UpdateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateExternalAccessRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateExternalAccessRuleRaw(context, request, cq));
    }
    // Deletes a single external access rule.
    virtual ::grpc::Status DeleteExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteExternalAccessRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteExternalAccessRuleRaw(context, request, cq));
    }
    // Lists logging servers configured for a given private
    // cloud.
    virtual ::grpc::Status ListLoggingServers(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest& request, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>> AsyncListLoggingServers(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>>(AsyncListLoggingServersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>> PrepareAsyncListLoggingServers(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>>(PrepareAsyncListLoggingServersRaw(context, request, cq));
    }
    // Gets details of a logging server.
    virtual ::grpc::Status GetLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest& request, ::google::cloud::vmwareengine::v1::LoggingServer* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::LoggingServer>> AsyncGetLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::LoggingServer>>(AsyncGetLoggingServerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::LoggingServer>> PrepareAsyncGetLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::LoggingServer>>(PrepareAsyncGetLoggingServerRaw(context, request, cq));
    }
    // Create a new logging server for a given private cloud.
    virtual ::grpc::Status CreateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateLoggingServerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateLoggingServerRaw(context, request, cq));
    }
    // Updates the parameters of a single logging server.
    // Only fields specified in `update_mask` are applied.
    virtual ::grpc::Status UpdateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateLoggingServerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateLoggingServerRaw(context, request, cq));
    }
    // Deletes a single logging server.
    virtual ::grpc::Status DeleteLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteLoggingServerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteLoggingServerRaw(context, request, cq));
    }
    // Lists node types
    virtual ::grpc::Status ListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>> AsyncListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>>(AsyncListNodeTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>> PrepareAsyncListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>>(PrepareAsyncListNodeTypesRaw(context, request, cq));
    }
    // Gets details of a single `NodeType`.
    virtual ::grpc::Status GetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::google::cloud::vmwareengine::v1::NodeType* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NodeType>> AsyncGetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NodeType>>(AsyncGetNodeTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NodeType>> PrepareAsyncGetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NodeType>>(PrepareAsyncGetNodeTypeRaw(context, request, cq));
    }
    // Gets details of credentials for NSX appliance.
    virtual ::grpc::Status ShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::google::cloud::vmwareengine::v1::Credentials* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>> AsyncShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>>(AsyncShowNsxCredentialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>> PrepareAsyncShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>>(PrepareAsyncShowNsxCredentialsRaw(context, request, cq));
    }
    // Gets details of credentials for Vcenter appliance.
    virtual ::grpc::Status ShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::google::cloud::vmwareengine::v1::Credentials* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>> AsyncShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>>(AsyncShowVcenterCredentialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>> PrepareAsyncShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>>(PrepareAsyncShowVcenterCredentialsRaw(context, request, cq));
    }
    // Resets credentials of the NSX appliance.
    virtual ::grpc::Status ResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncResetNsxCredentialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncResetNsxCredentialsRaw(context, request, cq));
    }
    // Resets credentials of the Vcenter appliance.
    virtual ::grpc::Status ResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncResetVcenterCredentialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncResetVcenterCredentialsRaw(context, request, cq));
    }
    // Gets details of the `DnsForwarding` config.
    virtual ::grpc::Status GetDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest& request, ::google::cloud::vmwareengine::v1::DnsForwarding* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::DnsForwarding>> AsyncGetDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::DnsForwarding>>(AsyncGetDnsForwardingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::DnsForwarding>> PrepareAsyncGetDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::DnsForwarding>>(PrepareAsyncGetDnsForwardingRaw(context, request, cq));
    }
    // Updates the parameters of the `DnsForwarding` config, like associated
    // domains. Only fields specified in `update_mask` are applied.
    virtual ::grpc::Status UpdateDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateDnsForwardingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateDnsForwardingRaw(context, request, cq));
    }
    // Retrieves a `NetworkPeering` resource by its resource name. The resource
    // contains details of the network peering, such as peered
    // networks, import and export custom route configurations, and peering state.
    // NetworkPeering is a global resource and location can only be global.
    virtual ::grpc::Status GetNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest& request, ::google::cloud::vmwareengine::v1::NetworkPeering* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPeering>> AsyncGetNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPeering>>(AsyncGetNetworkPeeringRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPeering>> PrepareAsyncGetNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPeering>>(PrepareAsyncGetNetworkPeeringRaw(context, request, cq));
    }
    // Lists `NetworkPeering` resources in a given project. NetworkPeering is a
    // global resource and location can only be global.
    virtual ::grpc::Status ListNetworkPeerings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest& request, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>> AsyncListNetworkPeerings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>>(AsyncListNetworkPeeringsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>> PrepareAsyncListNetworkPeerings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>>(PrepareAsyncListNetworkPeeringsRaw(context, request, cq));
    }
    // Creates a new network peering between the peer network and VMware Engine
    // network provided in a `NetworkPeering` resource. NetworkPeering is a
    // global resource and location can only be global.
    virtual ::grpc::Status CreateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateNetworkPeeringRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateNetworkPeeringRaw(context, request, cq));
    }
    // Deletes a `NetworkPeering` resource. When a network peering is deleted for
    // a VMware Engine network, the peer network becomes inaccessible to that
    // VMware Engine network. NetworkPeering is a global resource and location can
    // only be global.
    virtual ::grpc::Status DeleteNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteNetworkPeeringRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteNetworkPeeringRaw(context, request, cq));
    }
    // Modifies a `NetworkPeering` resource. Only the `description` field can be
    // updated. Only fields specified in `updateMask` are applied. NetworkPeering
    // is a global resource and location can only be global.
    virtual ::grpc::Status UpdateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateNetworkPeeringRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateNetworkPeeringRaw(context, request, cq));
    }
    // Lists the network peering routes exchanged over a peering connection.
    // NetworkPeering is a global resource and location can only be global.
    virtual ::grpc::Status ListPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest& request, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>> AsyncListPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>>(AsyncListPeeringRoutesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>> PrepareAsyncListPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>>(PrepareAsyncListPeeringRoutesRaw(context, request, cq));
    }
    // Creates a new HCX activation key in a given private cloud.
    virtual ::grpc::Status CreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateHcxActivationKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateHcxActivationKeyRaw(context, request, cq));
    }
    // Lists `HcxActivationKey` resources in a given private cloud.
    virtual ::grpc::Status ListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>> AsyncListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>>(AsyncListHcxActivationKeysRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>> PrepareAsyncListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>>(PrepareAsyncListHcxActivationKeysRaw(context, request, cq));
    }
    // Retrieves a `HcxActivationKey` resource by its resource name.
    virtual ::grpc::Status GetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::google::cloud::vmwareengine::v1::HcxActivationKey* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::HcxActivationKey>> AsyncGetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::HcxActivationKey>>(AsyncGetHcxActivationKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::HcxActivationKey>> PrepareAsyncGetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::HcxActivationKey>>(PrepareAsyncGetHcxActivationKeyRaw(context, request, cq));
    }
    // Retrieves a `NetworkPolicy` resource by its resource name.
    virtual ::grpc::Status GetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::google::cloud::vmwareengine::v1::NetworkPolicy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPolicy>> AsyncGetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPolicy>>(AsyncGetNetworkPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPolicy>> PrepareAsyncGetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPolicy>>(PrepareAsyncGetNetworkPolicyRaw(context, request, cq));
    }
    // Lists `NetworkPolicy` resources in a specified project and location.
    virtual ::grpc::Status ListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>> AsyncListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>>(AsyncListNetworkPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>> PrepareAsyncListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>>(PrepareAsyncListNetworkPoliciesRaw(context, request, cq));
    }
    // Creates a new network policy in a given VMware Engine network of a
    // project and location (region). A new network policy cannot be created if
    // another network policy already exists in the same scope.
    virtual ::grpc::Status CreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateNetworkPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateNetworkPolicyRaw(context, request, cq));
    }
    // Modifies a `NetworkPolicy` resource. Only the following fields can be
    // updated: `internet_access`, `external_ip`, `edge_services_cidr`.
    // Only fields specified in `updateMask` are applied. When updating a network
    // policy, the external IP network service can only be disabled if there are
    // no external IP addresses present in the scope of the policy. Also, a
    // `NetworkService` cannot be updated when `NetworkService.state` is set
    // to `RECONCILING`.
    //
    // During operation processing, the resource is temporarily in the `ACTIVE`
    // state before the operation fully completes. For that period of time, you
    // can't update the resource. Use the operation status to determine when the
    // processing fully completes.
    virtual ::grpc::Status UpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateNetworkPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateNetworkPolicyRaw(context, request, cq));
    }
    // Deletes a `NetworkPolicy` resource. A network policy cannot be deleted
    // when `NetworkService.state` is set to `RECONCILING` for either its external
    // IP or internet access service.
    virtual ::grpc::Status DeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteNetworkPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteNetworkPolicyRaw(context, request, cq));
    }
    // Lists Consumer VPCs bound to Management DNS Zone of a given private cloud.
    virtual ::grpc::Status ListManagementDnsZoneBindings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest& request, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>> AsyncListManagementDnsZoneBindings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>>(AsyncListManagementDnsZoneBindingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>> PrepareAsyncListManagementDnsZoneBindings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>>(PrepareAsyncListManagementDnsZoneBindingsRaw(context, request, cq));
    }
    // Retrieves a 'ManagementDnsZoneBinding' resource by its resource name.
    virtual ::grpc::Status GetManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest& request, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>> AsyncGetManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>>(AsyncGetManagementDnsZoneBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>> PrepareAsyncGetManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>>(PrepareAsyncGetManagementDnsZoneBindingRaw(context, request, cq));
    }
    // Creates a new `ManagementDnsZoneBinding` resource in a private cloud.
    // This RPC creates the DNS binding and the resource that represents the
    // DNS binding of the consumer VPC network to the management DNS zone. A
    // management DNS zone is the Cloud DNS cross-project binding zone that
    // VMware Engine creates for each private cloud. It contains FQDNs and
    // corresponding IP addresses for the private cloud's ESXi hosts and
    // management VM appliances like vCenter and NSX Manager.
    virtual ::grpc::Status CreateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateManagementDnsZoneBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateManagementDnsZoneBindingRaw(context, request, cq));
    }
    // Updates a `ManagementDnsZoneBinding` resource.
    // Only fields specified in `update_mask` are applied.
    virtual ::grpc::Status UpdateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateManagementDnsZoneBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateManagementDnsZoneBindingRaw(context, request, cq));
    }
    // Deletes a `ManagementDnsZoneBinding` resource. When a management DNS zone
    // binding is deleted, the corresponding consumer VPC network is no longer
    // bound to the management DNS zone.
    virtual ::grpc::Status DeleteManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteManagementDnsZoneBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteManagementDnsZoneBindingRaw(context, request, cq));
    }
    // Retries to create a `ManagementDnsZoneBinding` resource that is
    // in failed state.
    virtual ::grpc::Status RepairManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRepairManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRepairManagementDnsZoneBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRepairManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRepairManagementDnsZoneBindingRaw(context, request, cq));
    }
    // Creates a new VMware Engine network that can be used by a private cloud.
    virtual ::grpc::Status CreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateVmwareEngineNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateVmwareEngineNetworkRaw(context, request, cq));
    }
    // Modifies a VMware Engine network resource. Only the following fields can be
    // updated: `description`. Only fields specified in `updateMask` are
    // applied.
    virtual ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateVmwareEngineNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateVmwareEngineNetworkRaw(context, request, cq));
    }
    // Deletes a `VmwareEngineNetwork` resource. You can only delete a VMware
    // Engine network after all resources that refer to it are deleted. For
    // example, a private cloud, a network peering, and a network policy can all
    // refer to the same VMware Engine network.
    virtual ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteVmwareEngineNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteVmwareEngineNetworkRaw(context, request, cq));
    }
    // Retrieves a `VmwareEngineNetwork` resource by its resource name. The
    // resource contains details of the VMware Engine network, such as its VMware
    // Engine network type, peered networks in a service project, and state
    // (for example, `CREATING`, `ACTIVE`, `DELETING`).
    virtual ::grpc::Status GetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>> AsyncGetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>>(AsyncGetVmwareEngineNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>> PrepareAsyncGetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>>(PrepareAsyncGetVmwareEngineNetworkRaw(context, request, cq));
    }
    // Lists `VmwareEngineNetwork` resources in a given project and location.
    virtual ::grpc::Status ListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>> AsyncListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>>(AsyncListVmwareEngineNetworksRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>> PrepareAsyncListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>>(PrepareAsyncListVmwareEngineNetworksRaw(context, request, cq));
    }
    // Creates a new private connection that can be used for accessing private
    // Clouds.
    virtual ::grpc::Status CreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreatePrivateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreatePrivateConnectionRaw(context, request, cq));
    }
    // Retrieves a `PrivateConnection` resource by its resource name. The resource
    // contains details of the private connection, such as connected
    // network, routing mode and state.
    virtual ::grpc::Status GetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::google::cloud::vmwareengine::v1::PrivateConnection* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateConnection>> AsyncGetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateConnection>>(AsyncGetPrivateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateConnection>> PrepareAsyncGetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateConnection>>(PrepareAsyncGetPrivateConnectionRaw(context, request, cq));
    }
    // Lists `PrivateConnection` resources in a given project and location.
    virtual ::grpc::Status ListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>> AsyncListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>>(AsyncListPrivateConnectionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>> PrepareAsyncListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>>(PrepareAsyncListPrivateConnectionsRaw(context, request, cq));
    }
    // Modifies a `PrivateConnection` resource. Only `description` and
    // `routing_mode` fields can be updated. Only fields specified in `updateMask`
    // are applied.
    virtual ::grpc::Status UpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdatePrivateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdatePrivateConnectionRaw(context, request, cq));
    }
    // Deletes a `PrivateConnection` resource. When a private connection is
    // deleted for a VMware Engine network, the connected network becomes
    // inaccessible to that VMware Engine network.
    virtual ::grpc::Status DeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeletePrivateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeletePrivateConnectionRaw(context, request, cq));
    }
    // Lists the private connection routes exchanged over a peering connection.
    virtual ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>> AsyncListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>>(AsyncListPrivateConnectionPeeringRoutesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>> PrepareAsyncListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>>(PrepareAsyncListPrivateConnectionPeeringRoutesRaw(context, request, cq));
    }
    // Grants the bind permission to the customer provided principal(user /
    // service account) to bind their DNS zone with the intranet VPC associated
    // with the project. DnsBindPermission is a global resource and location can
    // only be global.
    virtual ::grpc::Status GrantDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncGrantDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncGrantDnsBindPermissionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncGrantDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncGrantDnsBindPermissionRaw(context, request, cq));
    }
    // Gets all the principals having bind permission on the intranet VPC
    // associated with the consumer project granted by the Grant API.
    // DnsBindPermission is a global resource and location can only be global.
    virtual ::grpc::Status GetDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest& request, ::google::cloud::vmwareengine::v1::DnsBindPermission* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::DnsBindPermission>> AsyncGetDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::DnsBindPermission>>(AsyncGetDnsBindPermissionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::DnsBindPermission>> PrepareAsyncGetDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::DnsBindPermission>>(PrepareAsyncGetDnsBindPermissionRaw(context, request, cq));
    }
    // Revokes the bind permission from the customer provided principal(user /
    // service account) on the intranet VPC associated with the consumer project.
    // DnsBindPermission is a global resource and location can only be global.
    virtual ::grpc::Status RevokeDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRevokeDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRevokeDnsBindPermissionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRevokeDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRevokeDnsBindPermissionRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists `PrivateCloud` resources in a given project and location.
      virtual void ListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a `PrivateCloud` resource by its resource name.
      virtual void GetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* request, ::google::cloud::vmwareengine::v1::PrivateCloud* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* request, ::google::cloud::vmwareengine::v1::PrivateCloud* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new `PrivateCloud` resource in a given project and location.
      // Private clouds of type `STANDARD` and
      // `TIME_LIMITED` are zonal resources, `STRETCHED` private clouds are
      // regional.
      // Creating a private cloud also creates a [management
      // cluster](https://cloud.google.com/vmware-engine/docs/concepts-vmware-components)
      // for that private cloud.
      virtual void CreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Modifies a `PrivateCloud` resource. Only the following fields can be
      // updated: `description`.
      // Only fields specified in `updateMask` are applied.
      //
      // During operation processing, the resource is temporarily in the `ACTIVE`
      // state before the operation fully completes. For that period of time, you
      // can't update the resource. Use the operation status to determine when the
      // processing fully completes.
      virtual void UpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Schedules a `PrivateCloud` resource for deletion.
      //
      // A `PrivateCloud` resource scheduled for deletion has `PrivateCloud.state`
      // set to `DELETED` and `expireTime` set to the time when deletion is final
      // and can no longer be reversed. The delete operation is marked as done
      // as soon as the `PrivateCloud` is successfully scheduled for deletion
      // (this also applies when `delayHours` is set to zero), and the operation is
      // not kept in pending state until `PrivateCloud` is purged.
      // `PrivateCloud` can be restored using `UndeletePrivateCloud` method before
      // the `expireTime` elapses. When `expireTime` is reached, deletion is final
      // and all private cloud resources are irreversibly removed and billing stops.
      // During the final removal process, `PrivateCloud.state` is set to `PURGING`.
      // `PrivateCloud` can be polled using standard `GET` method for the whole
      // period of deletion and purging. It will not be returned only
      // when it is completely purged.
      virtual void DeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Restores a private cloud that was previously scheduled for deletion by
      // `DeletePrivateCloud`. A `PrivateCloud` resource scheduled for deletion has
      // `PrivateCloud.state` set to `DELETED` and `PrivateCloud.expireTime` set to
      // the time when deletion can no longer be reversed.
      virtual void UndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists `Cluster` resources in a given private cloud.
      virtual void ListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest* request, ::google::cloud::vmwareengine::v1::ListClustersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest* request, ::google::cloud::vmwareengine::v1::ListClustersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a `Cluster` resource by its resource name.
      virtual void GetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest* request, ::google::cloud::vmwareengine::v1::Cluster* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest* request, ::google::cloud::vmwareengine::v1::Cluster* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new cluster in a given private cloud.
      // Creating a new cluster provides additional nodes for
      // use in the parent private cloud and requires sufficient [node
      // quota](https://cloud.google.com/vmware-engine/quotas).
      virtual void CreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Modifies a `Cluster` resource. Only fields specified in `updateMask` are
      // applied.
      //
      // During operation processing, the resource is temporarily in the `ACTIVE`
      // state before the operation fully completes. For that period of time, you
      // can't update the resource. Use the operation status to determine when the
      // processing fully completes.
      virtual void UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a `Cluster` resource. To avoid unintended data loss, migrate or
      // gracefully shut down any workloads running on the cluster before deletion.
      // You cannot delete the management cluster of a private cloud using this
      // method.
      virtual void DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists nodes in a given cluster.
      virtual void ListNodes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodesRequest* request, ::google::cloud::vmwareengine::v1::ListNodesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListNodes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodesRequest* request, ::google::cloud::vmwareengine::v1::ListNodesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single node.
      virtual void GetNode(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeRequest* request, ::google::cloud::vmwareengine::v1::Node* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetNode(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeRequest* request, ::google::cloud::vmwareengine::v1::Node* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists external IP addresses assigned to VMware workload VMs in a given
      // private cloud.
      virtual void ListExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest* request, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest* request, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists external IP addresses assigned to VMware workload VMs within the
      // scope of the given network policy.
      virtual void FetchNetworkPolicyExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest* request, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void FetchNetworkPolicyExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest* request, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single external IP address.
      virtual void GetExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest* request, ::google::cloud::vmwareengine::v1::ExternalAddress* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest* request, ::google::cloud::vmwareengine::v1::ExternalAddress* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new `ExternalAddress` resource in a given private cloud. The
      // network policy that corresponds to the private cloud must have the external
      // IP address network service enabled (`NetworkPolicy.external_ip`).
      virtual void CreateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single external IP address.
      // Only fields specified in `update_mask` are applied.
      //
      // During operation processing, the resource is temporarily in the `ACTIVE`
      // state before the operation fully completes. For that period of time, you
      // can't update the resource. Use the operation status to determine when the
      // processing fully completes.
      virtual void UpdateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single external IP address. When you delete an external IP
      // address, connectivity between the external IP address and the corresponding
      // internal IP address is lost.
      virtual void DeleteExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists subnets in a given private cloud.
      virtual void ListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* request, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* request, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single subnet.
      virtual void GetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* request, ::google::cloud::vmwareengine::v1::Subnet* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* request, ::google::cloud::vmwareengine::v1::Subnet* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single subnet. Only fields specified in
      // `update_mask` are applied.
      //
      // *Note*: This API is synchronous and always returns a successful
      // `google.longrunning.Operation` (LRO). The returned LRO will only have
      // `done` and `response` fields.
      virtual void UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists `ExternalAccessRule` resources in the specified network policy.
      virtual void ListExternalAccessRules(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest* request, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListExternalAccessRules(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest* request, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single external access rule.
      virtual void GetExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest* request, ::google::cloud::vmwareengine::v1::ExternalAccessRule* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest* request, ::google::cloud::vmwareengine::v1::ExternalAccessRule* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new external access rule in a given network policy.
      virtual void CreateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single external access rule.
      // Only fields specified in `update_mask` are applied.
      virtual void UpdateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single external access rule.
      virtual void DeleteExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists logging servers configured for a given private
      // cloud.
      virtual void ListLoggingServers(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest* request, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListLoggingServers(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest* request, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a logging server.
      virtual void GetLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest* request, ::google::cloud::vmwareengine::v1::LoggingServer* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest* request, ::google::cloud::vmwareengine::v1::LoggingServer* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Create a new logging server for a given private cloud.
      virtual void CreateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single logging server.
      // Only fields specified in `update_mask` are applied.
      virtual void UpdateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single logging server.
      virtual void DeleteLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists node types
      virtual void ListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* request, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* request, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single `NodeType`.
      virtual void GetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* request, ::google::cloud::vmwareengine::v1::NodeType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* request, ::google::cloud::vmwareengine::v1::NodeType* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of credentials for NSX appliance.
      virtual void ShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of credentials for Vcenter appliance.
      virtual void ShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Resets credentials of the NSX appliance.
      virtual void ResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Resets credentials of the Vcenter appliance.
      virtual void ResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of the `DnsForwarding` config.
      virtual void GetDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest* request, ::google::cloud::vmwareengine::v1::DnsForwarding* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest* request, ::google::cloud::vmwareengine::v1::DnsForwarding* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of the `DnsForwarding` config, like associated
      // domains. Only fields specified in `update_mask` are applied.
      virtual void UpdateDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a `NetworkPeering` resource by its resource name. The resource
      // contains details of the network peering, such as peered
      // networks, import and export custom route configurations, and peering state.
      // NetworkPeering is a global resource and location can only be global.
      virtual void GetNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest* request, ::google::cloud::vmwareengine::v1::NetworkPeering* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest* request, ::google::cloud::vmwareengine::v1::NetworkPeering* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists `NetworkPeering` resources in a given project. NetworkPeering is a
      // global resource and location can only be global.
      virtual void ListNetworkPeerings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListNetworkPeerings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new network peering between the peer network and VMware Engine
      // network provided in a `NetworkPeering` resource. NetworkPeering is a
      // global resource and location can only be global.
      virtual void CreateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a `NetworkPeering` resource. When a network peering is deleted for
      // a VMware Engine network, the peer network becomes inaccessible to that
      // VMware Engine network. NetworkPeering is a global resource and location can
      // only be global.
      virtual void DeleteNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Modifies a `NetworkPeering` resource. Only the `description` field can be
      // updated. Only fields specified in `updateMask` are applied. NetworkPeering
      // is a global resource and location can only be global.
      virtual void UpdateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the network peering routes exchanged over a peering connection.
      // NetworkPeering is a global resource and location can only be global.
      virtual void ListPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new HCX activation key in a given private cloud.
      virtual void CreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists `HcxActivationKey` resources in a given private cloud.
      virtual void ListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* request, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* request, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a `HcxActivationKey` resource by its resource name.
      virtual void GetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* request, ::google::cloud::vmwareengine::v1::HcxActivationKey* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* request, ::google::cloud::vmwareengine::v1::HcxActivationKey* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a `NetworkPolicy` resource by its resource name.
      virtual void GetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* request, ::google::cloud::vmwareengine::v1::NetworkPolicy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* request, ::google::cloud::vmwareengine::v1::NetworkPolicy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists `NetworkPolicy` resources in a specified project and location.
      virtual void ListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new network policy in a given VMware Engine network of a
      // project and location (region). A new network policy cannot be created if
      // another network policy already exists in the same scope.
      virtual void CreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Modifies a `NetworkPolicy` resource. Only the following fields can be
      // updated: `internet_access`, `external_ip`, `edge_services_cidr`.
      // Only fields specified in `updateMask` are applied. When updating a network
      // policy, the external IP network service can only be disabled if there are
      // no external IP addresses present in the scope of the policy. Also, a
      // `NetworkService` cannot be updated when `NetworkService.state` is set
      // to `RECONCILING`.
      //
      // During operation processing, the resource is temporarily in the `ACTIVE`
      // state before the operation fully completes. For that period of time, you
      // can't update the resource. Use the operation status to determine when the
      // processing fully completes.
      virtual void UpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a `NetworkPolicy` resource. A network policy cannot be deleted
      // when `NetworkService.state` is set to `RECONCILING` for either its external
      // IP or internet access service.
      virtual void DeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Consumer VPCs bound to Management DNS Zone of a given private cloud.
      virtual void ListManagementDnsZoneBindings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest* request, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListManagementDnsZoneBindings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest* request, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a 'ManagementDnsZoneBinding' resource by its resource name.
      virtual void GetManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest* request, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest* request, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new `ManagementDnsZoneBinding` resource in a private cloud.
      // This RPC creates the DNS binding and the resource that represents the
      // DNS binding of the consumer VPC network to the management DNS zone. A
      // management DNS zone is the Cloud DNS cross-project binding zone that
      // VMware Engine creates for each private cloud. It contains FQDNs and
      // corresponding IP addresses for the private cloud's ESXi hosts and
      // management VM appliances like vCenter and NSX Manager.
      virtual void CreateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a `ManagementDnsZoneBinding` resource.
      // Only fields specified in `update_mask` are applied.
      virtual void UpdateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a `ManagementDnsZoneBinding` resource. When a management DNS zone
      // binding is deleted, the corresponding consumer VPC network is no longer
      // bound to the management DNS zone.
      virtual void DeleteManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retries to create a `ManagementDnsZoneBinding` resource that is
      // in failed state.
      virtual void RepairManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RepairManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new VMware Engine network that can be used by a private cloud.
      virtual void CreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Modifies a VMware Engine network resource. Only the following fields can be
      // updated: `description`. Only fields specified in `updateMask` are
      // applied.
      virtual void UpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a `VmwareEngineNetwork` resource. You can only delete a VMware
      // Engine network after all resources that refer to it are deleted. For
      // example, a private cloud, a network peering, and a network policy can all
      // refer to the same VMware Engine network.
      virtual void DeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a `VmwareEngineNetwork` resource by its resource name. The
      // resource contains details of the VMware Engine network, such as its VMware
      // Engine network type, peered networks in a service project, and state
      // (for example, `CREATING`, `ACTIVE`, `DELETING`).
      virtual void GetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* request, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* request, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists `VmwareEngineNetwork` resources in a given project and location.
      virtual void ListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* request, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* request, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new private connection that can be used for accessing private
      // Clouds.
      virtual void CreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a `PrivateConnection` resource by its resource name. The resource
      // contains details of the private connection, such as connected
      // network, routing mode and state.
      virtual void GetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* request, ::google::cloud::vmwareengine::v1::PrivateConnection* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* request, ::google::cloud::vmwareengine::v1::PrivateConnection* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists `PrivateConnection` resources in a given project and location.
      virtual void ListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Modifies a `PrivateConnection` resource. Only `description` and
      // `routing_mode` fields can be updated. Only fields specified in `updateMask`
      // are applied.
      virtual void UpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a `PrivateConnection` resource. When a private connection is
      // deleted for a VMware Engine network, the connected network becomes
      // inaccessible to that VMware Engine network.
      virtual void DeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the private connection routes exchanged over a peering connection.
      virtual void ListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Grants the bind permission to the customer provided principal(user /
      // service account) to bind their DNS zone with the intranet VPC associated
      // with the project. DnsBindPermission is a global resource and location can
      // only be global.
      virtual void GrantDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GrantDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets all the principals having bind permission on the intranet VPC
      // associated with the consumer project granted by the Grant API.
      // DnsBindPermission is a global resource and location can only be global.
      virtual void GetDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest* request, ::google::cloud::vmwareengine::v1::DnsBindPermission* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest* request, ::google::cloud::vmwareengine::v1::DnsBindPermission* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Revokes the bind permission from the customer provided principal(user /
      // service account) on the intranet VPC associated with the consumer project.
      // DnsBindPermission is a global resource and location can only be global.
      virtual void RevokeDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RevokeDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>* AsyncListPrivateCloudsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>* PrepareAsyncListPrivateCloudsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateCloud>* AsyncGetPrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateCloud>* PrepareAsyncGetPrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreatePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreatePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdatePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdatePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeletePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeletePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUndeletePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUndeletePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListClustersResponse>* AsyncListClustersRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListClustersResponse>* PrepareAsyncListClustersRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Cluster>* AsyncGetClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Cluster>* PrepareAsyncGetClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodesResponse>* AsyncListNodesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodesResponse>* PrepareAsyncListNodesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Node>* AsyncGetNodeRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Node>* PrepareAsyncGetNodeRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>* AsyncListExternalAddressesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>* PrepareAsyncListExternalAddressesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>* AsyncFetchNetworkPolicyExternalAddressesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>* PrepareAsyncFetchNetworkPolicyExternalAddressesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ExternalAddress>* AsyncGetExternalAddressRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ExternalAddress>* PrepareAsyncGetExternalAddressRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateExternalAddressRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateExternalAddressRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateExternalAddressRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateExternalAddressRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteExternalAddressRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteExternalAddressRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>* AsyncListSubnetsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>* PrepareAsyncListSubnetsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Subnet>* AsyncGetSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Subnet>* PrepareAsyncGetSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>* AsyncListExternalAccessRulesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>* PrepareAsyncListExternalAccessRulesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ExternalAccessRule>* AsyncGetExternalAccessRuleRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ExternalAccessRule>* PrepareAsyncGetExternalAccessRuleRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateExternalAccessRuleRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateExternalAccessRuleRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateExternalAccessRuleRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateExternalAccessRuleRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteExternalAccessRuleRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteExternalAccessRuleRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>* AsyncListLoggingServersRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>* PrepareAsyncListLoggingServersRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::LoggingServer>* AsyncGetLoggingServerRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::LoggingServer>* PrepareAsyncGetLoggingServerRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateLoggingServerRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateLoggingServerRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateLoggingServerRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateLoggingServerRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteLoggingServerRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteLoggingServerRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>* AsyncListNodeTypesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>* PrepareAsyncListNodeTypesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NodeType>* AsyncGetNodeTypeRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NodeType>* PrepareAsyncGetNodeTypeRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>* AsyncShowNsxCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>* PrepareAsyncShowNsxCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>* AsyncShowVcenterCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>* PrepareAsyncShowVcenterCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncResetNsxCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncResetNsxCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncResetVcenterCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncResetVcenterCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::DnsForwarding>* AsyncGetDnsForwardingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::DnsForwarding>* PrepareAsyncGetDnsForwardingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateDnsForwardingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateDnsForwardingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPeering>* AsyncGetNetworkPeeringRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPeering>* PrepareAsyncGetNetworkPeeringRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>* AsyncListNetworkPeeringsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>* PrepareAsyncListNetworkPeeringsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateNetworkPeeringRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateNetworkPeeringRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteNetworkPeeringRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteNetworkPeeringRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateNetworkPeeringRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateNetworkPeeringRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>* AsyncListPeeringRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>* PrepareAsyncListPeeringRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateHcxActivationKeyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateHcxActivationKeyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>* AsyncListHcxActivationKeysRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>* PrepareAsyncListHcxActivationKeysRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::HcxActivationKey>* AsyncGetHcxActivationKeyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::HcxActivationKey>* PrepareAsyncGetHcxActivationKeyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPolicy>* AsyncGetNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPolicy>* PrepareAsyncGetNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>* AsyncListNetworkPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>* PrepareAsyncListNetworkPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>* AsyncListManagementDnsZoneBindingsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>* PrepareAsyncListManagementDnsZoneBindingsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>* AsyncGetManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>* PrepareAsyncGetManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRepairManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRepairManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>* AsyncGetVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>* PrepareAsyncGetVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>* AsyncListVmwareEngineNetworksRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>* PrepareAsyncListVmwareEngineNetworksRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreatePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreatePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateConnection>* AsyncGetPrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateConnection>* PrepareAsyncGetPrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>* AsyncListPrivateConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>* PrepareAsyncListPrivateConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdatePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdatePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeletePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeletePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>* AsyncListPrivateConnectionPeeringRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>* PrepareAsyncListPrivateConnectionPeeringRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncGrantDnsBindPermissionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncGrantDnsBindPermissionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::DnsBindPermission>* AsyncGetDnsBindPermissionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::DnsBindPermission>* PrepareAsyncGetDnsBindPermissionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRevokeDnsBindPermissionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRevokeDnsBindPermissionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>> AsyncListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>>(AsyncListPrivateCloudsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>> PrepareAsyncListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>>(PrepareAsyncListPrivateCloudsRaw(context, request, cq));
    }
    ::grpc::Status GetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::google::cloud::vmwareengine::v1::PrivateCloud* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateCloud>> AsyncGetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateCloud>>(AsyncGetPrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateCloud>> PrepareAsyncGetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateCloud>>(PrepareAsyncGetPrivateCloudRaw(context, request, cq));
    }
    ::grpc::Status CreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreatePrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreatePrivateCloudRaw(context, request, cq));
    }
    ::grpc::Status UpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdatePrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdatePrivateCloudRaw(context, request, cq));
    }
    ::grpc::Status DeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeletePrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeletePrivateCloudRaw(context, request, cq));
    }
    ::grpc::Status UndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUndeletePrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUndeletePrivateCloudRaw(context, request, cq));
    }
    ::grpc::Status ListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::google::cloud::vmwareengine::v1::ListClustersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListClustersResponse>> AsyncListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListClustersResponse>>(AsyncListClustersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListClustersResponse>> PrepareAsyncListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListClustersResponse>>(PrepareAsyncListClustersRaw(context, request, cq));
    }
    ::grpc::Status GetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::google::cloud::vmwareengine::v1::Cluster* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Cluster>> AsyncGetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Cluster>>(AsyncGetClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Cluster>> PrepareAsyncGetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Cluster>>(PrepareAsyncGetClusterRaw(context, request, cq));
    }
    ::grpc::Status CreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateClusterRaw(context, request, cq));
    }
    ::grpc::Status UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateClusterRaw(context, request, cq));
    }
    ::grpc::Status DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteClusterRaw(context, request, cq));
    }
    ::grpc::Status ListNodes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodesRequest& request, ::google::cloud::vmwareengine::v1::ListNodesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodesResponse>> AsyncListNodes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodesResponse>>(AsyncListNodesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodesResponse>> PrepareAsyncListNodes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodesResponse>>(PrepareAsyncListNodesRaw(context, request, cq));
    }
    ::grpc::Status GetNode(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeRequest& request, ::google::cloud::vmwareengine::v1::Node* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Node>> AsyncGetNode(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Node>>(AsyncGetNodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Node>> PrepareAsyncGetNode(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Node>>(PrepareAsyncGetNodeRaw(context, request, cq));
    }
    ::grpc::Status ListExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest& request, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>> AsyncListExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>>(AsyncListExternalAddressesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>> PrepareAsyncListExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>>(PrepareAsyncListExternalAddressesRaw(context, request, cq));
    }
    ::grpc::Status FetchNetworkPolicyExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest& request, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>> AsyncFetchNetworkPolicyExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>>(AsyncFetchNetworkPolicyExternalAddressesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>> PrepareAsyncFetchNetworkPolicyExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>>(PrepareAsyncFetchNetworkPolicyExternalAddressesRaw(context, request, cq));
    }
    ::grpc::Status GetExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest& request, ::google::cloud::vmwareengine::v1::ExternalAddress* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ExternalAddress>> AsyncGetExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ExternalAddress>>(AsyncGetExternalAddressRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ExternalAddress>> PrepareAsyncGetExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ExternalAddress>>(PrepareAsyncGetExternalAddressRaw(context, request, cq));
    }
    ::grpc::Status CreateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateExternalAddressRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateExternalAddressRaw(context, request, cq));
    }
    ::grpc::Status UpdateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateExternalAddressRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateExternalAddressRaw(context, request, cq));
    }
    ::grpc::Status DeleteExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteExternalAddressRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteExternalAddressRaw(context, request, cq));
    }
    ::grpc::Status ListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>> AsyncListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>>(AsyncListSubnetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>> PrepareAsyncListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>>(PrepareAsyncListSubnetsRaw(context, request, cq));
    }
    ::grpc::Status GetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::google::cloud::vmwareengine::v1::Subnet* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Subnet>> AsyncGetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Subnet>>(AsyncGetSubnetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Subnet>> PrepareAsyncGetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Subnet>>(PrepareAsyncGetSubnetRaw(context, request, cq));
    }
    ::grpc::Status UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateSubnetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateSubnetRaw(context, request, cq));
    }
    ::grpc::Status ListExternalAccessRules(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest& request, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>> AsyncListExternalAccessRules(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>>(AsyncListExternalAccessRulesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>> PrepareAsyncListExternalAccessRules(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>>(PrepareAsyncListExternalAccessRulesRaw(context, request, cq));
    }
    ::grpc::Status GetExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest& request, ::google::cloud::vmwareengine::v1::ExternalAccessRule* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ExternalAccessRule>> AsyncGetExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ExternalAccessRule>>(AsyncGetExternalAccessRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ExternalAccessRule>> PrepareAsyncGetExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ExternalAccessRule>>(PrepareAsyncGetExternalAccessRuleRaw(context, request, cq));
    }
    ::grpc::Status CreateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateExternalAccessRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateExternalAccessRuleRaw(context, request, cq));
    }
    ::grpc::Status UpdateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateExternalAccessRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateExternalAccessRuleRaw(context, request, cq));
    }
    ::grpc::Status DeleteExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteExternalAccessRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteExternalAccessRuleRaw(context, request, cq));
    }
    ::grpc::Status ListLoggingServers(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest& request, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>> AsyncListLoggingServers(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>>(AsyncListLoggingServersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>> PrepareAsyncListLoggingServers(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>>(PrepareAsyncListLoggingServersRaw(context, request, cq));
    }
    ::grpc::Status GetLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest& request, ::google::cloud::vmwareengine::v1::LoggingServer* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::LoggingServer>> AsyncGetLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::LoggingServer>>(AsyncGetLoggingServerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::LoggingServer>> PrepareAsyncGetLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::LoggingServer>>(PrepareAsyncGetLoggingServerRaw(context, request, cq));
    }
    ::grpc::Status CreateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateLoggingServerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateLoggingServerRaw(context, request, cq));
    }
    ::grpc::Status UpdateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateLoggingServerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateLoggingServerRaw(context, request, cq));
    }
    ::grpc::Status DeleteLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteLoggingServerRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteLoggingServerRaw(context, request, cq));
    }
    ::grpc::Status ListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>> AsyncListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>>(AsyncListNodeTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>> PrepareAsyncListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>>(PrepareAsyncListNodeTypesRaw(context, request, cq));
    }
    ::grpc::Status GetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::google::cloud::vmwareengine::v1::NodeType* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NodeType>> AsyncGetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NodeType>>(AsyncGetNodeTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NodeType>> PrepareAsyncGetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NodeType>>(PrepareAsyncGetNodeTypeRaw(context, request, cq));
    }
    ::grpc::Status ShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::google::cloud::vmwareengine::v1::Credentials* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>> AsyncShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>>(AsyncShowNsxCredentialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>> PrepareAsyncShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>>(PrepareAsyncShowNsxCredentialsRaw(context, request, cq));
    }
    ::grpc::Status ShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::google::cloud::vmwareengine::v1::Credentials* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>> AsyncShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>>(AsyncShowVcenterCredentialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>> PrepareAsyncShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>>(PrepareAsyncShowVcenterCredentialsRaw(context, request, cq));
    }
    ::grpc::Status ResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncResetNsxCredentialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncResetNsxCredentialsRaw(context, request, cq));
    }
    ::grpc::Status ResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncResetVcenterCredentialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncResetVcenterCredentialsRaw(context, request, cq));
    }
    ::grpc::Status GetDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest& request, ::google::cloud::vmwareengine::v1::DnsForwarding* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::DnsForwarding>> AsyncGetDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::DnsForwarding>>(AsyncGetDnsForwardingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::DnsForwarding>> PrepareAsyncGetDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::DnsForwarding>>(PrepareAsyncGetDnsForwardingRaw(context, request, cq));
    }
    ::grpc::Status UpdateDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateDnsForwardingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateDnsForwardingRaw(context, request, cq));
    }
    ::grpc::Status GetNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest& request, ::google::cloud::vmwareengine::v1::NetworkPeering* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPeering>> AsyncGetNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPeering>>(AsyncGetNetworkPeeringRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPeering>> PrepareAsyncGetNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPeering>>(PrepareAsyncGetNetworkPeeringRaw(context, request, cq));
    }
    ::grpc::Status ListNetworkPeerings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest& request, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>> AsyncListNetworkPeerings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>>(AsyncListNetworkPeeringsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>> PrepareAsyncListNetworkPeerings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>>(PrepareAsyncListNetworkPeeringsRaw(context, request, cq));
    }
    ::grpc::Status CreateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateNetworkPeeringRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateNetworkPeeringRaw(context, request, cq));
    }
    ::grpc::Status DeleteNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteNetworkPeeringRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteNetworkPeeringRaw(context, request, cq));
    }
    ::grpc::Status UpdateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateNetworkPeeringRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateNetworkPeeringRaw(context, request, cq));
    }
    ::grpc::Status ListPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest& request, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>> AsyncListPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>>(AsyncListPeeringRoutesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>> PrepareAsyncListPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>>(PrepareAsyncListPeeringRoutesRaw(context, request, cq));
    }
    ::grpc::Status CreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateHcxActivationKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateHcxActivationKeyRaw(context, request, cq));
    }
    ::grpc::Status ListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>> AsyncListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>>(AsyncListHcxActivationKeysRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>> PrepareAsyncListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>>(PrepareAsyncListHcxActivationKeysRaw(context, request, cq));
    }
    ::grpc::Status GetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::google::cloud::vmwareengine::v1::HcxActivationKey* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::HcxActivationKey>> AsyncGetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::HcxActivationKey>>(AsyncGetHcxActivationKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::HcxActivationKey>> PrepareAsyncGetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::HcxActivationKey>>(PrepareAsyncGetHcxActivationKeyRaw(context, request, cq));
    }
    ::grpc::Status GetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::google::cloud::vmwareengine::v1::NetworkPolicy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPolicy>> AsyncGetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPolicy>>(AsyncGetNetworkPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPolicy>> PrepareAsyncGetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPolicy>>(PrepareAsyncGetNetworkPolicyRaw(context, request, cq));
    }
    ::grpc::Status ListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>> AsyncListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>>(AsyncListNetworkPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>> PrepareAsyncListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>>(PrepareAsyncListNetworkPoliciesRaw(context, request, cq));
    }
    ::grpc::Status CreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateNetworkPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateNetworkPolicyRaw(context, request, cq));
    }
    ::grpc::Status UpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateNetworkPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateNetworkPolicyRaw(context, request, cq));
    }
    ::grpc::Status DeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteNetworkPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteNetworkPolicyRaw(context, request, cq));
    }
    ::grpc::Status ListManagementDnsZoneBindings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest& request, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>> AsyncListManagementDnsZoneBindings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>>(AsyncListManagementDnsZoneBindingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>> PrepareAsyncListManagementDnsZoneBindings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>>(PrepareAsyncListManagementDnsZoneBindingsRaw(context, request, cq));
    }
    ::grpc::Status GetManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest& request, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>> AsyncGetManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>>(AsyncGetManagementDnsZoneBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>> PrepareAsyncGetManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>>(PrepareAsyncGetManagementDnsZoneBindingRaw(context, request, cq));
    }
    ::grpc::Status CreateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateManagementDnsZoneBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateManagementDnsZoneBindingRaw(context, request, cq));
    }
    ::grpc::Status UpdateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateManagementDnsZoneBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateManagementDnsZoneBindingRaw(context, request, cq));
    }
    ::grpc::Status DeleteManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteManagementDnsZoneBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteManagementDnsZoneBindingRaw(context, request, cq));
    }
    ::grpc::Status RepairManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRepairManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRepairManagementDnsZoneBindingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRepairManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRepairManagementDnsZoneBindingRaw(context, request, cq));
    }
    ::grpc::Status CreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateVmwareEngineNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateVmwareEngineNetworkRaw(context, request, cq));
    }
    ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateVmwareEngineNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateVmwareEngineNetworkRaw(context, request, cq));
    }
    ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteVmwareEngineNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteVmwareEngineNetworkRaw(context, request, cq));
    }
    ::grpc::Status GetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>> AsyncGetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>>(AsyncGetVmwareEngineNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>> PrepareAsyncGetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>>(PrepareAsyncGetVmwareEngineNetworkRaw(context, request, cq));
    }
    ::grpc::Status ListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>> AsyncListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>>(AsyncListVmwareEngineNetworksRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>> PrepareAsyncListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>>(PrepareAsyncListVmwareEngineNetworksRaw(context, request, cq));
    }
    ::grpc::Status CreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreatePrivateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreatePrivateConnectionRaw(context, request, cq));
    }
    ::grpc::Status GetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::google::cloud::vmwareengine::v1::PrivateConnection* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateConnection>> AsyncGetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateConnection>>(AsyncGetPrivateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateConnection>> PrepareAsyncGetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateConnection>>(PrepareAsyncGetPrivateConnectionRaw(context, request, cq));
    }
    ::grpc::Status ListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>> AsyncListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>>(AsyncListPrivateConnectionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>> PrepareAsyncListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>>(PrepareAsyncListPrivateConnectionsRaw(context, request, cq));
    }
    ::grpc::Status UpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdatePrivateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdatePrivateConnectionRaw(context, request, cq));
    }
    ::grpc::Status DeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeletePrivateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeletePrivateConnectionRaw(context, request, cq));
    }
    ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>> AsyncListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>>(AsyncListPrivateConnectionPeeringRoutesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>> PrepareAsyncListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>>(PrepareAsyncListPrivateConnectionPeeringRoutesRaw(context, request, cq));
    }
    ::grpc::Status GrantDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncGrantDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncGrantDnsBindPermissionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncGrantDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncGrantDnsBindPermissionRaw(context, request, cq));
    }
    ::grpc::Status GetDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest& request, ::google::cloud::vmwareengine::v1::DnsBindPermission* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::DnsBindPermission>> AsyncGetDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::DnsBindPermission>>(AsyncGetDnsBindPermissionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::DnsBindPermission>> PrepareAsyncGetDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::DnsBindPermission>>(PrepareAsyncGetDnsBindPermissionRaw(context, request, cq));
    }
    ::grpc::Status RevokeDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRevokeDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRevokeDnsBindPermissionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRevokeDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRevokeDnsBindPermissionRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* request, ::google::cloud::vmwareengine::v1::PrivateCloud* response, std::function<void(::grpc::Status)>) override;
      void GetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* request, ::google::cloud::vmwareengine::v1::PrivateCloud* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest* request, ::google::cloud::vmwareengine::v1::ListClustersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest* request, ::google::cloud::vmwareengine::v1::ListClustersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest* request, ::google::cloud::vmwareengine::v1::Cluster* response, std::function<void(::grpc::Status)>) override;
      void GetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest* request, ::google::cloud::vmwareengine::v1::Cluster* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListNodes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodesRequest* request, ::google::cloud::vmwareengine::v1::ListNodesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListNodes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodesRequest* request, ::google::cloud::vmwareengine::v1::ListNodesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetNode(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeRequest* request, ::google::cloud::vmwareengine::v1::Node* response, std::function<void(::grpc::Status)>) override;
      void GetNode(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeRequest* request, ::google::cloud::vmwareengine::v1::Node* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest* request, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest* request, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void FetchNetworkPolicyExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest* request, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse* response, std::function<void(::grpc::Status)>) override;
      void FetchNetworkPolicyExternalAddresses(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest* request, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest* request, ::google::cloud::vmwareengine::v1::ExternalAddress* response, std::function<void(::grpc::Status)>) override;
      void GetExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest* request, ::google::cloud::vmwareengine::v1::ExternalAddress* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteExternalAddress(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* request, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* request, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* request, ::google::cloud::vmwareengine::v1::Subnet* response, std::function<void(::grpc::Status)>) override;
      void GetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* request, ::google::cloud::vmwareengine::v1::Subnet* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListExternalAccessRules(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest* request, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListExternalAccessRules(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest* request, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest* request, ::google::cloud::vmwareengine::v1::ExternalAccessRule* response, std::function<void(::grpc::Status)>) override;
      void GetExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest* request, ::google::cloud::vmwareengine::v1::ExternalAccessRule* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteExternalAccessRule(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListLoggingServers(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest* request, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListLoggingServers(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest* request, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest* request, ::google::cloud::vmwareengine::v1::LoggingServer* response, std::function<void(::grpc::Status)>) override;
      void GetLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest* request, ::google::cloud::vmwareengine::v1::LoggingServer* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteLoggingServer(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* request, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* request, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* request, ::google::cloud::vmwareengine::v1::NodeType* response, std::function<void(::grpc::Status)>) override;
      void GetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* request, ::google::cloud::vmwareengine::v1::NodeType* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response, std::function<void(::grpc::Status)>) override;
      void ShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response, std::function<void(::grpc::Status)>) override;
      void ShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest* request, ::google::cloud::vmwareengine::v1::DnsForwarding* response, std::function<void(::grpc::Status)>) override;
      void GetDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest* request, ::google::cloud::vmwareengine::v1::DnsForwarding* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateDnsForwarding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest* request, ::google::cloud::vmwareengine::v1::NetworkPeering* response, std::function<void(::grpc::Status)>) override;
      void GetNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest* request, ::google::cloud::vmwareengine::v1::NetworkPeering* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListNetworkPeerings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListNetworkPeerings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateNetworkPeering(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* request, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* response, std::function<void(::grpc::Status)>) override;
      void ListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* request, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* request, ::google::cloud::vmwareengine::v1::HcxActivationKey* response, std::function<void(::grpc::Status)>) override;
      void GetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* request, ::google::cloud::vmwareengine::v1::HcxActivationKey* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* request, ::google::cloud::vmwareengine::v1::NetworkPolicy* response, std::function<void(::grpc::Status)>) override;
      void GetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* request, ::google::cloud::vmwareengine::v1::NetworkPolicy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListManagementDnsZoneBindings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest* request, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListManagementDnsZoneBindings(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest* request, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest* request, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding* response, std::function<void(::grpc::Status)>) override;
      void GetManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest* request, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RepairManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RepairManagementDnsZoneBinding(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* request, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* response, std::function<void(::grpc::Status)>) override;
      void GetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* request, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* request, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* response, std::function<void(::grpc::Status)>) override;
      void ListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* request, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* request, ::google::cloud::vmwareengine::v1::PrivateConnection* response, std::function<void(::grpc::Status)>) override;
      void GetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* request, ::google::cloud::vmwareengine::v1::PrivateConnection* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GrantDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void GrantDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest* request, ::google::cloud::vmwareengine::v1::DnsBindPermission* response, std::function<void(::grpc::Status)>) override;
      void GetDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest* request, ::google::cloud::vmwareengine::v1::DnsBindPermission* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RevokeDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RevokeDnsBindPermission(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>* AsyncListPrivateCloudsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>* PrepareAsyncListPrivateCloudsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateCloud>* AsyncGetPrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateCloud>* PrepareAsyncGetPrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreatePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreatePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdatePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdatePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeletePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeletePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUndeletePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUndeletePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListClustersResponse>* AsyncListClustersRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListClustersResponse>* PrepareAsyncListClustersRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Cluster>* AsyncGetClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Cluster>* PrepareAsyncGetClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodesResponse>* AsyncListNodesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodesResponse>* PrepareAsyncListNodesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Node>* AsyncGetNodeRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Node>* PrepareAsyncGetNodeRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>* AsyncListExternalAddressesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>* PrepareAsyncListExternalAddressesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>* AsyncFetchNetworkPolicyExternalAddressesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>* PrepareAsyncFetchNetworkPolicyExternalAddressesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ExternalAddress>* AsyncGetExternalAddressRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ExternalAddress>* PrepareAsyncGetExternalAddressRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateExternalAddressRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateExternalAddressRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateExternalAddressRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateExternalAddressRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteExternalAddressRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteExternalAddressRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>* AsyncListSubnetsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>* PrepareAsyncListSubnetsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Subnet>* AsyncGetSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Subnet>* PrepareAsyncGetSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>* AsyncListExternalAccessRulesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>* PrepareAsyncListExternalAccessRulesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ExternalAccessRule>* AsyncGetExternalAccessRuleRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ExternalAccessRule>* PrepareAsyncGetExternalAccessRuleRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateExternalAccessRuleRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateExternalAccessRuleRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateExternalAccessRuleRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateExternalAccessRuleRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteExternalAccessRuleRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteExternalAccessRuleRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>* AsyncListLoggingServersRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>* PrepareAsyncListLoggingServersRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::LoggingServer>* AsyncGetLoggingServerRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::LoggingServer>* PrepareAsyncGetLoggingServerRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateLoggingServerRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateLoggingServerRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateLoggingServerRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateLoggingServerRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteLoggingServerRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteLoggingServerRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>* AsyncListNodeTypesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>* PrepareAsyncListNodeTypesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NodeType>* AsyncGetNodeTypeRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NodeType>* PrepareAsyncGetNodeTypeRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>* AsyncShowNsxCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>* PrepareAsyncShowNsxCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>* AsyncShowVcenterCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>* PrepareAsyncShowVcenterCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncResetNsxCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncResetNsxCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncResetVcenterCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncResetVcenterCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::DnsForwarding>* AsyncGetDnsForwardingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::DnsForwarding>* PrepareAsyncGetDnsForwardingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateDnsForwardingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateDnsForwardingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPeering>* AsyncGetNetworkPeeringRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPeering>* PrepareAsyncGetNetworkPeeringRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>* AsyncListNetworkPeeringsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>* PrepareAsyncListNetworkPeeringsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateNetworkPeeringRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateNetworkPeeringRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteNetworkPeeringRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteNetworkPeeringRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateNetworkPeeringRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateNetworkPeeringRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>* AsyncListPeeringRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>* PrepareAsyncListPeeringRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateHcxActivationKeyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateHcxActivationKeyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>* AsyncListHcxActivationKeysRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>* PrepareAsyncListHcxActivationKeysRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::HcxActivationKey>* AsyncGetHcxActivationKeyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::HcxActivationKey>* PrepareAsyncGetHcxActivationKeyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPolicy>* AsyncGetNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPolicy>* PrepareAsyncGetNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>* AsyncListNetworkPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>* PrepareAsyncListNetworkPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>* AsyncListManagementDnsZoneBindingsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>* PrepareAsyncListManagementDnsZoneBindingsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>* AsyncGetManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>* PrepareAsyncGetManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRepairManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRepairManagementDnsZoneBindingRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>* AsyncGetVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>* PrepareAsyncGetVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>* AsyncListVmwareEngineNetworksRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>* PrepareAsyncListVmwareEngineNetworksRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreatePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreatePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateConnection>* AsyncGetPrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateConnection>* PrepareAsyncGetPrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>* AsyncListPrivateConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>* PrepareAsyncListPrivateConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdatePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdatePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeletePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeletePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>* AsyncListPrivateConnectionPeeringRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>* PrepareAsyncListPrivateConnectionPeeringRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncGrantDnsBindPermissionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncGrantDnsBindPermissionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::DnsBindPermission>* AsyncGetDnsBindPermissionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::DnsBindPermission>* PrepareAsyncGetDnsBindPermissionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRevokeDnsBindPermissionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRevokeDnsBindPermissionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListPrivateClouds_;
    const ::grpc::internal::RpcMethod rpcmethod_GetPrivateCloud_;
    const ::grpc::internal::RpcMethod rpcmethod_CreatePrivateCloud_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdatePrivateCloud_;
    const ::grpc::internal::RpcMethod rpcmethod_DeletePrivateCloud_;
    const ::grpc::internal::RpcMethod rpcmethod_UndeletePrivateCloud_;
    const ::grpc::internal::RpcMethod rpcmethod_ListClusters_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_ListNodes_;
    const ::grpc::internal::RpcMethod rpcmethod_GetNode_;
    const ::grpc::internal::RpcMethod rpcmethod_ListExternalAddresses_;
    const ::grpc::internal::RpcMethod rpcmethod_FetchNetworkPolicyExternalAddresses_;
    const ::grpc::internal::RpcMethod rpcmethod_GetExternalAddress_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateExternalAddress_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateExternalAddress_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteExternalAddress_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSubnets_;
    const ::grpc::internal::RpcMethod rpcmethod_GetSubnet_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateSubnet_;
    const ::grpc::internal::RpcMethod rpcmethod_ListExternalAccessRules_;
    const ::grpc::internal::RpcMethod rpcmethod_GetExternalAccessRule_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateExternalAccessRule_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateExternalAccessRule_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteExternalAccessRule_;
    const ::grpc::internal::RpcMethod rpcmethod_ListLoggingServers_;
    const ::grpc::internal::RpcMethod rpcmethod_GetLoggingServer_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateLoggingServer_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateLoggingServer_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteLoggingServer_;
    const ::grpc::internal::RpcMethod rpcmethod_ListNodeTypes_;
    const ::grpc::internal::RpcMethod rpcmethod_GetNodeType_;
    const ::grpc::internal::RpcMethod rpcmethod_ShowNsxCredentials_;
    const ::grpc::internal::RpcMethod rpcmethod_ShowVcenterCredentials_;
    const ::grpc::internal::RpcMethod rpcmethod_ResetNsxCredentials_;
    const ::grpc::internal::RpcMethod rpcmethod_ResetVcenterCredentials_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDnsForwarding_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateDnsForwarding_;
    const ::grpc::internal::RpcMethod rpcmethod_GetNetworkPeering_;
    const ::grpc::internal::RpcMethod rpcmethod_ListNetworkPeerings_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateNetworkPeering_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteNetworkPeering_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateNetworkPeering_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPeeringRoutes_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateHcxActivationKey_;
    const ::grpc::internal::RpcMethod rpcmethod_ListHcxActivationKeys_;
    const ::grpc::internal::RpcMethod rpcmethod_GetHcxActivationKey_;
    const ::grpc::internal::RpcMethod rpcmethod_GetNetworkPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_ListNetworkPolicies_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateNetworkPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateNetworkPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteNetworkPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_ListManagementDnsZoneBindings_;
    const ::grpc::internal::RpcMethod rpcmethod_GetManagementDnsZoneBinding_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateManagementDnsZoneBinding_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateManagementDnsZoneBinding_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteManagementDnsZoneBinding_;
    const ::grpc::internal::RpcMethod rpcmethod_RepairManagementDnsZoneBinding_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateVmwareEngineNetwork_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateVmwareEngineNetwork_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteVmwareEngineNetwork_;
    const ::grpc::internal::RpcMethod rpcmethod_GetVmwareEngineNetwork_;
    const ::grpc::internal::RpcMethod rpcmethod_ListVmwareEngineNetworks_;
    const ::grpc::internal::RpcMethod rpcmethod_CreatePrivateConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_GetPrivateConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPrivateConnections_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdatePrivateConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_DeletePrivateConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPrivateConnectionPeeringRoutes_;
    const ::grpc::internal::RpcMethod rpcmethod_GrantDnsBindPermission_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDnsBindPermission_;
    const ::grpc::internal::RpcMethod rpcmethod_RevokeDnsBindPermission_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists `PrivateCloud` resources in a given project and location.
    virtual ::grpc::Status ListPrivateClouds(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* response);
    // Retrieves a `PrivateCloud` resource by its resource name.
    virtual ::grpc::Status GetPrivateCloud(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* request, ::google::cloud::vmwareengine::v1::PrivateCloud* response);
    // Creates a new `PrivateCloud` resource in a given project and location.
    // Private clouds of type `STANDARD` and
    // `TIME_LIMITED` are zonal resources, `STRETCHED` private clouds are
    // regional.
    // Creating a private cloud also creates a [management
    // cluster](https://cloud.google.com/vmware-engine/docs/concepts-vmware-components)
    // for that private cloud.
    virtual ::grpc::Status CreatePrivateCloud(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* request, ::google::longrunning::Operation* response);
    // Modifies a `PrivateCloud` resource. Only the following fields can be
    // updated: `description`.
    // Only fields specified in `updateMask` are applied.
    //
    // During operation processing, the resource is temporarily in the `ACTIVE`
    // state before the operation fully completes. For that period of time, you
    // can't update the resource. Use the operation status to determine when the
    // processing fully completes.
    virtual ::grpc::Status UpdatePrivateCloud(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* request, ::google::longrunning::Operation* response);
    // Schedules a `PrivateCloud` resource for deletion.
    //
    // A `PrivateCloud` resource scheduled for deletion has `PrivateCloud.state`
    // set to `DELETED` and `expireTime` set to the time when deletion is final
    // and can no longer be reversed. The delete operation is marked as done
    // as soon as the `PrivateCloud` is successfully scheduled for deletion
    // (this also applies when `delayHours` is set to zero), and the operation is
    // not kept in pending state until `PrivateCloud` is purged.
    // `PrivateCloud` can be restored using `UndeletePrivateCloud` method before
    // the `expireTime` elapses. When `expireTime` is reached, deletion is final
    // and all private cloud resources are irreversibly removed and billing stops.
    // During the final removal process, `PrivateCloud.state` is set to `PURGING`.
    // `PrivateCloud` can be polled using standard `GET` method for the whole
    // period of deletion and purging. It will not be returned only
    // when it is completely purged.
    virtual ::grpc::Status DeletePrivateCloud(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* request, ::google::longrunning::Operation* response);
    // Restores a private cloud that was previously scheduled for deletion by
    // `DeletePrivateCloud`. A `PrivateCloud` resource scheduled for deletion has
    // `PrivateCloud.state` set to `DELETED` and `PrivateCloud.expireTime` set to
    // the time when deletion can no longer be reversed.
    virtual ::grpc::Status UndeletePrivateCloud(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* request, ::google::longrunning::Operation* response);
    // Lists `Cluster` resources in a given private cloud.
    virtual ::grpc::Status ListClusters(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest* request, ::google::cloud::vmwareengine::v1::ListClustersResponse* response);
    // Retrieves a `Cluster` resource by its resource name.
    virtual ::grpc::Status GetCluster(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest* request, ::google::cloud::vmwareengine::v1::Cluster* response);
    // Creates a new cluster in a given private cloud.
    // Creating a new cluster provides additional nodes for
    // use in the parent private cloud and requires sufficient [node
    // quota](https://cloud.google.com/vmware-engine/quotas).
    virtual ::grpc::Status CreateCluster(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response);
    // Modifies a `Cluster` resource. Only fields specified in `updateMask` are
    // applied.
    //
    // During operation processing, the resource is temporarily in the `ACTIVE`
    // state before the operation fully completes. For that period of time, you
    // can't update the resource. Use the operation status to determine when the
    // processing fully completes.
    virtual ::grpc::Status UpdateCluster(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response);
    // Deletes a `Cluster` resource. To avoid unintended data loss, migrate or
    // gracefully shut down any workloads running on the cluster before deletion.
    // You cannot delete the management cluster of a private cloud using this
    // method.
    virtual ::grpc::Status DeleteCluster(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response);
    // Lists nodes in a given cluster.
    virtual ::grpc::Status ListNodes(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListNodesRequest* request, ::google::cloud::vmwareengine::v1::ListNodesResponse* response);
    // Gets details of a single node.
    virtual ::grpc::Status GetNode(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetNodeRequest* request, ::google::cloud::vmwareengine::v1::Node* response);
    // Lists external IP addresses assigned to VMware workload VMs in a given
    // private cloud.
    virtual ::grpc::Status ListExternalAddresses(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest* request, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse* response);
    // Lists external IP addresses assigned to VMware workload VMs within the
    // scope of the given network policy.
    virtual ::grpc::Status FetchNetworkPolicyExternalAddresses(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest* request, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse* response);
    // Gets details of a single external IP address.
    virtual ::grpc::Status GetExternalAddress(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest* request, ::google::cloud::vmwareengine::v1::ExternalAddress* response);
    // Creates a new `ExternalAddress` resource in a given private cloud. The
    // network policy that corresponds to the private cloud must have the external
    // IP address network service enabled (`NetworkPolicy.external_ip`).
    virtual ::grpc::Status CreateExternalAddress(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a single external IP address.
    // Only fields specified in `update_mask` are applied.
    //
    // During operation processing, the resource is temporarily in the `ACTIVE`
    // state before the operation fully completes. For that period of time, you
    // can't update the resource. Use the operation status to determine when the
    // processing fully completes.
    virtual ::grpc::Status UpdateExternalAddress(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single external IP address. When you delete an external IP
    // address, connectivity between the external IP address and the corresponding
    // internal IP address is lost.
    virtual ::grpc::Status DeleteExternalAddress(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest* request, ::google::longrunning::Operation* response);
    // Lists subnets in a given private cloud.
    virtual ::grpc::Status ListSubnets(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* request, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* response);
    // Gets details of a single subnet.
    virtual ::grpc::Status GetSubnet(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* request, ::google::cloud::vmwareengine::v1::Subnet* response);
    // Updates the parameters of a single subnet. Only fields specified in
    // `update_mask` are applied.
    //
    // *Note*: This API is synchronous and always returns a successful
    // `google.longrunning.Operation` (LRO). The returned LRO will only have
    // `done` and `response` fields.
    virtual ::grpc::Status UpdateSubnet(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response);
    // Lists `ExternalAccessRule` resources in the specified network policy.
    virtual ::grpc::Status ListExternalAccessRules(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest* request, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse* response);
    // Gets details of a single external access rule.
    virtual ::grpc::Status GetExternalAccessRule(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest* request, ::google::cloud::vmwareengine::v1::ExternalAccessRule* response);
    // Creates a new external access rule in a given network policy.
    virtual ::grpc::Status CreateExternalAccessRule(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a single external access rule.
    // Only fields specified in `update_mask` are applied.
    virtual ::grpc::Status UpdateExternalAccessRule(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single external access rule.
    virtual ::grpc::Status DeleteExternalAccessRule(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest* request, ::google::longrunning::Operation* response);
    // Lists logging servers configured for a given private
    // cloud.
    virtual ::grpc::Status ListLoggingServers(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest* request, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse* response);
    // Gets details of a logging server.
    virtual ::grpc::Status GetLoggingServer(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest* request, ::google::cloud::vmwareengine::v1::LoggingServer* response);
    // Create a new logging server for a given private cloud.
    virtual ::grpc::Status CreateLoggingServer(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a single logging server.
    // Only fields specified in `update_mask` are applied.
    virtual ::grpc::Status UpdateLoggingServer(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single logging server.
    virtual ::grpc::Status DeleteLoggingServer(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest* request, ::google::longrunning::Operation* response);
    // Lists node types
    virtual ::grpc::Status ListNodeTypes(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* request, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* response);
    // Gets details of a single `NodeType`.
    virtual ::grpc::Status GetNodeType(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* request, ::google::cloud::vmwareengine::v1::NodeType* response);
    // Gets details of credentials for NSX appliance.
    virtual ::grpc::Status ShowNsxCredentials(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response);
    // Gets details of credentials for Vcenter appliance.
    virtual ::grpc::Status ShowVcenterCredentials(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response);
    // Resets credentials of the NSX appliance.
    virtual ::grpc::Status ResetNsxCredentials(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* request, ::google::longrunning::Operation* response);
    // Resets credentials of the Vcenter appliance.
    virtual ::grpc::Status ResetVcenterCredentials(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* request, ::google::longrunning::Operation* response);
    // Gets details of the `DnsForwarding` config.
    virtual ::grpc::Status GetDnsForwarding(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest* request, ::google::cloud::vmwareengine::v1::DnsForwarding* response);
    // Updates the parameters of the `DnsForwarding` config, like associated
    // domains. Only fields specified in `update_mask` are applied.
    virtual ::grpc::Status UpdateDnsForwarding(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest* request, ::google::longrunning::Operation* response);
    // Retrieves a `NetworkPeering` resource by its resource name. The resource
    // contains details of the network peering, such as peered
    // networks, import and export custom route configurations, and peering state.
    // NetworkPeering is a global resource and location can only be global.
    virtual ::grpc::Status GetNetworkPeering(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest* request, ::google::cloud::vmwareengine::v1::NetworkPeering* response);
    // Lists `NetworkPeering` resources in a given project. NetworkPeering is a
    // global resource and location can only be global.
    virtual ::grpc::Status ListNetworkPeerings(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse* response);
    // Creates a new network peering between the peer network and VMware Engine
    // network provided in a `NetworkPeering` resource. NetworkPeering is a
    // global resource and location can only be global.
    virtual ::grpc::Status CreateNetworkPeering(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest* request, ::google::longrunning::Operation* response);
    // Deletes a `NetworkPeering` resource. When a network peering is deleted for
    // a VMware Engine network, the peer network becomes inaccessible to that
    // VMware Engine network. NetworkPeering is a global resource and location can
    // only be global.
    virtual ::grpc::Status DeleteNetworkPeering(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest* request, ::google::longrunning::Operation* response);
    // Modifies a `NetworkPeering` resource. Only the `description` field can be
    // updated. Only fields specified in `updateMask` are applied. NetworkPeering
    // is a global resource and location can only be global.
    virtual ::grpc::Status UpdateNetworkPeering(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest* request, ::google::longrunning::Operation* response);
    // Lists the network peering routes exchanged over a peering connection.
    // NetworkPeering is a global resource and location can only be global.
    virtual ::grpc::Status ListPeeringRoutes(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse* response);
    // Creates a new HCX activation key in a given private cloud.
    virtual ::grpc::Status CreateHcxActivationKey(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* request, ::google::longrunning::Operation* response);
    // Lists `HcxActivationKey` resources in a given private cloud.
    virtual ::grpc::Status ListHcxActivationKeys(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* request, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* response);
    // Retrieves a `HcxActivationKey` resource by its resource name.
    virtual ::grpc::Status GetHcxActivationKey(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* request, ::google::cloud::vmwareengine::v1::HcxActivationKey* response);
    // Retrieves a `NetworkPolicy` resource by its resource name.
    virtual ::grpc::Status GetNetworkPolicy(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* request, ::google::cloud::vmwareengine::v1::NetworkPolicy* response);
    // Lists `NetworkPolicy` resources in a specified project and location.
    virtual ::grpc::Status ListNetworkPolicies(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* response);
    // Creates a new network policy in a given VMware Engine network of a
    // project and location (region). A new network policy cannot be created if
    // another network policy already exists in the same scope.
    virtual ::grpc::Status CreateNetworkPolicy(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* request, ::google::longrunning::Operation* response);
    // Modifies a `NetworkPolicy` resource. Only the following fields can be
    // updated: `internet_access`, `external_ip`, `edge_services_cidr`.
    // Only fields specified in `updateMask` are applied. When updating a network
    // policy, the external IP network service can only be disabled if there are
    // no external IP addresses present in the scope of the policy. Also, a
    // `NetworkService` cannot be updated when `NetworkService.state` is set
    // to `RECONCILING`.
    //
    // During operation processing, the resource is temporarily in the `ACTIVE`
    // state before the operation fully completes. For that period of time, you
    // can't update the resource. Use the operation status to determine when the
    // processing fully completes.
    virtual ::grpc::Status UpdateNetworkPolicy(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* request, ::google::longrunning::Operation* response);
    // Deletes a `NetworkPolicy` resource. A network policy cannot be deleted
    // when `NetworkService.state` is set to `RECONCILING` for either its external
    // IP or internet access service.
    virtual ::grpc::Status DeleteNetworkPolicy(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* request, ::google::longrunning::Operation* response);
    // Lists Consumer VPCs bound to Management DNS Zone of a given private cloud.
    virtual ::grpc::Status ListManagementDnsZoneBindings(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest* request, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse* response);
    // Retrieves a 'ManagementDnsZoneBinding' resource by its resource name.
    virtual ::grpc::Status GetManagementDnsZoneBinding(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest* request, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding* response);
    // Creates a new `ManagementDnsZoneBinding` resource in a private cloud.
    // This RPC creates the DNS binding and the resource that represents the
    // DNS binding of the consumer VPC network to the management DNS zone. A
    // management DNS zone is the Cloud DNS cross-project binding zone that
    // VMware Engine creates for each private cloud. It contains FQDNs and
    // corresponding IP addresses for the private cloud's ESXi hosts and
    // management VM appliances like vCenter and NSX Manager.
    virtual ::grpc::Status CreateManagementDnsZoneBinding(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response);
    // Updates a `ManagementDnsZoneBinding` resource.
    // Only fields specified in `update_mask` are applied.
    virtual ::grpc::Status UpdateManagementDnsZoneBinding(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response);
    // Deletes a `ManagementDnsZoneBinding` resource. When a management DNS zone
    // binding is deleted, the corresponding consumer VPC network is no longer
    // bound to the management DNS zone.
    virtual ::grpc::Status DeleteManagementDnsZoneBinding(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response);
    // Retries to create a `ManagementDnsZoneBinding` resource that is
    // in failed state.
    virtual ::grpc::Status RepairManagementDnsZoneBinding(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response);
    // Creates a new VMware Engine network that can be used by a private cloud.
    virtual ::grpc::Status CreateVmwareEngineNetwork(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response);
    // Modifies a VMware Engine network resource. Only the following fields can be
    // updated: `description`. Only fields specified in `updateMask` are
    // applied.
    virtual ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response);
    // Deletes a `VmwareEngineNetwork` resource. You can only delete a VMware
    // Engine network after all resources that refer to it are deleted. For
    // example, a private cloud, a network peering, and a network policy can all
    // refer to the same VMware Engine network.
    virtual ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response);
    // Retrieves a `VmwareEngineNetwork` resource by its resource name. The
    // resource contains details of the VMware Engine network, such as its VMware
    // Engine network type, peered networks in a service project, and state
    // (for example, `CREATING`, `ACTIVE`, `DELETING`).
    virtual ::grpc::Status GetVmwareEngineNetwork(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* request, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* response);
    // Lists `VmwareEngineNetwork` resources in a given project and location.
    virtual ::grpc::Status ListVmwareEngineNetworks(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* request, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* response);
    // Creates a new private connection that can be used for accessing private
    // Clouds.
    virtual ::grpc::Status CreatePrivateConnection(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* request, ::google::longrunning::Operation* response);
    // Retrieves a `PrivateConnection` resource by its resource name. The resource
    // contains details of the private connection, such as connected
    // network, routing mode and state.
    virtual ::grpc::Status GetPrivateConnection(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* request, ::google::cloud::vmwareengine::v1::PrivateConnection* response);
    // Lists `PrivateConnection` resources in a given project and location.
    virtual ::grpc::Status ListPrivateConnections(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* response);
    // Modifies a `PrivateConnection` resource. Only `description` and
    // `routing_mode` fields can be updated. Only fields specified in `updateMask`
    // are applied.
    virtual ::grpc::Status UpdatePrivateConnection(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* request, ::google::longrunning::Operation* response);
    // Deletes a `PrivateConnection` resource. When a private connection is
    // deleted for a VMware Engine network, the connected network becomes
    // inaccessible to that VMware Engine network.
    virtual ::grpc::Status DeletePrivateConnection(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* request, ::google::longrunning::Operation* response);
    // Lists the private connection routes exchanged over a peering connection.
    virtual ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* response);
    // Grants the bind permission to the customer provided principal(user /
    // service account) to bind their DNS zone with the intranet VPC associated
    // with the project. DnsBindPermission is a global resource and location can
    // only be global.
    virtual ::grpc::Status GrantDnsBindPermission(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest* request, ::google::longrunning::Operation* response);
    // Gets all the principals having bind permission on the intranet VPC
    // associated with the consumer project granted by the Grant API.
    // DnsBindPermission is a global resource and location can only be global.
    virtual ::grpc::Status GetDnsBindPermission(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest* request, ::google::cloud::vmwareengine::v1::DnsBindPermission* response);
    // Revokes the bind permission from the customer provided principal(user /
    // service account) on the intranet VPC associated with the consumer project.
    // DnsBindPermission is a global resource and location can only be global.
    virtual ::grpc::Status RevokeDnsBindPermission(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPrivateClouds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPrivateClouds() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListPrivateClouds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateClouds(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPrivateClouds(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPrivateCloud() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetPrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateCloud* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPrivateCloud(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::PrivateCloud>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreatePrivateCloud() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePrivateCloud(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdatePrivateCloud() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePrivateCloud(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeletePrivateCloud() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePrivateCloud(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UndeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UndeletePrivateCloud() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_UndeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeletePrivateCloud(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListClusters() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListClustersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListClusters(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListClustersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListClustersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCluster() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetClusterRequest* /*request*/, ::google::cloud::vmwareengine::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCluster(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::Cluster>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCluster() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCluster(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreateClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCluster(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdateClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCluster(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::DeleteClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListNodes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListNodes() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_ListNodes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNodes(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListNodesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListNodesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetNode() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_GetNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNode(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeRequest* /*request*/, ::google::cloud::vmwareengine::v1::Node* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNode(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetNodeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::Node>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListExternalAddresses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListExternalAddresses() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_ListExternalAddresses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExternalAddresses(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListExternalAddresses(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_FetchNetworkPolicyExternalAddresses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_FetchNetworkPolicyExternalAddresses() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_FetchNetworkPolicyExternalAddresses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchNetworkPolicyExternalAddresses(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest* /*request*/, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFetchNetworkPolicyExternalAddresses(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetExternalAddress() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_GetExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest* /*request*/, ::google::cloud::vmwareengine::v1::ExternalAddress* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetExternalAddress(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetExternalAddressRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ExternalAddress>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateExternalAddress() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_CreateExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateExternalAddress(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateExternalAddress() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_UpdateExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateExternalAddress(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteExternalAddress() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_DeleteExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteExternalAddress(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSubnets() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSubnets(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListSubnetsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetSubnet() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* /*request*/, ::google::cloud::vmwareengine::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSubnet(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetSubnetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::Subnet>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSubnet(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListExternalAccessRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListExternalAccessRules() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_ListExternalAccessRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExternalAccessRules(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListExternalAccessRules(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetExternalAccessRule() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_GetExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest* /*request*/, ::google::cloud::vmwareengine::v1::ExternalAccessRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetExternalAccessRule(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ExternalAccessRule>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateExternalAccessRule() {
      ::grpc::Service::MarkMethodAsync(24);
    }
    ~WithAsyncMethod_CreateExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateExternalAccessRule(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateExternalAccessRule() {
      ::grpc::Service::MarkMethodAsync(25);
    }
    ~WithAsyncMethod_UpdateExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateExternalAccessRule(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteExternalAccessRule() {
      ::grpc::Service::MarkMethodAsync(26);
    }
    ~WithAsyncMethod_DeleteExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteExternalAccessRule(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListLoggingServers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListLoggingServers() {
      ::grpc::Service::MarkMethodAsync(27);
    }
    ~WithAsyncMethod_ListLoggingServers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLoggingServers(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListLoggingServers(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListLoggingServersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetLoggingServer() {
      ::grpc::Service::MarkMethodAsync(28);
    }
    ~WithAsyncMethod_GetLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest* /*request*/, ::google::cloud::vmwareengine::v1::LoggingServer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetLoggingServer(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetLoggingServerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::LoggingServer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateLoggingServer() {
      ::grpc::Service::MarkMethodAsync(29);
    }
    ~WithAsyncMethod_CreateLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateLoggingServer(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateLoggingServer() {
      ::grpc::Service::MarkMethodAsync(30);
    }
    ~WithAsyncMethod_UpdateLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateLoggingServer(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteLoggingServer() {
      ::grpc::Service::MarkMethodAsync(31);
    }
    ~WithAsyncMethod_DeleteLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteLoggingServer(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListNodeTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListNodeTypes() {
      ::grpc::Service::MarkMethodAsync(32);
    }
    ~WithAsyncMethod_ListNodeTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodeTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNodeTypes(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetNodeType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetNodeType() {
      ::grpc::Service::MarkMethodAsync(33);
    }
    ~WithAsyncMethod_GetNodeType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNodeType(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* /*request*/, ::google::cloud::vmwareengine::v1::NodeType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNodeType(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::NodeType>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ShowNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ShowNsxCredentials() {
      ::grpc::Service::MarkMethodAsync(34);
    }
    ~WithAsyncMethod_ShowNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestShowNsxCredentials(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::Credentials>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(34, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ShowVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ShowVcenterCredentials() {
      ::grpc::Service::MarkMethodAsync(35);
    }
    ~WithAsyncMethod_ShowVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestShowVcenterCredentials(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::Credentials>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(35, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ResetNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ResetNsxCredentials() {
      ::grpc::Service::MarkMethodAsync(36);
    }
    ~WithAsyncMethod_ResetNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetNsxCredentials(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(36, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ResetVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ResetVcenterCredentials() {
      ::grpc::Service::MarkMethodAsync(37);
    }
    ~WithAsyncMethod_ResetVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetVcenterCredentials(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(37, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDnsForwarding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDnsForwarding() {
      ::grpc::Service::MarkMethodAsync(38);
    }
    ~WithAsyncMethod_GetDnsForwarding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDnsForwarding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest* /*request*/, ::google::cloud::vmwareengine::v1::DnsForwarding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDnsForwarding(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::DnsForwarding>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(38, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateDnsForwarding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateDnsForwarding() {
      ::grpc::Service::MarkMethodAsync(39);
    }
    ~WithAsyncMethod_UpdateDnsForwarding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDnsForwarding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDnsForwarding(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(39, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetNetworkPeering() {
      ::grpc::Service::MarkMethodAsync(40);
    }
    ~WithAsyncMethod_GetNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPeering* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNetworkPeering(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::NetworkPeering>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(40, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListNetworkPeerings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListNetworkPeerings() {
      ::grpc::Service::MarkMethodAsync(41);
    }
    ~WithAsyncMethod_ListNetworkPeerings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworkPeerings(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNetworkPeerings(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(41, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateNetworkPeering() {
      ::grpc::Service::MarkMethodAsync(42);
    }
    ~WithAsyncMethod_CreateNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateNetworkPeering(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(42, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteNetworkPeering() {
      ::grpc::Service::MarkMethodAsync(43);
    }
    ~WithAsyncMethod_DeleteNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteNetworkPeering(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(43, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateNetworkPeering() {
      ::grpc::Service::MarkMethodAsync(44);
    }
    ~WithAsyncMethod_UpdateNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateNetworkPeering(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(44, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPeeringRoutes() {
      ::grpc::Service::MarkMethodAsync(45);
    }
    ~WithAsyncMethod_ListPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPeeringRoutes(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(45, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateHcxActivationKey() {
      ::grpc::Service::MarkMethodAsync(46);
    }
    ~WithAsyncMethod_CreateHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateHcxActivationKey(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(46, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListHcxActivationKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListHcxActivationKeys() {
      ::grpc::Service::MarkMethodAsync(47);
    }
    ~WithAsyncMethod_ListHcxActivationKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHcxActivationKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListHcxActivationKeys(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(47, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetHcxActivationKey() {
      ::grpc::Service::MarkMethodAsync(48);
    }
    ~WithAsyncMethod_GetHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* /*request*/, ::google::cloud::vmwareengine::v1::HcxActivationKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetHcxActivationKey(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::HcxActivationKey>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(48, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetNetworkPolicy() {
      ::grpc::Service::MarkMethodAsync(49);
    }
    ~WithAsyncMethod_GetNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNetworkPolicy(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::NetworkPolicy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(49, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListNetworkPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListNetworkPolicies() {
      ::grpc::Service::MarkMethodAsync(50);
    }
    ~WithAsyncMethod_ListNetworkPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworkPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNetworkPolicies(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(50, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateNetworkPolicy() {
      ::grpc::Service::MarkMethodAsync(51);
    }
    ~WithAsyncMethod_CreateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateNetworkPolicy(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(51, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateNetworkPolicy() {
      ::grpc::Service::MarkMethodAsync(52);
    }
    ~WithAsyncMethod_UpdateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateNetworkPolicy(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(52, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteNetworkPolicy() {
      ::grpc::Service::MarkMethodAsync(53);
    }
    ~WithAsyncMethod_DeleteNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteNetworkPolicy(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(53, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListManagementDnsZoneBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListManagementDnsZoneBindings() {
      ::grpc::Service::MarkMethodAsync(54);
    }
    ~WithAsyncMethod_ListManagementDnsZoneBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListManagementDnsZoneBindings(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListManagementDnsZoneBindings(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(54, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodAsync(55);
    }
    ~WithAsyncMethod_GetManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest* /*request*/, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetManagementDnsZoneBinding(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(55, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodAsync(56);
    }
    ~WithAsyncMethod_CreateManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateManagementDnsZoneBinding(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(56, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodAsync(57);
    }
    ~WithAsyncMethod_UpdateManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateManagementDnsZoneBinding(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(57, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodAsync(58);
    }
    ~WithAsyncMethod_DeleteManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteManagementDnsZoneBinding(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(58, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RepairManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RepairManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodAsync(59);
    }
    ~WithAsyncMethod_RepairManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RepairManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRepairManagementDnsZoneBinding(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(59, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodAsync(60);
    }
    ~WithAsyncMethod_CreateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateVmwareEngineNetwork(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(60, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodAsync(61);
    }
    ~WithAsyncMethod_UpdateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateVmwareEngineNetwork(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(61, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodAsync(62);
    }
    ~WithAsyncMethod_DeleteVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteVmwareEngineNetwork(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(62, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodAsync(63);
    }
    ~WithAsyncMethod_GetVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* /*request*/, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVmwareEngineNetwork(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(63, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListVmwareEngineNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListVmwareEngineNetworks() {
      ::grpc::Service::MarkMethodAsync(64);
    }
    ~WithAsyncMethod_ListVmwareEngineNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVmwareEngineNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListVmwareEngineNetworks(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(64, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreatePrivateConnection() {
      ::grpc::Service::MarkMethodAsync(65);
    }
    ~WithAsyncMethod_CreatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePrivateConnection(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(65, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPrivateConnection() {
      ::grpc::Service::MarkMethodAsync(66);
    }
    ~WithAsyncMethod_GetPrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPrivateConnection(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::PrivateConnection>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(66, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPrivateConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPrivateConnections() {
      ::grpc::Service::MarkMethodAsync(67);
    }
    ~WithAsyncMethod_ListPrivateConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPrivateConnections(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(67, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdatePrivateConnection() {
      ::grpc::Service::MarkMethodAsync(68);
    }
    ~WithAsyncMethod_UpdatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePrivateConnection(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(68, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeletePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeletePrivateConnection() {
      ::grpc::Service::MarkMethodAsync(69);
    }
    ~WithAsyncMethod_DeletePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePrivateConnection(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(69, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPrivateConnectionPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPrivateConnectionPeeringRoutes() {
      ::grpc::Service::MarkMethodAsync(70);
    }
    ~WithAsyncMethod_ListPrivateConnectionPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPrivateConnectionPeeringRoutes(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(70, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GrantDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GrantDnsBindPermission() {
      ::grpc::Service::MarkMethodAsync(71);
    }
    ~WithAsyncMethod_GrantDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GrantDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGrantDnsBindPermission(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(71, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDnsBindPermission() {
      ::grpc::Service::MarkMethodAsync(72);
    }
    ~WithAsyncMethod_GetDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest* /*request*/, ::google::cloud::vmwareengine::v1::DnsBindPermission* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDnsBindPermission(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::DnsBindPermission>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(72, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RevokeDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RevokeDnsBindPermission() {
      ::grpc::Service::MarkMethodAsync(73);
    }
    ~WithAsyncMethod_RevokeDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RevokeDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRevokeDnsBindPermission(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(73, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListPrivateClouds<WithAsyncMethod_GetPrivateCloud<WithAsyncMethod_CreatePrivateCloud<WithAsyncMethod_UpdatePrivateCloud<WithAsyncMethod_DeletePrivateCloud<WithAsyncMethod_UndeletePrivateCloud<WithAsyncMethod_ListClusters<WithAsyncMethod_GetCluster<WithAsyncMethod_CreateCluster<WithAsyncMethod_UpdateCluster<WithAsyncMethod_DeleteCluster<WithAsyncMethod_ListNodes<WithAsyncMethod_GetNode<WithAsyncMethod_ListExternalAddresses<WithAsyncMethod_FetchNetworkPolicyExternalAddresses<WithAsyncMethod_GetExternalAddress<WithAsyncMethod_CreateExternalAddress<WithAsyncMethod_UpdateExternalAddress<WithAsyncMethod_DeleteExternalAddress<WithAsyncMethod_ListSubnets<WithAsyncMethod_GetSubnet<WithAsyncMethod_UpdateSubnet<WithAsyncMethod_ListExternalAccessRules<WithAsyncMethod_GetExternalAccessRule<WithAsyncMethod_CreateExternalAccessRule<WithAsyncMethod_UpdateExternalAccessRule<WithAsyncMethod_DeleteExternalAccessRule<WithAsyncMethod_ListLoggingServers<WithAsyncMethod_GetLoggingServer<WithAsyncMethod_CreateLoggingServer<WithAsyncMethod_UpdateLoggingServer<WithAsyncMethod_DeleteLoggingServer<WithAsyncMethod_ListNodeTypes<WithAsyncMethod_GetNodeType<WithAsyncMethod_ShowNsxCredentials<WithAsyncMethod_ShowVcenterCredentials<WithAsyncMethod_ResetNsxCredentials<WithAsyncMethod_ResetVcenterCredentials<WithAsyncMethod_GetDnsForwarding<WithAsyncMethod_UpdateDnsForwarding<WithAsyncMethod_GetNetworkPeering<WithAsyncMethod_ListNetworkPeerings<WithAsyncMethod_CreateNetworkPeering<WithAsyncMethod_DeleteNetworkPeering<WithAsyncMethod_UpdateNetworkPeering<WithAsyncMethod_ListPeeringRoutes<WithAsyncMethod_CreateHcxActivationKey<WithAsyncMethod_ListHcxActivationKeys<WithAsyncMethod_GetHcxActivationKey<WithAsyncMethod_GetNetworkPolicy<WithAsyncMethod_ListNetworkPolicies<WithAsyncMethod_CreateNetworkPolicy<WithAsyncMethod_UpdateNetworkPolicy<WithAsyncMethod_DeleteNetworkPolicy<WithAsyncMethod_ListManagementDnsZoneBindings<WithAsyncMethod_GetManagementDnsZoneBinding<WithAsyncMethod_CreateManagementDnsZoneBinding<WithAsyncMethod_UpdateManagementDnsZoneBinding<WithAsyncMethod_DeleteManagementDnsZoneBinding<WithAsyncMethod_RepairManagementDnsZoneBinding<WithAsyncMethod_CreateVmwareEngineNetwork<WithAsyncMethod_UpdateVmwareEngineNetwork<WithAsyncMethod_DeleteVmwareEngineNetwork<WithAsyncMethod_GetVmwareEngineNetwork<WithAsyncMethod_ListVmwareEngineNetworks<WithAsyncMethod_CreatePrivateConnection<WithAsyncMethod_GetPrivateConnection<WithAsyncMethod_ListPrivateConnections<WithAsyncMethod_UpdatePrivateConnection<WithAsyncMethod_DeletePrivateConnection<WithAsyncMethod_ListPrivateConnectionPeeringRoutes<WithAsyncMethod_GrantDnsBindPermission<WithAsyncMethod_GetDnsBindPermission<WithAsyncMethod_RevokeDnsBindPermission<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListPrivateClouds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPrivateClouds() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* response) { return this->ListPrivateClouds(context, request, response); }));}
    void SetMessageAllocatorFor_ListPrivateClouds(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPrivateClouds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateClouds(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPrivateClouds(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetPrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPrivateCloud() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest, ::google::cloud::vmwareengine::v1::PrivateCloud>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* request, ::google::cloud::vmwareengine::v1::PrivateCloud* response) { return this->GetPrivateCloud(context, request, response); }));}
    void SetMessageAllocatorFor_GetPrivateCloud(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest, ::google::cloud::vmwareengine::v1::PrivateCloud>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest, ::google::cloud::vmwareengine::v1::PrivateCloud>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateCloud* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateCloud* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreatePrivateCloud() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* request, ::google::longrunning::Operation* response) { return this->CreatePrivateCloud(context, request, response); }));}
    void SetMessageAllocatorFor_CreatePrivateCloud(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdatePrivateCloud() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* request, ::google::longrunning::Operation* response) { return this->UpdatePrivateCloud(context, request, response); }));}
    void SetMessageAllocatorFor_UpdatePrivateCloud(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeletePrivateCloud() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* request, ::google::longrunning::Operation* response) { return this->DeletePrivateCloud(context, request, response); }));}
    void SetMessageAllocatorFor_DeletePrivateCloud(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UndeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UndeletePrivateCloud() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* request, ::google::longrunning::Operation* response) { return this->UndeletePrivateCloud(context, request, response); }));}
    void SetMessageAllocatorFor_UndeletePrivateCloud(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UndeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeletePrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListClusters() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListClustersRequest, ::google::cloud::vmwareengine::v1::ListClustersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest* request, ::google::cloud::vmwareengine::v1::ListClustersResponse* response) { return this->ListClusters(context, request, response); }));}
    void SetMessageAllocatorFor_ListClusters(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListClustersRequest, ::google::cloud::vmwareengine::v1::ListClustersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListClustersRequest, ::google::cloud::vmwareengine::v1::ListClustersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListClustersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListClusters(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListClustersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListClustersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCluster() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetClusterRequest, ::google::cloud::vmwareengine::v1::Cluster>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest* request, ::google::cloud::vmwareengine::v1::Cluster* response) { return this->GetCluster(context, request, response); }));}
    void SetMessageAllocatorFor_GetCluster(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetClusterRequest, ::google::cloud::vmwareengine::v1::Cluster>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetClusterRequest, ::google::cloud::vmwareengine::v1::Cluster>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetClusterRequest* /*request*/, ::google::cloud::vmwareengine::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetClusterRequest* /*request*/, ::google::cloud::vmwareengine::v1::Cluster* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCluster() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response) { return this->CreateCluster(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCluster(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreateClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response) { return this->UpdateCluster(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCluster(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdateClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response) { return this->DeleteCluster(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteCluster(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::DeleteClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListNodes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListNodes() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListNodesRequest, ::google::cloud::vmwareengine::v1::ListNodesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListNodesRequest* request, ::google::cloud::vmwareengine::v1::ListNodesResponse* response) { return this->ListNodes(context, request, response); }));}
    void SetMessageAllocatorFor_ListNodes(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListNodesRequest, ::google::cloud::vmwareengine::v1::ListNodesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListNodesRequest, ::google::cloud::vmwareengine::v1::ListNodesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListNodes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNodes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetNode() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetNodeRequest, ::google::cloud::vmwareengine::v1::Node>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetNodeRequest* request, ::google::cloud::vmwareengine::v1::Node* response) { return this->GetNode(context, request, response); }));}
    void SetMessageAllocatorFor_GetNode(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetNodeRequest, ::google::cloud::vmwareengine::v1::Node>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetNodeRequest, ::google::cloud::vmwareengine::v1::Node>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNode(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeRequest* /*request*/, ::google::cloud::vmwareengine::v1::Node* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNode(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeRequest* /*request*/, ::google::cloud::vmwareengine::v1::Node* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListExternalAddresses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListExternalAddresses() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest* request, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse* response) { return this->ListExternalAddresses(context, request, response); }));}
    void SetMessageAllocatorFor_ListExternalAddresses(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListExternalAddresses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExternalAddresses(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListExternalAddresses(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_FetchNetworkPolicyExternalAddresses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_FetchNetworkPolicyExternalAddresses() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest* request, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse* response) { return this->FetchNetworkPolicyExternalAddresses(context, request, response); }));}
    void SetMessageAllocatorFor_FetchNetworkPolicyExternalAddresses(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_FetchNetworkPolicyExternalAddresses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchNetworkPolicyExternalAddresses(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest* /*request*/, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FetchNetworkPolicyExternalAddresses(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest* /*request*/, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetExternalAddress() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetExternalAddressRequest, ::google::cloud::vmwareengine::v1::ExternalAddress>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest* request, ::google::cloud::vmwareengine::v1::ExternalAddress* response) { return this->GetExternalAddress(context, request, response); }));}
    void SetMessageAllocatorFor_GetExternalAddress(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetExternalAddressRequest, ::google::cloud::vmwareengine::v1::ExternalAddress>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetExternalAddressRequest, ::google::cloud::vmwareengine::v1::ExternalAddress>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest* /*request*/, ::google::cloud::vmwareengine::v1::ExternalAddress* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetExternalAddress(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest* /*request*/, ::google::cloud::vmwareengine::v1::ExternalAddress* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateExternalAddress() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest* request, ::google::longrunning::Operation* response) { return this->CreateExternalAddress(context, request, response); }));}
    void SetMessageAllocatorFor_CreateExternalAddress(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateExternalAddress(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateExternalAddress() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest* request, ::google::longrunning::Operation* response) { return this->UpdateExternalAddress(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateExternalAddress(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateExternalAddress(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteExternalAddress() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest* request, ::google::longrunning::Operation* response) { return this->DeleteExternalAddress(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteExternalAddress(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteExternalAddress(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSubnets() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListSubnetsRequest, ::google::cloud::vmwareengine::v1::ListSubnetsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* request, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* response) { return this->ListSubnets(context, request, response); }));}
    void SetMessageAllocatorFor_ListSubnets(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListSubnetsRequest, ::google::cloud::vmwareengine::v1::ListSubnetsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListSubnetsRequest, ::google::cloud::vmwareengine::v1::ListSubnetsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSubnets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetSubnet() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetSubnetRequest, ::google::cloud::vmwareengine::v1::Subnet>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* request, ::google::cloud::vmwareengine::v1::Subnet* response) { return this->GetSubnet(context, request, response); }));}
    void SetMessageAllocatorFor_GetSubnet(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetSubnetRequest, ::google::cloud::vmwareengine::v1::Subnet>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetSubnetRequest, ::google::cloud::vmwareengine::v1::Subnet>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* /*request*/, ::google::cloud::vmwareengine::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSubnet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* /*request*/, ::google::cloud::vmwareengine::v1::Subnet* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateSubnetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response) { return this->UpdateSubnet(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateSubnet(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdateSubnetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateSubnetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSubnet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListExternalAccessRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListExternalAccessRules() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest* request, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse* response) { return this->ListExternalAccessRules(context, request, response); }));}
    void SetMessageAllocatorFor_ListExternalAccessRules(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListExternalAccessRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExternalAccessRules(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListExternalAccessRules(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetExternalAccessRule() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest, ::google::cloud::vmwareengine::v1::ExternalAccessRule>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest* request, ::google::cloud::vmwareengine::v1::ExternalAccessRule* response) { return this->GetExternalAccessRule(context, request, response); }));}
    void SetMessageAllocatorFor_GetExternalAccessRule(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest, ::google::cloud::vmwareengine::v1::ExternalAccessRule>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest, ::google::cloud::vmwareengine::v1::ExternalAccessRule>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest* /*request*/, ::google::cloud::vmwareengine::v1::ExternalAccessRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetExternalAccessRule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest* /*request*/, ::google::cloud::vmwareengine::v1::ExternalAccessRule* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateExternalAccessRule() {
      ::grpc::Service::MarkMethodCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest* request, ::google::longrunning::Operation* response) { return this->CreateExternalAccessRule(context, request, response); }));}
    void SetMessageAllocatorFor_CreateExternalAccessRule(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(24);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateExternalAccessRule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateExternalAccessRule() {
      ::grpc::Service::MarkMethodCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest* request, ::google::longrunning::Operation* response) { return this->UpdateExternalAccessRule(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateExternalAccessRule(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(25);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateExternalAccessRule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteExternalAccessRule() {
      ::grpc::Service::MarkMethodCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest* request, ::google::longrunning::Operation* response) { return this->DeleteExternalAccessRule(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteExternalAccessRule(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(26);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteExternalAccessRule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListLoggingServers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListLoggingServers() {
      ::grpc::Service::MarkMethodCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListLoggingServersRequest, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest* request, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse* response) { return this->ListLoggingServers(context, request, response); }));}
    void SetMessageAllocatorFor_ListLoggingServers(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListLoggingServersRequest, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(27);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListLoggingServersRequest, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListLoggingServers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLoggingServers(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListLoggingServers(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetLoggingServer() {
      ::grpc::Service::MarkMethodCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetLoggingServerRequest, ::google::cloud::vmwareengine::v1::LoggingServer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest* request, ::google::cloud::vmwareengine::v1::LoggingServer* response) { return this->GetLoggingServer(context, request, response); }));}
    void SetMessageAllocatorFor_GetLoggingServer(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetLoggingServerRequest, ::google::cloud::vmwareengine::v1::LoggingServer>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(28);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetLoggingServerRequest, ::google::cloud::vmwareengine::v1::LoggingServer>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest* /*request*/, ::google::cloud::vmwareengine::v1::LoggingServer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetLoggingServer(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest* /*request*/, ::google::cloud::vmwareengine::v1::LoggingServer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateLoggingServer() {
      ::grpc::Service::MarkMethodCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest* request, ::google::longrunning::Operation* response) { return this->CreateLoggingServer(context, request, response); }));}
    void SetMessageAllocatorFor_CreateLoggingServer(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(29);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateLoggingServer(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateLoggingServer() {
      ::grpc::Service::MarkMethodCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest* request, ::google::longrunning::Operation* response) { return this->UpdateLoggingServer(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateLoggingServer(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(30);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateLoggingServer(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteLoggingServer() {
      ::grpc::Service::MarkMethodCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest* request, ::google::longrunning::Operation* response) { return this->DeleteLoggingServer(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteLoggingServer(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(31);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteLoggingServer(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListNodeTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListNodeTypes() {
      ::grpc::Service::MarkMethodCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListNodeTypesRequest, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* request, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* response) { return this->ListNodeTypes(context, request, response); }));}
    void SetMessageAllocatorFor_ListNodeTypes(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListNodeTypesRequest, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(32);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListNodeTypesRequest, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListNodeTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodeTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNodeTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetNodeType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetNodeType() {
      ::grpc::Service::MarkMethodCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetNodeTypeRequest, ::google::cloud::vmwareengine::v1::NodeType>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* request, ::google::cloud::vmwareengine::v1::NodeType* response) { return this->GetNodeType(context, request, response); }));}
    void SetMessageAllocatorFor_GetNodeType(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetNodeTypeRequest, ::google::cloud::vmwareengine::v1::NodeType>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(33);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetNodeTypeRequest, ::google::cloud::vmwareengine::v1::NodeType>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetNodeType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNodeType(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* /*request*/, ::google::cloud::vmwareengine::v1::NodeType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNodeType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* /*request*/, ::google::cloud::vmwareengine::v1::NodeType* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ShowNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ShowNsxCredentials() {
      ::grpc::Service::MarkMethodCallback(34,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response) { return this->ShowNsxCredentials(context, request, response); }));}
    void SetMessageAllocatorFor_ShowNsxCredentials(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(34);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ShowNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ShowNsxCredentials(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ShowVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ShowVcenterCredentials() {
      ::grpc::Service::MarkMethodCallback(35,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response) { return this->ShowVcenterCredentials(context, request, response); }));}
    void SetMessageAllocatorFor_ShowVcenterCredentials(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(35);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ShowVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ShowVcenterCredentials(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ResetNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ResetNsxCredentials() {
      ::grpc::Service::MarkMethodCallback(36,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* request, ::google::longrunning::Operation* response) { return this->ResetNsxCredentials(context, request, response); }));}
    void SetMessageAllocatorFor_ResetNsxCredentials(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(36);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ResetNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetNsxCredentials(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ResetVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ResetVcenterCredentials() {
      ::grpc::Service::MarkMethodCallback(37,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* request, ::google::longrunning::Operation* response) { return this->ResetVcenterCredentials(context, request, response); }));}
    void SetMessageAllocatorFor_ResetVcenterCredentials(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(37);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ResetVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetVcenterCredentials(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDnsForwarding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDnsForwarding() {
      ::grpc::Service::MarkMethodCallback(38,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest, ::google::cloud::vmwareengine::v1::DnsForwarding>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest* request, ::google::cloud::vmwareengine::v1::DnsForwarding* response) { return this->GetDnsForwarding(context, request, response); }));}
    void SetMessageAllocatorFor_GetDnsForwarding(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest, ::google::cloud::vmwareengine::v1::DnsForwarding>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(38);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest, ::google::cloud::vmwareengine::v1::DnsForwarding>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDnsForwarding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDnsForwarding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest* /*request*/, ::google::cloud::vmwareengine::v1::DnsForwarding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDnsForwarding(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest* /*request*/, ::google::cloud::vmwareengine::v1::DnsForwarding* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateDnsForwarding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateDnsForwarding() {
      ::grpc::Service::MarkMethodCallback(39,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest* request, ::google::longrunning::Operation* response) { return this->UpdateDnsForwarding(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateDnsForwarding(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(39);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateDnsForwarding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDnsForwarding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDnsForwarding(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetNetworkPeering() {
      ::grpc::Service::MarkMethodCallback(40,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest, ::google::cloud::vmwareengine::v1::NetworkPeering>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest* request, ::google::cloud::vmwareengine::v1::NetworkPeering* response) { return this->GetNetworkPeering(context, request, response); }));}
    void SetMessageAllocatorFor_GetNetworkPeering(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest, ::google::cloud::vmwareengine::v1::NetworkPeering>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(40);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest, ::google::cloud::vmwareengine::v1::NetworkPeering>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPeering* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNetworkPeering(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPeering* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListNetworkPeerings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListNetworkPeerings() {
      ::grpc::Service::MarkMethodCallback(41,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse* response) { return this->ListNetworkPeerings(context, request, response); }));}
    void SetMessageAllocatorFor_ListNetworkPeerings(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(41);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListNetworkPeerings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworkPeerings(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNetworkPeerings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateNetworkPeering() {
      ::grpc::Service::MarkMethodCallback(42,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest* request, ::google::longrunning::Operation* response) { return this->CreateNetworkPeering(context, request, response); }));}
    void SetMessageAllocatorFor_CreateNetworkPeering(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(42);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateNetworkPeering(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteNetworkPeering() {
      ::grpc::Service::MarkMethodCallback(43,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest* request, ::google::longrunning::Operation* response) { return this->DeleteNetworkPeering(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteNetworkPeering(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(43);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteNetworkPeering(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateNetworkPeering() {
      ::grpc::Service::MarkMethodCallback(44,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest* request, ::google::longrunning::Operation* response) { return this->UpdateNetworkPeering(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateNetworkPeering(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(44);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateNetworkPeering(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPeeringRoutes() {
      ::grpc::Service::MarkMethodCallback(45,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse* response) { return this->ListPeeringRoutes(context, request, response); }));}
    void SetMessageAllocatorFor_ListPeeringRoutes(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(45);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPeeringRoutes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateHcxActivationKey() {
      ::grpc::Service::MarkMethodCallback(46,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* request, ::google::longrunning::Operation* response) { return this->CreateHcxActivationKey(context, request, response); }));}
    void SetMessageAllocatorFor_CreateHcxActivationKey(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(46);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateHcxActivationKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListHcxActivationKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListHcxActivationKeys() {
      ::grpc::Service::MarkMethodCallback(47,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* request, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* response) { return this->ListHcxActivationKeys(context, request, response); }));}
    void SetMessageAllocatorFor_ListHcxActivationKeys(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(47);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListHcxActivationKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHcxActivationKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListHcxActivationKeys(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetHcxActivationKey() {
      ::grpc::Service::MarkMethodCallback(48,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest, ::google::cloud::vmwareengine::v1::HcxActivationKey>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* request, ::google::cloud::vmwareengine::v1::HcxActivationKey* response) { return this->GetHcxActivationKey(context, request, response); }));}
    void SetMessageAllocatorFor_GetHcxActivationKey(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest, ::google::cloud::vmwareengine::v1::HcxActivationKey>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(48);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest, ::google::cloud::vmwareengine::v1::HcxActivationKey>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* /*request*/, ::google::cloud::vmwareengine::v1::HcxActivationKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetHcxActivationKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* /*request*/, ::google::cloud::vmwareengine::v1::HcxActivationKey* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetNetworkPolicy() {
      ::grpc::Service::MarkMethodCallback(49,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest, ::google::cloud::vmwareengine::v1::NetworkPolicy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* request, ::google::cloud::vmwareengine::v1::NetworkPolicy* response) { return this->GetNetworkPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetNetworkPolicy(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest, ::google::cloud::vmwareengine::v1::NetworkPolicy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(49);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest, ::google::cloud::vmwareengine::v1::NetworkPolicy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNetworkPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPolicy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListNetworkPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListNetworkPolicies() {
      ::grpc::Service::MarkMethodCallback(50,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* response) { return this->ListNetworkPolicies(context, request, response); }));}
    void SetMessageAllocatorFor_ListNetworkPolicies(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(50);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListNetworkPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworkPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNetworkPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateNetworkPolicy() {
      ::grpc::Service::MarkMethodCallback(51,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* request, ::google::longrunning::Operation* response) { return this->CreateNetworkPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_CreateNetworkPolicy(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(51);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateNetworkPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateNetworkPolicy() {
      ::grpc::Service::MarkMethodCallback(52,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* request, ::google::longrunning::Operation* response) { return this->UpdateNetworkPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateNetworkPolicy(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(52);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateNetworkPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteNetworkPolicy() {
      ::grpc::Service::MarkMethodCallback(53,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* request, ::google::longrunning::Operation* response) { return this->DeleteNetworkPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteNetworkPolicy(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(53);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteNetworkPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListManagementDnsZoneBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListManagementDnsZoneBindings() {
      ::grpc::Service::MarkMethodCallback(54,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest* request, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse* response) { return this->ListManagementDnsZoneBindings(context, request, response); }));}
    void SetMessageAllocatorFor_ListManagementDnsZoneBindings(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(54);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListManagementDnsZoneBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListManagementDnsZoneBindings(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListManagementDnsZoneBindings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodCallback(55,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest* request, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding* response) { return this->GetManagementDnsZoneBinding(context, request, response); }));}
    void SetMessageAllocatorFor_GetManagementDnsZoneBinding(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(55);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest* /*request*/, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetManagementDnsZoneBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest* /*request*/, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodCallback(56,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response) { return this->CreateManagementDnsZoneBinding(context, request, response); }));}
    void SetMessageAllocatorFor_CreateManagementDnsZoneBinding(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(56);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateManagementDnsZoneBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodCallback(57,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response) { return this->UpdateManagementDnsZoneBinding(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateManagementDnsZoneBinding(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(57);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateManagementDnsZoneBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodCallback(58,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response) { return this->DeleteManagementDnsZoneBinding(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteManagementDnsZoneBinding(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(58);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteManagementDnsZoneBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RepairManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RepairManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodCallback(59,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest* request, ::google::longrunning::Operation* response) { return this->RepairManagementDnsZoneBinding(context, request, response); }));}
    void SetMessageAllocatorFor_RepairManagementDnsZoneBinding(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(59);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RepairManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RepairManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RepairManagementDnsZoneBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodCallback(60,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response) { return this->CreateVmwareEngineNetwork(context, request, response); }));}
    void SetMessageAllocatorFor_CreateVmwareEngineNetwork(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(60);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateVmwareEngineNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodCallback(61,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response) { return this->UpdateVmwareEngineNetwork(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateVmwareEngineNetwork(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(61);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateVmwareEngineNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodCallback(62,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response) { return this->DeleteVmwareEngineNetwork(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteVmwareEngineNetwork(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(62);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteVmwareEngineNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodCallback(63,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* request, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* response) { return this->GetVmwareEngineNetwork(context, request, response); }));}
    void SetMessageAllocatorFor_GetVmwareEngineNetwork(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(63);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* /*request*/, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVmwareEngineNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* /*request*/, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListVmwareEngineNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListVmwareEngineNetworks() {
      ::grpc::Service::MarkMethodCallback(64,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* request, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* response) { return this->ListVmwareEngineNetworks(context, request, response); }));}
    void SetMessageAllocatorFor_ListVmwareEngineNetworks(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(64);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListVmwareEngineNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVmwareEngineNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListVmwareEngineNetworks(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreatePrivateConnection() {
      ::grpc::Service::MarkMethodCallback(65,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* request, ::google::longrunning::Operation* response) { return this->CreatePrivateConnection(context, request, response); }));}
    void SetMessageAllocatorFor_CreatePrivateConnection(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(65);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePrivateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetPrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPrivateConnection() {
      ::grpc::Service::MarkMethodCallback(66,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest, ::google::cloud::vmwareengine::v1::PrivateConnection>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* request, ::google::cloud::vmwareengine::v1::PrivateConnection* response) { return this->GetPrivateConnection(context, request, response); }));}
    void SetMessageAllocatorFor_GetPrivateConnection(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest, ::google::cloud::vmwareengine::v1::PrivateConnection>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(66);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest, ::google::cloud::vmwareengine::v1::PrivateConnection>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPrivateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateConnection* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPrivateConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPrivateConnections() {
      ::grpc::Service::MarkMethodCallback(67,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* response) { return this->ListPrivateConnections(context, request, response); }));}
    void SetMessageAllocatorFor_ListPrivateConnections(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(67);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPrivateConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPrivateConnections(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdatePrivateConnection() {
      ::grpc::Service::MarkMethodCallback(68,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* request, ::google::longrunning::Operation* response) { return this->UpdatePrivateConnection(context, request, response); }));}
    void SetMessageAllocatorFor_UpdatePrivateConnection(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(68);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePrivateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeletePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeletePrivateConnection() {
      ::grpc::Service::MarkMethodCallback(69,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* request, ::google::longrunning::Operation* response) { return this->DeletePrivateConnection(context, request, response); }));}
    void SetMessageAllocatorFor_DeletePrivateConnection(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(69);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeletePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePrivateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPrivateConnectionPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPrivateConnectionPeeringRoutes() {
      ::grpc::Service::MarkMethodCallback(70,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* response) { return this->ListPrivateConnectionPeeringRoutes(context, request, response); }));}
    void SetMessageAllocatorFor_ListPrivateConnectionPeeringRoutes(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(70);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPrivateConnectionPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPrivateConnectionPeeringRoutes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GrantDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GrantDnsBindPermission() {
      ::grpc::Service::MarkMethodCallback(71,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest* request, ::google::longrunning::Operation* response) { return this->GrantDnsBindPermission(context, request, response); }));}
    void SetMessageAllocatorFor_GrantDnsBindPermission(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(71);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GrantDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GrantDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GrantDnsBindPermission(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDnsBindPermission() {
      ::grpc::Service::MarkMethodCallback(72,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest, ::google::cloud::vmwareengine::v1::DnsBindPermission>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest* request, ::google::cloud::vmwareengine::v1::DnsBindPermission* response) { return this->GetDnsBindPermission(context, request, response); }));}
    void SetMessageAllocatorFor_GetDnsBindPermission(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest, ::google::cloud::vmwareengine::v1::DnsBindPermission>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(72);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest, ::google::cloud::vmwareengine::v1::DnsBindPermission>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest* /*request*/, ::google::cloud::vmwareengine::v1::DnsBindPermission* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDnsBindPermission(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest* /*request*/, ::google::cloud::vmwareengine::v1::DnsBindPermission* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RevokeDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RevokeDnsBindPermission() {
      ::grpc::Service::MarkMethodCallback(73,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest* request, ::google::longrunning::Operation* response) { return this->RevokeDnsBindPermission(context, request, response); }));}
    void SetMessageAllocatorFor_RevokeDnsBindPermission(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(73);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RevokeDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RevokeDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RevokeDnsBindPermission(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListPrivateClouds<WithCallbackMethod_GetPrivateCloud<WithCallbackMethod_CreatePrivateCloud<WithCallbackMethod_UpdatePrivateCloud<WithCallbackMethod_DeletePrivateCloud<WithCallbackMethod_UndeletePrivateCloud<WithCallbackMethod_ListClusters<WithCallbackMethod_GetCluster<WithCallbackMethod_CreateCluster<WithCallbackMethod_UpdateCluster<WithCallbackMethod_DeleteCluster<WithCallbackMethod_ListNodes<WithCallbackMethod_GetNode<WithCallbackMethod_ListExternalAddresses<WithCallbackMethod_FetchNetworkPolicyExternalAddresses<WithCallbackMethod_GetExternalAddress<WithCallbackMethod_CreateExternalAddress<WithCallbackMethod_UpdateExternalAddress<WithCallbackMethod_DeleteExternalAddress<WithCallbackMethod_ListSubnets<WithCallbackMethod_GetSubnet<WithCallbackMethod_UpdateSubnet<WithCallbackMethod_ListExternalAccessRules<WithCallbackMethod_GetExternalAccessRule<WithCallbackMethod_CreateExternalAccessRule<WithCallbackMethod_UpdateExternalAccessRule<WithCallbackMethod_DeleteExternalAccessRule<WithCallbackMethod_ListLoggingServers<WithCallbackMethod_GetLoggingServer<WithCallbackMethod_CreateLoggingServer<WithCallbackMethod_UpdateLoggingServer<WithCallbackMethod_DeleteLoggingServer<WithCallbackMethod_ListNodeTypes<WithCallbackMethod_GetNodeType<WithCallbackMethod_ShowNsxCredentials<WithCallbackMethod_ShowVcenterCredentials<WithCallbackMethod_ResetNsxCredentials<WithCallbackMethod_ResetVcenterCredentials<WithCallbackMethod_GetDnsForwarding<WithCallbackMethod_UpdateDnsForwarding<WithCallbackMethod_GetNetworkPeering<WithCallbackMethod_ListNetworkPeerings<WithCallbackMethod_CreateNetworkPeering<WithCallbackMethod_DeleteNetworkPeering<WithCallbackMethod_UpdateNetworkPeering<WithCallbackMethod_ListPeeringRoutes<WithCallbackMethod_CreateHcxActivationKey<WithCallbackMethod_ListHcxActivationKeys<WithCallbackMethod_GetHcxActivationKey<WithCallbackMethod_GetNetworkPolicy<WithCallbackMethod_ListNetworkPolicies<WithCallbackMethod_CreateNetworkPolicy<WithCallbackMethod_UpdateNetworkPolicy<WithCallbackMethod_DeleteNetworkPolicy<WithCallbackMethod_ListManagementDnsZoneBindings<WithCallbackMethod_GetManagementDnsZoneBinding<WithCallbackMethod_CreateManagementDnsZoneBinding<WithCallbackMethod_UpdateManagementDnsZoneBinding<WithCallbackMethod_DeleteManagementDnsZoneBinding<WithCallbackMethod_RepairManagementDnsZoneBinding<WithCallbackMethod_CreateVmwareEngineNetwork<WithCallbackMethod_UpdateVmwareEngineNetwork<WithCallbackMethod_DeleteVmwareEngineNetwork<WithCallbackMethod_GetVmwareEngineNetwork<WithCallbackMethod_ListVmwareEngineNetworks<WithCallbackMethod_CreatePrivateConnection<WithCallbackMethod_GetPrivateConnection<WithCallbackMethod_ListPrivateConnections<WithCallbackMethod_UpdatePrivateConnection<WithCallbackMethod_DeletePrivateConnection<WithCallbackMethod_ListPrivateConnectionPeeringRoutes<WithCallbackMethod_GrantDnsBindPermission<WithCallbackMethod_GetDnsBindPermission<WithCallbackMethod_RevokeDnsBindPermission<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListPrivateClouds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPrivateClouds() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListPrivateClouds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateClouds(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetPrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPrivateCloud() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetPrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateCloud* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreatePrivateCloud() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdatePrivateCloud() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeletePrivateCloud() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UndeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UndeletePrivateCloud() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_UndeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListClusters() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListClustersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCluster() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetClusterRequest* /*request*/, ::google::cloud::vmwareengine::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCluster() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListNodes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListNodes() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_ListNodes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetNode() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_GetNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNode(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeRequest* /*request*/, ::google::cloud::vmwareengine::v1::Node* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListExternalAddresses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListExternalAddresses() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_ListExternalAddresses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExternalAddresses(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_FetchNetworkPolicyExternalAddresses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_FetchNetworkPolicyExternalAddresses() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_FetchNetworkPolicyExternalAddresses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchNetworkPolicyExternalAddresses(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest* /*request*/, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetExternalAddress() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_GetExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest* /*request*/, ::google::cloud::vmwareengine::v1::ExternalAddress* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateExternalAddress() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_CreateExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateExternalAddress() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_UpdateExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteExternalAddress() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_DeleteExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSubnets() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetSubnet() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* /*request*/, ::google::cloud::vmwareengine::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListExternalAccessRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListExternalAccessRules() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_ListExternalAccessRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExternalAccessRules(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetExternalAccessRule() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_GetExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest* /*request*/, ::google::cloud::vmwareengine::v1::ExternalAccessRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateExternalAccessRule() {
      ::grpc::Service::MarkMethodGeneric(24);
    }
    ~WithGenericMethod_CreateExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateExternalAccessRule() {
      ::grpc::Service::MarkMethodGeneric(25);
    }
    ~WithGenericMethod_UpdateExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteExternalAccessRule() {
      ::grpc::Service::MarkMethodGeneric(26);
    }
    ~WithGenericMethod_DeleteExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListLoggingServers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListLoggingServers() {
      ::grpc::Service::MarkMethodGeneric(27);
    }
    ~WithGenericMethod_ListLoggingServers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLoggingServers(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetLoggingServer() {
      ::grpc::Service::MarkMethodGeneric(28);
    }
    ~WithGenericMethod_GetLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest* /*request*/, ::google::cloud::vmwareengine::v1::LoggingServer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateLoggingServer() {
      ::grpc::Service::MarkMethodGeneric(29);
    }
    ~WithGenericMethod_CreateLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateLoggingServer() {
      ::grpc::Service::MarkMethodGeneric(30);
    }
    ~WithGenericMethod_UpdateLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteLoggingServer() {
      ::grpc::Service::MarkMethodGeneric(31);
    }
    ~WithGenericMethod_DeleteLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListNodeTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListNodeTypes() {
      ::grpc::Service::MarkMethodGeneric(32);
    }
    ~WithGenericMethod_ListNodeTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodeTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetNodeType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetNodeType() {
      ::grpc::Service::MarkMethodGeneric(33);
    }
    ~WithGenericMethod_GetNodeType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNodeType(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* /*request*/, ::google::cloud::vmwareengine::v1::NodeType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ShowNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ShowNsxCredentials() {
      ::grpc::Service::MarkMethodGeneric(34);
    }
    ~WithGenericMethod_ShowNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ShowVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ShowVcenterCredentials() {
      ::grpc::Service::MarkMethodGeneric(35);
    }
    ~WithGenericMethod_ShowVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ResetNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ResetNsxCredentials() {
      ::grpc::Service::MarkMethodGeneric(36);
    }
    ~WithGenericMethod_ResetNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ResetVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ResetVcenterCredentials() {
      ::grpc::Service::MarkMethodGeneric(37);
    }
    ~WithGenericMethod_ResetVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDnsForwarding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDnsForwarding() {
      ::grpc::Service::MarkMethodGeneric(38);
    }
    ~WithGenericMethod_GetDnsForwarding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDnsForwarding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest* /*request*/, ::google::cloud::vmwareengine::v1::DnsForwarding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateDnsForwarding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateDnsForwarding() {
      ::grpc::Service::MarkMethodGeneric(39);
    }
    ~WithGenericMethod_UpdateDnsForwarding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDnsForwarding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetNetworkPeering() {
      ::grpc::Service::MarkMethodGeneric(40);
    }
    ~WithGenericMethod_GetNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPeering* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListNetworkPeerings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListNetworkPeerings() {
      ::grpc::Service::MarkMethodGeneric(41);
    }
    ~WithGenericMethod_ListNetworkPeerings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworkPeerings(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateNetworkPeering() {
      ::grpc::Service::MarkMethodGeneric(42);
    }
    ~WithGenericMethod_CreateNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteNetworkPeering() {
      ::grpc::Service::MarkMethodGeneric(43);
    }
    ~WithGenericMethod_DeleteNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateNetworkPeering() {
      ::grpc::Service::MarkMethodGeneric(44);
    }
    ~WithGenericMethod_UpdateNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPeeringRoutes() {
      ::grpc::Service::MarkMethodGeneric(45);
    }
    ~WithGenericMethod_ListPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateHcxActivationKey() {
      ::grpc::Service::MarkMethodGeneric(46);
    }
    ~WithGenericMethod_CreateHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListHcxActivationKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListHcxActivationKeys() {
      ::grpc::Service::MarkMethodGeneric(47);
    }
    ~WithGenericMethod_ListHcxActivationKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHcxActivationKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetHcxActivationKey() {
      ::grpc::Service::MarkMethodGeneric(48);
    }
    ~WithGenericMethod_GetHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* /*request*/, ::google::cloud::vmwareengine::v1::HcxActivationKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetNetworkPolicy() {
      ::grpc::Service::MarkMethodGeneric(49);
    }
    ~WithGenericMethod_GetNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListNetworkPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListNetworkPolicies() {
      ::grpc::Service::MarkMethodGeneric(50);
    }
    ~WithGenericMethod_ListNetworkPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworkPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateNetworkPolicy() {
      ::grpc::Service::MarkMethodGeneric(51);
    }
    ~WithGenericMethod_CreateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateNetworkPolicy() {
      ::grpc::Service::MarkMethodGeneric(52);
    }
    ~WithGenericMethod_UpdateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteNetworkPolicy() {
      ::grpc::Service::MarkMethodGeneric(53);
    }
    ~WithGenericMethod_DeleteNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListManagementDnsZoneBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListManagementDnsZoneBindings() {
      ::grpc::Service::MarkMethodGeneric(54);
    }
    ~WithGenericMethod_ListManagementDnsZoneBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListManagementDnsZoneBindings(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodGeneric(55);
    }
    ~WithGenericMethod_GetManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest* /*request*/, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodGeneric(56);
    }
    ~WithGenericMethod_CreateManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodGeneric(57);
    }
    ~WithGenericMethod_UpdateManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodGeneric(58);
    }
    ~WithGenericMethod_DeleteManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RepairManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RepairManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodGeneric(59);
    }
    ~WithGenericMethod_RepairManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RepairManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodGeneric(60);
    }
    ~WithGenericMethod_CreateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodGeneric(61);
    }
    ~WithGenericMethod_UpdateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodGeneric(62);
    }
    ~WithGenericMethod_DeleteVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodGeneric(63);
    }
    ~WithGenericMethod_GetVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* /*request*/, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListVmwareEngineNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListVmwareEngineNetworks() {
      ::grpc::Service::MarkMethodGeneric(64);
    }
    ~WithGenericMethod_ListVmwareEngineNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVmwareEngineNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreatePrivateConnection() {
      ::grpc::Service::MarkMethodGeneric(65);
    }
    ~WithGenericMethod_CreatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetPrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPrivateConnection() {
      ::grpc::Service::MarkMethodGeneric(66);
    }
    ~WithGenericMethod_GetPrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPrivateConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPrivateConnections() {
      ::grpc::Service::MarkMethodGeneric(67);
    }
    ~WithGenericMethod_ListPrivateConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdatePrivateConnection() {
      ::grpc::Service::MarkMethodGeneric(68);
    }
    ~WithGenericMethod_UpdatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeletePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeletePrivateConnection() {
      ::grpc::Service::MarkMethodGeneric(69);
    }
    ~WithGenericMethod_DeletePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPrivateConnectionPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPrivateConnectionPeeringRoutes() {
      ::grpc::Service::MarkMethodGeneric(70);
    }
    ~WithGenericMethod_ListPrivateConnectionPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GrantDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GrantDnsBindPermission() {
      ::grpc::Service::MarkMethodGeneric(71);
    }
    ~WithGenericMethod_GrantDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GrantDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDnsBindPermission() {
      ::grpc::Service::MarkMethodGeneric(72);
    }
    ~WithGenericMethod_GetDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest* /*request*/, ::google::cloud::vmwareengine::v1::DnsBindPermission* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RevokeDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RevokeDnsBindPermission() {
      ::grpc::Service::MarkMethodGeneric(73);
    }
    ~WithGenericMethod_RevokeDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RevokeDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPrivateClouds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPrivateClouds() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListPrivateClouds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateClouds(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPrivateClouds(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPrivateCloud() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetPrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateCloud* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPrivateCloud(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreatePrivateCloud() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePrivateCloud(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdatePrivateCloud() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePrivateCloud(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeletePrivateCloud() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePrivateCloud(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UndeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UndeletePrivateCloud() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_UndeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeletePrivateCloud(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListClusters() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListClustersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListClusters(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCluster() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetClusterRequest* /*request*/, ::google::cloud::vmwareengine::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCluster() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListNodes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListNodes() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_ListNodes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNodes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetNode() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_GetNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNode(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeRequest* /*request*/, ::google::cloud::vmwareengine::v1::Node* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNode(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListExternalAddresses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListExternalAddresses() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_ListExternalAddresses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExternalAddresses(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListExternalAddresses(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_FetchNetworkPolicyExternalAddresses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_FetchNetworkPolicyExternalAddresses() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_FetchNetworkPolicyExternalAddresses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchNetworkPolicyExternalAddresses(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest* /*request*/, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFetchNetworkPolicyExternalAddresses(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetExternalAddress() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_GetExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest* /*request*/, ::google::cloud::vmwareengine::v1::ExternalAddress* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetExternalAddress(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateExternalAddress() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_CreateExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateExternalAddress(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateExternalAddress() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_UpdateExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateExternalAddress(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteExternalAddress() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_DeleteExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteExternalAddress(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSubnets() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSubnets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetSubnet() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* /*request*/, ::google::cloud::vmwareengine::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSubnet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSubnet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListExternalAccessRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListExternalAccessRules() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_ListExternalAccessRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExternalAccessRules(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListExternalAccessRules(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetExternalAccessRule() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_GetExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest* /*request*/, ::google::cloud::vmwareengine::v1::ExternalAccessRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetExternalAccessRule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateExternalAccessRule() {
      ::grpc::Service::MarkMethodRaw(24);
    }
    ~WithRawMethod_CreateExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateExternalAccessRule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateExternalAccessRule() {
      ::grpc::Service::MarkMethodRaw(25);
    }
    ~WithRawMethod_UpdateExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateExternalAccessRule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteExternalAccessRule() {
      ::grpc::Service::MarkMethodRaw(26);
    }
    ~WithRawMethod_DeleteExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteExternalAccessRule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListLoggingServers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListLoggingServers() {
      ::grpc::Service::MarkMethodRaw(27);
    }
    ~WithRawMethod_ListLoggingServers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLoggingServers(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListLoggingServers(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetLoggingServer() {
      ::grpc::Service::MarkMethodRaw(28);
    }
    ~WithRawMethod_GetLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest* /*request*/, ::google::cloud::vmwareengine::v1::LoggingServer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetLoggingServer(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateLoggingServer() {
      ::grpc::Service::MarkMethodRaw(29);
    }
    ~WithRawMethod_CreateLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateLoggingServer(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateLoggingServer() {
      ::grpc::Service::MarkMethodRaw(30);
    }
    ~WithRawMethod_UpdateLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateLoggingServer(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteLoggingServer() {
      ::grpc::Service::MarkMethodRaw(31);
    }
    ~WithRawMethod_DeleteLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteLoggingServer(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListNodeTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListNodeTypes() {
      ::grpc::Service::MarkMethodRaw(32);
    }
    ~WithRawMethod_ListNodeTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodeTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNodeTypes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetNodeType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetNodeType() {
      ::grpc::Service::MarkMethodRaw(33);
    }
    ~WithRawMethod_GetNodeType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNodeType(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* /*request*/, ::google::cloud::vmwareengine::v1::NodeType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNodeType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ShowNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ShowNsxCredentials() {
      ::grpc::Service::MarkMethodRaw(34);
    }
    ~WithRawMethod_ShowNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestShowNsxCredentials(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(34, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ShowVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ShowVcenterCredentials() {
      ::grpc::Service::MarkMethodRaw(35);
    }
    ~WithRawMethod_ShowVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestShowVcenterCredentials(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(35, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ResetNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ResetNsxCredentials() {
      ::grpc::Service::MarkMethodRaw(36);
    }
    ~WithRawMethod_ResetNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetNsxCredentials(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(36, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ResetVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ResetVcenterCredentials() {
      ::grpc::Service::MarkMethodRaw(37);
    }
    ~WithRawMethod_ResetVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetVcenterCredentials(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(37, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDnsForwarding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDnsForwarding() {
      ::grpc::Service::MarkMethodRaw(38);
    }
    ~WithRawMethod_GetDnsForwarding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDnsForwarding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest* /*request*/, ::google::cloud::vmwareengine::v1::DnsForwarding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDnsForwarding(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(38, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateDnsForwarding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateDnsForwarding() {
      ::grpc::Service::MarkMethodRaw(39);
    }
    ~WithRawMethod_UpdateDnsForwarding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDnsForwarding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDnsForwarding(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(39, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetNetworkPeering() {
      ::grpc::Service::MarkMethodRaw(40);
    }
    ~WithRawMethod_GetNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPeering* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNetworkPeering(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(40, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListNetworkPeerings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListNetworkPeerings() {
      ::grpc::Service::MarkMethodRaw(41);
    }
    ~WithRawMethod_ListNetworkPeerings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworkPeerings(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNetworkPeerings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(41, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateNetworkPeering() {
      ::grpc::Service::MarkMethodRaw(42);
    }
    ~WithRawMethod_CreateNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateNetworkPeering(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(42, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteNetworkPeering() {
      ::grpc::Service::MarkMethodRaw(43);
    }
    ~WithRawMethod_DeleteNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteNetworkPeering(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(43, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateNetworkPeering() {
      ::grpc::Service::MarkMethodRaw(44);
    }
    ~WithRawMethod_UpdateNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateNetworkPeering(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(44, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPeeringRoutes() {
      ::grpc::Service::MarkMethodRaw(45);
    }
    ~WithRawMethod_ListPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPeeringRoutes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(45, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateHcxActivationKey() {
      ::grpc::Service::MarkMethodRaw(46);
    }
    ~WithRawMethod_CreateHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateHcxActivationKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(46, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListHcxActivationKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListHcxActivationKeys() {
      ::grpc::Service::MarkMethodRaw(47);
    }
    ~WithRawMethod_ListHcxActivationKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHcxActivationKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListHcxActivationKeys(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(47, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetHcxActivationKey() {
      ::grpc::Service::MarkMethodRaw(48);
    }
    ~WithRawMethod_GetHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* /*request*/, ::google::cloud::vmwareengine::v1::HcxActivationKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetHcxActivationKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(48, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetNetworkPolicy() {
      ::grpc::Service::MarkMethodRaw(49);
    }
    ~WithRawMethod_GetNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNetworkPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(49, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListNetworkPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListNetworkPolicies() {
      ::grpc::Service::MarkMethodRaw(50);
    }
    ~WithRawMethod_ListNetworkPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworkPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNetworkPolicies(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(50, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateNetworkPolicy() {
      ::grpc::Service::MarkMethodRaw(51);
    }
    ~WithRawMethod_CreateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateNetworkPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(51, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateNetworkPolicy() {
      ::grpc::Service::MarkMethodRaw(52);
    }
    ~WithRawMethod_UpdateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateNetworkPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(52, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteNetworkPolicy() {
      ::grpc::Service::MarkMethodRaw(53);
    }
    ~WithRawMethod_DeleteNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteNetworkPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(53, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListManagementDnsZoneBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListManagementDnsZoneBindings() {
      ::grpc::Service::MarkMethodRaw(54);
    }
    ~WithRawMethod_ListManagementDnsZoneBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListManagementDnsZoneBindings(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListManagementDnsZoneBindings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(54, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodRaw(55);
    }
    ~WithRawMethod_GetManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest* /*request*/, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetManagementDnsZoneBinding(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(55, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodRaw(56);
    }
    ~WithRawMethod_CreateManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateManagementDnsZoneBinding(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(56, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodRaw(57);
    }
    ~WithRawMethod_UpdateManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateManagementDnsZoneBinding(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(57, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodRaw(58);
    }
    ~WithRawMethod_DeleteManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteManagementDnsZoneBinding(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(58, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RepairManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RepairManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodRaw(59);
    }
    ~WithRawMethod_RepairManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RepairManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRepairManagementDnsZoneBinding(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(59, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodRaw(60);
    }
    ~WithRawMethod_CreateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateVmwareEngineNetwork(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(60, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodRaw(61);
    }
    ~WithRawMethod_UpdateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateVmwareEngineNetwork(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(61, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodRaw(62);
    }
    ~WithRawMethod_DeleteVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteVmwareEngineNetwork(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(62, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodRaw(63);
    }
    ~WithRawMethod_GetVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* /*request*/, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVmwareEngineNetwork(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(63, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListVmwareEngineNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListVmwareEngineNetworks() {
      ::grpc::Service::MarkMethodRaw(64);
    }
    ~WithRawMethod_ListVmwareEngineNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVmwareEngineNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListVmwareEngineNetworks(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(64, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreatePrivateConnection() {
      ::grpc::Service::MarkMethodRaw(65);
    }
    ~WithRawMethod_CreatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePrivateConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(65, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPrivateConnection() {
      ::grpc::Service::MarkMethodRaw(66);
    }
    ~WithRawMethod_GetPrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPrivateConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(66, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPrivateConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPrivateConnections() {
      ::grpc::Service::MarkMethodRaw(67);
    }
    ~WithRawMethod_ListPrivateConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPrivateConnections(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(67, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdatePrivateConnection() {
      ::grpc::Service::MarkMethodRaw(68);
    }
    ~WithRawMethod_UpdatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePrivateConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(68, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeletePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeletePrivateConnection() {
      ::grpc::Service::MarkMethodRaw(69);
    }
    ~WithRawMethod_DeletePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePrivateConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(69, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPrivateConnectionPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPrivateConnectionPeeringRoutes() {
      ::grpc::Service::MarkMethodRaw(70);
    }
    ~WithRawMethod_ListPrivateConnectionPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPrivateConnectionPeeringRoutes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(70, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GrantDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GrantDnsBindPermission() {
      ::grpc::Service::MarkMethodRaw(71);
    }
    ~WithRawMethod_GrantDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GrantDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGrantDnsBindPermission(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(71, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDnsBindPermission() {
      ::grpc::Service::MarkMethodRaw(72);
    }
    ~WithRawMethod_GetDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest* /*request*/, ::google::cloud::vmwareengine::v1::DnsBindPermission* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDnsBindPermission(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(72, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RevokeDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RevokeDnsBindPermission() {
      ::grpc::Service::MarkMethodRaw(73);
    }
    ~WithRawMethod_RevokeDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RevokeDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRevokeDnsBindPermission(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(73, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPrivateClouds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPrivateClouds() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPrivateClouds(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPrivateClouds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateClouds(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPrivateClouds(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPrivateCloud() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPrivateCloud(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateCloud* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreatePrivateCloud() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreatePrivateCloud(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdatePrivateCloud() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdatePrivateCloud(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeletePrivateCloud() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeletePrivateCloud(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UndeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UndeletePrivateCloud() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UndeletePrivateCloud(context, request, response); }));
    }
    ~WithRawCallbackMethod_UndeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeletePrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListClusters() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListClusters(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListClustersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListClusters(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCluster() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetClusterRequest* /*request*/, ::google::cloud::vmwareengine::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCluster() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListNodes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListNodes() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListNodes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListNodes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNodes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetNode() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetNode(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNode(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeRequest* /*request*/, ::google::cloud::vmwareengine::v1::Node* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNode(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListExternalAddresses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListExternalAddresses() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListExternalAddresses(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListExternalAddresses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExternalAddresses(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListExternalAddresses(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_FetchNetworkPolicyExternalAddresses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_FetchNetworkPolicyExternalAddresses() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->FetchNetworkPolicyExternalAddresses(context, request, response); }));
    }
    ~WithRawCallbackMethod_FetchNetworkPolicyExternalAddresses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchNetworkPolicyExternalAddresses(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest* /*request*/, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FetchNetworkPolicyExternalAddresses(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetExternalAddress() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetExternalAddress(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest* /*request*/, ::google::cloud::vmwareengine::v1::ExternalAddress* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetExternalAddress(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateExternalAddress() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateExternalAddress(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateExternalAddress(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateExternalAddress() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateExternalAddress(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateExternalAddress(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteExternalAddress() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteExternalAddress(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteExternalAddress(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSubnets() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSubnets(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSubnets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetSubnet() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetSubnet(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* /*request*/, ::google::cloud::vmwareengine::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSubnet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateSubnet(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSubnet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListExternalAccessRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListExternalAccessRules() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListExternalAccessRules(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListExternalAccessRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExternalAccessRules(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListExternalAccessRules(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetExternalAccessRule() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetExternalAccessRule(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest* /*request*/, ::google::cloud::vmwareengine::v1::ExternalAccessRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetExternalAccessRule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateExternalAccessRule() {
      ::grpc::Service::MarkMethodRawCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateExternalAccessRule(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateExternalAccessRule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateExternalAccessRule() {
      ::grpc::Service::MarkMethodRawCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateExternalAccessRule(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateExternalAccessRule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteExternalAccessRule() {
      ::grpc::Service::MarkMethodRawCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteExternalAccessRule(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteExternalAccessRule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListLoggingServers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListLoggingServers() {
      ::grpc::Service::MarkMethodRawCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListLoggingServers(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListLoggingServers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLoggingServers(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListLoggingServers(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetLoggingServer() {
      ::grpc::Service::MarkMethodRawCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetLoggingServer(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest* /*request*/, ::google::cloud::vmwareengine::v1::LoggingServer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetLoggingServer(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateLoggingServer() {
      ::grpc::Service::MarkMethodRawCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateLoggingServer(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateLoggingServer(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateLoggingServer() {
      ::grpc::Service::MarkMethodRawCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateLoggingServer(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateLoggingServer(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteLoggingServer() {
      ::grpc::Service::MarkMethodRawCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteLoggingServer(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteLoggingServer(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListNodeTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListNodeTypes() {
      ::grpc::Service::MarkMethodRawCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListNodeTypes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListNodeTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodeTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNodeTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetNodeType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetNodeType() {
      ::grpc::Service::MarkMethodRawCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetNodeType(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetNodeType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNodeType(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* /*request*/, ::google::cloud::vmwareengine::v1::NodeType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNodeType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ShowNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ShowNsxCredentials() {
      ::grpc::Service::MarkMethodRawCallback(34,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ShowNsxCredentials(context, request, response); }));
    }
    ~WithRawCallbackMethod_ShowNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ShowNsxCredentials(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ShowVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ShowVcenterCredentials() {
      ::grpc::Service::MarkMethodRawCallback(35,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ShowVcenterCredentials(context, request, response); }));
    }
    ~WithRawCallbackMethod_ShowVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ShowVcenterCredentials(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ResetNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ResetNsxCredentials() {
      ::grpc::Service::MarkMethodRawCallback(36,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ResetNsxCredentials(context, request, response); }));
    }
    ~WithRawCallbackMethod_ResetNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetNsxCredentials(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ResetVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ResetVcenterCredentials() {
      ::grpc::Service::MarkMethodRawCallback(37,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ResetVcenterCredentials(context, request, response); }));
    }
    ~WithRawCallbackMethod_ResetVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetVcenterCredentials(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDnsForwarding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDnsForwarding() {
      ::grpc::Service::MarkMethodRawCallback(38,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDnsForwarding(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDnsForwarding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDnsForwarding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest* /*request*/, ::google::cloud::vmwareengine::v1::DnsForwarding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDnsForwarding(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateDnsForwarding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateDnsForwarding() {
      ::grpc::Service::MarkMethodRawCallback(39,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateDnsForwarding(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateDnsForwarding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDnsForwarding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDnsForwarding(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetNetworkPeering() {
      ::grpc::Service::MarkMethodRawCallback(40,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetNetworkPeering(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPeering* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNetworkPeering(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListNetworkPeerings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListNetworkPeerings() {
      ::grpc::Service::MarkMethodRawCallback(41,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListNetworkPeerings(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListNetworkPeerings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworkPeerings(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNetworkPeerings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateNetworkPeering() {
      ::grpc::Service::MarkMethodRawCallback(42,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateNetworkPeering(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateNetworkPeering(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteNetworkPeering() {
      ::grpc::Service::MarkMethodRawCallback(43,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteNetworkPeering(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteNetworkPeering(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateNetworkPeering() {
      ::grpc::Service::MarkMethodRawCallback(44,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateNetworkPeering(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateNetworkPeering(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPeeringRoutes() {
      ::grpc::Service::MarkMethodRawCallback(45,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPeeringRoutes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPeeringRoutes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateHcxActivationKey() {
      ::grpc::Service::MarkMethodRawCallback(46,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateHcxActivationKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateHcxActivationKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListHcxActivationKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListHcxActivationKeys() {
      ::grpc::Service::MarkMethodRawCallback(47,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListHcxActivationKeys(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListHcxActivationKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHcxActivationKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListHcxActivationKeys(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetHcxActivationKey() {
      ::grpc::Service::MarkMethodRawCallback(48,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetHcxActivationKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* /*request*/, ::google::cloud::vmwareengine::v1::HcxActivationKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetHcxActivationKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetNetworkPolicy() {
      ::grpc::Service::MarkMethodRawCallback(49,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetNetworkPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNetworkPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListNetworkPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListNetworkPolicies() {
      ::grpc::Service::MarkMethodRawCallback(50,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListNetworkPolicies(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListNetworkPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworkPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNetworkPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateNetworkPolicy() {
      ::grpc::Service::MarkMethodRawCallback(51,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateNetworkPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateNetworkPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateNetworkPolicy() {
      ::grpc::Service::MarkMethodRawCallback(52,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateNetworkPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateNetworkPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteNetworkPolicy() {
      ::grpc::Service::MarkMethodRawCallback(53,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteNetworkPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteNetworkPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListManagementDnsZoneBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListManagementDnsZoneBindings() {
      ::grpc::Service::MarkMethodRawCallback(54,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListManagementDnsZoneBindings(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListManagementDnsZoneBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListManagementDnsZoneBindings(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListManagementDnsZoneBindings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodRawCallback(55,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetManagementDnsZoneBinding(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest* /*request*/, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetManagementDnsZoneBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodRawCallback(56,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateManagementDnsZoneBinding(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateManagementDnsZoneBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodRawCallback(57,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateManagementDnsZoneBinding(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateManagementDnsZoneBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodRawCallback(58,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteManagementDnsZoneBinding(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteManagementDnsZoneBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RepairManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RepairManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodRawCallback(59,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RepairManagementDnsZoneBinding(context, request, response); }));
    }
    ~WithRawCallbackMethod_RepairManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RepairManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RepairManagementDnsZoneBinding(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodRawCallback(60,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateVmwareEngineNetwork(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateVmwareEngineNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodRawCallback(61,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateVmwareEngineNetwork(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateVmwareEngineNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodRawCallback(62,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteVmwareEngineNetwork(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteVmwareEngineNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodRawCallback(63,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetVmwareEngineNetwork(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* /*request*/, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVmwareEngineNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListVmwareEngineNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListVmwareEngineNetworks() {
      ::grpc::Service::MarkMethodRawCallback(64,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListVmwareEngineNetworks(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListVmwareEngineNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVmwareEngineNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListVmwareEngineNetworks(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreatePrivateConnection() {
      ::grpc::Service::MarkMethodRawCallback(65,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreatePrivateConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePrivateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPrivateConnection() {
      ::grpc::Service::MarkMethodRawCallback(66,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPrivateConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPrivateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPrivateConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPrivateConnections() {
      ::grpc::Service::MarkMethodRawCallback(67,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPrivateConnections(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPrivateConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPrivateConnections(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdatePrivateConnection() {
      ::grpc::Service::MarkMethodRawCallback(68,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdatePrivateConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePrivateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeletePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeletePrivateConnection() {
      ::grpc::Service::MarkMethodRawCallback(69,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeletePrivateConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeletePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePrivateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPrivateConnectionPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPrivateConnectionPeeringRoutes() {
      ::grpc::Service::MarkMethodRawCallback(70,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPrivateConnectionPeeringRoutes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPrivateConnectionPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPrivateConnectionPeeringRoutes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GrantDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GrantDnsBindPermission() {
      ::grpc::Service::MarkMethodRawCallback(71,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GrantDnsBindPermission(context, request, response); }));
    }
    ~WithRawCallbackMethod_GrantDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GrantDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GrantDnsBindPermission(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDnsBindPermission() {
      ::grpc::Service::MarkMethodRawCallback(72,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDnsBindPermission(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest* /*request*/, ::google::cloud::vmwareengine::v1::DnsBindPermission* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDnsBindPermission(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RevokeDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RevokeDnsBindPermission() {
      ::grpc::Service::MarkMethodRawCallback(73,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RevokeDnsBindPermission(context, request, response); }));
    }
    ~WithRawCallbackMethod_RevokeDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RevokeDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RevokeDnsBindPermission(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPrivateClouds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPrivateClouds() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>* streamer) {
                       return this->StreamedListPrivateClouds(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPrivateClouds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPrivateClouds(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPrivateClouds(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest,::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPrivateCloud() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest, ::google::cloud::vmwareengine::v1::PrivateCloud>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest, ::google::cloud::vmwareengine::v1::PrivateCloud>* streamer) {
                       return this->StreamedGetPrivateCloud(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateCloud* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPrivateCloud(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest,::google::cloud::vmwareengine::v1::PrivateCloud>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreatePrivateCloud() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreatePrivateCloud(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreatePrivateCloud(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdatePrivateCloud() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdatePrivateCloud(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdatePrivateCloud(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeletePrivateCloud() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeletePrivateCloud(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeletePrivateCloud(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UndeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UndeletePrivateCloud() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUndeletePrivateCloud(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UndeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UndeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUndeletePrivateCloud(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListClusters() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListClustersRequest, ::google::cloud::vmwareengine::v1::ListClustersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListClustersRequest, ::google::cloud::vmwareengine::v1::ListClustersResponse>* streamer) {
                       return this->StreamedListClusters(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListClustersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListClusters(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListClustersRequest,::google::cloud::vmwareengine::v1::ListClustersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCluster() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetClusterRequest, ::google::cloud::vmwareengine::v1::Cluster>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetClusterRequest, ::google::cloud::vmwareengine::v1::Cluster>* streamer) {
                       return this->StreamedGetCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetClusterRequest* /*request*/, ::google::cloud::vmwareengine::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetClusterRequest,::google::cloud::vmwareengine::v1::Cluster>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCluster() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreateClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreateClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreateClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdateClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdateClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdateClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::DeleteClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::DeleteClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::DeleteClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListNodes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListNodes() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListNodesRequest, ::google::cloud::vmwareengine::v1::ListNodesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListNodesRequest, ::google::cloud::vmwareengine::v1::ListNodesResponse>* streamer) {
                       return this->StreamedListNodes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListNodes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListNodes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListNodes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListNodesRequest,::google::cloud::vmwareengine::v1::ListNodesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetNode() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetNodeRequest, ::google::cloud::vmwareengine::v1::Node>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetNodeRequest, ::google::cloud::vmwareengine::v1::Node>* streamer) {
                       return this->StreamedGetNode(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetNode(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeRequest* /*request*/, ::google::cloud::vmwareengine::v1::Node* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetNode(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetNodeRequest,::google::cloud::vmwareengine::v1::Node>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListExternalAddresses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListExternalAddresses() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>* streamer) {
                       return this->StreamedListExternalAddresses(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListExternalAddresses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListExternalAddresses(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListExternalAddressesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListExternalAddresses(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListExternalAddressesRequest,::google::cloud::vmwareengine::v1::ListExternalAddressesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_FetchNetworkPolicyExternalAddresses : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_FetchNetworkPolicyExternalAddresses() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>* streamer) {
                       return this->StreamedFetchNetworkPolicyExternalAddresses(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_FetchNetworkPolicyExternalAddresses() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status FetchNetworkPolicyExternalAddresses(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest* /*request*/, ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedFetchNetworkPolicyExternalAddresses(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesRequest,::google::cloud::vmwareengine::v1::FetchNetworkPolicyExternalAddressesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetExternalAddress() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetExternalAddressRequest, ::google::cloud::vmwareengine::v1::ExternalAddress>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetExternalAddressRequest, ::google::cloud::vmwareengine::v1::ExternalAddress>* streamer) {
                       return this->StreamedGetExternalAddress(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetExternalAddressRequest* /*request*/, ::google::cloud::vmwareengine::v1::ExternalAddress* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetExternalAddress(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetExternalAddressRequest,::google::cloud::vmwareengine::v1::ExternalAddress>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateExternalAddress() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateExternalAddress(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateExternalAddress(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreateExternalAddressRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateExternalAddress() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateExternalAddress(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateExternalAddress(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdateExternalAddressRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteExternalAddress : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteExternalAddress() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteExternalAddress(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteExternalAddress() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteExternalAddress(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteExternalAddress(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::DeleteExternalAddressRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSubnets() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListSubnetsRequest, ::google::cloud::vmwareengine::v1::ListSubnetsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListSubnetsRequest, ::google::cloud::vmwareengine::v1::ListSubnetsResponse>* streamer) {
                       return this->StreamedListSubnets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSubnets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListSubnetsRequest,::google::cloud::vmwareengine::v1::ListSubnetsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetSubnet() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetSubnetRequest, ::google::cloud::vmwareengine::v1::Subnet>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetSubnetRequest, ::google::cloud::vmwareengine::v1::Subnet>* streamer) {
                       return this->StreamedGetSubnet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* /*request*/, ::google::cloud::vmwareengine::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetSubnet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetSubnetRequest,::google::cloud::vmwareengine::v1::Subnet>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdateSubnetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdateSubnetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateSubnet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateSubnet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdateSubnetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListExternalAccessRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListExternalAccessRules() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>* streamer) {
                       return this->StreamedListExternalAccessRules(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListExternalAccessRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListExternalAccessRules(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListExternalAccessRules(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListExternalAccessRulesRequest,::google::cloud::vmwareengine::v1::ListExternalAccessRulesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetExternalAccessRule() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest, ::google::cloud::vmwareengine::v1::ExternalAccessRule>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest, ::google::cloud::vmwareengine::v1::ExternalAccessRule>* streamer) {
                       return this->StreamedGetExternalAccessRule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest* /*request*/, ::google::cloud::vmwareengine::v1::ExternalAccessRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetExternalAccessRule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetExternalAccessRuleRequest,::google::cloud::vmwareengine::v1::ExternalAccessRule>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateExternalAccessRule() {
      ::grpc::Service::MarkMethodStreamed(24,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateExternalAccessRule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateExternalAccessRule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreateExternalAccessRuleRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateExternalAccessRule() {
      ::grpc::Service::MarkMethodStreamed(25,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateExternalAccessRule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateExternalAccessRule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdateExternalAccessRuleRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteExternalAccessRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteExternalAccessRule() {
      ::grpc::Service::MarkMethodStreamed(26,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteExternalAccessRule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteExternalAccessRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteExternalAccessRule(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteExternalAccessRule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::DeleteExternalAccessRuleRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListLoggingServers : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListLoggingServers() {
      ::grpc::Service::MarkMethodStreamed(27,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListLoggingServersRequest, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListLoggingServersRequest, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse>* streamer) {
                       return this->StreamedListLoggingServers(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListLoggingServers() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListLoggingServers(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListLoggingServersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListLoggingServersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListLoggingServers(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListLoggingServersRequest,::google::cloud::vmwareengine::v1::ListLoggingServersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetLoggingServer() {
      ::grpc::Service::MarkMethodStreamed(28,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetLoggingServerRequest, ::google::cloud::vmwareengine::v1::LoggingServer>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetLoggingServerRequest, ::google::cloud::vmwareengine::v1::LoggingServer>* streamer) {
                       return this->StreamedGetLoggingServer(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetLoggingServerRequest* /*request*/, ::google::cloud::vmwareengine::v1::LoggingServer* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetLoggingServer(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetLoggingServerRequest,::google::cloud::vmwareengine::v1::LoggingServer>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateLoggingServer() {
      ::grpc::Service::MarkMethodStreamed(29,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateLoggingServer(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateLoggingServer(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreateLoggingServerRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateLoggingServer() {
      ::grpc::Service::MarkMethodStreamed(30,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateLoggingServer(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateLoggingServer(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdateLoggingServerRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteLoggingServer : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteLoggingServer() {
      ::grpc::Service::MarkMethodStreamed(31,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteLoggingServer(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteLoggingServer() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteLoggingServer(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteLoggingServer(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::DeleteLoggingServerRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListNodeTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListNodeTypes() {
      ::grpc::Service::MarkMethodStreamed(32,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListNodeTypesRequest, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListNodeTypesRequest, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>* streamer) {
                       return this->StreamedListNodeTypes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListNodeTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListNodeTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListNodeTypes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListNodeTypesRequest,::google::cloud::vmwareengine::v1::ListNodeTypesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetNodeType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetNodeType() {
      ::grpc::Service::MarkMethodStreamed(33,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetNodeTypeRequest, ::google::cloud::vmwareengine::v1::NodeType>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetNodeTypeRequest, ::google::cloud::vmwareengine::v1::NodeType>* streamer) {
                       return this->StreamedGetNodeType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetNodeType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetNodeType(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* /*request*/, ::google::cloud::vmwareengine::v1::NodeType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetNodeType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetNodeTypeRequest,::google::cloud::vmwareengine::v1::NodeType>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ShowNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ShowNsxCredentials() {
      ::grpc::Service::MarkMethodStreamed(34,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>* streamer) {
                       return this->StreamedShowNsxCredentials(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ShowNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ShowNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedShowNsxCredentials(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest,::google::cloud::vmwareengine::v1::Credentials>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ShowVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ShowVcenterCredentials() {
      ::grpc::Service::MarkMethodStreamed(35,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>* streamer) {
                       return this->StreamedShowVcenterCredentials(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ShowVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ShowVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedShowVcenterCredentials(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest,::google::cloud::vmwareengine::v1::Credentials>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ResetNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ResetNsxCredentials() {
      ::grpc::Service::MarkMethodStreamed(36,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedResetNsxCredentials(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ResetNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ResetNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResetNsxCredentials(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ResetVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ResetVcenterCredentials() {
      ::grpc::Service::MarkMethodStreamed(37,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedResetVcenterCredentials(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ResetVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ResetVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResetVcenterCredentials(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDnsForwarding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDnsForwarding() {
      ::grpc::Service::MarkMethodStreamed(38,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest, ::google::cloud::vmwareengine::v1::DnsForwarding>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest, ::google::cloud::vmwareengine::v1::DnsForwarding>* streamer) {
                       return this->StreamedGetDnsForwarding(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDnsForwarding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDnsForwarding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest* /*request*/, ::google::cloud::vmwareengine::v1::DnsForwarding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDnsForwarding(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetDnsForwardingRequest,::google::cloud::vmwareengine::v1::DnsForwarding>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateDnsForwarding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateDnsForwarding() {
      ::grpc::Service::MarkMethodStreamed(39,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateDnsForwarding(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateDnsForwarding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateDnsForwarding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateDnsForwarding(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdateDnsForwardingRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetNetworkPeering() {
      ::grpc::Service::MarkMethodStreamed(40,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest, ::google::cloud::vmwareengine::v1::NetworkPeering>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest, ::google::cloud::vmwareengine::v1::NetworkPeering>* streamer) {
                       return this->StreamedGetNetworkPeering(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPeering* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetNetworkPeering(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetNetworkPeeringRequest,::google::cloud::vmwareengine::v1::NetworkPeering>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListNetworkPeerings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListNetworkPeerings() {
      ::grpc::Service::MarkMethodStreamed(41,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>* streamer) {
                       return this->StreamedListNetworkPeerings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListNetworkPeerings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListNetworkPeerings(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListNetworkPeerings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListNetworkPeeringsRequest,::google::cloud::vmwareengine::v1::ListNetworkPeeringsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateNetworkPeering() {
      ::grpc::Service::MarkMethodStreamed(42,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateNetworkPeering(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateNetworkPeering(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreateNetworkPeeringRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteNetworkPeering() {
      ::grpc::Service::MarkMethodStreamed(43,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteNetworkPeering(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteNetworkPeering(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::DeleteNetworkPeeringRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateNetworkPeering : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateNetworkPeering() {
      ::grpc::Service::MarkMethodStreamed(44,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateNetworkPeering(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateNetworkPeering() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateNetworkPeering(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateNetworkPeering(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdateNetworkPeeringRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPeeringRoutes() {
      ::grpc::Service::MarkMethodStreamed(45,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>* streamer) {
                       return this->StreamedListPeeringRoutes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPeeringRoutes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListPeeringRoutesRequest,::google::cloud::vmwareengine::v1::ListPeeringRoutesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateHcxActivationKey() {
      ::grpc::Service::MarkMethodStreamed(46,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateHcxActivationKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateHcxActivationKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListHcxActivationKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListHcxActivationKeys() {
      ::grpc::Service::MarkMethodStreamed(47,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>* streamer) {
                       return this->StreamedListHcxActivationKeys(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListHcxActivationKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListHcxActivationKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListHcxActivationKeys(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest,::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetHcxActivationKey() {
      ::grpc::Service::MarkMethodStreamed(48,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest, ::google::cloud::vmwareengine::v1::HcxActivationKey>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest, ::google::cloud::vmwareengine::v1::HcxActivationKey>* streamer) {
                       return this->StreamedGetHcxActivationKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* /*request*/, ::google::cloud::vmwareengine::v1::HcxActivationKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetHcxActivationKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest,::google::cloud::vmwareengine::v1::HcxActivationKey>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetNetworkPolicy() {
      ::grpc::Service::MarkMethodStreamed(49,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest, ::google::cloud::vmwareengine::v1::NetworkPolicy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest, ::google::cloud::vmwareengine::v1::NetworkPolicy>* streamer) {
                       return this->StreamedGetNetworkPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetNetworkPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest,::google::cloud::vmwareengine::v1::NetworkPolicy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListNetworkPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListNetworkPolicies() {
      ::grpc::Service::MarkMethodStreamed(50,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>* streamer) {
                       return this->StreamedListNetworkPolicies(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListNetworkPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListNetworkPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListNetworkPolicies(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest,::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateNetworkPolicy() {
      ::grpc::Service::MarkMethodStreamed(51,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateNetworkPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateNetworkPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateNetworkPolicy() {
      ::grpc::Service::MarkMethodStreamed(52,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateNetworkPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateNetworkPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteNetworkPolicy() {
      ::grpc::Service::MarkMethodStreamed(53,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteNetworkPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteNetworkPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListManagementDnsZoneBindings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListManagementDnsZoneBindings() {
      ::grpc::Service::MarkMethodStreamed(54,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>* streamer) {
                       return this->StreamedListManagementDnsZoneBindings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListManagementDnsZoneBindings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListManagementDnsZoneBindings(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListManagementDnsZoneBindings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsRequest,::google::cloud::vmwareengine::v1::ListManagementDnsZoneBindingsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodStreamed(55,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>* streamer) {
                       return this->StreamedGetManagementDnsZoneBinding(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest* /*request*/, ::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetManagementDnsZoneBinding(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetManagementDnsZoneBindingRequest,::google::cloud::vmwareengine::v1::ManagementDnsZoneBinding>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodStreamed(56,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateManagementDnsZoneBinding(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateManagementDnsZoneBinding(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreateManagementDnsZoneBindingRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodStreamed(57,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateManagementDnsZoneBinding(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateManagementDnsZoneBinding(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdateManagementDnsZoneBindingRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodStreamed(58,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteManagementDnsZoneBinding(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteManagementDnsZoneBinding(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::DeleteManagementDnsZoneBindingRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RepairManagementDnsZoneBinding : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RepairManagementDnsZoneBinding() {
      ::grpc::Service::MarkMethodStreamed(59,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRepairManagementDnsZoneBinding(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RepairManagementDnsZoneBinding() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RepairManagementDnsZoneBinding(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRepairManagementDnsZoneBinding(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::RepairManagementDnsZoneBindingRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodStreamed(60,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateVmwareEngineNetwork(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateVmwareEngineNetwork(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodStreamed(61,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateVmwareEngineNetwork(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateVmwareEngineNetwork(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodStreamed(62,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteVmwareEngineNetwork(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteVmwareEngineNetwork(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodStreamed(63,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>* streamer) {
                       return this->StreamedGetVmwareEngineNetwork(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* /*request*/, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetVmwareEngineNetwork(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest,::google::cloud::vmwareengine::v1::VmwareEngineNetwork>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListVmwareEngineNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListVmwareEngineNetworks() {
      ::grpc::Service::MarkMethodStreamed(64,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>* streamer) {
                       return this->StreamedListVmwareEngineNetworks(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListVmwareEngineNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListVmwareEngineNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListVmwareEngineNetworks(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest,::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreatePrivateConnection() {
      ::grpc::Service::MarkMethodStreamed(65,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreatePrivateConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreatePrivateConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPrivateConnection() {
      ::grpc::Service::MarkMethodStreamed(66,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest, ::google::cloud::vmwareengine::v1::PrivateConnection>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest, ::google::cloud::vmwareengine::v1::PrivateConnection>* streamer) {
                       return this->StreamedGetPrivateConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPrivateConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest,::google::cloud::vmwareengine::v1::PrivateConnection>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPrivateConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPrivateConnections() {
      ::grpc::Service::MarkMethodStreamed(67,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>* streamer) {
                       return this->StreamedListPrivateConnections(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPrivateConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPrivateConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPrivateConnections(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest,::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdatePrivateConnection() {
      ::grpc::Service::MarkMethodStreamed(68,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdatePrivateConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdatePrivateConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeletePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeletePrivateConnection() {
      ::grpc::Service::MarkMethodStreamed(69,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeletePrivateConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeletePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeletePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeletePrivateConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPrivateConnectionPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPrivateConnectionPeeringRoutes() {
      ::grpc::Service::MarkMethodStreamed(70,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>* streamer) {
                       return this->StreamedListPrivateConnectionPeeringRoutes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPrivateConnectionPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPrivateConnectionPeeringRoutes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest,::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GrantDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GrantDnsBindPermission() {
      ::grpc::Service::MarkMethodStreamed(71,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedGrantDnsBindPermission(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GrantDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GrantDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGrantDnsBindPermission(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GrantDnsBindPermissionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDnsBindPermission() {
      ::grpc::Service::MarkMethodStreamed(72,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest, ::google::cloud::vmwareengine::v1::DnsBindPermission>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest, ::google::cloud::vmwareengine::v1::DnsBindPermission>* streamer) {
                       return this->StreamedGetDnsBindPermission(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest* /*request*/, ::google::cloud::vmwareengine::v1::DnsBindPermission* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDnsBindPermission(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetDnsBindPermissionRequest,::google::cloud::vmwareengine::v1::DnsBindPermission>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RevokeDnsBindPermission : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RevokeDnsBindPermission() {
      ::grpc::Service::MarkMethodStreamed(73,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRevokeDnsBindPermission(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RevokeDnsBindPermission() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RevokeDnsBindPermission(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRevokeDnsBindPermission(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::RevokeDnsBindPermissionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListPrivateClouds<WithStreamedUnaryMethod_GetPrivateCloud<WithStreamedUnaryMethod_CreatePrivateCloud<WithStreamedUnaryMethod_UpdatePrivateCloud<WithStreamedUnaryMethod_DeletePrivateCloud<WithStreamedUnaryMethod_UndeletePrivateCloud<WithStreamedUnaryMethod_ListClusters<WithStreamedUnaryMethod_GetCluster<WithStreamedUnaryMethod_CreateCluster<WithStreamedUnaryMethod_UpdateCluster<WithStreamedUnaryMethod_DeleteCluster<WithStreamedUnaryMethod_ListNodes<WithStreamedUnaryMethod_GetNode<WithStreamedUnaryMethod_ListExternalAddresses<WithStreamedUnaryMethod_FetchNetworkPolicyExternalAddresses<WithStreamedUnaryMethod_GetExternalAddress<WithStreamedUnaryMethod_CreateExternalAddress<WithStreamedUnaryMethod_UpdateExternalAddress<WithStreamedUnaryMethod_DeleteExternalAddress<WithStreamedUnaryMethod_ListSubnets<WithStreamedUnaryMethod_GetSubnet<WithStreamedUnaryMethod_UpdateSubnet<WithStreamedUnaryMethod_ListExternalAccessRules<WithStreamedUnaryMethod_GetExternalAccessRule<WithStreamedUnaryMethod_CreateExternalAccessRule<WithStreamedUnaryMethod_UpdateExternalAccessRule<WithStreamedUnaryMethod_DeleteExternalAccessRule<WithStreamedUnaryMethod_ListLoggingServers<WithStreamedUnaryMethod_GetLoggingServer<WithStreamedUnaryMethod_CreateLoggingServer<WithStreamedUnaryMethod_UpdateLoggingServer<WithStreamedUnaryMethod_DeleteLoggingServer<WithStreamedUnaryMethod_ListNodeTypes<WithStreamedUnaryMethod_GetNodeType<WithStreamedUnaryMethod_ShowNsxCredentials<WithStreamedUnaryMethod_ShowVcenterCredentials<WithStreamedUnaryMethod_ResetNsxCredentials<WithStreamedUnaryMethod_ResetVcenterCredentials<WithStreamedUnaryMethod_GetDnsForwarding<WithStreamedUnaryMethod_UpdateDnsForwarding<WithStreamedUnaryMethod_GetNetworkPeering<WithStreamedUnaryMethod_ListNetworkPeerings<WithStreamedUnaryMethod_CreateNetworkPeering<WithStreamedUnaryMethod_DeleteNetworkPeering<WithStreamedUnaryMethod_UpdateNetworkPeering<WithStreamedUnaryMethod_ListPeeringRoutes<WithStreamedUnaryMethod_CreateHcxActivationKey<WithStreamedUnaryMethod_ListHcxActivationKeys<WithStreamedUnaryMethod_GetHcxActivationKey<WithStreamedUnaryMethod_GetNetworkPolicy<WithStreamedUnaryMethod_ListNetworkPolicies<WithStreamedUnaryMethod_CreateNetworkPolicy<WithStreamedUnaryMethod_UpdateNetworkPolicy<WithStreamedUnaryMethod_DeleteNetworkPolicy<WithStreamedUnaryMethod_ListManagementDnsZoneBindings<WithStreamedUnaryMethod_GetManagementDnsZoneBinding<WithStreamedUnaryMethod_CreateManagementDnsZoneBinding<WithStreamedUnaryMethod_UpdateManagementDnsZoneBinding<WithStreamedUnaryMethod_DeleteManagementDnsZoneBinding<WithStreamedUnaryMethod_RepairManagementDnsZoneBinding<WithStreamedUnaryMethod_CreateVmwareEngineNetwork<WithStreamedUnaryMethod_UpdateVmwareEngineNetwork<WithStreamedUnaryMethod_DeleteVmwareEngineNetwork<WithStreamedUnaryMethod_GetVmwareEngineNetwork<WithStreamedUnaryMethod_ListVmwareEngineNetworks<WithStreamedUnaryMethod_CreatePrivateConnection<WithStreamedUnaryMethod_GetPrivateConnection<WithStreamedUnaryMethod_ListPrivateConnections<WithStreamedUnaryMethod_UpdatePrivateConnection<WithStreamedUnaryMethod_DeletePrivateConnection<WithStreamedUnaryMethod_ListPrivateConnectionPeeringRoutes<WithStreamedUnaryMethod_GrantDnsBindPermission<WithStreamedUnaryMethod_GetDnsBindPermission<WithStreamedUnaryMethod_RevokeDnsBindPermission<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListPrivateClouds<WithStreamedUnaryMethod_GetPrivateCloud<WithStreamedUnaryMethod_CreatePrivateCloud<WithStreamedUnaryMethod_UpdatePrivateCloud<WithStreamedUnaryMethod_DeletePrivateCloud<WithStreamedUnaryMethod_UndeletePrivateCloud<WithStreamedUnaryMethod_ListClusters<WithStreamedUnaryMethod_GetCluster<WithStreamedUnaryMethod_CreateCluster<WithStreamedUnaryMethod_UpdateCluster<WithStreamedUnaryMethod_DeleteCluster<WithStreamedUnaryMethod_ListNodes<WithStreamedUnaryMethod_GetNode<WithStreamedUnaryMethod_ListExternalAddresses<WithStreamedUnaryMethod_FetchNetworkPolicyExternalAddresses<WithStreamedUnaryMethod_GetExternalAddress<WithStreamedUnaryMethod_CreateExternalAddress<WithStreamedUnaryMethod_UpdateExternalAddress<WithStreamedUnaryMethod_DeleteExternalAddress<WithStreamedUnaryMethod_ListSubnets<WithStreamedUnaryMethod_GetSubnet<WithStreamedUnaryMethod_UpdateSubnet<WithStreamedUnaryMethod_ListExternalAccessRules<WithStreamedUnaryMethod_GetExternalAccessRule<WithStreamedUnaryMethod_CreateExternalAccessRule<WithStreamedUnaryMethod_UpdateExternalAccessRule<WithStreamedUnaryMethod_DeleteExternalAccessRule<WithStreamedUnaryMethod_ListLoggingServers<WithStreamedUnaryMethod_GetLoggingServer<WithStreamedUnaryMethod_CreateLoggingServer<WithStreamedUnaryMethod_UpdateLoggingServer<WithStreamedUnaryMethod_DeleteLoggingServer<WithStreamedUnaryMethod_ListNodeTypes<WithStreamedUnaryMethod_GetNodeType<WithStreamedUnaryMethod_ShowNsxCredentials<WithStreamedUnaryMethod_ShowVcenterCredentials<WithStreamedUnaryMethod_ResetNsxCredentials<WithStreamedUnaryMethod_ResetVcenterCredentials<WithStreamedUnaryMethod_GetDnsForwarding<WithStreamedUnaryMethod_UpdateDnsForwarding<WithStreamedUnaryMethod_GetNetworkPeering<WithStreamedUnaryMethod_ListNetworkPeerings<WithStreamedUnaryMethod_CreateNetworkPeering<WithStreamedUnaryMethod_DeleteNetworkPeering<WithStreamedUnaryMethod_UpdateNetworkPeering<WithStreamedUnaryMethod_ListPeeringRoutes<WithStreamedUnaryMethod_CreateHcxActivationKey<WithStreamedUnaryMethod_ListHcxActivationKeys<WithStreamedUnaryMethod_GetHcxActivationKey<WithStreamedUnaryMethod_GetNetworkPolicy<WithStreamedUnaryMethod_ListNetworkPolicies<WithStreamedUnaryMethod_CreateNetworkPolicy<WithStreamedUnaryMethod_UpdateNetworkPolicy<WithStreamedUnaryMethod_DeleteNetworkPolicy<WithStreamedUnaryMethod_ListManagementDnsZoneBindings<WithStreamedUnaryMethod_GetManagementDnsZoneBinding<WithStreamedUnaryMethod_CreateManagementDnsZoneBinding<WithStreamedUnaryMethod_UpdateManagementDnsZoneBinding<WithStreamedUnaryMethod_DeleteManagementDnsZoneBinding<WithStreamedUnaryMethod_RepairManagementDnsZoneBinding<WithStreamedUnaryMethod_CreateVmwareEngineNetwork<WithStreamedUnaryMethod_UpdateVmwareEngineNetwork<WithStreamedUnaryMethod_DeleteVmwareEngineNetwork<WithStreamedUnaryMethod_GetVmwareEngineNetwork<WithStreamedUnaryMethod_ListVmwareEngineNetworks<WithStreamedUnaryMethod_CreatePrivateConnection<WithStreamedUnaryMethod_GetPrivateConnection<WithStreamedUnaryMethod_ListPrivateConnections<WithStreamedUnaryMethod_UpdatePrivateConnection<WithStreamedUnaryMethod_DeletePrivateConnection<WithStreamedUnaryMethod_ListPrivateConnectionPeeringRoutes<WithStreamedUnaryMethod_GrantDnsBindPermission<WithStreamedUnaryMethod_GetDnsBindPermission<WithStreamedUnaryMethod_RevokeDnsBindPermission<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace vmwareengine
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fvmwareengine_2fv1_2fvmwareengine_2eproto__INCLUDED
